<?php

namespace cms;

//should never happen if software is installed correctly
if (! cms_load("directory")) return;

class menu_tab
{
        var $flexview    = NULL;
        var $indentation = -1;
        var $i           = 0;

        function __construct()
        {
                //get display object containing the directory tree structure
                $this->flexview = directory_get_flexview();

                //set currently selected directory entry
                $index = directory_get_visible();
                $this->flexview->set_index($index);

                //set base entry of directory branch to be displayed
                //all elements outside that branch are ignored
                $this->flexview->set_base(0);

                //set action to be executed on selection, usually an url
                $this->flexview->set_action(CMS_ROOT_URL . "%index%" . cms_param());

                //set icons
                $this->flexview->set_icon(directory_get_type());

                //evoke display method
                $this->flexview->show_custom(array($this, "show"));
        }

        function show($flexview_entry)
        {
                //the passed variable flexview_entry is a structure containing
                //all necessary information about the current entry
                //each entry below the given base entry is processed
                //beginning with the top of the tree and following the branches

                switch ($flexview_entry->type) //the type of event that is passed
                {
                case CMS_FLEXVIEW_ENTRY_TYPE_BASE: //before first entry

                        //nothing to do here
                        return;

                case CMS_FLEXVIEW_ENTRY_TYPE_ENTRY: //current entry

                        //base level
                        if ($flexview_entry->indentation === 0)
                        {
                                //end sublevels
                                for (; $this->indentation > -1; $this->indentation--)
                                {
                                        if ($this->indentation === 1) echo("</div>");
                                        echo("</div>");
                                };

                                //start base level
                                echo("<div class=\"level level-0\">");
                                $this->indentation = 0;
                        }

                        //sublevel
                        else
                        {
                                //start sublevel
                                if ($flexview_entry->indentation > $this->indentation)
                                {
                                        echo("<div class=\"level level-" . $flexview_entry->indentation . "\">");
                                        $this->indentation = $flexview_entry->indentation;

                                        if ($flexview_entry->indentation === 1)
                                        {
                                                echo("<div class=\"column\">");
                                                $this->i = 0;
                                        };
                                }

                                //end sublevels
                                elseif ($flexview_entry->indentation < $this->indentation)
                                {
                                        for (; $this->indentation > $flexview_entry->indentation; $this->indentation--)
                                        {
                                                if ($this->indentation === 1) echo("</div>");
                                                echo("</div>");
                                        };

                                        if (
                                             ($flexview_entry->indentation === 1)
                                             &&
                                             ($flexview_entry->position <= $flexview_entry->count)
                                             &&
                                             (++$this->i === 2)
                                           )
                                        {
                                                echo("</div>" .
                                                     "<div class=\"column\">");

                                                $this->i = 0;
                                        };
                                };
                        };

                        //entry has subentries and therefore is considered a title
                        if ($flexview_entry->subcount)

                                //set display string
                                $this->flexview->display =
                                        isset($this->flexview->object[$flexview_entry->index]["#data"]["url"]) ?

                                        "<a[ href=\"%action%\"]" .
                                          " class=\"title[ %class%]\">" .
                                        "[%icon% ]%name%" .
                                        "</a>" :

                                        "<a class=\"title[ %class%]\">" .
                                        "[%icon% ]%name%" .
                                        "</a>";

                        //entry stands alone
                        else

                                //set display string
                                $this->flexview->display =
                                        isset($this->flexview->object[$flexview_entry->index]["#data"]["url"]) ?

                                        "<a[ href=\"%action%\"]" .
                                          "[ class=\"%class%\"]>" .
                                        "[%icon% ]%name%" .
                                        "</a>" :

                                        "<a[ class=\"%class%\"]>" .
                                        "[%icon% ]%name%" .
                                        "</a>";

                        //display entry
                        $this->flexview->display($flexview_entry->index,
                                                 $flexview_entry->open);
                        return; //subentries are processed

                case CMS_FLEXVIEW_ENTRY_TYPE_END: //after last entry

                        //end sublevel
                        for (; $this->indentation > -1; $this->indentation--)
                        {
                                if ($this->indentation === 1) echo("</div>");
                                echo("</div>");
                        };
                };
        }
};

new menu_tab(); //instantiate class
?>