/*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

function thumbnail_init()
{
        var list   = document.getElementsByTagName("a");
        var object = null;
        var c      = list.length;
        var func   = function() { thumbnail(this); return false; };

        for (var i = 0; i < c; i++)
        {
                object = list.item(i);
                if (object.className.match(/(^| )thumbnail($| )/) &&
                    ((typeof photoswipe_active === "undefined") ||
                     (! object.hasAttribute("data-size"))))
                        object.onclick = func;
        };
};

function thumbnail(object)
{
        var body  = document.getElementsByTagName("body")[0];
        var image = new Image();
        var div1  = document.createElement("div");
        div1.setAttribute("class", "thumbnail-loading");
        body.appendChild(div1);

        image.onload = function()
        {
                var div2     = document.createElement("div");
                div2.setAttribute("class", "thumbnail");
                div2.onclick = function() { body.removeChild(div2); };

                var width    = this.width;
                var height   = this.height;
                var _width   = fx_window_width  - 50;
                var _height  = fx_window_height - 50;
                if (width  > _width)  { height *= _width  / width;  width  = _width;  };
                if (height > _height) { width  *= _height / height; height = _height; };

                var _image  = document.createElement("img");
                _image.setAttribute("src", this.src);
                _image.style.width      = width  + "px";
                _image.style.height     = height + "px";
                _image.style.marginLeft = "-" + (~~(width  / 2)) + "px";
                _image.style.marginTop  = "-" + (~~(height / 2)) + "px";

                body.removeChild(div1);

                div2.appendChild(_image);
                body.appendChild(div2);
        };

        image.onerror = function()
        {
                body.removeChild(div1);
        };

        image.src = object.getAttribute("href");
};