<?php

namespace cms;

//should never happen if software is installed correctly
if (! cms_load("directory"))                  return;

//do not display on empty selection
if (! defined("CMS_CONTENT_DIRECTORY_INDEX")) return;
if (! CMS_CONTENT_DIRECTORY_INDEX)            return;

//get display object containing the directory tree structure
$flexview = directory_get_flexview();

//set currently selected directory entry or nearest visible entry above
$index = directory_get_visible();
$flexview->set_index($index);

//set base entry of directory branch to be displayed
//all elements outside that branch are ignored
$flexview->set_base(0);

//set action to be executed on selection, usually an url
$flexview->set_action(CMS_ROOT_URL . "%index%" . cms_param());

//retrieve home page
reset($flexview->object[0]);
while (list($key) = each($flexview->object[0]))
{
        //skip indexes not representing an entry
        if (preg_match("/^#(?:data|parent)$/", $key)) continue;

        //exit if home page is currently being displayed
        if (streq($index, $key))                      return;

        //set display string
        $flexview->display = "<a[ href=\"%action%\"]" .
                                " class=\"base[ %class%]\">" .
                             "%name%" .
                             "</a>";

        //display home page
        $flexview->display($key);
        break;
};

//get list of elements connecting base entry with selected entry (inclusive)
$path = $flexview->get_path();

//set display string
$flexview->display = "<a[ href=\"%action%\"]" .
                       "[ class=\"%class%\"]>" .
                     "%name%" .
                     "</a>";

reset($path);
while (list(, $value) = each($path))
{
        //skip home page
        if ($value === $key) continue;

        //display the current entry
        $flexview->display($value);
};
?>