/****************************************
  stick menu
****************************************/

var func = (function()
{
    var object = document.getElementById("menu");
    var dummy  = document.createElement("DIV");
    var offset = 0;

    return function ()
    {
        if (object.className.match(/(^|\s)menu-sticky($|\s)/))
        {
            if (fx_window_width <= 640) return;

            offset = fx_offset_top(object, true);
            if (offset < fx_page_top())
            {
                dummy.style.height = fx_height(object, true) + "px";
                object.parentNode.insertBefore(dummy, object.nextSibling);
                object.className   = object.className.replace(/(?:^|\s)menu-sticky(?:$|\s)/, "menu-sticky-stick");
            };
        }
        else if (offset >= fx_page_top())
        {
            dummy.parentNode.removeChild(dummy);
            object.className = object.className.replace(/(?:^|\s)menu-sticky-stick(?:$|\s)/, "menu-sticky");
        };
    };
}) ();

fx_event_listen(window, "resize", func);
fx_event_listen(window, "scroll", func);

/****************************************
  top button
****************************************/

fx_event_listen(window, "scroll", function()
{
    var object = document.getElementById("goto-top");
    var flag   = fx_page_top() > 250;
    object.style.opacity = flag ? "1" : "0";
    object.style.right   = flag ? "0" : "-99999px";
});

/****************************************
  menu switch
****************************************/

function menu_switch(object)
{
    var hover = arguments.length > 1;
    var on    = object.className == "menu-switch-on";
    if (hover && on) return;
    var link  = object.parentNode.parentNode.getElementsByClassName("menu-switch-on");
    while (link.length) link[0].className = "menu-switch-off";
    if (! on) object.className = "menu-switch-on";
};

var func = function()
{
    var container = document.getElementById("menu");
    var link      = container.getElementsByClassName("container");
    var _link     = null;
    var _switch   = null;

    for (var i = 0; i < link.length; i++)
    {
        _link   = link[i];
        _switch = document.createElement("a");
        _switch.setAttribute("href",  "#");
        _switch.setAttribute("class", _link.className.match(/(^|\s)active($|\s)/) ?
                                      "menu-switch-on" : "menu-switch-off");
        fx_event_listen(_switch, "click", function(event) { event.preventDefault(); menu_switch(this); });
        fx_event_listen(_switch, "mouseenter", function() { menu_switch(this, true); });
        _link.parentElement.insertBefore(_switch, _link.nextSibling);
    };
};

func();