<?php

define("REFRESH_TIME", 600); //<-- update interval in seconds (default: 600)

define("CURRENT_PATH", dirname(__FILE__));
define("CACHE_FILE",   CURRENT_PATH . "/playlist.txt");
define("CACHE_TEMP",   CURRENT_PATH . "/playlist.tmp");
$path = str_replace("\\", "/", dirname($_SERVER["PHP_SELF"]));
$path = preg_replace_callback("/[^0-9A-Za-z\\x21\\x24\\x27-\\x2F\\x5F]/",
                              function($value) { return "%" . bin2hex($value[0]); },
                              $path);
define("BASE_URL",     "http://" . rawurlencode(getenv("HTTP_HOST")) . $path . "/");

//initial settings
ignore_user_abort(TRUE);
set_time_limit(30);
error_reporting(0);

//check cache
$time = time();

if (

//cache age lies within specified time frame
     ((int)filemtime(CACHE_FILE) > ($time - REFRESH_TIME))
     ||
     (

//or new list is already being created
       is_file(CACHE_FILE_NEW)
       &&

//and creating process was not aborted
       ((int)filemtime(CACHE_FILE_NEW) > ($time - REFRESH_TIME))
     )
   )
{
        //output playlist and stop
        @readfile(CACHE_FILE);
        exit();
};

//collect mp3 files
$url  = "http://" . getenv("HTTP_HOST") . dirname($_SERVER["PHP_SELF"]) . "/";
$list = array();
$dir  = opendir(CURRENT_PATH);

while (($file = readdir($dir)) !== FALSE)
{
        if (! is_file($file)) continue; //not a file, skip

        $type = strtolower(substr($file, -4));
        if ($type !== ".mp3") continue; //not a mp3, skip

        //add to list
        $list[] = $file;
};

closedir($dir);

//sort by file name
sort($list);

//create temp file
$file = @fopen(CACHE_TEMP, "wb");
if ($file === FALSE) die("Could not open file '" . CACHE_TEMP . "' for writing.");

//compose playlist
reset($list);
while (list(, $value) = each($list))
{
        $name  = htmlspecialchars(str_replace(array("|", "\n"), " ", substr($value, 0, -4)));
        $value = htmlspecialchars(rawurlencode($value));
        $entry = BASE_URL . "$value|$name\n";

        //write entry to playlist
        if (@fwrite($file, $entry) === FALSE)
                die("Could not write to file '" . CACHE_TEMP . "'.");

        //output
        echo($entry);
};

fclose($file);

//make temp file live playlist
if (is_file(CACHE_FILE))
{
        if (unlink(CACHE_FILE) === FALSE) die("Could not delete file '" . CACHE_FILE . "'.");
};

if (rename(CACHE_TEMP, CACHE_FILE) === FALSE)
        pl_error("Could not rename file '" . CACHE_TEMP . "' to '" . CACHE_FILE . "'.");

?>