<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< ENGLISH LANGUAGE PACKAGE >======================================================================
//-----------------------------------------------------------------------------------------------------
//nuos include
//.....................................................................................................
define("CMS_001",                       "Identified");
define("CMS_002",                       "Unauthorized, UserID: %s");
//language
//.....................................................................................................
define("CMS_LANGUAGE_SEPARATOR",        chr(31)); //ascii unit separator
//error
//.....................................................................................................
define("CMS_MSG_ERROR",                 "<strong style=\"COLOR:#ff0000\">" .
                                        "Error" .
                                        "</strong><br>");
define("CMS_MSG_DONE",                  "<strong>" .
                                        "OK" .
                                        "</strong><br>");
define("CMS_MSG_UNAVAILABLE",           "The service is not available.");
//common
//.....................................................................................................
define("CMS_L_USER_ANONYMOUS",          "Guest");
define("CMS_L_NOSCRIPT",                "This application is not available or offers limited functionality, " .
                                        "because JavaScript is inactive or not supported by your web software.");
define("CMS_L_NOCOOKIE",                "This application is not available or offers limited functionality, " .
                                        "because cookies are inactive or not supported by your web software.");
define("CMS_L_NAME",                    "Name");
define("CMS_L_UNKNOWN",                 "Unknown");
define("CMS_L_PASSWORD",                "Password");
define("CMS_L_COLOR",                   "Color");
define("CMS_L_DESCRIPTION",             "Description");
define("CMS_L_EMAIL",                   "E-mail");
define("CMS_L_IMAGE",                   "Image");
define("CMS_L_URL",                     "Address");
define("CMS_L_LANGUAGE_DEFAULT",        "default");
define("CMS_L_DATE_FORMAT",             "Y-m-d");
define("CMS_L_TIME_FORMAT",             "H:i:s");
define("CMS_L_SHORT_TIME_FORMAT",       "H:i");
define("CMS_L_DECIMAL_SEPARATOR",       ".");
define("CMS_L_THOUSAND_SEPARATOR",      ",");

define("CMS_L_SUNDAY",                  "Sunday");
define("CMS_L_MONDAY",                  "Monday");
define("CMS_L_TUESDAY",                 "Tuesday");
define("CMS_L_WEDNESDAY",               "Wednesday");
define("CMS_L_THURSDAY",                "Thursday");
define("CMS_L_FRIDAY",                  "Friday");
define("CMS_L_SATURDAY",                "Saturday");

define("CMS_L_SUNDAY_ABBR",             "Sun");
define("CMS_L_MONDAY_ABBR",             "Mon");
define("CMS_L_TUESDAY_ABBR",            "Tues");
define("CMS_L_WEDNESDAY_ABBR",          "Wed");
define("CMS_L_THURSDAY_ABBR",           "Thurs");
define("CMS_L_FRIDAY_ABBR",             "Fri");
define("CMS_L_SATURDAY_ABBR",           "Sat");

define("CMS_L_JANUARY",                 "January");
define("CMS_L_FEBRUARY",                "February");
define("CMS_L_MARCH",                   "March");
define("CMS_L_APRIL",                   "April");
define("CMS_L_MAY",                     "May");
define("CMS_L_JUNE",                    "June");
define("CMS_L_JULY",                    "July");
define("CMS_L_AUGUST",                  "August");
define("CMS_L_SEPTEMBER",               "September");
define("CMS_L_OCTOBER",                 "October");
define("CMS_L_NOVEMBER",                "November");
define("CMS_L_DECEMBER",                "December");

define("CMS_L_JANUARY_ABBR",            "Jan");
define("CMS_L_FEBRUARY_ABBR",           "Feb");
define("CMS_L_MARCH_ABBR",              "Mar");
define("CMS_L_APRIL_ABBR",              "Apr");
define("CMS_L_MAY_ABBR",                "May");
define("CMS_L_JUNE_ABBR",               "Jun");
define("CMS_L_JULY_ABBR",               "Jul");
define("CMS_L_AUGUST_ABBR",             "Aug");
define("CMS_L_SEPTEMBER_ABBR",          "Sept");
define("CMS_L_OCTOBER_ABBR",            "Oct");
define("CMS_L_NOVEMBER_ABBR",           "Nov");
define("CMS_L_DECEMBER_ABBR",           "Dec");

define("CMS_L_ACCESS",                  "Access");
define("CMS_L_READ",                    "Read");
define("CMS_L_WRITE",                   "Write");
define("CMS_L_OPERATOR",                "Operator");
//common commands
//.....................................................................................................
define("CMS_L_COMMAND_ADD",             "New");
define("CMS_L_COMMAND_APPEND",          "Append");
define("CMS_L_COMMAND_BOTTOM",          "Bottom");
define("CMS_L_COMMAND_BUFFER",          "Buffer");
define("CMS_L_COMMAND_CANCEL",          "Cancel");
define("CMS_L_COMMAND_CLOSE",           "Close");
define("CMS_L_COMMAND_CONFIRM",         "OK");
define("CMS_L_COMMAND_CONNECT",         "Connect");
define("CMS_L_COMMAND_COPY",            "Copy");
define("CMS_L_COMMAND_CUT",             "Move");
define("CMS_L_COMMAND_DELETE",          "Delete");
define("CMS_L_COMMAND_EDIT",            "Edit");
define("CMS_L_COMMAND_END",             "End");
define("CMS_L_COMMAND_EXPORT",          "Export");
define("CMS_L_COMMAND_INSERT",          "Insert");
define("CMS_L_COMMAND_NEXT",            "Next");
define("CMS_L_COMMAND_PASTE",           "Paste");
define("CMS_L_COMMAND_PREVIOUS",        "Previous");
define("CMS_L_COMMAND_PRINT",           "Print");
define("CMS_L_COMMAND_REFRESH",         "Refresh");
define("CMS_L_COMMAND_SAVE",            "Save");
define("CMS_L_COMMAND_SHOW",            "Show");
define("CMS_L_COMMAND_START",           "Start");
define("CMS_L_COMMAND_TOP",             "Top");
//system
//-----------------------------------------------------------------------------------------------------
//comment
//.....................................................................................................
define("CMS_L_COMMENT_001", "Entry, ID: %d, Name: %s");
//common
//.....................................................................................................
define("CMS_L_COMMON_001", "SYSTEM MESSAGE");
define("CMS_L_COMMON_002", "%d sec ago");
define("CMS_L_COMMON_003", "%d min ago");
define("CMS_L_COMMON_004", "Yesterday, %s");
define("CMS_L_COMMON_005", "%s, %s");
define("CMS_L_COMMON_006", "%s, %d days ago, %s");
define("CMS_L_COMMON_007", "%d %s, %s");
define("CMS_L_COMMON_008", "Yes");
define("CMS_L_COMMON_009", "No");
define("CMS_L_COMMON_010", "Clearance");
define("CMS_L_COMMON_011", "Insertions");
define("CMS_L_COMMON_012", "in %d sec");
define("CMS_L_COMMON_013", "in %d min");
define("CMS_L_COMMON_014", "Tomorrow, %s");
define("CMS_L_COMMON_015", "%d hrs, %d min ago");
define("CMS_L_COMMON_016", "%s, in %d days, %s");
define("CMS_L_COMMON_017", "in %d hrs, %d min");
define("CMS_L_COMMON_018", "%d hrs ago");
define("CMS_L_COMMON_019", "in %d hrs");
//content_pool
//.....................................................................................................
define("CMS_L_CONTENT_POOL_001", "New entry");
//core
//.....................................................................................................
define("CMS_L_CORE_001", "User %s has logged in.");
define("CMS_L_CORE_002", "User %s has logged off.");
define("CMS_L_CORE_003", "User %s enters channel %s.");
define("CMS_L_CORE_004", "User %s exits channel %s.");
define("CMS_L_CORE_005", "Channel %s has been opened.");
define("CMS_L_CORE_006", "The settings of channel %s have been saved.");
define("CMS_L_CORE_007", "Channel %s has been closed.");
define("CMS_L_CORE_008", "The profile has been saved.");
define("CMS_L_CORE_009", "User %s in channel %s is now %s.");
define("CMS_L_CORE_010", "Administrator");
define("CMS_L_CORE_011", "Operator");
define("CMS_L_CORE_012", "absent");
define("CMS_L_CORE_013", "mute");
define("CMS_L_CORE_014", "banned");
define("CMS_L_CORE_015", "Spy");
define("CMS_L_CORE_016", "User %s in channel %s is no longer %s.");
define("CMS_L_CORE_017", "invisible");
//core_control
//.....................................................................................................
define("CMS_L_CORE_CONTROL_001", "Channels");
define("CMS_L_CORE_CONTROL_002", "Participants");
define("CMS_L_CORE_CONTROL_003", "Status");
define("CMS_L_CORE_CONTROL_004", "Administrator");
define("CMS_L_CORE_CONTROL_005", "Operator");
define("CMS_L_CORE_CONTROL_006", "Member");
define("CMS_L_CORE_CONTROL_007", "Guest");
define("CMS_L_CORE_CONTROL_008", "Permanent channels");
define("CMS_L_CORE_CONTROL_009", "Temporary channels");
define("CMS_L_CORE_CONTROL_010", "%d participants present");
define("CMS_L_CORE_CONTROL_011", "Password required");
define("CMS_L_CORE_CONTROL_012", "Click on <em>Connect</em> to enter channel %s.");
define("CMS_L_CORE_CONTROL_013", "A password is required to enter this channel.");
define("CMS_L_CORE_CONTROL_014", "You have been banned from channel %s.");
define("CMS_L_CORE_CONTROL_015", "Edit channel");
define("CMS_L_CORE_CONTROL_016", "Delete channel");
define("CMS_L_CORE_CONTROL_017", "Create channel");
define("CMS_L_CORE_CONTROL_018", "Permanent channel");
define("CMS_L_CORE_CONTROL_019", "The selected channel is not available.");
define("CMS_L_CORE_CONTROL_020", "Click on <em>Delete</em> to close channel %s.");
define("CMS_L_CORE_CONTROL_021", "Photo");
define("CMS_L_CORE_CONTROL_022", "The selected user is not available.");
define("CMS_L_CORE_CONTROL_023", "Edit profile");
define("CMS_L_CORE_CONTROL_024", "Delete profile");
define("CMS_L_CORE_CONTROL_025", "Command");
define("CMS_L_CORE_CONTROL_026", "Set for:");
define("CMS_L_CORE_CONTROL_027", "Revoke for:");
define("CMS_L_CORE_CONTROL_028", "Spy");
define("CMS_L_CORE_CONTROL_029", "Invisible");
define("CMS_L_CORE_CONTROL_030", "Absent");
define("CMS_L_CORE_CONTROL_031", "Mute");
define("CMS_L_CORE_CONTROL_032", "Banned");
define("CMS_L_CORE_CONTROL_033", "User");
define("CMS_L_CORE_CONTROL_034", "Channel");
define("CMS_L_CORE_CONTROL_035", "Private message");
define("CMS_L_CORE_CONTROL_036", "Recipient");
define("CMS_L_CORE_CONTROL_037", "Message text");
define("CMS_L_CORE_CONTROL_038", "Send");
define("CMS_L_CORE_CONTROL_039", "There are no available recipients.");
define("CMS_L_CORE_CONTROL_040", "Please note that you need to have the proper authorization " .
                                 "to execute a command on the respective users and channels");
define("CMS_L_CORE_CONTROL_041", "Profile");
define("CMS_L_CORE_CONTROL_042", "Profile text");
define("CMS_L_CORE_CONTROL_043", "Upload photo");
define("CMS_L_CORE_CONTROL_044", "To transmit a photo, you require an image file (GIF, JPG, PNG) " .
                                 "with a maximum size of 200 KB.");
define("CMS_L_CORE_CONTROL_045", "Select profile");
define("CMS_L_CORE_CONTROL_046", "The selected profile is not available.");
define("CMS_L_CORE_CONTROL_047", "Administrator");
define("CMS_L_CORE_CONTROL_048", "Specify a name for the channel to be created. " .
                                 "If the channel already exists, a connection attempt will be made.");
define("CMS_L_CORE_CONTROL_049", "Apply");
define("CMS_L_CORE_CONTROL_050", "Create");
define("CMS_L_CORE_CONTROL_051", "Option");
//desktop
//.....................................................................................................
define("CMS_L_DESKTOP_001", "In-box");
define("CMS_L_DESKTOP_002", "Appointments");
define("CMS_L_DESKTOP_003", "Addresses");
//directory
//.....................................................................................................
define("CMS_L_DIRECTORY_002", "Start");
//flexview
//.....................................................................................................
define("CMS_L_FLEXVIEW_001", "(Empty)");
define("CMS_L_FLEXVIEW_002", "Start");
//forum
//.....................................................................................................
define("CMS_L_FORUM_001", "New message");
define("CMS_L_FORUM_002", "Dear %s,\n\n" .
                          "you have received a reply to your message \"%s\" " .
                          "on the bulletin board of %s at %s");
define("CMS_L_FORUM_003", "Enter one or more search keys.");
define("CMS_L_FORUM_004", "There are no applicable entries.");
define("CMS_L_FORUM_005", "%s, %s, %d hits");
define("CMS_L_FORUM_006", "There are no entries at present.");
define("CMS_L_FORUM_007", "Search: \"%s\"");
define("CMS_L_FORUM_008", "Entry, ID: %d, Title: \"%s\", Name: %s");
//ifc
//.....................................................................................................
define("CMS_L_IFC_001", "This application is inactive.");
define("CMS_L_IFC_002", "Close");
define("CMS_L_IFC_003", "Window is closing...");
define("CMS_L_IFC_004", "Expand/restore");
define("CMS_L_IFC_005", "Invalid value");
define("CMS_L_IFC_006", "Desktop");
define("CMS_L_IFC_007", "Log out");
define("CMS_L_IFC_008", "Website");
//log
//.....................................................................................................
define("CMS_L_LOG_001", "No records found.");
define("CMS_L_LOG_002", "Sum: %d (100,0%%)");
define("CMS_L_LOG_003", "%d Line(s), %d Column(s); execution time: %01.10f seconds");
define("CMS_L_LOG_004", "%d Line(s) edited; execution time: %01.10f seconds");
//media_type
//.....................................................................................................
define("CMS_L_MEDIA_TYPE_001", "(Automatic)");
define("CMS_L_MEDIA_TYPE_002", "The resource <em>%s</em> is loading...");
define("CMS_L_MEDIA_TYPE_003", "The resource <a href=\"%s\"><em>%s</em></a> cannot be displayed. " .
                               "Additional software may be required for support.");
//permission
//.....................................................................................................
define("CMS_L_PERMISSION_001", "Administrator");
define("CMS_L_PERMISSION_002", "Main administrative account");
define("CMS_L_PERMISSION_003", "Authorization for unidentified users");
define("CMS_L_PERMISSION_004", "Registration");
define("CMS_L_PERMISSION_005", "Authorization defaults for user registration");
//pop
//.....................................................................................................
define("CMS_L_POP_001", "The host %s is not available.");
//rss_parser
//.....................................................................................................
define("CMS_L_RSS_PARSER_001", "Publication date");
define("CMS_L_RSS_PARSER_002", "Last build date");
define("CMS_L_RSS_PARSER_003", "Generator");
define("CMS_L_RSS_PARSER_004", "Managing editor");
define("CMS_L_RSS_PARSER_005", "Web master");
define("CMS_L_RSS_PARSER_006", "Comments");
define("CMS_L_RSS_PARSER_007", "By");
define("CMS_L_RSS_PARSER_008", "Source");
define("CMS_L_RSS_PARSER_009", "Permanent link");
//smtp
//.....................................................................................................
define("CMS_L_SMTP_001", "The host %s is not available.");
//template
//.....................................................................................................
define("CMS_L_TEMPLATE_001", "New entry");
define("CMS_L_TEMPLATE_002", "Preview");
define("CMS_L_TEMPLATE_003", "Plugin");
define("CMS_L_TEMPLATE_004", "Conditional blocks");
define("CMS_L_TEMPLATE_005", "Links");
define("CMS_L_TEMPLATE_006", "Plugins");
define("CMS_L_TEMPLATE_007", "Texts");
define("CMS_L_TEMPLATE_008", "Downloads");
define("CMS_L_TEMPLATE_009", "Images");
define("CMS_L_TEMPLATE_010", "Thumbnails");
define("CMS_L_TEMPLATE_011", "Templates");
define("CMS_L_TEMPLATE_012", "Full mode");
define("CMS_L_TEMPLATE_013", "Output view");
define("CMS_L_TEMPLATE_014", "Document ID");
define("CMS_L_TEMPLATE_015", "Layout mode");
define("CMS_L_TEMPLATE_016", "Content mode");
define("CMS_L_TEMPLATE_017", "[+] Zoom");
define("CMS_L_TEMPLATE_018", "Swap");
define("CMS_L_TEMPLATE_019", "Activate");
define("CMS_L_TEMPLATE_020", "Repeat");
define("CMS_L_TEMPLATE_021", "Media");
define("CMS_L_TEMPLATE_022", "Position shift");
define("CMS_L_TEMPLATE_023", "Alternative blocks");
define("CMS_L_TEMPLATE_024", "Insert above");
define("CMS_L_TEMPLATE_025", "Insert below");
define("CMS_L_TEMPLATE_026", "Delete above");
define("CMS_L_TEMPLATE_027", "Delete below");
define("CMS_L_TEMPLATE_028", "Groups");
define("CMS_L_TEMPLATE_029", "Text");
define("CMS_L_TEMPLATE_030", "Download");
define("CMS_L_TEMPLATE_031", "Image");
define("CMS_L_TEMPLATE_032", "Thumbnail");
define("CMS_L_TEMPLATE_033", "Media");
define("CMS_L_TEMPLATE_034", "Template");
define("CMS_L_TEMPLATE_035", "Group");
define("CMS_L_TEMPLATE_036", "Repetition");
define("CMS_L_TEMPLATE_037", "Position shift");
define("CMS_L_TEMPLATE_039", "Link");
define("CMS_L_TEMPLATE_040", "Share");
define("CMS_L_TEMPLATE_041", "Reference");
define("CMS_L_TEMPLATE_042", "Referenced content");
define("CMS_L_TEMPLATE_043", "Value");
define("CMS_L_TEMPLATE_044", "Values");
define("CMS_L_TEMPLATE_045", "Double-click to edit, " .
                             "click + drag to move, " .
                             "Shift/Ctrl/Alt + click + drag to copy. " .
                             "Touch the icon and move mouse right to open context menu.");
define("CMS_L_TEMPLATE_046", "Shift/Ctrl/Alt + click to display this range exclusively.");
define("CMS_L_TEMPLATE_047", "Debug");
define("CMS_L_TEMPLATE_048", "Functions");
define("CMS_L_TEMPLATE_049", "Modified");
define("CMS_L_TEMPLATE_050", "(Empty)");
//module
//-----------------------------------------------------------------------------------------------------
//mod_blog
//.....................................................................................................
define("CMS_L_MOD_BLOG_001", "More articles");
define("CMS_L_MOD_BLOG_002", "Write article");
define("CMS_L_MOD_BLOG_003", "Title");
define("CMS_L_MOD_BLOG_004", "Tags");
define("CMS_L_MOD_BLOG_005", "Save and view");
define("CMS_L_MOD_BLOG_006", "The article has been deleted.");
define("CMS_L_MOD_BLOG_007", "The article has been saved.");
define("CMS_L_MOD_BLOG_008", "The article has been created.");
define("CMS_L_MOD_BLOG_009", "Edit article");
define("CMS_L_MOD_BLOG_010", "Read on");
define("CMS_L_MOD_BLOG_011", "To overview");
define("CMS_L_MOD_BLOG_012", "The article could not be deleted.");
define("CMS_L_MOD_BLOG_013", "The article could not be saved.");
define("CMS_L_MOD_BLOG_014", "The article could not be created.");
define("CMS_L_MOD_BLOG_015", "%d articles");
define("CMS_L_MOD_BLOG_016", "Edit code");
define("CMS_L_MOD_BLOG_017", "The code has been saved.");
define("CMS_L_MOD_BLOG_018", "The code could not be saved.");
define("CMS_L_MOD_BLOG_019", "Archive");
define("CMS_L_MOD_BLOG_020", "Tags");
define("CMS_L_MOD_BLOG_021", "Show all");
define("CMS_L_MOD_BLOG_022", "Publication");
define("CMS_L_MOD_BLOG_023", "Now");
define("CMS_L_MOD_BLOG_024", "Disabled");
define("CMS_L_MOD_BLOG_025", "Day");
define("CMS_L_MOD_BLOG_026", "Month");
define("CMS_L_MOD_BLOG_027", "Year");
define("CMS_L_MOD_BLOG_028", "Time");
define("CMS_L_MOD_BLOG_029", "Do you really want to remove this article?");
define("CMS_L_MOD_BLOG_030", "RSS feed");
define("CMS_L_MOD_BLOG_031", "Blog");
define("CMS_L_MOD_BLOG_032", "Placeholders");
define("CMS_L_MOD_BLOG_033", "by %s");
define("CMS_L_MOD_BLOG_034", "Author");
define("CMS_L_MOD_BLOG_035", "User name");
define("CMS_L_MOD_BLOG_036", "The requested article is not available (anymore).");
define("CMS_L_MOD_BLOG_037", "Highlight");
define("CMS_L_MOD_BLOG_038", "%d comment(s)");
//-----------------------------------------------------------------------------------------------------
//mod_comment
//.....................................................................................................
define("CMS_L_MOD_COMMENT_001", "Please specify your name.");
define("CMS_L_MOD_COMMENT_002", "Please specify a valid e-mail address.");
define("CMS_L_MOD_COMMENT_003", "More comments");
define("CMS_L_MOD_COMMENT_004", "Your comment contains no text.");
define("CMS_L_MOD_COMMENT_005", "Please specify a name.");
define("CMS_L_MOD_COMMENT_006", "The comment contains no text.");
define("CMS_L_MOD_COMMENT_007", "Edit comment");
define("CMS_L_MOD_COMMENT_008", "Will not be published.");
define("CMS_L_MOD_COMMENT_009", "Homepage URL");
define("CMS_L_MOD_COMMENT_010", "Comment");
define("CMS_L_MOD_COMMENT_011", "Write comment");
define("CMS_L_MOD_COMMENT_012", "%d comment(s)");
define("CMS_L_MOD_COMMENT_013", "Do you want to delete the comment?");
define("CMS_L_MOD_COMMENT_014", "says");
define("CMS_L_MOD_COMMENT_015", "Disable");
define("CMS_L_MOD_COMMENT_016", "Enable");
define("CMS_L_MOD_COMMENT_017", "ID: %s");
define("CMS_L_MOD_COMMENT_018", "Homepage");
define("CMS_L_MOD_COMMENT_019", "%d rating(s)");
define("CMS_L_MOD_COMMENT_020", "Spam");
define("CMS_L_MOD_COMMENT_021", "Do you want to rate the comment as spam and delete it?");
define("CMS_L_MOD_COMMENT_022", "Your comment could not be saved.");
define("CMS_L_MOD_COMMENT_023", "The comment could not be saved.");
define("CMS_L_MOD_COMMENT_024", "The command could not be executed.");
define("CMS_L_MOD_COMMENT_025", "Rate positively");
define("CMS_L_MOD_COMMENT_026", "Rate negatively");
define("CMS_L_MOD_COMMENT_027", "New comment (Approval required)");
define("CMS_L_MOD_COMMENT_028", "New comment");
define("CMS_L_MOD_COMMENT_029", "You received a new comment at %s requiring approval:\n\n%s\n\n" .
                                "Click here to approve the comment:\n%s\n\n" .
                                "Click here to reject the comment:\n%s\n\n" .
                                "Click here, if the comment resembles spam:\n%s");
define("CMS_L_MOD_COMMENT_030", "You received a new comment at %s :\n\n%s\n\n" .
                                "Click here to hide the comment:\n%s\n\n" .
                                "Click here to reject the comment:\n%s\n\n" .
                                "Click here, if the comment resembles spam:\n%s");
define("CMS_L_MOD_COMMENT_031", "Your comment has been saved.");
define("CMS_L_MOD_COMMENT_032", "Your comment has been saved and will not appear " .
                                "before being approved by a moderator.");
define("CMS_L_MOD_COMMENT_033", "The changes have been saved.");
define("CMS_L_MOD_COMMENT_034", "Do you want to rate the comment negatively?");
define("CMS_L_MOD_COMMENT_035", "Do you want to rate the comment positively?");
define("CMS_L_MOD_COMMENT_036", "Rate negatively");
define("CMS_L_MOD_COMMENT_037", "Rate positively");
define("CMS_L_MOD_COMMENT_038", "Your comment has been identified as spam.");
define("CMS_L_MOD_COMMENT_039", "Spam probability");
define("CMS_L_MOD_COMMENT_040", "An identical comment already exists.");
define("CMS_L_MOD_COMMENT_041", "Approval of your comment");
define("CMS_L_MOD_COMMENT_042", "Your comment at %s has just been approved.");
define("CMS_L_MOD_COMMENT_043", "CAPTCHA");
define("CMS_L_MOD_COMMENT_044", "Please enter the characters from the image.");
define("CMS_L_MOD_COMMENT_045", "The CAPTCHA code is invalid.");
//mod_content
//.....................................................................................................
define("CMS_L_MOD_CONTENT_001", "Access: \"%s\"");
define("CMS_L_MOD_CONTENT_002", "The buffer is empty.");
define("CMS_L_MOD_CONTENT_003", "Apply changes");
define("CMS_L_MOD_CONTENT_004", "Discard changes");
define("CMS_L_MOD_CONTENT_005", "Swap");
define("CMS_L_MOD_CONTENT_006", "Text analysis");
define("CMS_L_MOD_CONTENT_007", "Backend");
define("CMS_L_MOD_CONTENT_008", "Desktop");
define("CMS_L_MOD_CONTENT_009", "Repetitions");
define("CMS_L_MOD_CONTENT_010", "Position shift");
define("CMS_L_MOD_CONTENT_011", "Insert above");
define("CMS_L_MOD_CONTENT_012", "Insert below");
define("CMS_L_MOD_CONTENT_013", "The input is invalid.");
define("CMS_L_MOD_CONTENT_014", "Content pool");
define("CMS_L_MOD_CONTENT_015", "Log out");
define("CMS_L_MOD_CONTENT_016", "Undo");
define("CMS_L_MOD_CONTENT_017", "Redo");
//mod_desktop
//.....................................................................................................
define("CMS_L_MOD_DESKTOP_001", "New object");
define("CMS_L_MOD_DESKTOP_002", "Upcoming appointments");
define("CMS_L_MOD_DESKTOP_003", "Link");
define("CMS_L_MOD_DESKTOP_004", "Memo");
define("CMS_L_MOD_DESKTOP_005", "Appointment");
define("CMS_L_MOD_DESKTOP_006", "Address");
define("CMS_L_MOD_DESKTOP_007", "Folder");
define("CMS_L_MOD_DESKTOP_008", "Mailbox");
define("CMS_L_MOD_DESKTOP_009", "Rename");
define("CMS_L_MOD_DESKTOP_010", "There are no recipients.");
define("CMS_L_MOD_DESKTOP_011", "Copy to...");
define("CMS_L_MOD_DESKTOP_012", "Recipient");
define("CMS_L_MOD_DESKTOP_013", "Extract address");
define("CMS_L_MOD_DESKTOP_014", "Current password");
define("CMS_L_MOD_DESKTOP_015", "New password");
define("CMS_L_MOD_DESKTOP_016", "Password confirmation");
define("CMS_L_MOD_DESKTOP_017", "Move");
define("CMS_L_MOD_DESKTOP_018", "Favorites");
define("CMS_L_MOD_DESKTOP_019", "In-box");
define("CMS_L_MOD_DESKTOP_020", "Messenger");
define("CMS_L_MOD_DESKTOP_021", "Address book");
define("CMS_L_MOD_DESKTOP_022", "Date book");
define("CMS_L_MOD_DESKTOP_023", "Create %s");
define("CMS_L_MOD_DESKTOP_024", "START");
define("CMS_L_MOD_DESKTOP_025", "Time zone");
define("CMS_L_MOD_DESKTOP_026", "Settings");
define("CMS_L_MOD_DESKTOP_027", "Change password");
define("CMS_L_MOD_DESKTOP_028", "Other settings");
define("CMS_L_MOD_DESKTOP_029", "Backend");
define("CMS_L_MOD_DESKTOP_030", "Website");
//mod_download
//.....................................................................................................
define("CMS_L_MOD_DOWNLOAD_001", "File download");
define("CMS_L_MOD_DOWNLOAD_002", "If the download does not start after 3 seconds, " .
                                 "<a href=\"%s\">click here</a>.");
define("CMS_L_MOD_DOWNLOAD_003", "Please save the file locally before opening. " .
                                 "You may <a href=\"javascript:window.close();\">close this window</a> after download starts.");
define("CMS_L_MOD_DOWNLOAD_004", "Title");
define("CMS_L_MOD_DOWNLOAD_005", "Size");
define("CMS_L_MOD_DOWNLOAD_006", "Format");
define("CMS_L_MOD_DOWNLOAD_007", "The requested file ist not available.");
define("CMS_L_MOD_DOWNLOAD_008", "File download: \"%s\"");
//mod_forum
//.....................................................................................................
define("CMS_L_MOD_FORUM_001", "%s wrote on %s, %s at %s");
define("CMS_L_MOD_FORUM_002", "RE: ");
define("CMS_L_MOD_FORUM_003", "Create channel");
define("CMS_L_MOD_FORUM_004", "Search");
define("CMS_L_MOD_FORUM_005", "Search results");
define("CMS_L_MOD_FORUM_006", "The optionally specified e-mail address is used " .
                              "to inform you about replies and will not be displayed.");
define("CMS_L_MOD_FORUM_007", "Recent messages");
define("CMS_L_MOD_FORUM_008", "Top of page");
define("CMS_L_MOD_FORUM_009", "Send reply notification by e-mail");
define("CMS_L_MOD_FORUM_010", "Write message");
define("CMS_L_MOD_FORUM_011", "Do you want to delete the message \"%s\"?");
define("CMS_L_MOD_FORUM_012", "Directory");
define("CMS_L_MOD_FORUM_013", "Please specify a valid e-mail address or leave the input box blank.");
define("CMS_L_MOD_FORUM_014", "Title");
define("CMS_L_MOD_FORUM_015", "Preview");
define("CMS_L_MOD_FORUM_016", "Message text");
define("CMS_L_MOD_FORUM_017", "Please specify a title.");
define("CMS_L_MOD_FORUM_018", "Your message contains no text.");
define("CMS_L_MOD_FORUM_019", "Please specify your name.");
define("CMS_L_MOD_FORUM_020", "%d hits");
define("CMS_L_MOD_FORUM_021", "%d replies");
define("CMS_L_MOD_FORUM_022", "Navigation bar");
define("CMS_L_MOD_FORUM_023", "Hide replies");
define("CMS_L_MOD_FORUM_024", "Show replies");
define("CMS_L_MOD_FORUM_025", "Next message");
define("CMS_L_MOD_FORUM_026", "Previous message");
//mod_identification
//.....................................................................................................
define("CMS_L_MOD_IDENTIFICATION_001", "You are currently logged in as %s (%s).");
define("CMS_L_MOD_IDENTIFICATION_002", "User name");
define("CMS_L_MOD_IDENTIFICATION_003", "Logoff");
define("CMS_L_MOD_IDENTIFICATION_004", "Login");
define("CMS_L_MOD_IDENTIFICATION_005", "Log on");
define("CMS_L_MOD_IDENTIFICATION_006", "Forgot password?");
define("CMS_L_MOD_IDENTIFICATION_007", "You are being redirected to the login prompt. " .
                                       "<a href=\"%s\">Click here</a>, " .
                                       "if the request is not processed by your web software.");
define("CMS_L_MOD_IDENTIFICATION_008", "Proceed as current user");
define("CMS_L_MOD_IDENTIFICATION_009", "Set new password");
define("CMS_L_MOD_IDENTIFICATION_010", "Please enter your user name.");
define("CMS_L_MOD_IDENTIFICATION_011", "The specified user does not exist or has no valid e-mail address.");
define("CMS_L_MOD_IDENTIFICATION_012", "A message has been sent to the associated e-mail address, " .
                                       "by which you can set a new password.");
define("CMS_L_MOD_IDENTIFICATION_013", "The characters from the image are incorrect. " .
                                       "Please try again.");
define("CMS_L_MOD_IDENTIFICATION_014", "CAPTCHA");
define("CMS_L_MOD_IDENTIFICATION_015", "Please enter the characters from the image.");
define("CMS_L_MOD_IDENTIFICATION_016", "In order to overwrite the password belonging to the user %s " .
                                       "at %s, open the address\n%s\nwithin one hour.\n\n" .
                                       "In case you have not requested a new password, " .
                                       "you can safely ignore this message.");
define("CMS_L_MOD_IDENTIFICATION_017", "The operation is invalid or expired.");
define("CMS_L_MOD_IDENTIFICATION_018", "A new password has been set.");
define("CMS_L_MOD_IDENTIFICATION_019", "The password has been sent to the associated e-mail address.");
define("CMS_L_MOD_IDENTIFICATION_020", "The new password could not be sent to the associated e-mail address.");
define("CMS_L_MOD_IDENTIFICATION_021", "A new password has been set for the user %s at %s.\n\n" .
                                       "\tKennwort:\t%s");
define("CMS_L_MOD_IDENTIFICATION_022", "Your new password");
//mod_image
//.....................................................................................................
define("CMS_L_MOD_IMAGE_001", "The image is not available.");
//mod_mailform
//.....................................................................................................
define("CMS_L_MOD_MAILFORM_001", "Transmission confirmation");
define("CMS_L_MOD_MAILFORM_002", "The form has been transmitted.");
define("CMS_L_MOD_MAILFORM_003", "Send");
define("CMS_L_MOD_MAILFORM_004", "Form: \"%s\"");
define("CMS_L_MOD_MAILFORM_005", "Field");
define("CMS_L_MOD_MAILFORM_006", "Value");
define("CMS_L_MOD_MAILFORM_008", "Please revise the input marked in " .
                                 "<span style=\"COLOR:#ff0000\">" .
                                 "red" .
                                 "</span>.");
define("CMS_L_MOD_MAILFORM_009", "CAPTCHA");
define("CMS_L_MOD_MAILFORM_010", "Please enter the characters from the image.");
define("CMS_L_MOD_MAILFORM_011", "Forms");
define("CMS_L_MOD_MAILFORM_012", "The form could not be transmitted.");
//mod_messenger
//.....................................................................................................
define("CMS_L_MOD_MESSENGER_001", "<p>" .
                                  "A connection is not possible at this time, " .
                                  "because your ID is in use." .
                                  "</p>" .
                                  "<p>" .
                                  "<strong>" .
                                  "Please be patient..." .
                                  "</strong>" .
                                  "</p>" .
                                  "<p>" .
                                  "You will be automatically redirected to the login " .
                                  "when your ID becomes clear again." .
                                  "</p>");
define("CMS_L_MOD_MESSENGER_002", "private");
define("CMS_L_MOD_MESSENGER_003", "The selected name is already taken.");
define("CMS_L_MOD_MESSENGER_004", "The connection has been closed.");
define("CMS_L_MOD_MESSENGER_005", "%s says something.");
define("CMS_L_MOD_MESSENGER_006", "Sounds");
define("CMS_L_MOD_MESSENGER_007", "%d users are active in %d channels.");
define("CMS_L_MOD_MESSENGER_008", "Specify a name to participate under.");
define("CMS_L_MOD_MESSENGER_009", "AutoScroll");
define("CMS_L_MOD_MESSENGER_010", "Login, Name: \"%s\"");
define("CMS_L_MOD_MESSENGER_011", "AutoFocus");
define("CMS_L_MOD_MESSENGER_012", "Control");
define("CMS_L_MOD_MESSENGER_013", "Log on here, if you have a user account.");
define("CMS_L_MOD_MESSENGER_014", "Live-Messenger");
define("CMS_L_MOD_MESSENGER_015", "Click here to log on again.");
define("CMS_L_MOD_MESSENGER_016", "AutoAFK");
define("CMS_L_MOD_MESSENGER_017", "Log out");
define("CMS_L_MOD_MESSENGER_018", "Monkey");
define("CMS_L_MOD_MESSENGER_019", "<p>" .
                                  "A connection is not possible at this time." .
                                  "</p>" .
                                  "<strong>" .
                                  "You have been excluded from participation " .
                                  "or there is a technical problem." .
                                  "</strong>" .
                                  "</p>");
define("CMS_L_MOD_MESSENGER_020", "Clear display");
//mod_messenger_online
//.....................................................................................................
define("CMS_L_MOD_MESSENGER_ONLINE_001", "(%d online)");
//mod_profile
//.....................................................................................................
define("CMS_L_MOD_PROFILE_001", "(No value)");
define("CMS_L_MOD_PROFILE_002", "User credentials");
define("CMS_L_MOD_PROFILE_003", "Personal data");
define("CMS_L_MOD_PROFILE_004", "Contact information");
define("CMS_L_MOD_PROFILE_005", "Banking details");
define("CMS_L_MOD_PROFILE_006", "Credit card information");
define("CMS_L_MOD_PROFILE_007", "Miscellaneous");
define("CMS_L_MOD_PROFILE_008", "Identifier");
define("CMS_L_MOD_PROFILE_009", "User name");
define("CMS_L_MOD_PROFILE_010", "Custom");
define("CMS_L_MOD_PROFILE_011", "Extended information");
define("CMS_L_MOD_PROFILE_012", "Organization");
define("CMS_L_MOD_PROFILE_013", "Forename");
define("CMS_L_MOD_PROFILE_014", "Surname");
define("CMS_L_MOD_PROFILE_015", "Street");
define("CMS_L_MOD_PROFILE_016", "Zip");
define("CMS_L_MOD_PROFILE_017", "City");
define("CMS_L_MOD_PROFILE_018", "Country");
define("CMS_L_MOD_PROFILE_019", "Phone");
define("CMS_L_MOD_PROFILE_020", "Phone 2");
define("CMS_L_MOD_PROFILE_021", "Cell phone");
define("CMS_L_MOD_PROFILE_022", "Fax");
define("CMS_L_MOD_PROFILE_023", "Account number");
define("CMS_L_MOD_PROFILE_024", "Bank");
define("CMS_L_MOD_PROFILE_025", "Bank code");
define("CMS_L_MOD_PROFILE_026", "Account holder");
define("CMS_L_MOD_PROFILE_027", "Credit card number");
define("CMS_L_MOD_PROFILE_028", "Credit institution");
define("CMS_L_MOD_PROFILE_029", "Credit card holder");
define("CMS_L_MOD_PROFILE_030", "Expiry");
define("CMS_L_MOD_PROFILE_031", "Remark");
define("CMS_L_MOD_PROFILE_032", "Password and password confirmation do not match.");
define("CMS_L_MOD_PROFILE_033", "The password must be at least 4 characters long.");
define("CMS_L_MOD_PROFILE_034", "The changes have been saved.");
define("CMS_L_MOD_PROFILE_035", "Password confirmation");
define("CMS_L_MOD_PROFILE_036", "Please revise the input marked in " .
                                "<span style=\"COLOR:#ff0000\">" .
                                "red" .
                                "</span>.");
define("CMS_L_MOD_PROFILE_037", "CAPTCHA");
define("CMS_L_MOD_PROFILE_038", "Please enter the characters from the image.");
define("CMS_L_MOD_PROFILE_039", "Registration");
define("CMS_L_MOD_PROFILE_040", "Create account");
define("CMS_L_MOD_PROFILE_041", "Registration confirmation");
define("CMS_L_MOD_PROFILE_042", "Thank you for registering at %s.\n\n" .
                                "\tUser name:\t%s\n\tPassword:\t%s\n\n" .
                                "Please confirm your registration within 24 hours " .
                                "by opening the address\n%s");
define("CMS_L_MOD_PROFILE_043", "The registration process has been completed. " .
                                "You are about to receive a confirmation message by e-mail " .
                                "that contains the code required to activate your account.");
define("CMS_L_MOD_PROFILE_044", "Please specify a valid e-mail address.");
define("CMS_L_MOD_PROFILE_045", "The user name is already taken. " .
                                "Please choose an alternative.");
define("CMS_L_MOD_PROFILE_046", "The characters from the image are incorrect. " .
                                "Please try again.");
define("CMS_L_MOD_PROFILE_047", "The activation code is invalid or expired.");
define("CMS_L_MOD_PROFILE_048", "Your user account has been activated.");
define("CMS_L_MOD_PROFILE_049", "Leave this field empty if you do not want to change the password.");
define("CMS_L_MOD_PROFILE_050", "Registration: \"%s\"");
define("CMS_L_MOD_PROFILE_051", "The field may not be empty.");
define("CMS_L_MOD_PROFILE_052", "An account using this e-mail address already exists.");
//mod_profile_data
//.....................................................................................................
define("CMS_L_MOD_PROFILE_DATA_001", "Phone");
define("CMS_L_MOD_PROFILE_DATA_002", "Phone 2");
define("CMS_L_MOD_PROFILE_DATA_003", "Cell phone");
define("CMS_L_MOD_PROFILE_DATA_004", "Fax");
//mod_rss
//.....................................................................................................
define("CMS_L_MOD_RSS_001", "NEW");
define("CMS_L_MOD_RSS_002", "Update");
define("CMS_L_MOD_RSS_003", "%d sec ago");
define("CMS_L_MOD_RSS_004", "%d min ago");
define("CMS_L_MOD_RSS_005", "%d hrs ago");
define("CMS_L_MOD_RSS_006", "%d days ago");
define("CMS_L_MOD_RSS_007", "Top");
//mod_search
//.....................................................................................................
define("CMS_L_MOD_SEARCH_001", "Search");
define("CMS_L_MOD_SEARCH_002", "Submit page");
define("CMS_L_MOD_SEARCH_003", "Only HTTP addresses are accepted.");
define("CMS_L_MOD_SEARCH_004", "Submit");
define("CMS_L_MOD_SEARCH_005", "Contents corresponding to your query are not available.");
define("CMS_L_MOD_SEARCH_006", "Further results corresponding to your query are not available.");
define("CMS_L_MOD_SEARCH_007", "More results");
define("CMS_L_MOD_SEARCH_008", "Address: %s \xE2\x80\x94 Date: %s \xE2\x80\x94 Score: %s");
define("CMS_L_MOD_SEARCH_009", "Page");
define("CMS_L_MOD_SEARCH_010", "Search through %s pages");
define("CMS_L_MOD_SEARCH_011", " \xE2\x80\x94 %d similar page(s)");
define("CMS_L_MOD_SEARCH_012", "All languages");
define("CMS_L_MOD_SEARCH_013", "Search term");
//interface
//-----------------------------------------------------------------------------------------------------
//ifc_content
//.....................................................................................................
define("CMS_L_IFC_CONTENT",     "Editor");
define("CMS_L_IFC_CONTENT_001", "Execution time");
define("CMS_L_IFC_CONTENT_002", "Dispatch information");
define("CMS_L_IFC_CONTENT_003", "Sender");
define("CMS_L_IFC_CONTENT_004", "Date");
define("CMS_L_IFC_CONTENT_005", "Event type");
define("CMS_L_IFC_CONTENT_006", "Status");
define("CMS_L_IFC_CONTENT_007", "Type");
define("CMS_L_IFC_CONTENT_008", "Summary");
define("CMS_L_IFC_CONTENT_009", "Writer");
define("CMS_L_IFC_CONTENT_010", "Updated");
define("CMS_L_IFC_CONTENT_011", "Directory");
define("CMS_L_IFC_CONTENT_012", "Keywords");
define("CMS_L_IFC_CONTENT_013", "Page template");
define("CMS_L_IFC_CONTENT_014", "Authorization");
define("CMS_L_IFC_CONTENT_015", "Editor");
define("CMS_L_IFC_CONTENT_016", "Date");
define("CMS_L_IFC_CONTENT_017", "Memo");
define("CMS_L_IFC_CONTENT_018", "Publication");
define("CMS_L_IFC_CONTENT_019", "Publisher");
define("CMS_L_IFC_CONTENT_020", "Date");
define("CMS_L_IFC_CONTENT_021", "New draft");
define("CMS_L_IFC_CONTENT_022", "My drafts");
define("CMS_L_IFC_CONTENT_023", "Data");
define("CMS_L_IFC_CONTENT_024", "Publications");
define("CMS_L_IFC_CONTENT_025", "Full view");
define("CMS_L_IFC_CONTENT_026", "(Empty)");
define("CMS_L_IFC_CONTENT_027", "Title");
define("CMS_L_IFC_CONTENT_028", "Text");
define("CMS_L_IFC_CONTENT_029", "Authorize and lock (document)");
define("CMS_L_IFC_CONTENT_030", "Documents");
define("CMS_L_IFC_CONTENT_031", "Draft");
define("CMS_L_IFC_CONTENT_032", "Document");
define("CMS_L_IFC_CONTENT_033", "Publication");
define("CMS_L_IFC_CONTENT_034", "Original");
define("CMS_L_IFC_CONTENT_035", "Duplicate");
define("CMS_L_IFC_CONTENT_036", "Copy");
define("CMS_L_IFC_CONTENT_037", "My draft duplicates");
define("CMS_L_IFC_CONTENT_038", "Draft duplicates");
define("CMS_L_IFC_CONTENT_039", "Drafts");
define("CMS_L_IFC_CONTENT_040", "Publication");
define("CMS_L_IFC_CONTENT_041", "Directory entry");
define("CMS_L_IFC_CONTENT_042", "Publication");
define("CMS_L_IFC_CONTENT_043", "RSS channel");
define("CMS_L_IFC_CONTENT_044", "Function");
define("CMS_L_IFC_CONTENT_045", "There are no authorized recipients.");
define("CMS_L_IFC_CONTENT_046", "Forward");
define("CMS_L_IFC_CONTENT_047", "Author");
define("CMS_L_IFC_CONTENT_048", "Recipient");
define("CMS_L_IFC_CONTENT_049", "Create draft");
define("CMS_L_IFC_CONTENT_050", "Clear cache");
define("CMS_L_IFC_CONTENT_051", "Duplicate");
define("CMS_L_IFC_CONTENT_052", "Copy");
define("CMS_L_IFC_CONTENT_053", "Remove authorization and lock (draft)");
define("CMS_L_IFC_CONTENT_054", "Withdrawal");
define("CMS_L_IFC_CONTENT_055", "In-box");
define("CMS_L_IFC_CONTENT_056", "My draft copies");
define("CMS_L_IFC_CONTENT_057", "Draft copies");
define("CMS_L_IFC_CONTENT_058", "RSS channel of %s");
define("CMS_L_IFC_CONTENT_059", "Document copies");
define("CMS_L_IFC_CONTENT_060", "Lines/Page");
define("CMS_L_IFC_CONTENT_061", "RSS feed");
define("CMS_L_IFC_CONTENT_062", "Category"); //rss
define("CMS_L_IFC_CONTENT_063", "Rename Category");
define("CMS_L_IFC_CONTENT_064", "Preset selection");
define("CMS_L_IFC_CONTENT_065", "ID");
define("CMS_L_IFC_CONTENT_066", "Output view");
define("CMS_L_IFC_CONTENT_067", "Starts with");
define("CMS_L_IFC_CONTENT_068", "Contains");
define("CMS_L_IFC_CONTENT_069", "Ends with");
define("CMS_L_IFC_CONTENT_070", "Greater than");
define("CMS_L_IFC_CONTENT_071", "Equal to");
define("CMS_L_IFC_CONTENT_072", "Lower than");
define("CMS_L_IFC_CONTENT_073", "Reset");
define("CMS_L_IFC_CONTENT_074", "Default");
define("CMS_L_IFC_CONTENT_075", "Assign selection");
define("CMS_L_IFC_CONTENT_076", "Assignment");
define("CMS_L_IFC_CONTENT_077", "Meta data");
define("CMS_L_IFC_CONTENT_078", "RSS");
define("CMS_L_IFC_CONTENT_079", "Subscribe to RSS channel");
define("CMS_L_IFC_CONTENT_080", "Editing view");
define("CMS_L_IFC_CONTENT_081", "Export basic template");
define("CMS_L_IFC_CONTENT_082", "Page");
define("CMS_L_IFC_CONTENT_083", "Layout view");
define("CMS_L_IFC_CONTENT_084", "In process");
define("CMS_L_IFC_CONTENT_085", "Versions");
define("CMS_L_IFC_CONTENT_086", "Activate");
define("CMS_L_IFC_CONTENT_087", "Apply changes");
define("CMS_L_IFC_CONTENT_088", "Discard changes");
define("CMS_L_IFC_CONTENT_089", "Versions");
define("CMS_L_IFC_CONTENT_090", "The preview is not available. " .
                                "IFRAMEs are inactive or not supported by your web software.");
define("CMS_L_IFC_CONTENT_091", "User box");
define("CMS_L_IFC_CONTENT_092", "Folder");
define("CMS_L_IFC_CONTENT_093", "Search filter");
define("CMS_L_IFC_CONTENT_094", "All");
define("CMS_L_IFC_CONTENT_095", "Apply all changes");
define("CMS_L_IFC_CONTENT_096", "Textual content");
define("CMS_L_IFC_CONTENT_097", "Text analysis");
define("CMS_L_IFC_CONTENT_098", "Word");
define("CMS_L_IFC_CONTENT_099", "Occurences");
define("CMS_L_IFC_CONTENT_100", "Rate");
define("CMS_L_IFC_CONTENT_101", "Total");
define("CMS_L_IFC_CONTENT_102", "Word span");
define("CMS_L_IFC_CONTENT_103", "Single occurences are not displayed.");
define("CMS_L_IFC_CONTENT_104", "HTML");
define("CMS_L_IFC_CONTENT_105", "All");
define("CMS_L_IFC_CONTENT_106", "Invert");
define("CMS_L_IFC_CONTENT_107", "None");
define("CMS_L_IFC_CONTENT_109", "Apply now");
define("CMS_L_IFC_CONTENT_110", "Save version");
define("CMS_L_IFC_CONTENT_111", "Day");
define("CMS_L_IFC_CONTENT_112", "Month");
define("CMS_L_IFC_CONTENT_113", "Year");
define("CMS_L_IFC_CONTENT_114", "Time");
define("CMS_L_IFC_CONTENT_115", "Delete schedule");
define("CMS_L_IFC_CONTENT_116", "Publication details");
define("CMS_L_IFC_CONTENT_117", "Never apply");
define("CMS_L_IFC_CONTENT_118", "Extended");
define("CMS_L_IFC_CONTENT_119", "Overwrite entry");
define("CMS_L_IFC_CONTENT_120", "Schedule");
define("CMS_L_IFC_CONTENT_122", "Activate version");
define("CMS_L_IFC_CONTENT_123", "Target path");
define("CMS_L_IFC_CONTENT_124", "Target path has not been specified or is invalid.");
define("CMS_L_IFC_CONTENT_125", "Version");
define("CMS_L_IFC_CONTENT_126", "Version is invalid.");
define("CMS_L_IFC_CONTENT_127", "Action");
define("CMS_L_IFC_CONTENT_128", "Publish without directory entry");
define("CMS_L_IFC_CONTENT_129", "Category"); //pool
define("CMS_L_IFC_CONTENT_130", "Contents");
define("CMS_L_IFC_CONTENT_131", "Pool");
define("CMS_L_IFC_CONTENT_132", "Full synchronization");
define("CMS_L_IFC_CONTENT_133", "Read into copy buffer");
define("CMS_L_IFC_CONTENT_134", "Preset for new pages");
define("CMS_L_IFC_CONTENT_135", "Version %d");
define("CMS_L_IFC_CONTENT_136", "Value");
define("CMS_L_IFC_CONTENT_137", "The selected object is not linked.");
define("CMS_L_IFC_CONTENT_138", "Info");
define("CMS_L_IFC_CONTENT_139", "Exclude from sitemap");
define("CMS_L_IFC_CONTENT_140", "Settings");
//ifc_database
//.....................................................................................................
define("CMS_L_IFC_DATABASE",     "Database");
define("CMS_L_IFC_DATABASE_001", "Edit field");
define("CMS_L_IFC_DATABASE_002", "Create field");
define("CMS_L_IFC_DATABASE_003", "Data type");
define("CMS_L_IFC_DATABASE_004", "Type-specific attributes");
define("CMS_L_IFC_DATABASE_005", "Default value");
define("CMS_L_IFC_DATABASE_006", "Size");
define("CMS_L_IFC_DATABASE_007", "Attribute");
define("CMS_L_IFC_DATABASE_008", "Decimal places");
define("CMS_L_IFC_DATABASE_009", "Format");
define("CMS_L_IFC_DATABASE_010", "Length");
define("CMS_L_IFC_DATABASE_011", "Value list");
define("CMS_L_IFC_DATABASE_012", "Create index");
define("CMS_L_IFC_DATABASE_013", "Memory system");
define("CMS_L_IFC_DATABASE_014", "Edit table");
define("CMS_L_IFC_DATABASE_015", "Create table");
define("CMS_L_IFC_DATABASE_016", "Description");
define("CMS_L_IFC_DATABASE_017", "Table editor");
define("CMS_L_IFC_DATABASE_018", "Display");
define("CMS_L_IFC_DATABASE_019", "Start");
define("CMS_L_IFC_DATABASE_020", "End");
define("CMS_L_IFC_DATABASE_021", "Lines");
define("CMS_L_IFC_DATABASE_022", "Characters");
define("CMS_L_IFC_DATABASE_023", "Filter");
define("CMS_L_IFC_DATABASE_024", "Contains");
define("CMS_L_IFC_DATABASE_025", "Order by");
define("CMS_L_IFC_DATABASE_026", "%d Records");
define("CMS_L_IFC_DATABASE_027", "CSV export file");
define("CMS_L_IFC_DATABASE_028", "Field separator");
define("CMS_L_IFC_DATABASE_029", "Comma (MS Excel)");
define("CMS_L_IFC_DATABASE_030", "Semicolon (MS Access)");
define("CMS_L_IFC_DATABASE_031", "Tab");
define("CMS_L_IFC_DATABASE_032", "Space");
define("CMS_L_IFC_DATABASE_033", "Value separator");
define("CMS_L_IFC_DATABASE_034", "\" (MS Excel, MS Access)");
define("CMS_L_IFC_DATABASE_035", "'");
define("CMS_L_IFC_DATABASE_036", "(None)");
define("CMS_L_IFC_DATABASE_037", "Export data");
define("CMS_L_IFC_DATABASE_038", "Import data");
define("CMS_L_IFC_DATABASE_039", "Import file");
define("CMS_L_IFC_DATABASE_040", "Connection not established.");
define("CMS_L_IFC_DATABASE_041", "MySQL server");
define("CMS_L_IFC_DATABASE_042", "MySQL database");
define("CMS_L_IFC_DATABASE_043", "User");
define("CMS_L_IFC_DATABASE_044", "Password");
define("CMS_L_IFC_DATABASE_050", "Set up connection");
define("CMS_L_IFC_DATABASE_051", "SQL console");
define("CMS_L_IFC_DATABASE_052", "SQL command");
define("CMS_L_IFC_DATABASE_053", "Maintain database");
define("CMS_L_IFC_DATABASE_054", "Table");
define("CMS_L_IFC_DATABASE_056", "Record format");
define("CMS_L_IFC_DATABASE_057", "Number of records");
define("CMS_L_IFC_DATABASE_058", "Average record size");
define("CMS_L_IFC_DATABASE_059", "Data size");
define("CMS_L_IFC_DATABASE_060", "Maximum data size");
define("CMS_L_IFC_DATABASE_061", "Index size");
define("CMS_L_IFC_DATABASE_062", "Free allocated memory");
define("CMS_L_IFC_DATABASE_063", "Next automatic value");
define("CMS_L_IFC_DATABASE_064", "Created");
define("CMS_L_IFC_DATABASE_065", "Updated");
define("CMS_L_IFC_DATABASE_066", "Checked");
define("CMS_L_IFC_DATABASE_067", "NULL value");
define("CMS_L_IFC_DATABASE_068", "Index");
define("CMS_L_IFC_DATABASE_069", "Options");
define("CMS_L_IFC_DATABASE_070", "Unique values");
define("CMS_L_IFC_DATABASE_071", "Index position");
define("CMS_L_IFC_DATABASE_073", "Number of unique values");
define("CMS_L_IFC_DATABASE_074", "Use structure");
define("CMS_L_IFC_DATABASE_075", "Save structure");
define("CMS_L_IFC_DATABASE_077", "First line contains field names");
define("CMS_L_IFC_DATABASE_079", "(Empty)");
define("CMS_L_IFC_DATABASE_080", "Does not contain");
define("CMS_L_IFC_DATABASE_081", "Execute");
define("CMS_L_IFC_DATABASE_082", "Backup database");
define("CMS_L_IFC_DATABASE_083", "Restore database");
define("CMS_L_IFC_DATABASE_084", "Format");
define("CMS_L_IFC_DATABASE_085", "Compression");
define("CMS_L_IFC_DATABASE_086", "Version");
define("CMS_L_IFC_DATABASE_087", "Checksum");
define("CMS_L_IFC_DATABASE_088", "Collation");
define("CMS_L_IFC_DATABASE_089", "Authorization");
define("CMS_L_IFC_DATABASE_090", "(Default)");
define("CMS_L_IFC_DATABASE_091", "Index type");
define("CMS_L_IFC_DATABASE_092", "Included fields");
define("CMS_L_IFC_DATABASE_093", "Field");
define("CMS_L_IFC_DATABASE_094", "Value");
define("CMS_L_IFC_DATABASE_095", "Field assignment");
define("CMS_L_IFC_DATABASE_096", "All");
define("CMS_L_IFC_DATABASE_097", "Invert");
define("CMS_L_IFC_DATABASE_098", "None");
define("CMS_L_IFC_DATABASE_099", "3 months");
//ifc_directory
//.....................................................................................................
define("CMS_L_IFC_DIRECTORY",     "Directory");
define("CMS_L_IFC_DIRECTORY_001", "New entry");
define("CMS_L_IFC_DIRECTORY_002", "Clean");
define("CMS_L_IFC_DIRECTORY_003", "Step 1: Data");
define("CMS_L_IFC_DIRECTORY_004", "Step 2: Position");
define("CMS_L_IFC_DIRECTORY_005", "Hidden");
define("CMS_L_IFC_DIRECTORY_007", "Data");
define("CMS_L_IFC_DIRECTORY_008", "Title");
define("CMS_L_IFC_DIRECTORY_009", "Active (Image/URL)");
define("CMS_L_IFC_DIRECTORY_010", "Placeholder");
define("CMS_L_IFC_DIRECTORY_011", "Graphical buttons");
define("CMS_L_IFC_DIRECTORY_012", "Normal (Image/URL)");
define("CMS_L_IFC_DIRECTORY_013", "Hover (Image/URL)");
define("CMS_L_IFC_DIRECTORY_014", "Extended");
define("CMS_L_IFC_DIRECTORY_015", "Override output path");
define("CMS_L_IFC_DIRECTORY_016", "Dynamic");
define("CMS_L_IFC_DIRECTORY_017", "New icon");
define("CMS_L_IFC_DIRECTORY_018", "All");
define("CMS_L_IFC_DIRECTORY_019", "Invert");
define("CMS_L_IFC_DIRECTORY_020", "None");
define("CMS_L_IFC_DIRECTORY_021", "Canonical base address");
define("CMS_L_IFC_DIRECTORY_022", "Canonical address");
define("CMS_L_IFC_DIRECTORY_062", "Icons");
define("CMS_L_IFC_DIRECTORY_063", "Icon");
define("CMS_L_IFC_DIRECTORY_064", "Normal image");
define("CMS_L_IFC_DIRECTORY_065", "Active image");
define("CMS_L_IFC_DIRECTORY_066", "Recommended image dimensions: 16x16px");
define("CMS_L_IFC_DIRECTORY_072", "Sort");
//ifc_download
//.....................................................................................................
define("CMS_L_IFC_DOWNLOAD",     "Downloads");
define("CMS_L_IFC_DOWNLOAD_001", "Upload");
define("CMS_L_IFC_DOWNLOAD_002", "File");
define("CMS_L_IFC_DOWNLOAD_003", "Category");
define("CMS_L_IFC_DOWNLOAD_004", "The preview is not available. " .
                                 "IFRAMEs are inactive or not supported by your web software.");
define("CMS_L_IFC_DOWNLOAD_005", "File information");
define("CMS_L_IFC_DOWNLOAD_006", "Rename category");
define("CMS_L_IFC_DOWNLOAD_007", "Downloads");
define("CMS_L_IFC_DOWNLOAD_008", "Replace file");
define("CMS_L_IFC_DOWNLOAD_009", "New category");
define("CMS_L_IFC_DOWNLOAD_010", "Existing category");
define("CMS_L_IFC_DOWNLOAD_011", "Format");
define("CMS_L_IFC_DOWNLOAD_012", "Size");
define("CMS_L_IFC_DOWNLOAD_013", "Download");
define("CMS_L_IFC_DOWNLOAD_014", "Multi upload");
define("CMS_L_IFC_DOWNLOAD_015", "Here you can select multiple files for upload.");
//ifc_easypage
//.....................................................................................................
define("CMS_L_IFC_EASYPAGE",     "Web pages");
define("CMS_L_IFC_EASYPAGE_001", "Directory");
define("CMS_L_IFC_EASYPAGE_002", "Entry data");
define("CMS_L_IFC_EASYPAGE_003", "Step 1: Data");
define("CMS_L_IFC_EASYPAGE_004", "Title");
define("CMS_L_IFC_EASYPAGE_005", "Keywords");
define("CMS_L_IFC_EASYPAGE_006", "Step 2: Position");
define("CMS_L_IFC_EASYPAGE_007", "New entry");
define("CMS_L_IFC_EASYPAGE_008", "Here you can specify the meta data of the selected entry.");
define("CMS_L_IFC_EASYPAGE_009", "Title");
define("CMS_L_IFC_EASYPAGE_010", "Select the entry you want to edit.");
define("CMS_L_IFC_EASYPAGE_011", "Hidden");
define("CMS_L_IFC_EASYPAGE_012", "Description");
define("CMS_L_IFC_EASYPAGE_015", "Page template");
define("CMS_L_IFC_EASYPAGE_021", "Select the entry position.");
define("CMS_L_IFC_EASYPAGE_022", "Here you can specify the title and appearance of the new entry.");
//ifc_filemanager
//.....................................................................................................
define("CMS_L_IFC_FILEMANAGER",     "Files");
define("CMS_L_IFC_FILEMANAGER_001", "Upload");
define("CMS_L_IFC_FILEMANAGER_002", "Multi file upload");
define("CMS_L_IFC_FILEMANAGER_003", "Contents");
define("CMS_L_IFC_FILEMANAGER_004", "Save and close");
define("CMS_L_IFC_FILEMANAGER_006", "Create folder");
define("CMS_L_IFC_FILEMANAGER_007", "Create file");
define("CMS_L_IFC_FILEMANAGER_008", "Directory entry");
define("CMS_L_IFC_FILEMANAGER_009", "Data");
define("CMS_L_IFC_FILEMANAGER_010", "Access permission");
define("CMS_L_IFC_FILEMANAGER_011", "Owner");
define("CMS_L_IFC_FILEMANAGER_012", "Group");
define("CMS_L_IFC_FILEMANAGER_013", "Other");
define("CMS_L_IFC_FILEMANAGER_014", "Read");
define("CMS_L_IFC_FILEMANAGER_015", "Write");
define("CMS_L_IFC_FILEMANAGER_016", "Execute");
define("CMS_L_IFC_FILEMANAGER_017", "Write protection on Windows systems");
define("CMS_L_IFC_FILEMANAGER_018", "Type");
define("CMS_L_IFC_FILEMANAGER_019", "Size");
define("CMS_L_IFC_FILEMANAGER_020", "Updated");
define("CMS_L_IFC_FILEMANAGER_021", "Accessed");
define("CMS_L_IFC_FILEMANAGER_022", "Available disk space");
define("CMS_L_IFC_FILEMANAGER_023", "Download time (64 kbps)");
define("CMS_L_IFC_FILEMANAGER_024", "All");
define("CMS_L_IFC_FILEMANAGER_025", "Invert");
define("CMS_L_IFC_FILEMANAGER_026", "None");
define("CMS_L_IFC_FILEMANAGER_027", "Drop files onto the above field to upload.");
define("CMS_L_IFC_FILEMANAGER_029", "Download");
define("CMS_L_IFC_FILEMANAGER_033", "Web download");
define("CMS_L_IFC_FILEMANAGER_036", "Compress");
define("CMS_L_IFC_FILEMANAGER_037", "Decompress");
define("CMS_L_IFC_FILEMANAGER_038", "Total disk space");
//ifc_image
//.....................................................................................................
define("CMS_L_IFC_IMAGE",     "Images");
define("CMS_L_IFC_IMAGE_001", "Image upload");
define("CMS_L_IFC_IMAGE_002", "Image file");
define("CMS_L_IFC_IMAGE_003", "Existent category");
define("CMS_L_IFC_IMAGE_004", "The preview is not available. " .
                              "IFRAMEs are inactive or not supported by your web software.");
define("CMS_L_IFC_IMAGE_005", "Preview");
define("CMS_L_IFC_IMAGE_007", "Images");
define("CMS_L_IFC_IMAGE_008", "Replace image");
define("CMS_L_IFC_IMAGE_009", "New category");
define("CMS_L_IFC_IMAGE_010", "Rename category");
define("CMS_L_IFC_IMAGE_011", "Clear cache");
define("CMS_L_IFC_IMAGE_012", "The source is linked externally and cannot be replaced internally. " .
                              "Select <em>Edit</em> to change the source.");
define("CMS_L_IFC_IMAGE_013", "File name");
define("CMS_L_IFC_IMAGE_014", "Category");
define("CMS_L_IFC_IMAGE_015", "Extended");
define("CMS_L_IFC_IMAGE_016", "Multi image upload");
define("CMS_L_IFC_IMAGE_017", "Here you can select multiple files for upload.");
//ifc_insert
//.....................................................................................................
define("CMS_L_IFC_INSERT",     "Insertions");
define("CMS_L_IFC_INSERT_001", "All");
define("CMS_L_IFC_INSERT_002", "New insertion");
define("CMS_L_IFC_INSERT_003", "Insertion");
define("CMS_L_IFC_INSERT_004", "Insertions");
define("CMS_L_IFC_INSERT_005", "Data");
define("CMS_L_IFC_INSERT_006", "HTML");
define("CMS_L_IFC_INSERT_007", "Text");
define("CMS_L_IFC_INSERT_008", "Position");
define("CMS_L_IFC_INSERT_009", "Invert");
define("CMS_L_IFC_INSERT_010", "None");
//ifc_language
//.....................................................................................................
define("CMS_L_IFC_LANGUAGE",     "Languages");
define("CMS_L_IFC_LANGUAGE_001", "All");
define("CMS_L_IFC_LANGUAGE_002", "Invert");
define("CMS_L_IFC_LANGUAGE_003", "None");
define("CMS_L_IFC_LANGUAGE_004", "Language code");
define("CMS_L_IFC_LANGUAGE_005", "Name");
define("CMS_L_IFC_LANGUAGE_006", "Data");
define("CMS_L_IFC_LANGUAGE_007", "Internal icon");
define("CMS_L_IFC_LANGUAGE_008", "External icon");
define("CMS_L_IFC_LANGUAGE_009", "Activate selection");
define("CMS_L_IFC_LANGUAGE_010", "New language");
define("CMS_L_IFC_LANGUAGE_011", "Active");
define("CMS_L_IFC_LANGUAGE_012", "Stop words (whitespace-separated)");
define("CMS_L_IFC_LANGUAGE_013", "Default language");
//ifc_log
//.....................................................................................................
define("CMS_L_IFC_LOG",     "Log");
define("CMS_L_IFC_LOG_001", "Date");
define("CMS_L_IFC_LOG_002", "Time");
define("CMS_L_IFC_LOG_003", "ID");
define("CMS_L_IFC_LOG_004", "IP");
define("CMS_L_IFC_LOG_005", "User name");
define("CMS_L_IFC_LOG_006", "Action");
define("CMS_L_IFC_LOG_007", "Reference");
define("CMS_L_IFC_LOG_008", "Station");
define("CMS_L_IFC_LOG_009", "Software");
define("CMS_L_IFC_LOG_010", "Language");
define("CMS_L_IFC_LOG_011", "Your current ID: %s");
define("CMS_L_IFC_LOG_012", "Organization");
define("CMS_L_IFC_LOG_013", "Address");
define("CMS_L_IFC_LOG_014", "Phone");
define("CMS_L_IFC_LOG_015", "Fax");
define("CMS_L_IFC_LOG_016", "Assignment -->");
define("CMS_L_IFC_LOG_017", "Load settings");
define("CMS_L_IFC_LOG_018", "Save settings");
define("CMS_L_IFC_LOG_019", "Data fields");
define("CMS_L_IFC_LOG_020", "Condition");
define("CMS_L_IFC_LOG_021", "Contains");
define("CMS_L_IFC_LOG_022", "Lower than");
define("CMS_L_IFC_LOG_023", "Lower than or equal to");
define("CMS_L_IFC_LOG_024", "Equal to");
define("CMS_L_IFC_LOG_025", "Greater than or equal to");
define("CMS_L_IFC_LOG_026", "Greater than");
define("CMS_L_IFC_LOG_027", "Not equal to");
define("CMS_L_IFC_LOG_028", "Display");
define("CMS_L_IFC_LOG_029", "Lines");
define("CMS_L_IFC_LOG_030", "Output");
define("CMS_L_IFC_LOG_031", "Table");
define("CMS_L_IFC_LOG_032", "Statistics");
define("CMS_L_IFC_LOG_033", "Hits");
define("CMS_L_IFC_LOG_034", "Actions");
define("CMS_L_IFC_LOG_035", "Relation");
define("CMS_L_IFC_LOG_036", "Today");
define("CMS_L_IFC_LOG_037", "Visitors");
define("CMS_L_IFC_LOG_038", "Yesterday");
define("CMS_L_IFC_LOG_039", "Difference");
define("CMS_L_IFC_LOG_040", "Divergence");
define("CMS_L_IFC_LOG_041", "Reference statistics");
define("CMS_L_IFC_LOG_042", "Action statistics");
define("CMS_L_IFC_LOG_043", "Registered users");
define("CMS_L_IFC_LOG_044", "Daily report");
define("CMS_L_IFC_LOG_045", "Profiles");
define("CMS_L_IFC_LOG_046", "Create profile");
define("CMS_L_IFC_LOG_047", "Memo");
define("CMS_L_IFC_LOG_048", "Profile");
define("CMS_L_IFC_LOG_049", "Data");
define("CMS_L_IFC_LOG_050", "Most recent actions");
define("CMS_L_IFC_LOG_051", "Action statistics");
define("CMS_L_IFC_LOG_052", "Configuration");
define("CMS_L_IFC_LOG_053", "Extent");
define("CMS_L_IFC_LOG_054", "Unlimited");
define("CMS_L_IFC_LOG_055", "3 years");
define("CMS_L_IFC_LOG_056", "2 years");
define("CMS_L_IFC_LOG_057", "1 year");
define("CMS_L_IFC_LOG_058", "6 months");
define("CMS_L_IFC_LOG_059", "3 months");
define("CMS_L_IFC_LOG_060", "1 month");
define("CMS_L_IFC_LOG_061", "2 weeks");
define("CMS_L_IFC_LOG_062", "1 week");
define("CMS_L_IFC_LOG_063", "3 days");
define("CMS_L_IFC_LOG_064", "2 days");
define("CMS_L_IFC_LOG_065", "1 day");
define("CMS_L_IFC_LOG_066", "Inactive");
define("CMS_L_IFC_LOG_067", "Anonymize IP address");
define("CMS_L_IFC_LOG_068", "Do not save user data");
//ifc_mailform
//.....................................................................................................
define("CMS_L_IFC_MAILFORM",     "Forms");
define("CMS_L_IFC_MAILFORM_001", "New form");
define("CMS_L_IFC_MAILFORM_002", "Create element");
define("CMS_L_IFC_MAILFORM_003", "Type");
define("CMS_L_IFC_MAILFORM_004", "Option box");
define("CMS_L_IFC_MAILFORM_005", "Select box");
define("CMS_L_IFC_MAILFORM_006", "Drop-down list");
define("CMS_L_IFC_MAILFORM_007", "Single-line text box");
define("CMS_L_IFC_MAILFORM_008", "Multiline text box");
define("CMS_L_IFC_MAILFORM_009", "New element");
define("CMS_L_IFC_MAILFORM_010", "Create form");
define("CMS_L_IFC_MAILFORM_011", "All");
define("CMS_L_IFC_MAILFORM_012", "Data");
define("CMS_L_IFC_MAILFORM_013", "Recipient e-mail");
define("CMS_L_IFC_MAILFORM_014", "Options");
define("CMS_L_IFC_MAILFORM_015", "Put + at the beginning of a line to preselect an option.");
define("CMS_L_IFC_MAILFORM_016", "Width");
define("CMS_L_IFC_MAILFORM_017", "Characters");
define("CMS_L_IFC_MAILFORM_018", "Default value");
define("CMS_L_IFC_MAILFORM_019", "Verification");
define("CMS_L_IFC_MAILFORM_020", "Name");
define("CMS_L_IFC_MAILFORM_021", "E-mail");
define("CMS_L_IFC_MAILFORM_022", "Phone/fax");
define("CMS_L_IFC_MAILFORM_023", "Input required");
define("CMS_L_IFC_MAILFORM_024", "Height");
define("CMS_L_IFC_MAILFORM_025", "Description");
define("CMS_L_IFC_MAILFORM_026", "Confirmation");
define("CMS_L_IFC_MAILFORM_027", "Receiving address (HTTP POST)");
define("CMS_L_IFC_MAILFORM_028", "If no field ID is set, values are transmitted via HTTP POST " .
                                 "using the ID <strong>mailform_value(n)</strong> in field order:" .
                                 "<strong>mailform_value1</strong>, <strong>mailform_value2</strong>, etc.<br>" .
                                 "&nbsp;<br>" .
                                 "The field ID containing the subject line is <strong>mailform_subject</strong>.");
define("CMS_L_IFC_MAILFORM_029", "Hidden field");
define("CMS_L_IFC_MAILFORM_030", "Field ID");
define("CMS_L_IFC_MAILFORM_031", "Number");
define("CMS_L_IFC_MAILFORM_032", "Contains e-mail, send confirmation");
define("CMS_L_IFC_MAILFORM_033", "Pagebreak");
define("CMS_L_IFC_MAILFORM_034", "Columns");
define("CMS_L_IFC_MAILFORM_035", "Custom verification (PCRE)");
define("CMS_L_IFC_MAILFORM_036", "Invert");
define("CMS_L_IFC_MAILFORM_037", "None");
define("CMS_L_IFC_MAILFORM_038", "Step 1: Data");
define("CMS_L_IFC_MAILFORM_039", "Step 2: Position");
define("CMS_L_IFC_MAILFORM_040", "Set up connection");
define("CMS_L_IFC_MAILFORM_041", "SMTP server");
define("CMS_L_IFC_MAILFORM_042", "E-mail address");
define("CMS_L_IFC_MAILFORM_043", "User");
define("CMS_L_IFC_MAILFORM_044", "Password");
define("CMS_L_IFC_MAILFORM_045", "Test connection");
define("CMS_L_IFC_MAILFORM_046", "Use CAPTCHA");
define("CMS_L_IFC_MAILFORM_047", "HTML code");
define("CMS_L_IFC_MAILFORM_048", "HTML");
define("CMS_L_IFC_MAILFORM_049", "The HTML code must contain a form field " .
                                 "whose NAME attribute matches the field ID." .
                                 "&nbsp;<br>" .
                                 "Available placeholders: " .
                                 "<strong>%label%</strong> field label, " .
                                 "<strong>%id%</strong> field ID, " .
                                 "<strong>%name%</strong> field name, " .
                                 "<strong>%value%</strong> field value");
define("CMS_L_IFC_MAILFORM_050", "Submit button labeling");
define("CMS_L_IFC_MAILFORM_051", "Show code only");
define("CMS_L_IFC_MAILFORM_052", "Use mail() function");
define("CMS_L_IFC_MAILFORM_053", "Use SMTP server");
define("CMS_L_IFC_MAILFORM_054", "SMTP settings");
define("CMS_L_IFC_MAILFORM_055", "Test message");
define("CMS_L_IFC_MAILFORM_056", "Exclude field from confirmation");
define("CMS_L_IFC_MAILFORM_057", "URL");
define("CMS_L_IFC_MAILFORM_058", "Street/No.");
//ifc_media
//.....................................................................................................
define("CMS_L_IFC_MEDIA",     "Media");
define("CMS_L_IFC_MEDIA_001", "Media upload");
define("CMS_L_IFC_MEDIA_002", "Media file");
define("CMS_L_IFC_MEDIA_003", "Existing category");
define("CMS_L_IFC_MEDIA_004", "The preview is not available. " .
                              "IFRAMEs are inactive or not supported by your web software.");
define("CMS_L_IFC_MEDIA_005", "Rename category");
define("CMS_L_IFC_MEDIA_007", "Media");
define("CMS_L_IFC_MEDIA_008", "Replace media");
define("CMS_L_IFC_MEDIA_009", "New category");
define("CMS_L_IFC_MEDIA_010", "Media formats");
define("CMS_L_IFC_MEDIA_011", "New media format");
define("CMS_L_IFC_MEDIA_012", "Media format");
define("CMS_L_IFC_MEDIA_013", "Assigned file extensions (comma-separated)");
define("CMS_L_IFC_MEDIA_014", "Source code");
define("CMS_L_IFC_MEDIA_015", "Placeholders");
define("CMS_L_IFC_MEDIA_016", "The source is linked externally and cannot be replaced internally. " .
                              "Select <em>Edit</em> to change the source.");
define("CMS_L_IFC_MEDIA_017", "Extended");
define("CMS_L_IFC_MEDIA_018", "File name");
define("CMS_L_IFC_MEDIA_019", "Category");
define("CMS_L_IFC_MEDIA_020", "Multi media upload");
define("CMS_L_IFC_MEDIA_021", "Here you can select multiple files for upload.");
//ifc_permission
//.....................................................................................................
define("CMS_L_IFC_PERMISSION",     "Administration");
define("CMS_L_IFC_PERMISSION_001", "Create account");
define("CMS_L_IFC_PERMISSION_002", "User name");
define("CMS_L_IFC_PERMISSION_003", "Password confirmation");
define("CMS_L_IFC_PERMISSION_004", "Create Group");
define("CMS_L_IFC_PERMISSION_005", "Group ID");
define("CMS_L_IFC_PERMISSION_006", "Remark");
define("CMS_L_IFC_PERMISSION_007", "Group");
define("CMS_L_IFC_PERMISSION_008", "Inactive");
define("CMS_L_IFC_PERMISSION_009", "Permissions");
define("CMS_L_IFC_PERMISSION_010", "Account");
define("CMS_L_IFC_PERMISSION_011", "Expiry (Days)");
define("CMS_L_IFC_PERMISSION_012", "User");
define("CMS_L_IFC_PERMISSION_014", "Permission manager");
define("CMS_L_IFC_PERMISSION_015", "Permission granted");
define("CMS_L_IFC_PERMISSION_016", "Permission denied");
define("CMS_L_IFC_PERMISSION_017", "Time zone");
define("CMS_L_IFC_PERMISSION_018", "Exclusions");
define("CMS_L_IFC_PERMISSION_019", "Authorization");
define("CMS_L_IFC_PERMISSION_020", "Extended");
define("CMS_L_IFC_PERMISSION_021", "Users"); //plural
define("CMS_L_IFC_PERMISSION_022", "Groups");
define("CMS_L_IFC_PERMISSION_023", "All");
define("CMS_L_IFC_PERMISSION_024", "Invert");
define("CMS_L_IFC_PERMISSION_025", "None");
define("CMS_L_IFC_PERMISSION_026", "Activate");
define("CMS_L_IFC_PERMISSION_027", "Deactivate");
define("CMS_L_IFC_PERMISSION_028", "Delete permission");
define("CMS_L_IFC_PERMISSION_029", "Delete exclusion");
define("CMS_L_IFC_PERMISSION_030", "<strong>+</strong> explicitly granted");
define("CMS_L_IFC_PERMISSION_031", "<strong>+</strong> explicitly granted, <strong>-</strong> explicitly denied");
define("CMS_L_IFC_PERMISSION_032", "Key");
//ifc_profile
//.....................................................................................................
define("CMS_L_IFC_PROFILE",     "Profiles");
define("CMS_L_IFC_PROFILE_001", "ID");
define("CMS_L_IFC_PROFILE_002", "Identifier");
define("CMS_L_IFC_PROFILE_003", "User name");
define("CMS_L_IFC_PROFILE_004", "Account inheritance");
define("CMS_L_IFC_PROFILE_005", "Organization");
define("CMS_L_IFC_PROFILE_006", "Forename");
define("CMS_L_IFC_PROFILE_007", "Surname");
define("CMS_L_IFC_PROFILE_008", "Street");
define("CMS_L_IFC_PROFILE_009", "Zip");
define("CMS_L_IFC_PROFILE_010", "City");
define("CMS_L_IFC_PROFILE_011", "Country");
define("CMS_L_IFC_PROFILE_012", "Phone");
define("CMS_L_IFC_PROFILE_013", "Phone 2");
define("CMS_L_IFC_PROFILE_014", "Cell phone");
define("CMS_L_IFC_PROFILE_015", "Fax");
define("CMS_L_IFC_PROFILE_016", "Remark");
define("CMS_L_IFC_PROFILE_017", "Starts with");
define("CMS_L_IFC_PROFILE_018", "Contains");
define("CMS_L_IFC_PROFILE_019", "Ends with");
define("CMS_L_IFC_PROFILE_020", "Greater than");
define("CMS_L_IFC_PROFILE_021", "Equal to");
define("CMS_L_IFC_PROFILE_022", "Lower than");
define("CMS_L_IFC_PROFILE_023", "Grouping");
define("CMS_L_IFC_PROFILE_024", "Lines/Page");
define("CMS_L_IFC_PROFILE_025", "Reset");
define("CMS_L_IFC_PROFILE_026", "(Empty)");
define("CMS_L_IFC_PROFILE_027", "User credentials");
define("CMS_L_IFC_PROFILE_028", "Personal data");
define("CMS_L_IFC_PROFILE_029", "Contact information");
define("CMS_L_IFC_PROFILE_030", "Miscellaneous");
define("CMS_L_IFC_PROFILE_031", "(No value)");
define("CMS_L_IFC_PROFILE_032", "Visible");
define("CMS_L_IFC_PROFILE_033", "Editable");
define("CMS_L_IFC_PROFILE_034", "Basic settings");
define("CMS_L_IFC_PROFILE_035", "Required");
define("CMS_L_IFC_PROFILE_036", "Extended settings");
define("CMS_L_IFC_PROFILE_037", "Extended information");
define("CMS_L_IFC_PROFILE_038", "Custom");
define("CMS_L_IFC_PROFILE_039", "Search filter");
define("CMS_L_IFC_PROFILE_040", "Page");
define("CMS_L_IFC_PROFILE_041", "Active");
define("CMS_L_IFC_PROFILE_042", "Credit card information");
define("CMS_L_IFC_PROFILE_043", "Banking details");
define("CMS_L_IFC_PROFILE_044", "Credit card number");
define("CMS_L_IFC_PROFILE_045", "Credit institution");
define("CMS_L_IFC_PROFILE_046", "Credit card holder");
define("CMS_L_IFC_PROFILE_047", "Expiry");
define("CMS_L_IFC_PROFILE_048", "Account number");
define("CMS_L_IFC_PROFILE_049", "Bank");
define("CMS_L_IFC_PROFILE_050", "Bank code");
define("CMS_L_IFC_PROFILE_051", "Account holder");
define("CMS_L_IFC_PROFILE_052", "Login data");
define("CMS_L_IFC_PROFILE_053", "Created");
define("CMS_L_IFC_PROFILE_054", "Updated");
define("CMS_L_IFC_PROFILE_055", "Generate");
define("CMS_L_IFC_PROFILE_056", "Save and close");
//ifc_search
//.....................................................................................................
define("CMS_L_IFC_SEARCH",     "Search");
define("CMS_L_IFC_SEARCH_001", "Search filter");
define("CMS_L_IFC_SEARCH_002", "Title");
define("CMS_L_IFC_SEARCH_003", "The scan queue contains <strong>a total of %d tasks</strong> " .
                               "<a href=\"%s\" style=\"COLOR:#00ff00\">[Process]</a> " .
                               "<a href=\"%s\" style=\"COLOR:#ff0000\">[Delete]</a>, " .
                               "thereof <strong>%d internal pages</strong> " .
                               "<a href=\"%s\" style=\"COLOR:#00ff00\">[Process]</a> " .
                               "<a href=\"%s\" style=\"COLOR:#ff0000\">[Delete]</a>, " .
                               "<strong>%d selected entries</strong> " .
                               "<a href=\"%s\" style=\"COLOR:#00ff00\">[Process]</a> " .
                               "<a href=\"%s\" style=\"COLOR:#ff0000\">[Delete]</a>, " .
                               "<strong>%d extrinsic submissions</strong> " .
                               "<a href=\"%s\" style=\"COLOR:#00ff00\">[Process]</a> " .
                               "<a href=\"%s\" style=\"COLOR:#ff0000\">[Delete]</a>, " .
                               "<strong>%d discovered links</strong> " .
                               "<a href=\"%s\" style=\"COLOR:#00ff00\">[Process]</a> " .
                               "<a href=\"%s\" style=\"COLOR:#ff0000\">[Delete]</a> " .
                               "and <strong>%d updates</strong> " .
                               "<a href=\"%s\" style=\"COLOR:#00ff00\">[Process]</a> " .
                               "<a href=\"%s\" style=\"COLOR:#ff0000\">[Delete]</a>.");
define("CMS_L_IFC_SEARCH_004", "Text");
define("CMS_L_IFC_SEARCH_005", "Date");
define("CMS_L_IFC_SEARCH_006", "Starts with");
define("CMS_L_IFC_SEARCH_007", "Contains");
define("CMS_L_IFC_SEARCH_008", "Ends with");
define("CMS_L_IFC_SEARCH_009", "Greater than");
define("CMS_L_IFC_SEARCH_010", "Equal to");
define("CMS_L_IFC_SEARCH_011", "Lower than");
define("CMS_L_IFC_SEARCH_012", "Lines/Page");
define("CMS_L_IFC_SEARCH_013", "Redirection limit exceeded");
define("CMS_L_IFC_SEARCH_014", "Scan");
define("CMS_L_IFC_SEARCH_015", "Queue all entries");
define("CMS_L_IFC_SEARCH_016", "Follow links");
define("CMS_L_IFC_SEARCH_017", "Build search index");
define("CMS_L_IFC_SEARCH_018", "Register page");
define("CMS_L_IFC_SEARCH_019", "Process all tasks");
define("CMS_L_IFC_SEARCH_020", "Process internal pages");
define("CMS_L_IFC_SEARCH_021", "Process extrinsic submissions");
define("CMS_L_IFC_SEARCH_022", "Process discovered links");
define("CMS_L_IFC_SEARCH_023", "Process updates");
define("CMS_L_IFC_SEARCH_024", "Clone window");
define("CMS_L_IFC_SEARCH_025", "Perform maintenance");
define("CMS_L_IFC_SEARCH_026", "Queue internal pages");
define("CMS_L_IFC_SEARCH_027", "Process selected entries");
define("CMS_L_IFC_SEARCH_028", "Queue selection");
define("CMS_L_IFC_SEARCH_029", "Retrieval...");
define("CMS_L_IFC_SEARCH_030", "Error");
define("CMS_L_IFC_SEARCH_031", "OK");
define("CMS_L_IFC_SEARCH_032", "Complete");
define("CMS_L_IFC_SEARCH_033", "Invalid address");
define("CMS_L_IFC_SEARCH_034", "No connection");
define("CMS_L_IFC_SEARCH_035", "Unsupported resource format");
define("CMS_L_IFC_SEARCH_036", "No modification");
define("CMS_L_IFC_SEARCH_037", "Update omitted");
define("CMS_L_IFC_SEARCH_038", "Data fetch failed");
define("CMS_L_IFC_SEARCH_039", "No content");
define("CMS_L_IFC_SEARCH_040", "Indexing undesired");
define("CMS_L_IFC_SEARCH_041", "Indexed");
define("CMS_L_IFC_SEARCH_042", "Indexing failed");
define("CMS_L_IFC_SEARCH_043", "Unknown Error");
define("CMS_L_IFC_SEARCH_044", "Reset");
define("CMS_L_IFC_SEARCH_045", "Order by");
define("CMS_L_IFC_SEARCH_046", "Processing data");
define("CMS_L_IFC_SEARCH_047", "Initializing page score");
define("CMS_L_IFC_SEARCH_048", "Computing page score, iteration %d of %d");
define("CMS_L_IFC_SEARCH_049", "Finalizing page score");
define("CMS_L_IFC_SEARCH_050", "Integrating dangling links, level %d of %d");
define("CMS_L_IFC_SEARCH_051", "Address rejected");
define("CMS_L_IFC_SEARCH_052", "Address filter");
define("CMS_L_IFC_SEARCH_053", "Blacklist");
define("CMS_L_IFC_SEARCH_054", "Whitelist, overrides blacklisting");
define("CMS_L_IFC_SEARCH_055", "Use regular expressions (" .
                               "<a href=\"javascript:load_page('http://www.pcre.org/pcre.txt');\">PCRE</a>) " .
                               "to block matching addresses, specifying one expression per line. " .
                               "Furthermore, the whitelist allows to define exceptions from the blacklist. " .
                               "The meaning of an expression can be inverted " .
                               "by putting an exclamation mark at the beginning of a line. " .
                               "&nbsp;<br>" .
                               "Example: !~^http://[^\.]*?\.example\.com(?:/|$)~i<br>" .
                               "Refers to all addresses that do not belong to the domain example.com.");
define("CMS_L_IFC_SEARCH_056", "Force update");
define("CMS_L_IFC_SEARCH_057", "Start queue processing");
define("CMS_L_IFC_SEARCH_058", "Score");
define("CMS_L_IFC_SEARCH_059", "Stop word lists");
define("CMS_L_IFC_SEARCH_060", "Stop words (whitespace-separated)");
define("CMS_L_IFC_SEARCH_061", "Define words without contentual relevance in the respective language, " .
                               "e.g. articles, conjunctions, prepositions, etc. " .
                               "Filtering those words allows for a more efficient search. " .
                               "Separate each word by whitespace (space, line break, etc.)");
//ifc_setup
//.....................................................................................................
define("CMS_L_IFC_SETUP",     "Setup");
define("CMS_L_IFC_SETUP_001", "Administrator password");
define("CMS_L_IFC_SETUP_002", "The administrator password is still set to default and is not safe. " .
                              "Please specify a new password to log on as administrator.");
define("CMS_L_IFC_SETUP_003", "New password");
define("CMS_L_IFC_SETUP_004", "Password confirmation");
define("CMS_L_IFC_SETUP_005", "Database connection settings");
define("CMS_L_IFC_SETUP_006", "Please specify access data for a MySQL database " .
                              "you want to use to store your application data.");
define("CMS_L_IFC_SETUP_007", "MySQL server");
define("CMS_L_IFC_SETUP_008", "MySQL database");
define("CMS_L_IFC_SETUP_009", "User");
define("CMS_L_IFC_SETUP_010", "Password");
define("CMS_L_IFC_SETUP_011", "The setup has been completed.");
define("CMS_L_IFC_SETUP_012", "E-mail delivery settings");
define("CMS_L_IFC_SETUP_013", "Please specify an e-mail address " .
                              "you want to use to send form data " .
                              "and choose a dispatch method.");
define("CMS_L_IFC_SETUP_014", "SMTP server");
define("CMS_L_IFC_SETUP_015", "E-mail address");
define("CMS_L_IFC_SETUP_016", "User");
define("CMS_L_IFC_SETUP_017", "Password");
define("CMS_L_IFC_SETUP_018", "The initial data has been successfully written to the database.");
define("CMS_L_IFC_SETUP_019", "The initial data could not be written to the database.");
define("CMS_L_IFC_SETUP_020", "You have not specified a password.");
define("CMS_L_IFC_SETUP_021", "Password and password confirmation do not match.");
define("CMS_L_IFC_SETUP_022", "Database connection could not be established.");
define("CMS_L_IFC_SETUP_023", "E-mail delivery server connection could not be established.");
define("CMS_L_IFC_SETUP_024", "Do not show setup after login anymore.");
define("CMS_L_IFC_SETUP_025", "Use mail() function");
define("CMS_L_IFC_SETUP_026", "Use SMTP server");
define("CMS_L_IFC_SETUP_027", "SMTP settings");
define("CMS_L_IFC_SETUP_028", "Test message");
//ifc_system
//.....................................................................................................
define("CMS_L_IFC_SYSTEM",     "#System");
define("CMS_L_IFC_SYSTEM_001", "Attribute");
define("CMS_L_IFC_SYSTEM_002", "Allow ancillary elements");
define("CMS_L_IFC_SYSTEM_003", "All");
define("CMS_L_IFC_SYSTEM_004", "Invert");
define("CMS_L_IFC_SYSTEM_005", "None");
define("CMS_L_IFC_SYSTEM_006", "Step 1: Data");
define("CMS_L_IFC_SYSTEM_007", "Value");
define("CMS_L_IFC_SYSTEM_008", "Step 2: Position");
define("CMS_L_IFC_SYSTEM_009", "Index");
//ifc_template
//.....................................................................................................
define("CMS_L_IFC_TEMPLATE",     "Templates");
define("CMS_L_IFC_TEMPLATE_001", "Source code from address (URL):");
define("CMS_L_IFC_TEMPLATE_002", "Blank source code");
define("CMS_L_IFC_TEMPLATE_003", "Source code from file (HTML):");
define("CMS_L_IFC_TEMPLATE_004", "New category");
define("CMS_L_IFC_TEMPLATE_005", "Category");
define("CMS_L_IFC_TEMPLATE_006", "Source code");
define("CMS_L_IFC_TEMPLATE_007", "Templates");
define("CMS_L_IFC_TEMPLATE_008", "Page template");
define("CMS_L_IFC_TEMPLATE_009", "The preview is not available. " .
                                 "IFRAMEs are inactive or not supported by your web software.");
define("CMS_L_IFC_TEMPLATE_010", "Images");
define("CMS_L_IFC_TEMPLATE_011", "Tools");
define("CMS_L_IFC_TEMPLATE_012", "Keep source code");
define("CMS_L_IFC_TEMPLATE_013", "Placeholders");
define("CMS_L_IFC_TEMPLATE_014", "Meta data");
define("CMS_L_IFC_TEMPLATE_015", "Control pad");
define("CMS_L_IFC_TEMPLATE_016", "Conditional block");
define("CMS_L_IFC_TEMPLATE_017", "Conditional alternative");
define("CMS_L_IFC_TEMPLATE_018", "Repeat");
define("CMS_L_IFC_TEMPLATE_019", "Template");
define("CMS_L_IFC_TEMPLATE_020", "Text");
define("CMS_L_IFC_TEMPLATE_021", "Link");
define("CMS_L_IFC_TEMPLATE_022", "Image");
define("CMS_L_IFC_TEMPLATE_023", "Thumbnail");
define("CMS_L_IFC_TEMPLATE_024", "Media");
define("CMS_L_IFC_TEMPLATE_025", "Download");
define("CMS_L_IFC_TEMPLATE_026", "Plugin");
define("CMS_L_IFC_TEMPLATE_027", "PHP script");
define("CMS_L_IFC_TEMPLATE_029", "HTML comment");
define("CMS_L_IFC_TEMPLATE_030", "Page frame");
define("CMS_L_IFC_TEMPLATE_031", "Backlink");
define("CMS_L_IFC_TEMPLATE_032", "Blind table");
define("CMS_L_IFC_TEMPLATE_033", "PHP include");
define("CMS_L_IFC_TEMPLATE_034", "Rename category");
define("CMS_L_IFC_TEMPLATE_035", "Position shift");
define("CMS_L_IFC_TEMPLATE_036", "No caching");
define("CMS_L_IFC_TEMPLATE_037", "Group");
define("CMS_L_IFC_TEMPLATE_038", "Namespace");
define("CMS_L_IFC_TEMPLATE_039", "Base namespace");
define("CMS_L_IFC_TEMPLATE_040", "Value");
define("CMS_L_IFC_TEMPLATE_041", "CSS");
define("CMS_L_IFC_TEMPLATE_042", "Directory");
define("CMS_L_IFC_TEMPLATE_043", "PHP output");
define("CMS_L_IFC_TEMPLATE_044", "Save + display");
define("CMS_L_IFC_TEMPLATE_045", "Menu");
define("CMS_L_IFC_TEMPLATE_046", "Downloads");
define("CMS_L_IFC_TEMPLATE_047", "Directory (PHP)");
define("CMS_L_IFC_TEMPLATE_048", "Images (PHP)");
//ifc_token
//.....................................................................................................
define("CMS_L_IFC_TOKEN",     "Placeholders");
define("CMS_L_IFC_TOKEN_001", "Category");
define("CMS_L_IFC_TOKEN_002", "Placeholders");
define("CMS_L_IFC_TOKEN_003", "Placeholder");
define("CMS_L_IFC_TOKEN_004", "The preview is not available. " .
                              "IFRAMEs are inactive or not supported by your web software.");
define("CMS_L_IFC_TOKEN_006", "Text");
define("CMS_L_IFC_TOKEN_007", "New category");
define("CMS_L_IFC_TOKEN_008", "Values (comma-separated)");
define("CMS_L_IFC_TOKEN_009", "Rename category");
//desktop
//-----------------------------------------------------------------------------------------------------
//desktop_address
//.....................................................................................................
define("CMS_L_DESKTOP_ADDRESS_001", "Address");
define("CMS_L_DESKTOP_ADDRESS_002", "Memo");
define("CMS_L_DESKTOP_ADDRESS_003", "Organization");
define("CMS_L_DESKTOP_ADDRESS_004", "Phone");
define("CMS_L_DESKTOP_ADDRESS_005", "Fax");
define("CMS_L_DESKTOP_ADDRESS_006", "Address");
//desktop_appointment
//.....................................................................................................
define("CMS_L_DESKTOP_APPOINTMENT_001", "New appointment");
define("CMS_L_DESKTOP_APPOINTMENT_002", "Appointment");
define("CMS_L_DESKTOP_APPOINTMENT_003", "Date");
define("CMS_L_DESKTOP_APPOINTMENT_004", "Time");
define("CMS_L_DESKTOP_APPOINTMENT_005", "Subject");
define("CMS_L_DESKTOP_APPOINTMENT_006", "Location");
define("CMS_L_DESKTOP_APPOINTMENT_007", "Day");
define("CMS_L_DESKTOP_APPOINTMENT_008", "Month");
define("CMS_L_DESKTOP_APPOINTMENT_009", "Year");
define("CMS_L_DESKTOP_APPOINTMENT_010", "Time");
define("CMS_L_DESKTOP_APPOINTMENT_011", "Remove after expiry");
define("CMS_L_DESKTOP_APPOINTMENT_012", "Contents");
define("CMS_L_DESKTOP_APPOINTMENT_013", "Participants");
//desktop_mailbox
//.....................................................................................................
define("CMS_L_DESKTOP_MAILBOX_001", "In-box");
define("CMS_L_DESKTOP_MAILBOX_002", "Out-box");
define("CMS_L_DESKTOP_MAILBOX_003", "Drafts");
define("CMS_L_DESKTOP_MAILBOX_004", "Trash");
define("CMS_L_DESKTOP_MAILBOX_005", "Spam");
define("CMS_L_DESKTOP_MAILBOX_006", "%d new message(s), thereof %d identified as spam.");
define("CMS_L_DESKTOP_MAILBOX_007", "Message");
define("CMS_L_DESKTOP_MAILBOX_008", "Sender");
define("CMS_L_DESKTOP_MAILBOX_009", "RE");
define("CMS_L_DESKTOP_MAILBOX_010", "Send date");
define("CMS_L_DESKTOP_MAILBOX_011", "Recipient");
define("CMS_L_DESKTOP_MAILBOX_012", "Secondary recipient");
define("CMS_L_DESKTOP_MAILBOX_013", "<small>Format:</small> " .
                                    "<strong>%s</strong>, " .
                                    "<small>Size:</small> %s");
define("CMS_L_DESKTOP_MAILBOX_014", "Compose message");
define("CMS_L_DESKTOP_MAILBOX_015", "CC (Copy)");
define("CMS_L_DESKTOP_MAILBOX_016", "BCC (Blind copy)");
define("CMS_L_DESKTOP_MAILBOX_017", "Subject");
define("CMS_L_DESKTOP_MAILBOX_018", "Account name");
define("CMS_L_DESKTOP_MAILBOX_019", "Incoming mail server (POP3)");
define("CMS_L_DESKTOP_MAILBOX_020", "Outgoing mail server (SMTP)");
define("CMS_L_DESKTOP_MAILBOX_021", "Signature");
define("CMS_L_DESKTOP_MAILBOX_022", "Spam filter activation threshold");
define("CMS_L_DESKTOP_MAILBOX_023", "Inactive");
define("CMS_L_DESKTOP_MAILBOX_024", "Receive");
define("CMS_L_DESKTOP_MAILBOX_025", "Send");
define("CMS_L_DESKTOP_MAILBOX_026", "Create folder");
define("CMS_L_DESKTOP_MAILBOX_027", "Rename folder");
define("CMS_L_DESKTOP_MAILBOX_028", "Delete folder");
define("CMS_L_DESKTOP_MAILBOX_029", "Settings");
define("CMS_L_DESKTOP_MAILBOX_030", "Read message");
define("CMS_L_DESKTOP_MAILBOX_031", "Mailbox");
define("CMS_L_DESKTOP_MAILBOX_032", "Folder");
define("CMS_L_DESKTOP_MAILBOX_033", "All");
define("CMS_L_DESKTOP_MAILBOX_034", "Invert");
define("CMS_L_DESKTOP_MAILBOX_035", "None");
define("CMS_L_DESKTOP_MAILBOX_036", "Move to");
define("CMS_L_DESKTOP_MAILBOX_037", "Date");
define("CMS_L_DESKTOP_MAILBOX_038", "Sort by date");
define("CMS_L_DESKTOP_MAILBOX_039", "Sender");
define("CMS_L_DESKTOP_MAILBOX_040", "Sort by Sender");
define("CMS_L_DESKTOP_MAILBOX_041", "Spam");
define("CMS_L_DESKTOP_MAILBOX_042", "Sort by spam probability");
define("CMS_L_DESKTOP_MAILBOX_043", "Size");
define("CMS_L_DESKTOP_MAILBOX_044", "Sort by size");
define("CMS_L_DESKTOP_MAILBOX_045", "Subject");
define("CMS_L_DESKTOP_MAILBOX_046", "Sort by subject");
define("CMS_L_DESKTOP_MAILBOX_047", "Training");
define("CMS_L_DESKTOP_MAILBOX_048", "Train as spam");
define("CMS_L_DESKTOP_MAILBOX_049", "Train as normal");
define("CMS_L_DESKTOP_MAILBOX_050", "Empty trash");
define("CMS_L_DESKTOP_MAILBOX_051", "Delete messages from server after receipt");
define("CMS_L_DESKTOP_MAILBOX_052", "Addresses");
define("CMS_L_DESKTOP_MAILBOX_053", "File attachment");
define("CMS_L_DESKTOP_MAILBOX_054", "-------- Original message --------");
define("CMS_L_DESKTOP_MAILBOX_055", "The to be forwarded message has been attached.");
define("CMS_L_DESKTOP_MAILBOX_056", "Reply");
define("CMS_L_DESKTOP_MAILBOX_057", "Forward");
define("CMS_L_DESKTOP_MAILBOX_058", "RE");
define("CMS_L_DESKTOP_MAILBOX_059", "FW");
define("CMS_L_DESKTOP_MAILBOX_060", "%d deleted message(s), thereof %d deleted from mail server.");
define("CMS_L_DESKTOP_MAILBOX_061", "Contains attachment");
//desktop_note
//.....................................................................................................
define("CMS_L_DESKTOP_NOTE_001", "Memo");
define("CMS_L_DESKTOP_NOTE_002", "Save and close");
//desktop_ims
//.....................................................................................................
define("CMS_L_DESKTOP_IMS_001", "Compose message");
define("CMS_L_DESKTOP_IMS_002", "Recipient");
define("CMS_L_DESKTOP_IMS_003", "Message");
define("CMS_L_DESKTOP_IMS_004", "There are no recipients.");
define("CMS_L_DESKTOP_IMS_005", "There are no messages.");
define("CMS_L_DESKTOP_IMS_006", "All");
define("CMS_L_DESKTOP_IMS_007", "Invert");
define("CMS_L_DESKTOP_IMS_008", "None");
define("CMS_L_DESKTOP_IMS_009", "Display correspondence with user");
define("CMS_L_DESKTOP_IMS_010", "Display successional messages");
define("CMS_L_DESKTOP_IMS_011", "Reply");
define("CMS_L_DESKTOP_IMS_012", "Messenger");
?>