<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

function diffpercent($value1,
                     $value2)
{
        /*
         * computes difference as percentual value
         *
         * binary safe, utf-8 compliant
         */

        if (! $value1)         return FALSE;

        $difference = abs(100 - (100 / $value1 * $value2));
        if ($value2 < $value1) $difference *= -1;

        return number_format($difference, 1, CMS_L_DECIMAL_SEPARATOR, "") . "%";
};
//-----------------------------------------------------------------------------------------------------
function format_bytesize($value)
{
        /*
         * formats byte value
         *
         * binary safe, utf-8 compliant
         */

        if ($value < 1024)
                return "$value Byte";
        if ($value < 1048576)
                return number_format($value / 1024, 2, CMS_L_DECIMAL_SEPARATOR, NULL) . " KB";
        if ($value < 1073741824)
                return number_format($value / 1048576, 2, CMS_L_DECIMAL_SEPARATOR, NULL) . " MB";
        return number_format($value / 1073741824, 2, CMS_L_DECIMAL_SEPARATOR, NULL) . " GB";
};
//-----------------------------------------------------------------------------------------------------
function flag($bitmask,
              $flag)
{
        /*
         * returns binary comparison result
         *
         * binary safe, utf-8 compliant
         */

        return (bool)($bitmask & $flag);
};
//-----------------------------------------------------------------------------------------------------
function sgn($value)
{
        /*
         * returns signum of value
         *
         * binary safe, utf-8 compliant
         */

        if($value > 0) return  1;
        if($value < 0) return -1;
        return 0;
};
?>