<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< CORE_CONTROL FUNCTIONS >========================================================================
//-----------------------------------------------------------------------------------------------------
function core_control(&$core,
                      $core_control_object  = NULL,
                      $core_control_command = NULL,
                      $core_control_value   = NULL,
                      $param                = NULL)
{
        //object type and id
        if (($i = strpos($core_control_object, ":")) !== FALSE)
        {
                $type   = substr($core_control_object, 0, $i);
                $object = substr($core_control_object, $i + 1);
        }
        else
        {
                $type   = $core_control_object;
                $object = "";
        };

        //command
        if (nstre($core_control_command))
        {
                switch ($type)
                {
                case "channel":
//.....................................................................................................
                        switch ($core_control_command)
                        {
                        case "connect":
//.....................................................................................................
                                $core->connect_channel($object,
                                                       isset($core_control_value["password"]) ?
                                                       $core_control_value["password"] : "");
                                break;

                        case "create":
//.....................................................................................................
                                if (isset($core_control_value["permanent"]))
                                        $core->create_channel($core_control_value["channel"],
                                                              $core_control_value["text"],
                                                              $core_control_value["password"]);

                                $core->connect_channel($core_control_value["channel"]);

                                $object = $core_control_value["channel"];
                                break;

                        case "edit":
//.....................................................................................................
                                $core->set_channel($object,
                                                   $core_control_value["text"],
                                                   $core_control_value["password"]);
                                break;

                        case "delete":
//.....................................................................................................
                                $core->delete_channel($object);
                                break;
                        };

                        break;

                case "user":
//.....................................................................................................
                        switch ($core_control_command)
                        {
                        case "private":
//.....................................................................................................
                                $core->send($core_control_value["data"],
                                            $core_control_value["guid"]);
                                break;
                        };

                        break;

                case "profile":
//.....................................................................................................
                        switch ($core_control_command)
                        {
                        case "edit":
//.....................................................................................................
                                if (nstreq($object, $core->guid))
                                {
                                        if (! $core->operator) break;

                                        if (
                                             (substr($object, 0, 1) === "!")
                                             &&
                                             cms_permission(CMS_CORE_PERMISSION_OPERATOR, TRUE, TRUE, substr($object, 1))
                                           )
                                                break;
                                };

                                global $core_control_value_image,
                                       $core_control_value_image_name,
                                       $core_control_value_image_size,
                                       $core_control_value_image_type;

                                if (
                                     nstre($core_control_value_image)
                                     &&
                                     is_file($core_control_value_image)
                                     &&
                                     preg_match("/\.(gif|jpe?g|png)$/i", $core_control_value_image_name)
                                     &&
                                     ($core_control_value_image_size <= 204800)
                                     &&
                                     preg_match("/^image\//i", $core_control_value_image_type)
                                   )
                                {
                                        $path      = CMS_DATA_PATH . "core/";
                                        $extension = strtolower(strrchr($core_control_value_image_name, "."));
                                        if (streq($extension, ".jpeg")) $extension = ".jpg";
                                        $filename  = unique_id() . $extension;

                                        mkpath($path);
                                        move_uploaded_file($core_control_value_image,
                                                           $path . $filename);
                                }
                                else
                                {
                                        $filename = "";
                                };

                                $core->set_profile($object,
                                                   $core_control_value["name"],
                                                   $core_control_value["color"],
                                                   $core_control_value["text"],
                                                   $filename);

                                $log = new log();
                                $log->user($core_control_value["name"]);
                        };

                        break;

                case "command":
//.....................................................................................................
                        switch ($core_control_command)
                        {
                        case "execute":
//.....................................................................................................
                                $status = $core_control_value["status"] * $core_control_value["activate"];

                                reset($core_control_value["guid"]);
                                while (list($key, $value) = each($core_control_value["guid"]))
                                {
                                        reset($core_control_value["channel"]);
                                        while (list($key, $_value) = each($core_control_value["channel"]))
                                                $core->status($status, $value, $_value);
                                };
                        };

                        break;
                };
        };

        //active channel
        $channel = $core->index->seek(array("guid" => $core->guid)) ?
                   $core->index->get("channel") : "";

        //set default
        if (stre($type))
        {
                $type   = "channel";
                $object = $channel;
        };

        //reload url
        $reload_url = "";

        echo("<form name=\"core_control\" " .
                   "method=\"post\" " .
                   "action=\"" . x(CMS_ACTIVE_URL . querystring($param)) . "\" " .
                   "enctype=\"multipart/form-data\">" .

        //menu
             "<table style=\"WIDTH:100%\">" .
             "<colgroup>" .
             "<col span=\"2\" " .
                  "style=\"WIDTH:50%\">" .
             "</colgroup>" .
             "<tr>" .
             "<th>" .

        //channels
             "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "channel_index"))) . "\">" .
             CMS_L_CORE_CONTROL_001 .
             "</a>" .
             "</th>" .
             "<th>" .

        //commands
             "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "command"))) . "\">" .
             CMS_L_CORE_CONTROL_025 .
             "</a>" .
             "</th>" .
             "</tr>" .

             "<tr>" .
             "<th>" .

        //users in active channel
             "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param)) . "\">" .
             CMS_L_CORE_CONTROL_002 .
             "</a>" .
             "</th>" .
             "<th>" .

        //profile
             "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "profile:" . $core->guid))) . "\">" .
             CMS_L_CORE_CONTROL_041 .
             "</a>" .
             "</th>" .
             "</tr>");

        switch ($type)
        {
        case "channel":
//.....................................................................................................
                $status = $core->get_status(NULL, $object);

                //menu
                if (
                     nstre($object)
                     &&
                     flag($status, CMS_CORE_STATUS_OWNER)
                     &&
                     $core->channel->seek(array("channel" => $object))
                   )
                        echo("<tr>" .
                             "<td colspan=\"2\">" .

                        //edit command
                             "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "channel_edit:$object"))) . "\">" .
                             CMS_L_CORE_CONTROL_015 .
                             "</a><br>" .

                        //delete command
                             "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "channel_delete:$object"))) . "\">" .
                             CMS_L_CORE_CONTROL_016 .
                             "</a>" .
                             "</td>" .
                             "</tr>");

                //show connect dialog
                if (nstreq($object, $channel))
                {
                        $status_override = flag($status, CMS_CORE_STATUS_OWNER) || flag($status, CMS_CORE_STATUS_OPERATOR);

                        //banned
                        if ((! $status_override) && flag($status, CMS_CORE_STATUS_BANNED))
                        {
                                echo("<tr>" .
                                     "<td colspan=\"2\">" .
                                     sprintf(CMS_L_CORE_CONTROL_014,
                                             "<strong>" .
                                             x($object) .
                                             "</strong>") .
                                     "</td>" .
                                     "</tr>");
                                break;
                        };

                        echo("<tr>" .
                             "<td colspan=\"2\">" .

                        //data
                             "<input name=\"core_control_object\" " .
                                    "type=\"hidden\" " .
                                    "value=\"channel:" . x($object) . "\">" .
                             "<input name=\"core_control_command\" " .
                                    "type=\"hidden\" " .
                                    "value=\"connect\">" .

                             "<p>" .
                             sprintf(CMS_L_CORE_CONTROL_012,
                                     "<strong>" .
                                     x($object) .
                                     "</strong>") .
                             "</p>");

                        //password
                        if (
                             (! $status_override)
                             &&
                             $core->channel->seek(array("channel"  => $object,
                                                        "password" => TRUE))
                           )
                                echo("<p>" .
                                     CMS_L_CORE_CONTROL_013 .
                                     "</p>" .
                                     "<label>" .
                                     "<small>" .
                                     CMS_L_PASSWORD .
                                     "</small><br>" .
                                     "<input name=\"core_control_value[password]\" " .
                                            "type=\"password\" " .
                                            "size=\"15\" " .
                                            "maxlength=\"20\">" .
                                     "</label> ");

                        //connect button
                        echo("<input type=\"submit\" " .
                                    "value=\"" . CMS_L_COMMAND_CONNECT . "\">" .
                             "</td>" .
                             "</tr>");
                        break;
                };

                //show users in active channel
                echo("<tr>" .
                     "<th colspan=\"2\">" .
                     image("core/icon_channel") . " " . x(stre($object) ? CMS_CORE_PORTAL : $object) .
                     "</th>" .
                     "</tr>");

                $core->index->reset();
                while ($core->index->next(array("guid"    => TRUE,
                                                "channel" => $object)))
                {
                        $guid   = $core->index->get("guid");
                        $status = $core->get_status($guid, $object);

                        //invisible
                        if ((! $core->operator) && nstreq($guid, $core->guid) && flag($status, CMS_CORE_STATUS_INVISIBLE)) continue;

                        $profile = $core->get_profile($guid);

                        //color
                        $name = x($profile["name"]);
                        if (nstre($profile["color"]))
                                $name = "<span style=\"COLOR:" . x($profile["color"]) . "\">" .
                                        $name .
                                        "</span>";

                        //absent
                        $name = (flag($status, CMS_CORE_STATUS_ABSENT) ?
                                "<span style=\"FONT-STYLE:italic\">" :
                                "<span style=\"FONT-WEIGHT:bold\">") .
                                $name .
                                "</span>";

                        //mute
                        if (flag($status, CMS_CORE_STATUS_MUTE))
                                $name = "<span style=\"TEXT-DECORATION:line-through\">" .
                                        $name .
                                        "</span>";

                        //icon
                        $icon = "core/icon_user";
                        if (flag($status, CMS_CORE_STATUS_OWNER))
                                $icon .= "_ow" .
                                         (flag($status, CMS_CORE_STATUS_INVISIBLE) ? "_i" : "") .
                                         (flag($status, CMS_CORE_STATUS_ABSENT)    ? "_a" : "");
                        elseif (flag($status, CMS_CORE_STATUS_OPERATOR))
                                $icon .= "_op" .
                                         (flag($status, CMS_CORE_STATUS_ABSENT)    ? "_a" : "");
                        else
                                $icon .= (flag($status, CMS_CORE_STATUS_ABSENT)    ? "_a" : "") .
                                         (flag($status, CMS_CORE_STATUS_MUTE)      ? "_m" : "");

                        $varied = class_varied();
                        echo("<tr>" .
                             "<td colspan=\"2\"$varied>");

                        //image
                        if (nstre($profile["image"]))
                        {
                                $image = CMS_DATA_URL . "core/" . r($profile["image"]);
                                echo("<div style=\"FLOAT:right;" .
                                                  "HEIGHT:auto;" .
                                                  "MAX-HEIGHT:65px;" .
                                                  "OVERFLOW:hidden;" .
                                                  "Z-INDEX:10\">" .
                                     "<a href=\"" . x($image) . "\" " .
                                        "onclick=\"load_page(this.href);return false;\">" .
                                     image($image, 75, NULL, CMS_L_CORE_CONTROL_021) .
                                     "</a>" .
                                     "</div>");
                        };

                        //name
                        echo("<div>" .
                             "<a href=\"" . x(CMS_ACTIVE_URL .
                                              querystring($param,
                                                          array("core_control_object" => streq($guid, $core->guid) ?
                                                                                         "profile:$guid" :
                                                                                         "user:$guid"))) . "\" " .
                                "title=\"" . x($guid) . "\">" .
                             image($icon) . " $name" .
                             "</a>" .
                             "</div>");

                        //description
                        if (nstre($profile["text"]))
                                echo("<div>" .
                                     "<small>" .
                                     ((utf8_strlen($profile["text"]) > 25) ?
                                     "<span title=\"" . x($profile["text"]) . "\">" .
                                     x(utf8_substr($profile["text"], 0, 24) . "\xE2\x80\xA6") .
                                     "</span>" :
                                     x($profile["text"])) .
                                     "</small>" .
                                     "</div>");

                        //primary status
                        echo("<div>" .
                             "<small>" .
                             CMS_L_CORE_CONTROL_003 . ": " .
                             "<strong>");
                        if (flag($status, CMS_CORE_STATUS_OWNER))        echo(CMS_L_CORE_CONTROL_004);
                        elseif (flag($status, CMS_CORE_STATUS_OPERATOR)) echo(CMS_L_CORE_CONTROL_005);
                        elseif (substr($guid, 0, 1) === "!")             echo(CMS_L_CORE_CONTROL_006);
                        else                                             echo(CMS_L_CORE_CONTROL_007);
                        echo("</strong>");

                        //special status
                        if ($core->operator)
                        {
                                if (flag($status, CMS_CORE_STATUS_SPY))       echo(" (" . CMS_L_CORE_CONTROL_028 . ")");
                                if (flag($status, CMS_CORE_STATUS_INVISIBLE)) echo(" (" . CMS_L_CORE_CONTROL_029 . ")");
                        };

                        //additional status
                        if (flag($status, CMS_CORE_STATUS_ABSENT)) echo(" (" . CMS_L_CORE_CONTROL_030 . ")");
                        if (flag($status, CMS_CORE_STATUS_MUTE))   echo(" (" . CMS_L_CORE_CONTROL_031 . ")");
                        if (flag($status, CMS_CORE_STATUS_BANNED)) echo(" (" . CMS_L_CORE_CONTROL_032 . ")");
                        echo("</small>" .
                             "</div>" .
                             "</td>" .
                             "</tr>");
                };

                //refresh
                $reload_url = CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "channel:$channel"));
                break;

        case "channel_create":
//.....................................................................................................

                //create new channel
                echo("<tr>" .
                     "<th colspan=\"2\">" .
                     CMS_L_CORE_CONTROL_017 .
                     "</th>" .
                     "</tr>" .

                     "<tr>" .
                     "<td colspan=\"2\">" .

                //data
                     "<input name=\"core_control_object\" " .
                            "type=\"hidden\" " .
                            "value=\"channel\">" .
                     "<input name=\"core_control_command\" " .
                            "type=\"hidden\" " .
                            "value=\"create\">" .

                     "<p>" .
                     CMS_L_CORE_CONTROL_048 .
                     "</p>" .

                //name
                     "<label>" .
                     "<small>" .
                     CMS_L_NAME .
                     "</small><br>" .
                     "<input name=\"core_control_value[channel]\" " .
                            "type=\"text\" " .
                            "size=\"15\" " .
                            "maxlength=\"20\"> " .
                     "</label>" .

                //create button
                     "<input type=\"submit\" " .
                            "value=\"" . CMS_L_CORE_CONTROL_050 . "\">");

                //extended
                if ($core->operator)

                        //permanent
                        echo("<hr>" .
                             "<label>" .
                             "<input name=\"core_control_value[permanent]\" " .
                                   "type=\"checkbox\" " .
                                   "value=\"1\">" .
                             CMS_L_CORE_CONTROL_018 .
                             "</label><br>" .

                        //description
                             "<label>" .
                             "<small>" .
                             CMS_L_DESCRIPTION .
                             "</small><br>" .
                             "<textarea name=\"core_control_value[text]\" " .
                                       "cols=\"25\" " .
                                       "rows=\"5\" " .
                                       "onkeyup=\"limit(this,1024);\">\n" .
                             "</textarea>" .
                             "</label><br>" .

                        //password
                             "<label>" .
                             "<small>" .
                             CMS_L_PASSWORD .
                             "</small><br>" .
                             "<input name=\"core_control_value[password]\" " .
                                    "type=\"password\" " .
                                    "size=\"20\" " .
                                    "maxlength=\"20\">" .
                             "</label>");

                echo("</td>" .
                     "</tr>");
                break;

        case "channel_edit":
//.....................................................................................................
                if (stre($object)) break;

                //edit permanent channel
                echo("<tr>" .
                     "<th colspan=\"2\">" .
                     CMS_L_CORE_CONTROL_015 .
                     "</th>" .
                     "</tr>");

                //not found
                if (! $core->channel->seek(array("channel" => $object)))
                {
                        echo("<tr>" .
                             "<td colspan=\"2\">" .
                             CMS_L_CORE_CONTROL_019 .
                             "</td>" .
                             "</tr>");
                        break;
                };

                echo("<tr>" .
                     "<td colspan=\"2\">" .

                //data
                     "<input name=\"core_control_object\" " .
                            "type=\"hidden\" " .
                            "value=\"channel:" . x($object) . "\">" .
                     "<input name=\"core_control_command\" " .
                            "type=\"hidden\" " .
                            "value=\"edit\">" .

                //description
                     "<label>" .
                     "<small>" .
                     CMS_L_DESCRIPTION .
                     "</small><br>" .
                     "<textarea name=\"core_control_value[text]\" " .
                               "cols=\"25\" " .
                               "rows=\"5\" " .
                               "onkeyup=\"limit(this,1024);\">\n" .
                     x($core->channel->get("text")) .
                     "</textarea>" .
                     "</label><br>" .

                //password
                     "<label>" .
                     "<small>" .
                     CMS_L_PASSWORD .
                     "</small><br>" .
                     "<input name=\"core_control_value[password]\" " .
                            "type=\"password\" " .
                            "value=\"" . x($core->channel->get("password")) . "\" " .
                            "size=\"15\" " .
                            "maxlength=\"20\">" .
                     "</label> " .

                //save button
                     "<input type=\"submit\" " .
                            "value=\"" . CMS_L_COMMAND_SAVE . "\">" .
                     "</td>" .
                     "</tr>");
                break;

        case "channel_delete":
//.....................................................................................................
                if (stre($object)) break;

                //delete permanent channel
                echo("<tr>" .
                     "<th colspan=\"2\">" .
                     CMS_L_CORE_CONTROL_016 .
                     "</th>" .
                     "</tr>");

                //not found
                if (! $core->channel->seek(array("channel" => $object)))
                {
                        echo("<tr>" .
                             "<td colspan=\"2\">" .
                             CMS_L_CORE_CONTROL_019 .
                             "</td>" .
                             "</tr>");
                        break;
                };

                echo("<tr>" .
                     "<td colspan=\"2\">" .

                //data
                     "<input name=\"core_control_object\" " .
                            "type=\"hidden\" " .
                            "value=\"channel:" . x($object) . "\">" .
                     "<input name=\"core_control_command\" " .
                            "type=\"hidden\" " .
                            "value=\"delete\">" .

                     "<p>" .
                     sprintf(CMS_L_CORE_CONTROL_020,
                             "<strong>" .
                             x($object) .
                             "</strong>") .
                     "</p>" .

                //delete button
                     "<input type=\"submit\" " .
                            "value=\"" . CMS_L_COMMAND_DELETE . "\">" .
                     "</td>" .
                     "</tr>");
                break;

        case "channel_index":
//.....................................................................................................

                //menu
                echo("<tr>" .
                     "<td colspan=\"2\">" .
                     "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "channel_create"))) . "\">" .
                     CMS_L_CORE_CONTROL_017 .
                     "</a>" .
                     "</td>" .
                     "</tr>");

                //collect permanent channels
                $list = array();

                $core->channel->reset();
                while ($core->channel->next(array("channel" => TRUE)))
                {
                        $_channel = $core->channel->get("channel");
                        $list[$_channel] = array("text"     => $core->channel->get("text"),
                                                 "password" => (bool)$core->channel->get("password"),
                                                 "user"     => 0);
                };

                //collect temporary channels
                $_list = array("" => 0);

                $core->index->reset();
                while ($core->index->next(array("guid" => TRUE)))
                {
                        $guid     = $core->index->get("guid");
                        $_channel = $core->index->get("channel");

                        //invisible
                        if (
                             (! $core->operator)
                             &&
                             nstreq($guid, $core->guid)
                             &&
                             flag($core->get_status($guid, $_channel), CMS_CORE_STATUS_INVISIBLE)
                           )
                                continue;

                        if (isset($list[$_channel]))      $list[$_channel]["user"]++;
                        elseif (isset($_list[$_channel])) $_list[$_channel]++;
                        else                              $_list[$_channel] = 1;
                };

                //display portal
                echo("<tr>" .
                     "<td colspan=\"2\">" .
                     "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "channel"))) . "\">" .
                     image("core/icon_channel") . " " . x(CMS_CORE_PORTAL) .
                     "</a><br>" .
                     "<small>" .
                     sprintf(CMS_L_CORE_CONTROL_010, $_list[""]) .
                     "</small>" .
                     "</td>" .
                     "</tr>");

                unset($_list[""]);

                //display permanent channels
                if (count($list) > 0)
                {
                        echo("<tr>" .
                             "<th colspan=\"2\">" .
                             CMS_L_CORE_CONTROL_008 .
                             "</th>" .
                             "</tr>");

                        reset($list);
                        while (list($key) = each($list))
                        {
                                $varied = class_varied();
                                echo("<tr>" .
                                     "<td colspan=\"2\"$varied>" .
                                     "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "channel:$key"))) . "\"" .
                                     (stre($list[$key]["text"])     ? ">" : " title=\"" . x($list[$key]["text"]) . "\">") .
                                     image("core/icon_channel") . " " . x($key) .
                                     "</a><br>" .
                                     "<small>" .
                                     sprintf(CMS_L_CORE_CONTROL_010, $list[$key]["user"]) .
                                     (stre($list[$key]["password"]) ? ""  : "<br>" . CMS_L_CORE_CONTROL_011) .
                                     "</small>" .
                                     "</td>" .
                                     "</tr>");
                        };
                };

                //display temporary channels
                if (count($_list) > 0)
                {
                        echo("<tr>" .
                             "<th colspan=\"2\">" .
                             CMS_L_CORE_CONTROL_009 .
                             "</th>" .
                             "</tr>");

                        reset($_list);
                        while (list($key, $value) = each($_list))
                        {
                                $varied = class_varied();
                                echo("<tr>" .
                                     "<td colspan=\"2\"$varied>" .
                                     "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "channel:$key"))) . "\">" .
                                     image("core/icon_channel") . " " . x($key) .
                                     "</a><br>" .
                                     "<small>" .
                                     sprintf(CMS_L_CORE_CONTROL_010, $value) .
                                     "</small>" .
                                     "</td>" .
                                     "</tr>");
                        };
                };

                //refresh
                $reload_url = CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "channel_index"));
                break;

        case "user":
//.....................................................................................................

                //send private message
                if (! isset($core_control_value["guid"])) $core_control_value["guid"] = $object;

                echo("<tr>" .
                     "<th colspan=\"2\">" .
                     CMS_L_CORE_CONTROL_035 .
                     "</th>" .
                     "</tr>" .

                     "<tr>" .
                     "<td colspan=\"2\">" .

                //data
                     "<input name=\"core_control_object\" " .
                            "type=\"hidden\" " .
                            "value=\"user:" . x($object) . "\">" .
                     "<input name=\"core_control_command\" " .
                            "type=\"hidden\" " .
                            "value=\"private\">");

                //collect users in active channel
                $list = array();
                $flag = TRUE;

                $core->index->reset();
                while ($core->index->next(array("guid"    => TRUE,
                                                "channel" => $channel)))
                {
                        $guid = $core->index->get("guid");

                        if (

                        //exclude self
                             nstreq($guid, $core->guid)
                             &&

                        //exclude invisible
                             (
                               ($core->operator)
                               ||
                               (! flag($core->get_status($guid), CMS_CORE_STATUS_INVISIBLE))
                             )
                           )
                        {
                                $core->profile->seek(array("guid" => $guid));
                                $name = $core->profile->get("name");
                                if ($flag)
                                {
                                        $name .= str_repeat(" ", 25 - utf8_strlen($name));
                                        $flag  = FALSE;
                                };
                                $list[$name] = $guid;
                        };
                };

                if (count($list) === 0)
                {
                        echo(CMS_L_CORE_CONTROL_039 .
                             "</td>" .
                             "</tr>");
                        break;
                };

                //receiver
                echo("<label>" .
                     "<small>" .
                     CMS_L_CORE_CONTROL_036 .
                     "</small><br>");
                select($list,
                       $core_control_value["guid"],
                       "core_control_value[guid]",
                       TRUE,
                       FALSE,
                       10);
                echo("</label><br>" .

                //message
                     "<label>" .
                     "<small>" .
                     CMS_L_CORE_CONTROL_037 .
                     "</small><br>" .
                     "<textarea name=\"core_control_value[data]\" " .
                               "cols=\"25\" " .
                               "rows=\"5\" " .
                               "onkeyup=\"limit(this,1024);\">\n" .
                     "</textarea>" .
                     "</label><br>" .

                //send button
                     "<input type=\"submit\" " .
                            "value=\"" . CMS_L_CORE_CONTROL_038 . "\">" .
                     "</td>" .
                     "</tr>");
                break;

        case "profile":
//.....................................................................................................

                //foreign profile
                if (nstreq($object, $core->guid))
                {
                        //operators only
                        if (! $core->operator) break;

                        //exclude administrators
                        if (
                             (substr($object, 0, 1) === "!")
                             &&
                             cms_permission(CMS_CORE_PERMISSION_OPERATOR, TRUE, TRUE, substr($object, 1))
                           )
                                break;
                };

                //not found
                if (($profile = $core->get_profile($object)) === FALSE)
                {
                        echo("<tr>" .
                             "<td colspan=\"2\">" .
                             CMS_L_CORE_CONTROL_046 .
                             "</td>" .
                             "</tr>");
                        break;
                };

                //menu
                if ($core->operator)
                        echo("<tr>" .
                             "<td colspan=\"2\">" .
                             "<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "profile_index"))) . "\">" .
                             CMS_L_CORE_CONTROL_045 .
                             "</a>" .
                             "</td>" .
                             "</tr>");

                echo("<tr>" .
                     "<td colspan=\"2\">" .

                //data
                     "<input name=\"core_control_object\" " .
                            "type=\"hidden\" " .
                            "value=\"profile:" . x($object) . "\">" .
                     "<input name=\"core_control_command\" " .
                            "type=\"hidden\" " .
                            "value=\"edit\">" .

                //name
                     "<label>" .
                     "<small>" .
                     CMS_L_NAME .
                     "</small><br>" .
                     "<input name=\"core_control_value[name]\" " .
                            "type=\"text\" " .
                            "value=\"" . x($profile["name"]) . "\" " .
                            "size=\"15\" " .
                            "maxlength=\"40\">" .
                     "</label> " .

                //save button
                     "<input type=\"submit\" " .
                            "value=\"" . CMS_L_COMMAND_SAVE . "\"><br>" .

                //color
                     "<small" . (stre($profile["color"]) ? ">" : " style=\"COLOR:" . x($profile["color"]) . "\">") .
                     CMS_L_COLOR .
                     "</small><br>" .
                     "<input name=\"core_control_value[color]\" " .
                            "type=\"hidden\" " .
                            "value=\"" . x($profile["color"]) . "\">" .
                     jscript("colorcontrol(\"document.core_control.elements[4]\", " .
                             "\"" . q(CMS_IMAGES_URL) . "colorcontrol/map.png\");") .
                             "<br>" .

                //description
                     "<label>" .
                     "<small>" .
                     CMS_L_CORE_CONTROL_042 .
                     "</small><br>" .
                     "<textarea name=\"core_control_value[text]\" " .
                               "cols=\"25\" " .
                               "rows=\"5\" " .
                               "onkeyup=\"limit(this,1024);\">\n" .
                     x($profile["text"]) .
                     "</textarea>" .
                     "</label><br>");

                //image
                if (nstre($image = $profile["image"]))
                {
                        $image = CMS_DATA_URL . "core/" . r($image);
                        echo("<small>" .
                             CMS_L_CORE_CONTROL_021 .
                             "</small><br>" .
                             "<a href=\"" . x($image) . "\" " .
                                "onclick=\"load_page(this.href);return false;\">" .
                             image($image, 200, NULL, CMS_L_CORE_CONTROL_021) .
                             "</a><br>");
                };
                echo("<label>" .
                     "<small>" .
                     CMS_L_CORE_CONTROL_043 .
                     "</small><br>" .
                     "<input name=\"core_control_value_image\" " .
                            "type=\"file\">" .
                     "</label><br>" .
                     CMS_L_CORE_CONTROL_044 .

                     "</td>" .
                     "</tr>");
                break;

        case "profile_index":
//.....................................................................................................
                if (! $core->operator) break; //operators only

                echo("<tr>" .
                     "<th colspan=\"2\">" .
                     CMS_L_CORE_CONTROL_045 .
                     "</th>" .
                     "</tr>");

                $core->profile->reset();
                while ($core->profile->next(array("guid" => TRUE)))
                {
                        $guid   = $core->profile->get("guid");
                        $status = $core->get_status($guid, $channel);

                        //and invisible
                        if ((! $core->operator) && nstreq($guid, $core->guid) && flag($status, CMS_CORE_STATUS_INVISIBLE)) continue;

                        $profile = $core->get_profile($guid);

                        //color
                        $name = x($profile["name"]);
                        if (nstre($profile["color"]))
                                $name = "<span style=\"COLOR:" . x($profile["color"]) . "\">" .
                                        $name .
                                        "</span>";

                        //absent
                        $name = (flag($status, CMS_CORE_STATUS_ABSENT) ?
                                "<span style=\"FONT-STYLE:italic\">" :
                                "<span style=\"FONT-WEIGHT:bold\">") .
                                $name .
                                "</span>";

                        //mute
                        if (flag($status, CMS_CORE_STATUS_MUTE))
                                $name = "<span style=\"TEXT-DECORATION:line-through\">" .
                                        $name .
                                        "</span>";

                        //icon
                        $icon = "core/icon_user";
                        if (flag($status, CMS_CORE_STATUS_OWNER))
                                $icon .= "_ow" .
                                         (flag($status, CMS_CORE_STATUS_INVISIBLE) ? "_i" : "") .
                                         (flag($status, CMS_CORE_STATUS_ABSENT)    ? "_a" : "");
                        elseif (flag($status, CMS_CORE_STATUS_OPERATOR))
                                $icon .= "_op" .
                                         (flag($status, CMS_CORE_STATUS_ABSENT)    ? "_a" : "");
                        else
                                $icon .= (flag($status, CMS_CORE_STATUS_BANNED)    ? "_b" :
                                         (flag($status, CMS_CORE_STATUS_ABSENT)    ? "_a" : "") .
                                         (flag($status, CMS_CORE_STATUS_MUTE)      ? "_m" : ""));

                        $varied = class_varied();
                        echo("<tr>" .
                             "<td colspan=\"2\"$varied>");

                        //image
                        if (nstre($profile["image"]))
                        {
                                $image  = CMS_DATA_URL . "core/" . r($profile["image"]);
                                echo("<div style=\"FLOAT:right;" .
                                                  "HEIGHT:auto;" .
                                                  "MAX-HEIGHT:65px;" .
                                                  "OVERFLOW:hidden;" .
                                                  "Z-INDEX:10\">" .
                                     "<a href=\"" . x($image) . "\" " .
                                        "onclick=\"load_page(this.href);return false;\">" .
                                     image($image, 75, NULL, CMS_L_CORE_CONTROL_021) .
                                     "</a>" .
                                     "</div>");
                        };

                        //name
                        echo("<div>");

                        //self or not administrator
                        if (
                             streq($guid, $core->guid)
                             ||
                             (substr($guid, 0, 1) !== "!")
                             ||
                             (! cms_permission(CMS_CORE_PERMISSION_OPERATOR, TRUE, TRUE, substr($guid, 1)))
                           )
                                echo("<a href=\"" . x(CMS_ACTIVE_URL . querystring($param, array("core_control_object" => "profile:$guid"))) . "\" " .
                                        "title=\"" . x($guid) . "\">" .
                                     image($icon) . " $name" .
                                     "</a>");
                        else
                                echo("<span title=\"" . x($guid) . "\">" .
                                     image($icon) . " $name" .
                                     "</span>");
                        echo("</div>");

                        //description
                        if (nstre($profile["text"]))
                                echo("<div>" .
                                     "<small>" .
                                     ((utf8_strlen($profile["text"]) > 25) ?
                                     "<span title=\"" . x($profile["text"]) . "\">" .
                                     x(utf8_substr($profile["text"], 0, 24) . "\xE2\x80\xA6") .
                                     "</span>" :
                                     x($profile["text"])) .
                                     "</small>" .
                                     "</div>");

                        //primary status
                        echo("<div>" .
                             "<small>" .
                             CMS_L_CORE_CONTROL_003 . ": " .
                             "<strong>");
                        if (flag($status, CMS_CORE_STATUS_OWNER))        echo(CMS_L_CORE_CONTROL_004);
                        elseif (flag($status, CMS_CORE_STATUS_OPERATOR)) echo(CMS_L_CORE_CONTROL_005);
                        elseif (substr($guid, 0, 1) === "!")             echo(CMS_L_CORE_CONTROL_006);
                        else                                             echo(CMS_L_CORE_CONTROL_007);
                        echo("</strong>");

                        //special status
                        if ($core->operator)
                        {
                                if (flag($status, CMS_CORE_STATUS_SPY))       echo(" (" . CMS_L_CORE_CONTROL_028 . ")");
                                if (flag($status, CMS_CORE_STATUS_INVISIBLE)) echo(" (" . CMS_L_CORE_CONTROL_029 . ")");
                        };

                        //additional status
                        if (flag($status, CMS_CORE_STATUS_ABSENT)) echo(" (" . CMS_L_CORE_CONTROL_030 . ")");
                        if (flag($status, CMS_CORE_STATUS_MUTE))   echo(" (" . CMS_L_CORE_CONTROL_031 . ")");
                        if (flag($status, CMS_CORE_STATUS_BANNED)) echo(" (" . CMS_L_CORE_CONTROL_032 . ")");
                        echo("</small>" .
                             "</div>" .
                             "</td>" .
                             "</tr>");
                };

                break;

        case "command":
//.....................................................................................................
                if (! isset($core_control_value["status"]))   $core_control_value["status"]    = CMS_CORE_STATUS_ABSENT;
                if (! isset($core_control_value["activate"])) $core_control_value["activate"]  = 1;
                else                                          $core_control_value["activate"] *= -1;
                if (! isset($core_control_value["guid"]))     $core_control_value["guid"]      = $core->guid;
                if (! isset($core_control_value["channel"]))  $core_control_value["channel"]   = $channel;

                echo("<tr>" .
                     "<td colspan=\"2\">" .

                //data
                     "<input name=\"core_control_object\" " .
                            "type=\"hidden\" " .
                            "value=\"command\">" .
                     "<input name=\"core_control_command\" " .
                            "type=\"hidden\" " .
                            "value=\"execute\">" .

                     "<p>" .
                     CMS_L_CORE_CONTROL_040 .
                     "</p>");

                //status
                $list = array();

                if ($core->operator)
                {
                        $list[CMS_L_CORE_CONTROL_004] = CMS_CORE_STATUS_OWNER;
                        $list[CMS_L_CORE_CONTROL_028] = CMS_CORE_STATUS_SPY;
                        $list[CMS_L_CORE_CONTROL_029] = CMS_CORE_STATUS_INVISIBLE;
                };

                $list[CMS_L_CORE_CONTROL_030] = CMS_CORE_STATUS_ABSENT;
                $list[CMS_L_CORE_CONTROL_005] = CMS_CORE_STATUS_OPERATOR;
                $list[CMS_L_CORE_CONTROL_031] = CMS_CORE_STATUS_MUTE;
                $list[CMS_L_CORE_CONTROL_032] = CMS_CORE_STATUS_BANNED;

                echo("<label>" .
                     "<small>" .
                     CMS_L_CORE_CONTROL_051 .
                     "</small><br>");
                select($list,
                       $core_control_value["status"],
                       "core_control_value[status]",
                       TRUE);
                echo("</label> " .

                     "<input type=\"submit\" " .
                            "value=\"" . CMS_L_CORE_CONTROL_049 . "\"><br>" .
                     "<label>" .

                //set
                     "<input name=\"core_control_value[activate]\" " .
                            "type=\"radio\" " .
                            "value=\"1\"" .
                            (($core_control_value["activate"] > 0) ? " checked>" : ">") .
                     CMS_L_CORE_CONTROL_026 .
                     "</label> " .

                //revoke
                     "<label>" .
                     "<input name=\"core_control_value[activate]\" " .
                            "type=\"radio\" " .
                            "value=\"-1\"" .
                            (($core_control_value["activate"] < 0) ? " checked>" : ">") .
                     CMS_L_CORE_CONTROL_027 .
                     "</label>" .
                     "</td>" .
                     "</tr>" .

                //target user
                     "<tr>" .
                     "<th colspan=\"2\">" .
                     image("core/icon_user") . " " . CMS_L_CORE_CONTROL_033 .
                     "</th>" .
                     "</tr>" .

                     "<tr>" .
                     "<td colspan=\"2\">");

                $list = array();
                $flag = TRUE;

                $core->profile->reset();
                while ($core->profile->next(array("guid" => TRUE)))
                {
                        $guid = $core->profile->get("guid");

                        if (
                             $core->operator
                             ||
                             streq($guid, $core->guid)
                             ||
                             (substr($guid, 0, 1) === "!")
                             ||
                             (! flag($core->get_status($guid), CMS_CORE_STATUS_INVISIBLE))
                           )
                        {
                                $name = $core->profile->get("name");
                                if ($flag)
                                {
                                        $name .= str_repeat(" ", 25 - utf8_strlen($name));
                                        $flag  = FALSE;
                                };
                                $list[$name] = $core->profile->get("guid");
                        }
                };

                ksort($list);

                select($list,
                       $core_control_value["guid"],
                       "core_control_value[guid]",
                       TRUE,
                       FALSE,
                       10);

                echo("</td>" .
                     "</tr>" .

                //target channel
                     "<tr>" .
                     "<th colspan=\"2\">" .
                     image("core/icon_channel") . " " . CMS_L_CORE_CONTROL_034 .
                     "</th>" .
                     "</tr>" .

                     "<tr>" .
                     "<td colspan=\"2\">");


                $list = array(str_repeat(" ", 25) => "");

                $core->channel->reset();
                while ($core->channel->next(array("channel" => TRUE)))
                {
                        $name        = $core->channel->get("channel");
                        $list[$name] = $name;
                };

                $core->index->reset();
                while ($core->index->next(array("channel" => TRUE)))
                {
                        $name        = $core->index->get("channel");
                        $list[$name] = $name;
                };

                ksort($list);

                select($list,
                       $core_control_value["channel"],
                       "core_control_value[channel]",
                       TRUE,
                       FALSE,
                       10);

                echo("</td>" .
                     "</tr>");
        };

        echo("</table>" .
             "</form>");

        //refresh
        if (nstre($reload_url))
                echo(jscript("setTimeout(\"location.replace(\\\"" . q(q($reload_url)) . "\\\");\", 20000);"));
};
?>