<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< FORUM CLASS >===================================================================================
//-----------------------------------------------------------------------------------------------------

//permission
define("CMS_FORUM_PERMISSION_WRITER",    "writer");
define("CMS_FORUM_PERMISSION_OPERATOR",  "operator");

//database
define("CMS_DB_FORUM",                   CMS_DB_PREFIX . "forum");
define("CMS_DB_FORUM_INDEX",             "id");
define("CMS_DB_FORUM_CONTAINER",         "container");
define("CMS_DB_FORUM_USER",              "user");
define("CMS_DB_FORUM_TITLE",             "title");
define("CMS_DB_FORUM_TEXT",              "text");
define("CMS_DB_FORUM_NAME",              "name");
define("CMS_DB_FORUM_EMAIL",             "email");
define("CMS_DB_FORUM_TIME",              "time");
define("CMS_DB_FORUM_ACCESS",            "access");

//option
define("CMS_FORUM_OPTION_SHOW_SUBENTRY", 1);

class forum
{
//properties
//-----------------------------------------------------------------------------------------------------
        public $instance = NULL;
        public $db_table = CMS_DB_FORUM;
        public $mysql    = NULL;
        public $operator = NULL;
        public $writer   = NULL;
        public $enabled  = NULL;
//constructor
//-----------------------------------------------------------------------------------------------------
        function __construct()
        {
                if (cms_instance()) $this->db_table .= "_" . cms_instance();

                $this->mysql = new mysql();
                if ($this->mysql->verify_table($this->db_table,
                                               array(CMS_DB_FORUM_INDEX     => "INT UNSIGNED PRIMARY KEY AUTO_INCREMENT NOT NULL",
                                                     CMS_DB_FORUM_CONTAINER => "INT UNSIGNED NOT NULL",
                                                     CMS_DB_FORUM_USER      => "VARCHAR(40) NOT NULL",
                                                     CMS_DB_FORUM_TITLE     => "VARCHAR(40) NOT NULL",
                                                     CMS_DB_FORUM_TEXT      => "TEXT NOT NULL",
                                                     CMS_DB_FORUM_NAME      => "VARCHAR(40) NOT NULL",
                                                     CMS_DB_FORUM_EMAIL     => "VARCHAR(40) NOT NULL",
                                                     CMS_DB_FORUM_TIME      => "INT UNSIGNED NOT NULL",
                                                     CMS_DB_FORUM_ACCESS    => "INT UNSIGNED NOT NULL")))
                {
                        $this->operator = cms_permission(CMS_FORUM_PERMISSION_OPERATOR);
                        $this->writer   = cms_permission(CMS_FORUM_PERMISSION_WRITER);
                        $this->enabled  = TRUE;
                };
        }
//methods
//-----------------------------------------------------------------------------------------------------
        function move($index,
                      $parent)
        {
                if (
                     $this->enabled
                     &&
                     $this->operator
                     &&
                     mysql_query("UPDATE " . $this->db_table . " " .
                                 "SET " .    CMS_DB_FORUM_CONTAINER . "='" . sqlesc($parent) . "' " .
                                 "WHERE " .  CMS_DB_FORUM_INDEX .     "='" . sqlesc($index) . "' " .
                                 "LIMIT 1")
                   )
                        return TRUE;

                return FALSE;
        }
//-----------------------------------------------------------------------------------------------------
        function delete($index)
        {
                if (
                     $this->enabled
                     &&
                     $this->operator
                     &&
                     $this->mysql->delete($index, $this->db_table)
                   )
                        return TRUE;

                return FALSE;
        }
//-----------------------------------------------------------------------------------------------------
        function add($index,
                     $title,
                     $message,
                     $name,
                     $email = NULL)
        {
                $index = sqlesc($index);
                $time  = time();

                if (
                     ($this->enabled)
                     &&
                     $this->writer
                     &&
                     (
                       $index
                       ||
                       $this->operator
                     )
                     &&
                     mysql_query("INSERT " . $this->db_table . " " .
                                       "(" . CMS_DB_FORUM_CONTAINER . ", " .
                                             CMS_DB_FORUM_USER . ", " .
                                             CMS_DB_FORUM_TITLE . ", " .
                                             CMS_DB_FORUM_TEXT . ", " .
                                             CMS_DB_FORUM_NAME . ", " .
                                             CMS_DB_FORUM_EMAIL . ", " .
                                             CMS_DB_FORUM_TIME . ") " .
                                 "VALUES " .
                                      "('" . $index . "', " .
                                       "'" . sqlesc(CMS_USER) . "', " .
                                       "'" . sqlesc($title) . "', " .
                                       "'" . sqlesc($message) . "', " .
                                       "'" . sqlesc($name) . "', " .
                                       "'" . sqlesc($email) . "', " .
                                       "'" . $time . "')")
                   )
                {
                        $_index     = mysql_insert_id();

                        $log = new log();
                        $log->access(sprintf(CMS_L_FORUM_008, $_index, $title, $name));
                        $log->user($name, NULL, NULL, NULL, NULL, $email);

                        if ($index && $_index)
                        {
                                $result    = mysql_query("SELECT " . CMS_DB_FORUM_TITLE . ", " .
                                                                     CMS_DB_FORUM_NAME . ", " .
                                                                     CMS_DB_FORUM_EMAIL . ", " .
                                                                     CMS_DB_FORUM_TIME . " " .
                                                         "FROM " .   $this->db_table . " " .
                                                         "WHERE " .  CMS_DB_FORUM_INDEX . "='$index' " .
                                                         "LIMIT 1");
                                $resultrow = mysql_fetch_assoc($result);

                                if (
                                     $resultrow[CMS_DB_FORUM_EMAIL]
                                     &&
                                     cms_load("smtp")
                                   )
                                {
                                        smtp_send($resultrow[CMS_DB_FORUM_EMAIL],
                                                  CMS_L_FORUM_001,
                                                  sprintf(CMS_L_FORUM_002,
                                                          $resultrow[CMS_DB_FORUM_NAME],
                                                          $resultrow[CMS_DB_FORUM_TITLE] . ", " .
                                                          date(CMS_L_DATE_FORMAT, $resultrow[CMS_DB_FORUM_TIME]),
                                                          CMS_ROOT_URL,
                                                          CMS_ACTIVE_URL .
                                                          cms_param(array("forum_instance" => cms_instance(),
                                                                          "forum_index"    => $_index))));
                                };
                        };

                        return $_index;
                };

                return $index;
        }
//-----------------------------------------------------------------------------------------------------
        function log_access($index)
        {
                if (! $this->enabled) return FALSE;

                mysql_query("UPDATE " . $this->db_table . " " .
                            "SET " .    CMS_DB_FORUM_ACCESS . "=" . CMS_DB_FORUM_ACCESS . "+1 " .
                            "WHERE " .  CMS_DB_FORUM_INDEX .  "='" . sqlesc($index) . "' " .
                            "LIMIT 1");
        }
//-----------------------------------------------------------------------------------------------------
        function edit($index,
                      $title,
                      $message,
                      $name,
                      $email)
        {
                if (
                     $this->enabled
                     &&
                     $this->operator
                     &&
                     mysql_query("UPDATE " . $this->db_table . " " .
                                 "SET " .    CMS_DB_FORUM_TITLE . "='" . sqlesc($title) . "', " .
                                             CMS_DB_FORUM_TEXT .  "='" . sqlesc($message) . "', " .
                                             CMS_DB_FORUM_NAME .  "='" . sqlesc($name) . "', " .
                                             CMS_DB_FORUM_EMAIL . "='" . sqlesc($email) . "' " .
                                 "WHERE " .  CMS_DB_FORUM_INDEX . "='" . sqlesc($index) . "' " .
                                 "LIMIT 1")
                   )
                        return TRUE;

                return FALSE;
        }
//-----------------------------------------------------------------------------------------------------
        function search($keyword,
                        $action)
        {
                if (! $this->enabled) return FALSE;

                $log = new log();
                $log->access(sprintf(CMS_L_FORUM_007, $keyword));

                $keyword    = stripspaces($keyword);
                if (! $keyword)
                {
                        echo(info(CMS_L_FORUM_003));
                        return FALSE;
                };

                $_keyword   = str_replace(" ", "%' OR " . CMS_DB_FORUM_TITLE . " LIKE '%", $keyword);
                $__keyword  = str_replace(" ", "%' OR " . CMS_DB_FORUM_NAME .  " LIKE '%", $keyword);
                $___keyword = str_replace(" ", "%' OR " . CMS_DB_FORUM_TEXT .  " LIKE '%", $keyword);
                $result     = mysql_query("SELECT * " .
                                          "FROM " .  $this->db_table . " " .
                                          "WHERE " . CMS_DB_FORUM_TITLE . " LIKE '%$_keyword%' " .
                                          "OR " .    CMS_DB_FORUM_NAME .  " LIKE '%$__keyword%' " .
                                          "OR " .    CMS_DB_FORUM_TEXT .  " LIKE '%$___keyword%'");

                $array      = explode(" ", $keyword);
                while ($resultrow = mysql_fetch_assoc($result))
                {
                        $_array[$resultrow[CMS_DB_FORUM_INDEX]]  = 0;
                        $__array[$resultrow[CMS_DB_FORUM_INDEX]] =
                                array(CMS_DB_FORUM_TITLE  => $resultrow[CMS_DB_FORUM_TITLE],
                                      CMS_DB_FORUM_NAME   => $resultrow[CMS_DB_FORUM_NAME],
                                      CMS_DB_FORUM_TIME   => $resultrow[CMS_DB_FORUM_TIME],
                                      CMS_DB_FORUM_ACCESS => $resultrow[CMS_DB_FORUM_ACCESS]);

                        reset($array);
                        while (list(, $value) = each($array))
                                $_array[$resultrow[CMS_DB_FORUM_INDEX]] +=
                                        substri_count($resultrow[CMS_DB_FORUM_TITLE], $value) * 3 +
                                        substri_count($resultrow[CMS_DB_FORUM_NAME],  $value) * 2 +
                                        substri_count($resultrow[CMS_DB_FORUM_TEXT],  $value);
                };

                if (! isset($_array))
                {
                        echo(info(CMS_L_FORUM_004));
                        return FALSE;
                };

                arsort($_array);
                reset($_array);
                $maxrel = current($_array);

                while (list($key, $value) = each($_array))
                {
                        $value   = (int)(100 / $maxrel * $value);
                        $_action = streq(substr($action, 0, 11), "javascript:") ?
                                   rq($key) : r($key);
                        $_action = str_replace("%index%", $_action, $action);

                        echo("<p>" .
                             "<a href=\"" . x($_action) . "\">" .
                             "<strong>" .
                             x($__array[$key][CMS_DB_FORUM_TITLE]) .
                             "</strong>" .
                             "</a><br>" .
                             "<small>" .
                             sprintf(CMS_L_FORUM_005,
                                     x($__array[$key][CMS_DB_FORUM_NAME]),
                                     x(friendly_date($__array[$key][CMS_DB_FORUM_TIME])),
                                     $__array[$key][CMS_DB_FORUM_ACCESS]) .
                             "</small><br>" .
                             image("beam", $value, 10, str_repeat("*", ceil($value / 10))) .
                             "&nbsp;$value%" .
                             "</p>");
                };

                return TRUE;
        }
//-----------------------------------------------------------------------------------------------------
        function show_new($action)
        {
                if (
                     (! $this->enabled)
                     ||
                     (! $result = mysql_query("SELECT * " .
                                              "FROM " .     $this->db_table . " " .
                                              "WHERE " .    CMS_DB_FORUM_CONTAINER . "!='' " .
                                              "ORDER BY " . CMS_DB_FORUM_TIME . " DESC " .
                                              "LIMIT 15"))
                     ||
                     (! mysql_num_rows($result))
                   )
                {
                        echo(info(CMS_L_FORUM_006));
                        return;
                };

                while ($resultrow = mysql_fetch_assoc($result))
                {
                        $_action = streq(substr($action, 0, 11), "javascript:") ?
                                   rq($resultrow[CMS_DB_FORUM_INDEX]) :
                                   r($resultrow[CMS_DB_FORUM_INDEX]);
                        $_action = str_replace("%index%", $_action, $action);

                        echo("<p>" .
                             "<a href=\"" . x($_action) . "\">" .
                             "<strong>" .
                             x($resultrow[CMS_DB_FORUM_TITLE]) .
                             "</strong>" .
                             "</a><br>" .
                             "<small>" .
                             sprintf(CMS_L_FORUM_005,
                                     x($resultrow[CMS_DB_FORUM_NAME]),
                                     x(friendly_date($resultrow[CMS_DB_FORUM_TIME])),
                                     $resultrow[CMS_DB_FORUM_ACCESS]) .
                             "</small>" .
                             "</p>");
                };
        }
};
?>
