<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< RSS CLASS >=====================================================================================
//-----------------------------------------------------------------------------------------------------

//related functions
//-----------------------------------------------------------------------------------------------------
function rss_get_default()
{
        $data  = new data("#system/rss");
        $value = NULL;

        $data->move("first");
        while ($key = $data->move("next"))
        {
                if ($data->get($key, "default"))
                        $value .= "/$key/";
        };

        return $value;
};

class rss
{
//properties
//-----------------------------------------------------------------------------------------------------
        public $data = NULL;
//constructor
//-----------------------------------------------------------------------------------------------------
        function __construct()
        {
                $this->data = new data("#system/rss");
        }
//methods
//-----------------------------------------------------------------------------------------------------
        function add_channel($name,
                             $description,
                             $link,
                             $image           = NULL,
                             $category        = NULL,
                             $default         = NULL)
        {
                $this->data->set_buffer(array(array("name"            => $name,
                                                    "description"     => $description,
                                                    "link"            => $link,
                                                    "image"           => $image,
                                                    "category"        => $category,
                                                    "default"         => (bool)$default)));

                return $this->data->insert();
        }
//-----------------------------------------------------------------------------------------------------
        function set_channel($index,
                             $name,
                             $description,
                             $link,
                             $image           = NULL,
                             $category        = NULL,
                             $default         = NULL)
        {
                $this->data->set($name,            $index, "name");
                $this->data->set($description,     $index, "description");
                $this->data->set($link,            $index, "link");
                $this->data->set($image,           $index, "image");
                $this->data->set($category,        $index, "category");
                $this->data->set((bool)$default,   $index, "default");

                return $index;
        }
//-----------------------------------------------------------------------------------------------------
        function del_channel($index)
        {
                return $this->data->del($index);
        }
//-----------------------------------------------------------------------------------------------------
        function save()
        {
                return $this->data->save();
        }
};
?>