<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< LOG CLASS >==============================================================================
//-----------------------------------------------------------------------------------------------------

//special referer
define("CMS_LOG_REFERRER_NONE",      "none");

//database
define("CMS_DB_LOG_ACCESS",          CMS_DB_PREFIX . "log_access");
define("CMS_DB_LOG_ACCESS_INDEX",    "id");
define("CMS_DB_LOG_ACCESS_USERID",   "userid");
define("CMS_DB_LOG_ACCESS_TIME",     "time");
define("CMS_DB_LOG_ACCESS_DATE",     "date");
define("CMS_DB_LOG_ACCESS_IP",       "ip");
define("CMS_DB_LOG_ACCESS_USER",     "user");
define("CMS_DB_LOG_ACCESS_ACTION",   "action");
define("CMS_DB_LOG_ACCESS_URL",      "url");
define("CMS_DB_LOG_ACCESS_REFERER",  "referer");
define("CMS_DB_LOG_ACCESS_COMPUTER", "computer");
define("CMS_DB_LOG_ACCESS_CLIENT",   "client");
define("CMS_DB_LOG_ACCESS_LANGUAGE", "language");

define("CMS_DB_LOG_USER",            CMS_DB_PREFIX . "log_user");
define("CMS_DB_LOG_USER_USERID",     "userid");
define("CMS_DB_LOG_USER_NAME",       "name");
define("CMS_DB_LOG_USER_COMPANY",    "company");
define("CMS_DB_LOG_USER_ADDRESS",    "address");
define("CMS_DB_LOG_USER_PHONE",      "phone");
define("CMS_DB_LOG_USER_FAX",        "fax");
define("CMS_DB_LOG_USER_EMAIL",      "email");
define("CMS_DB_LOG_USER_COMMENT",    "comment");

//related functions
//.....................................................................................................
function log_report($sqlcode,
                    $rows_limit = 0,
                    $display    = NULL,
                    $name       = NULL)
{
        //query start time
        $time = microtime(TRUE);

        //error
        if (! $result = mysql_query($sqlcode)) return FALSE;

        //compute query execution time
        $time = microtime(TRUE) - $time;

        //operation without selection
        if ($result === TRUE)
        {
                if ($display !== NULL)
                {
                        $rows = mysql_affected_rows();
                        echo(sprintf(CMS_L_LOG_004, $rows, $time));
                };

                return TRUE;
        };

        //dimension
        $rows   = mysql_num_rows($result);
        $fields = mysql_num_fields($result);

        for ($i = 0; $i < $fields; $i++)
        {
                $_name          = mysql_field_name($result, $i);
                $field_name[$i] = isset($name[$_name]) ? $name[$_name] : $_name;
        };

        if ($display !== NULL) echo(sprintf(CMS_L_LOG_003, $rows, $fields, $time));

        switch ($display)
        {
        case "statistics":
//.....................................................................................................
                while ($resultrow = mysql_fetch_row($result))
                {
                        for ($i = 0; $i < $fields; $i++)
                        {
                                if (! $resultrow[$i]) continue;

                                //count
                                if (empty($_result[$i][$resultrow[$i]]))
                                        $_result[$i][$resultrow[$i]] = 1;
                                else
                                        $_result[$i][$resultrow[$i]]++;

                                //sum
                                if (empty($total[$i]))
                                        $total[$i] = 1;
                                else
                                        $total[$i]++;
                        };
                };

                //no data
                if (! isset($_result))
                {
                        echo(info(CMS_L_LOG_001));
                        break;
                };

                //output
                ifc_table_open();
                echo("<colgroup>" .
                     "<col>" .
                     "<col style=\"WIDTH:100%\">" .
                     "</colgroup>");

                reset($_result);
                while (list($key, $value) = each($_result))
                {
                        $rows       = 0;
                        $_total     = 0;

                        echo("<tr>" .
                             "<th colspan=\"2\">" .
                             x($field_name[$key]) .
                             "</th>" .
                             "</tr>");

                        arsort($value);
                        reset($value);
                        while (
                                (list($_key, $_value) = each($value))
                                &&
                                (
                                  (! $rows_limit)
                                  ||
                                  ($rows++ < $rows_limit)
                                )
                              )
                        {
                                if (! $_total) $_total = $_value;
                                $__value = (int)(100 / $_total * $_value);

                                $varied  = class_varied();
                                echo("<tr>" .
                                     "<td$varied>" .
                                     x($_key) .
                                     "</td>" .
                                     "<td$varied>" .
                                     image("beam", $__value, 10, str_repeat("*", ceil($__value / 10))) .
                                     "&nbsp;$_value (" .
                                     number_format(100 / $total[$key] * $_value,
                                                   1,
                                                   CMS_L_DECIMAL_SEPARATOR,
                                                   NULL) . "%)" .
                                     "</td>" .
                                     "</tr>");
                        };
                        echo("<tr>" .
                             "<td colspan=\"2\" " .
                                 "style=\"FONT-WEIGHT:bold\">" .
                             sprintf(CMS_L_LOG_002, $total[$key]) .
                             "</td>" .
                             "</tr>");
                };

                ifc_table_close();
                break;

        case "table":
//.....................................................................................................
                ifc_table_open();

                $rows = 0;
                $i    = 0;

                while (
                        ($resultrow = mysql_fetch_row($result))
                        &&
                        (
                          (! $rows_limit)
                          ||
                          ($rows++ < $rows_limit)
                        )
                      )
                {
                        if (! $i)
                        {
                                echo("<tr>");
                                for ($_i = 0; $_i < $fields; $_i++)
                                {
                                        echo("<th>" .
                                             x($field_name[$_i]) .
                                             "</th>");
                                };
                                echo("</tr>");
                        };

                        if (++$i == 15) $i = 0;

                        $varied = class_varied("br");

                        echo("<tr>");
                        for ($_i = 0; $_i < $fields; $_i++)
                                echo("<td$varied>" .
                                     x($resultrow[$_i]) .
                                     "</td>");
                        echo("</tr>");
                };

                ifc_table_close();
                break;

        case "assignment":
//.....................................................................................................
                while ($resultrow = mysql_fetch_row($result))
                {
                        for ($i = 1; $i < $fields; $i++)
                        {
                                if (! $resultrow[$i]) continue;

                                //count
                                if (empty($_result[$resultrow[0]][$i][$resultrow[$i]]))
                                        $_result[$resultrow[0]][$i][$resultrow[$i]] = 1;
                                else
                                        $_result[$resultrow[0]][$i][$resultrow[$i]]++;

                                //sum
                                if (empty($total[$resultrow[0]][$i]))
                                        $total[$resultrow[0]][$i] = 1;
                                else
                                        $total[$resultrow[0]][$i]++;

                                //maximum
                                if (
                                     empty($max[$i])
                                     ||
                                     ($max[$i] < $_result[$resultrow[0]][$i][$resultrow[$i]])
                                   )
                                        $max[$i] = $_result[$resultrow[0]][$i][$resultrow[$i]];
                        };
                };

                //no data
                if (! isset($_result))
                {
                        echo(info(CMS_L_LOG_001));
                        break;
                };

                $rows = 0;

                //output
                ifc_table_open();
                echo("<colgroup>" .
                     "<col span=\"2\">" .
                     "<col style=\"WIDTH:100%\">" .
                     "</colgroup>");

                krsort($_result);
                reset($_result);
                while (
                        (list($key, $value) = each($_result))
                        &&
                        (
                          (! $rows_limit)
                          ||
                          ($rows++ < $rows_limit)
                        )
                      )
                {
                        echo("<tr>" .
                             "<th>" .
                             x($field_name[0]) .
                             "</th>" .
                             "<th colspan=\"2\">" .
                             x($key) .
                             "</th>" .
                             "</tr>");

                        reset($value);
                        while (list($_key, $_value) = each($value))
                        {
                                echo("<tr>" .
                                     "<th rowspan=\"" . count($_value) . "\">" .
                                     x($field_name[$_key]) .
                                     "</th>");

                                arsort($_value);
                                reset($_value);
                                while (list($__key, $__value) = each($_value))
                                {
                                        $___value = (int)(100 / $max[$_key] * $__value);

                                        $varied   = class_varied();
                                        echo("<td$varied>" .
                                             x($__key) .
                                             "</td>" .
                                             "<td$varied>" .
                                             image("beam", $___value, 10, str_repeat("*", ceil($___value / 10))) .
                                             "&nbsp;$__value (" .
                                             number_format(100 / $total[$key][$_key] * $__value,
                                                           1,
                                                           CMS_L_DECIMAL_SEPARATOR,
                                                           NULL) . "%)" .
                                             "</td>" .
                                             "</tr>" .
                                             "<tr>");
                                };
                                echo("<td colspan=\"3\" " .
                                         "style=\"FONT-WEIGHT:bold\">" .
                                     sprintf(CMS_L_LOG_002, $total[$key][$_key]) .
                                     "</td>" .
                                     "</tr>");
                        };
                };

                ifc_table_close();
                break;

        default:
//.....................................................................................................
                $array = array();
                $rows  = 0;
                while (
                        (
                          (! $rows_limit)
                          ||
                          ($rows < $rows_limit)
                        )
                        &&
                        ($resultrow = mysql_fetch_assoc($result))
                      )
                        $array[$rows++] = $resultrow;

                return $array;
        };

        return TRUE;
};
//-----------------------------------------------------------------------------------------------------
class log
{
//properties
//-----------------------------------------------------------------------------------------------------
        public $limit     = NULL;
        public $anonymize = NULL;
        public $privacy   = NULL;
        public $enabled   = NULL;
//constructor
//-----------------------------------------------------------------------------------------------------
        function __construct()
        {
                $mysql = new mysql();
                if (
                     $mysql->verify_table(CMS_DB_LOG_ACCESS,
                                          array(CMS_DB_LOG_ACCESS_INDEX    => "INT UNSIGNED PRIMARY KEY AUTO_INCREMENT NOT NULL",
                                                CMS_DB_LOG_ACCESS_USERID   => "CHAR(32) NOT NULL",
                                                CMS_DB_LOG_ACCESS_TIME     => "TIME NOT NULL",
                                                CMS_DB_LOG_ACCESS_DATE     => "DATE NOT NULL",
                                                CMS_DB_LOG_ACCESS_IP       => "CHAR(31) NOT NULL",
                                                CMS_DB_LOG_ACCESS_USER     => "VARCHAR(40) NOT NULL",
                                                CMS_DB_LOG_ACCESS_ACTION   => "VARCHAR(120) NOT NULL",
                                                CMS_DB_LOG_ACCESS_URL      => "VARCHAR(255) NOT NULL",
                                                CMS_DB_LOG_ACCESS_REFERER  => "VARCHAR(255) NOT NULL",
                                                CMS_DB_LOG_ACCESS_COMPUTER => "VARCHAR(80) NOT NULL",
                                                CMS_DB_LOG_ACCESS_CLIENT   => "VARCHAR(120) NOT NULL",
                                                CMS_DB_LOG_ACCESS_LANGUAGE => "VARCHAR(20) NOT NULL"))
                     &&
                     $mysql->verify_table(CMS_DB_LOG_USER,
                                          array(CMS_DB_LOG_USER_USERID     => "CHAR(32) PRIMARY KEY NOT NULL",
                                                CMS_DB_LOG_USER_NAME       => "VARCHAR(80) NOT NULL",
                                                CMS_DB_LOG_USER_COMPANY    => "VARCHAR(80) NOT NULL",
                                                CMS_DB_LOG_USER_ADDRESS    => "VARCHAR(120) NOT NULL",
                                                CMS_DB_LOG_USER_PHONE      => "VARCHAR(40) NOT NULL",
                                                CMS_DB_LOG_USER_FAX        => "VARCHAR(40) NOT NULL",
                                                CMS_DB_LOG_USER_EMAIL      => "VARCHAR(40) NOT NULL",
                                                CMS_DB_LOG_USER_COMMENT    => "VARCHAR(255) NOT NULL"))
                   )
                        $this->enabled = TRUE;

                $system          = new system();
                $this->limit     = $system->getval("log", "limit");
                $this->anonymize = $system->getval("log", "anonymize");
                $this->privacy   = $system->getval("log", "privacy");
        }
//methods
//-----------------------------------------------------------------------------------------------------
        function access($action,
                        $referrer  = NULL,
                        $important = NULL)
        {
                if ((! $this->enabled) || ($this->limit < 0) || streq(CMS_USER, "admin")) return;

                if (
                     ($referrer === FALSE)
                     ||
                     (
                       (! $referrer)
                       &&
                       (! $referrer = getenv("HTTP_REFERER"))
                     )
                   )
                        $referrer  = CMS_LOG_REFERRER_NONE;

                if ($action)    $action    = ": $action";
                if ($important) $important = "(!)";

                //implementation of abnf from rfc 3986
                $dec_octet   = "(?:\d|[1-9]\d|1\d{2}|2[0-4]\d|25[0-5])";
                $ipv4address = "(?:$dec_octet\.){3}$dec_octet";
                $h16         = "[0-9a-f]{1,4}";
                $ls32        = "(?:$h16:$h16|$ipv4address)";
                $ipv6address = "(?:" .
                                       "(?:" .
                                               "(?:$h16:){6}" .
                                               "|" .
                                               "::(?:$h16:){5}" .
                                               "|" .
                                               "(?:$h16)?::(?:$h16:){4}" .
                                               "|" .
                                               "(?:(?:$h16:){0,1}$h16)?::(?:$h16:){3}" .
                                               "|" .
                                               "(?:(?:$h16:){0,2}$h16)?::(?:$h16:){2}" .
                                               "|" .
                                               "(?:(?:$h16:){0,3}$h16)?::$h16:" .
                                               "|" .
                                               "(?:(?:$h16:){0,4}$h16)?::" .
                                       ")" .
                                       "$ls32" .
                                       "|" .
                                       "(?:" .
                                               "(?:(?:$h16:){0,5}$h16)?::$h16" .
                                               "|" .
                                               "(?:($h16:){0,6}$h16)?::" .
                                       ")" .
                                       "|" .
                                       "$ipv4address" . //additional ipv4 support
                               ")";

                $name  = NULL;
                if (
                     ($ip = getenv("HTTP_X_FORWARDED_FOR"))
                     &&
                     preg_match("/$ipv6address/i", $ip, $_ip)
                   )
                {
                        $ip  = $_ip[0];
                        if ($name = gethostbyaddr($ip)) $name .= "|";
                        if ($this->anonymize) $ip = anonymize_ip($ip);
                        $ip .= "|";
                };
                $name .= gethostbyaddr(getenv("REMOTE_ADDR"));
                $_ip   = getenv("REMOTE_ADDR");
                if ($this->anonymize) $_ip = anonymize_ip($_ip);
                $ip   .= $_ip;

                mysql_unbuffered_query("INSERT " . CMS_DB_LOG_ACCESS .
                                            " (" . CMS_DB_LOG_ACCESS_USERID . ", " .
                                                   CMS_DB_LOG_ACCESS_TIME . ", " .
                                                   CMS_DB_LOG_ACCESS_DATE . ", " .
                                                   CMS_DB_LOG_ACCESS_IP . ", " .
                                                   CMS_DB_LOG_ACCESS_USER . ", " .
                                                   CMS_DB_LOG_ACCESS_ACTION . ", " .
                                                   CMS_DB_LOG_ACCESS_URL . ", " .
                                                   CMS_DB_LOG_ACCESS_REFERER . ", " .
                                                   CMS_DB_LOG_ACCESS_COMPUTER . ", " .
                                                   CMS_DB_LOG_ACCESS_CLIENT . ", " .
                                                   CMS_DB_LOG_ACCESS_LANGUAGE . ") " .
                                       "VALUES (" .
                                             "'" . sqlesc(CMS_USERID) . "', " .
                                                  "CURTIME(), " .
                                                  "CURDATE(), " .
                                             "'" . sqlesc($ip) . "', " .
                                             "'" . sqlesc(CMS_USER) . "', " .
                                             "'" . sqlesc($important . CMS_APPLICATION . $action) . "', " .
                                             "'" . sqlesc(getenv("REQUEST_URI")) . "', " .
                                             "'" . sqlesc($referrer) . "', " .
                                             "'" . sqlesc($name) . "', " .
                                             "'" . sqlesc(getenv("HTTP_USER_AGENT")) . "', " .
                                             "'" . sqlesc(getenv("HTTP_ACCEPT_LANGUAGE")) . "')");

                $this->limit();
        }
//-----------------------------------------------------------------------------------------------------
        function user($name,
                      $company = NULL,
                      $address = NULL,
                      $phone   = NULL,
                      $fax     = NULL,
                      $email   = NULL)
        {
                if ((! $this->enabled) || $this->privacy) return;

                $userid = sqlesc(CMS_USERID);
                $result = mysql_query("SELECT " . CMS_DB_LOG_USER_NAME . ", " .
                                                  CMS_DB_LOG_USER_COMPANY . ", " .
                                                  CMS_DB_LOG_USER_ADDRESS . ", " .
                                                  CMS_DB_LOG_USER_PHONE . ", " .
                                                  CMS_DB_LOG_USER_FAX . ", " .
                                                  CMS_DB_LOG_USER_EMAIL . " " .
                                      "FROM " .   CMS_DB_LOG_USER . " " .
                                      "WHERE " .  CMS_DB_LOG_USER_USERID . "='$userid' " .
                                      "LIMIT 1");

                $data   = array($name, $company, $address, $phone, $fax, $email);

                if ($resultrow = mysql_fetch_row($result))
                {
                        reset($data);
                        while (list($key, $value) = each($data))
                        {
                                if ($resultrow[$key])
                                {
                                        if ($value && (! stristr($resultrow[$key], $value)))
                                                $data[$key] .= " | " . $resultrow[$key];
                                        else
                                                $data[$key]  = $resultrow[$key];
                                };
                        };

                        mysql_unbuffered_query("DELETE FROM " . CMS_DB_LOG_USER . " " .
                                               "WHERE " .       CMS_DB_LOG_USER_USERID . "='$userid'");
                };

                mysql_unbuffered_query("INSERT " . CMS_DB_LOG_USER .
                                            " (" . CMS_DB_LOG_USER_USERID . ", " .
                                                   CMS_DB_LOG_USER_NAME . ", " .
                                                   CMS_DB_LOG_USER_COMPANY . ", " .
                                                   CMS_DB_LOG_USER_ADDRESS . ", " .
                                                   CMS_DB_LOG_USER_PHONE . ", " .
                                                   CMS_DB_LOG_USER_FAX . ", " .
                                                   CMS_DB_LOG_USER_EMAIL . ") " .
                                       "VALUES (" .
                                                 "'$userid', " .
                                             "'" . sqlesc($data[0]) . "', " .
                                             "'" . sqlesc($data[1]) . "', " .
                                             "'" . sqlesc($data[2]) . "', " .
                                             "'" . sqlesc($data[3]) . "', " .
                                             "'" . sqlesc($data[4]) . "', " .
                                             "'" . sqlesc($data[5]) . "')");
        }
//-----------------------------------------------------------------------------------------------------
        function limit()
        {
                if ((! $this->enabled) || ($this->limit < 0)) return;

                //execute only once per hour
                $cache_time = cms_cache_time("log.limit");
                if (($cache_time !== FALSE) && ($cache_time > (time() - 3600))) return;
                cms_cache($cache_key, TRUE, TRUE);

                mysql_unbuffered_query(
                       "DELETE FROM " . CMS_DB_LOG_ACCESS . " " .
                       "WHERE TIMESTAMP(" . CMS_DB_LOG_ACCESS_DATE . ", " . CMS_DB_LOG_ACCESS_TIME . ")" .
                       "<SUBDATE(NOW(), " . sqlesc($this->limit) . ")");
        }
};
?>