<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< MYSQL CLASS >===================================================================================
//-----------------------------------------------------------------------------------------------------
class mysql
{
//properties
//-----------------------------------------------------------------------------------------------------
        public $database = NULL;
        public $host     = NULL;
        public $user     = NULL;
        public $password = NULL;
//constructor
//-----------------------------------------------------------------------------------------------------
        function __construct()
        {
                $system         = new system();

                $this->database = $system->getval("mysql", "database");
                $this->host     = $system->getval("mysql", "host");
                $this->user     = $system->getval("mysql", "user");
                $this->password = $system->getval("mysql", "password");

                $this->connection();
        }
//methods
//-----------------------------------------------------------------------------------------------------
        function connection()
        {
                $connection = mysql_get_link_identifier();
                if ($connection !== NULL)      return $connection;

                if ($this->database === FALSE) return FALSE;
                if ($this->host === FALSE)     return FALSE;

                if (mysql_connect($this->host, $this->user, $this->password))
                {
                        mysql_unbuffered_query("/*!40100 SET NAMES utf8 COLLATE utf8_general_ci*/");
                        mysql_unbuffered_query("/*!40100 SET CHARACTER SET utf8 COLLATE utf8_general_ci*/");

                        if (mysql_select_db($this->database)) return $connection;
                };

                return FALSE;
        }
//-----------------------------------------------------------------------------------------------------
        function get($index,
                     $column,
                     $table,
                     $index_key = "id")
        {
                if ($this->connection() === FALSE) return FALSE;

                $result = mysql_query("SELECT `" . sqlesc($column) . "` " .
                                      "FROM `" .   sqlesc($table) . "` " .
                                      "WHERE `" .  sqlesc($index_key) . "`='" . sqlesc($index) . "' " .
                                      "LIMIT 1");
                if ($result === FALSE)           return FALSE;
                if (mysql_num_rows($result) < 1) return FALSE;
                return mysql_result($result, 0);
        }
//-----------------------------------------------------------------------------------------------------
        function set($index,
                     $column,
                     $table,
                     $value,
                     $index_key = "id")
        {
                if ($this->connection() === FALSE) return FALSE;

                return mysql_query("UPDATE `" . sqlesc($table) . "` " .
                                   "SET `" .    sqlesc($column) . "`='" . sqlesc($value) . "' " .
                                   "WHERE `" .  sqlesc($index_key) . "`='" . sqlesc($index) . "' " .
                                   "LIMIT 1");
        }
//-----------------------------------------------------------------------------------------------------
        function delete($index,
                        $table,
                        $index_key  = "id",
                        $parent_key = "container")
        {
                if ($this->connection() === FALSE) return FALSE;

                $index      = sqlesc($index);
                $_table     = sqlesc($table);
                $_index_key = sqlesc($index_key);

                $result = mysql_query("SELECT `$_index_key` " .
                                      "FROM `$_table` " .
                                      "WHERE `" . sqlesc($parent_key) . "`='$index'");
                if ($result === FALSE) return FALSE;

                while ($resultrow = mysql_fetch_row($result))
                {
                        if (! $this->delete($resultrow[0],
                                            $table,
                                            $index_key,
                                            $parent_key))
                                return FALSE;
                };

                return mysql_query("DELETE FROM `$_table` " .
                                   "WHERE `$_index_key`='$index' " .
                                   "LIMIT 1");
        }
//-----------------------------------------------------------------------------------------------------
        function is_child($index,
                          $parent,
                          $table,
                          $index_key  = "id",
                          $parent_key = "container")
        {
                if ($this->connection() === FALSE) return FALSE;

                do
                {
                        $result = mysql_query("SELECT `" . sqlesc($parent_key) . "` " .
                                              "FROM `" .   sqlesc($table) . "` " .
                                              "WHERE `" .  sqlesc($index_key) . "`='" . sqlesc($index) . "' " .
                                              "LIMIT 1");
                        if ($result === FALSE)           return FALSE;
                        if (mysql_num_rows($result) < 1) return FALSE;

                        $index = mysql_result($result, 0, $parent_key);
                        if (streq($index, $parent)) return TRUE;
                }
                while (! empty($index));

                return FALSE;
        }
//-----------------------------------------------------------------------------------------------------
        function verify_table($table,
                              $structure)
        {
                static $buffer = array();

                if ($this->connection() === FALSE) return FALSE;
                if (isset($buffer[$table]))        return $buffer[$table];

                reset($structure);
                list($key, $value) = each($structure);

                $_table = sqlesc($table);
                $result = mysql_query("SHOW TABLES");
                $flag   = FALSE;

                while ($resultrow = mysql_fetch_row($result))
                {
                        if (streq($resultrow[0], $table))
                        {
                                $flag = TRUE;
                                break;
                        };
                };

                if (
                     (! $flag)
                     &&
                     (! mysql_query("CREATE TABLE `$_table` (`" . sqlesc($key) . "` $value) " .
                                    "ENGINE=MyISAM" .
                                    "/*!40100 DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci*/"))
                   )
                        return FALSE;

                $result = mysql_query("SHOW COLUMNS FROM `$_table`");

                while ($resultrow = mysql_fetch_row($result))
                        $array[$resultrow[0]] = TRUE;

                while (list($key, $value) = each($structure))
                {
                        if (
                             (! isset($array[$key]))
                             &&
                             (! mysql_query("ALTER TABLE `$_table` " .
                                            "ADD COLUMN `" . sqlesc($key) . "` $value"))
                           )
                        {
                                $buffer[$table] = FALSE;
                                return FALSE;
                        };
                };

                $buffer[$table] = TRUE;
                return TRUE;
        }
//-----------------------------------------------------------------------------------------------------
        function export_sql($table,
                            $file = NULL)
        {
                if ($this->connection() === FALSE) return FALSE;

                if ($file === NULL) $file = CMS_DATA_PATH . "#database/$table";

                $path = dirname($file);

                $result = mysql_query("SHOW CREATE TABLE `" . sqlesc($table) . "`");
                if ($result === FALSE) return FALSE;

                if (! mkpath($path))                                return FALSE;
                if (($hfile = fopen("$file.sql", "wb")) === FALSE) return FALSE;

                fputs($hfile, mysql_result($result, 0, 1));
                fclose($hfile);

                return TRUE;
        }
//-----------------------------------------------------------------------------------------------------
        function export_csv($table,
                            $separator  = ",",
                            $delimeter  = "\"",
                            $file       = NULL,
                            $set_fields = FALSE)
        {
                if ($this->connection() === FALSE) return FALSE;

                if ($file === NULL) $file = CMS_DATA_PATH . "#database/$table";

                $path       = dirname($file);
                $table      = sqlesc($table);
                $separator  = sqlesc($separator);
                $_delimeter = str_repeat($delimeter, 2);

                $result = mysql_query("SHOW COLUMNS FROM `$table`");
                if ($result === FALSE) return FALSE;

                $array = array();
                $field = "";

                while ($resultrow = mysql_fetch_assoc($result))
                {
                        $array[]  = $resultrow["Field"];
                        $field   .= $delimeter .
                                    str_replace($delimeter, $_delimeter, $resultrow["Field"]) .
                                    $delimeter .
                                    $separator;
                };

                $field      = substr($field, 0, -strlen($separator)) . "\n";
                $delimeter  = sqlesc($delimeter);
                $_delimeter = sqlesc($_delimeter);

                $result = mysql_query("SELECT CONCAT(" .
                                      "CONCAT_WS('$separator', " .
                                      "CONCAT('$delimeter', " .
                                      "REPLACE(" .
                                      "/*!40002 CAST(*/`" .
                                      implode("`/*!40002 AS CHAR*//*!40100 CHARACTER SET utf8 *//*!40002 )*//*!40100 COLLATE utf8_general_ci*/, " .
                                              "'$delimeter', '$_delimeter'), '$delimeter'), " .
                                              "CONCAT('$delimeter', " .
                                              "REPLACE(" .
                                              "/*!40002 CAST(*/`",
                                              $array) .
                                      "`/*!40002 AS CHAR*//*!40100 CHARACTER SET utf8 *//*!40002 )*//*!40100 COLLATE utf8_general_ci*/, " .
                                      "'$delimeter', '$_delimeter'), '$delimeter')), " .
                                      "'\n') " .
                                      "FROM `$table`");
                if ($result === FALSE)                             return FALSE;
                if (! mkpath($path))                               return FALSE;
                if (($hfile = fopen("$file.csv", "wb")) === FALSE) return FALSE;

                if ($set_fields)
                        fputs($hfile, $field);

                while ($resultrow = mysql_fetch_row($result))
                        fputs($hfile, $resultrow[0]);

                fclose($hfile);

                return TRUE;
        }
//-----------------------------------------------------------------------------------------------------
        function import_csv($file,
                            $separator        = ",",
                            $delimeter        = "\"",
                            $table            = NULL,
                            $get_fields       = FALSE,
                            $ignore_first_row = FALSE,
                            $mapping          = NULL)
        {
                if ($this->connection() === FALSE)           return FALSE;
                if (($hfile = fopen($file, "rb")) === FALSE) return FALSE;

                //process mapping
                if ((! $get_fields) && is_array($mapping))
                {
                        $_mapping = array();

                        reset($mapping);
                        while (list($key, $value) = each($mapping))
                        {
                                if (! is_int($key))      continue; //no column number
                                if (! is_string($value)) continue; //no field name
                                if ($value === "")       continue; //no field assigned

                                $_mapping[$key] = sqlesc($value);
                        };

                        if (count($_mapping) === 0) return TRUE; //no assignments

                        $mapping = "`" . implode("`, `", $_mapping) . "`";
                };

                $table = sqlesc($table);
                $value = array(0 => "");
                $i     = 0;
                $flag  = FALSE;
                $char  = fgetc($hfile);

                if ($char === FALSE) return $get_fields ? array() : TRUE;

                while (TRUE)
                {
                        $_char = fgetc($hfile); //lookahead

                        //within delimeter
                        if ($flag)
                        {
                                //delimeter
                                if ($char === $delimeter)
                                {
                                        //escaped delimeter
                                        if ($_char === $delimeter)
                                        {
                                                $value[$i] .= $char;

                                                //overwrite lookahead
                                                $_char = fgetc($hfile);
                                        }

                                        //closing delimeter
                                        else
                                        {
                                                $flag = FALSE;
                                        };
                                }

                                //content
                                else
                                {
                                        $value[$i] .= $char;
                                };
                        }

                        //opening delimeter
                        elseif ($char === $delimeter)
                        {
                                $flag = TRUE;
                        }

                        //separator
                        elseif ($char === $separator)
                        {
                                if (! $get_fields) $value[$i] = sqlesc($value[$i]);

                                //advance field in row
                                $value[++$i] = "";
                        }

                        //end of dataset
                        elseif (($char === "\n") || ($char === FALSE))
                        {
                                //only return fields of first row
                                if ($get_fields)
                                {
                                        fclose($hfile);
                                        return $value;
                                };

                                $value[$i] = sqlesc($value[$i]);

                                //skip first row
                                if ($ignore_first_row)
                                {
                                        $ignore_first_row = FALSE;
                                }

                                //insert record by mapping
                                elseif (isset($_mapping))
                                {
                                        $query = "REPLACE `$table` " .
                                                 "($mapping) VALUES (";

                                        reset($_mapping);
                                        while (list($key) = each($_mapping))
                                                $query .= isset($value[$key]) ?
                                                          "'" . $value[$key] . "', " :
                                                          "'', ";

                                        $query = substr($query, 0, -2) . ")";

                                        mysql_query($query);
                                }

                                //insert record sequentially
                                else
                                {
                                        $query = "REPLACE `$table` " .
                                                 "VALUES ('" . implode("', '", $value) . "')";

                                        mysql_query($query);
                                };

                                //end of file
                                if ($_char === FALSE) break;

                                //reset field in row
                                $value = array(0 => "");
                                $i     = 0;
                        }

                        //content
                        elseif (($char !== "\r") || ($_char !== "\n"))
                        {
                                $value[$i] .= $char;
                        };

                        //shift lookahead
                        $char = $_char;

                        //end of file
                        if ($char === FALSE) $flag = FALSE;
                };

                fclose($hfile);
                return TRUE;
        }
//-----------------------------------------------------------------------------------------------------
        function backup()
        {
                if ($this->connection() === FALSE) return FALSE;

                //get tables
                $result = mysql_query("SHOW TABLES");
                if ($result === FALSE) return FALSE;

                $path = CMS_DATA_PATH . "#database/backup/";
                $flag = FALSE;

                while ($resultrow = mysql_fetch_row($result))
                {
                        set_time_limit(600); //10 minutes

                        $table = $resultrow[0];

                        //export definition and content of table that is no backup
                        if (nstreq(substr($table, 0, 8), "#backup_"))
                        {
                                $flag |= ! $this->export_sql($table, $path . $table);
                                $flag |= ! $this->export_csv($table, ",", "\"", $path . $table, TRUE);
                        };
                };

                return ! $flag;
        }
//-----------------------------------------------------------------------------------------------------
        function restore()
        {
                if ($this->connection() === FALSE) return FALSE;

                $path = CMS_DATA_PATH . "#database/backup";
                if (! is_dir($path))                    return FALSE;
                if (($hdir = opendir($path)) === FALSE) return FALSE;

                $flag = FALSE;

                while ($file_object = readdir($hdir))
                {
                        set_time_limit(600); //10 minutes

                        //get definition file
                        if (! is_file("$path/$file_object"))                             continue;
                        if (! preg_match("/^(.*)\.sql$/i", $file_object, $_file_object)) continue;

                        $query = read_file("$path/$file_object");
                        if ($query !== FALSE)
                        {
                                $table  = $_file_object[1]; //assuming filename is not changed
                                $_table = sqlesc($table);

                                //create backup of existing table
                                mysql_query("DROP TABLE IF EXISTS `#backup_$_table`");
                                mysql_query("RENAME TABLE `$_table` TO `#backup_$_table`");

                                //execute, create table
                                if (mysql_query($query))
                                {
                                        $_file_object = "$path/$table.csv";

                                        //restore data
                                        if (is_file($_file_object))
                                                $flag |= ! $this->import_csv($_file_object, //file
                                                                             ",",           //separator
                                                                             "\"",          //delimeter
                                                                             $table,        //table
                                                                             FALSE,         //get fields
                                                                             TRUE);         //ignore first row
                                }

                                //failed, restore backup
                                else
                                {
                                        mysql_query("RENAME TABLE `#backup_$_table` TO `$_table`");
                                        $flag = TRUE;
                                };
                        }

                        //no file contents
                        else
                        {
                                $flag = TRUE;
                        };
                };

                closedir($hdir);

                return ! $flag;
        }
};
?>
