/*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

//--------------------------------
//    STRING
//--------------------------------
function string_repeat(string,
                       count)
{
        var _string = "";
        for (var i = 0; i < count; i++) _string += string;
        return _string;
};
//................................
function htmlspecialchars(string)
{
        string = string.replace(/</g, "&lt;");
        string = string.replace(/>/g, "&gt;");
        return string.replace(/"/g, "&quot;");
};
//................................
function unique_id(count)
{
        var _string = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
        var i       = 0;
        var value   = "";

        for (; i < count; i++)
                value += _string.charAt(Math.floor(Math.random() * 62));

        return value;
};
//................................
function strabridge(string) //arguments: 1 => length
{
        var length        = (arguments.length > 1) ? arguments[1] : 40;
        var _length       = string.length;
        if (_length <= length) return string;

        length           -= 1;
        var length_start  = Math.round(length * 65 / 100, 0);
        var length_end    = length - length_start;

        return string.substr(0, length_start) +
               "…" +
               string.substr(-length_end);
}
//................................
function addslashes(string)
{
        return string.replace(/([\x00"'\\])/g, "\\$1");
};
//--------------------------------
//    COLORCONTROL
//--------------------------------
function colorcontrol(object,
                      image_path)
{
        var color = new Array("#ffffff", "#cfc0aa", "#cdaf84", "#f6a98e", "#f8bd95", "#f8bd95", "#fefdac", "#c9e7ad", "#acddad", "#90d5ad", "#8dd4d0", "#89d3f6", "#96b0dd", "#9b9ed1", "#9e8dc6", "#b392c7", "#ca99c8", "#f6a6ca", "#f6a8ac",
                              "#cacaca", "#a79989", "#b2926b", "#f38568", "#f5a36f", "#f8c177", "#fefc84", "#b3df8b", "#88d28d", "#42c68e", "#30c6c0", "#00c3f2", "#6996d1", "#7680c2", "#7e67b4", "#9c6cb4", "#b871b5", "#f37db6", "#f38290",
                              "#939393", "#86796e", "#9c7b53", "#ef3b3e", "#f28040", "#f5aa41", "#fefb37", "#95d560", "#33c567", "#00b86b", "#00b7ac", "#00b3ef", "#007cc5", "#3a5eb2", "#5629a1", "#821ea0", "#a6009f", "#f0009c", "#f02270",
                              "#555555", "#6a5f59", "#88663e", "#ac2727", "#ae5d29", "#af7c2b", "#b3b52e", "#689c46", "#00924c", "#008951", "#008880", "#0085b0", "#005a92", "#294084", "#3f0078", "#610077", "#7b0075", "#af0073", "#ad0050",
                              "#000000", "#4e4845", "#75532d", "#8d0a00", "#8d4a06", "#8f640f", "#91931e", "#517f36", "#00773c", "#007140", "#007069", "#006d91", "#004677", "#102c6c", "#300062", "#4e0061", "#65005f", "#8f005c", "#8d003e");
        var map_name = "colorcontrol" + parseInt(Math.random() * 99999999);
        var x        = 0;
        var y        = 0;
        var i        = 0;

        document.write("<map name=\"" + map_name + "\">");

        for (y = 1; y < 22; y += 5)
        {
                for (x = 1; x < 92; x += 5)
                        document.write("<area shape=\"rect\" " +
                                             "coords=\"" + x + "," + y + "," +
                                             (x + 5) + "," + (y + 5) + "\" " +
                                             "href=\"javascript:colorcontrol_set(" +
                                             "'" + object + "','" + color[i++] + "');\">");
        };

        document.write("</map>" +
                       "<img src=\"" + image_path + "\" " +
                            "usemap=\"#" + map_name +"\">");
};
//................................
function colorcontrol_set(object,
                          value)
{
        eval("var object_handle = " + object);
        object_handle.value = value;
};
//--------------------------------
//    TEXTCONTROL
//--------------------------------
function textcontrol(object,
                     image_path) //arguments: 2 => extension
{
        image_path += "textcontrol/";

        document.write("<div class=\"textcontrol\">" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','+');\">" +
                       "<img src=\"" + image_path + "button_bold.png\" alt=\"bold\" title=\"bold\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','/');\">" +
                       "<img src=\"" + image_path + "button_italic.png\" alt=\"italic\" title=\"italic\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','_');\">" +
                       "<img src=\"" + image_path + "button_underline.png\" alt=\"underline\" title=\"underline\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','<');\">" +
                       "<img src=\"" + image_path + "button_big.png\" alt=\"big\" title=\"big\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','>');\">" +
                       "<img src=\"" + image_path + "button_small.png\" alt=\"small\" title=\"small\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','<-');\">" +
                       "<img src=\"" + image_path + "button_left.png\" alt=\"align left\" title=\"align left\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','<->');\">" +
                       "<img src=\"" + image_path + "button_center.png\" alt=\"center\" title=\"center\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','->');\">" +
                       "<img src=\"" + image_path + "button_right.png\" alt=\"align right\" title=\"align right\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','*');\">" +
                       "<img src=\"" + image_path + "button_title.png\" alt=\"title\" title=\"title\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','&quot;');\">" +
                       "<img src=\"" + image_path + "button_quote.png\" alt=\"quote\" title=\"quote\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','-');\">" +
                       "<img src=\"" + image_path + "button_monospace.png\" alt=\"fixed character width\" title=\"fixed character width\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','#image_left');\">" +
                       "<img src=\"" + image_path + "button_image_left.png\" alt=\"left aligned image\" title=\"left aligned image\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','#image_right');\">" +
                       "<img src=\"" + image_path + "button_image_right.png\" alt=\"right aligned image\" title=\"right aligned image\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','#hyperlink');\">" +
                       "<img src=\"" + image_path + "button_hyperlink.png\" alt=\"hyperlink\" title=\"hyperlink\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','#email');\">" +
                       "<img src=\"" + image_path + "button_email.png\" alt=\"email\" title=\"email\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','#table');\">" +
                       "<img src=\"" + image_path + "button_table.png\" alt=\"table\" title=\"table\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','#tablerow');\">" +
                       "<img src=\"" + image_path + "button_table_row.png\" alt=\"table row separator\" title=\"table row separator\">" +
                       "</a>" +

                       "<a href=\"javascript:textcontrol_set('" + object + "','#tablecell');\">" +
                       "<img src=\"" + image_path + "button_table_cell.png\" alt=\"table cell separator\" title=\"table cell separator\">" +
                       "</a>");

        if (arguments.length > 2) document.write(arguments[2]);

        document.write("</div>");
};
//................................
function textcontrol_select(object_handle)
{
        if (document.selection != null) object_handle._selection = document.selection.createRange();
};
//................................
function textcontrol_set(object,
                         format) //arguments: 2 => data
{
        eval("var object_handle = " + object);
        if (object_handle.disabled) return;

        var data         = (arguments.length > 2) ? arguments[2] : "";
        var _format      = "";
        var text         = "";
        var select_start = 0;
        var select_end   = 0;

        if (document.selection != null)
        {
                if (! object_handle._selection)
                {
                        object_handle._selection = object_handle.createTextRange();
                        object_handle._selection.move("textedit");
                };

                text = object_handle._selection.text;
        }
        else if (object_handle.selectionStart != null)
        {
                text           = object_handle.value.substring(object_handle.selectionStart, object_handle.selectionEnd);
                var scroll_top = object_handle.scrollTop;
        }
        else
        {
                text = "";
        };

        switch (format)
        {
        case "#image_left":
                if (data)
                {
                        _format      = "[<-IMG " + data + " * *]" + text;
                        select_start = -text.length;
                        select_end   = select_start;
                }
                else
                {
                        _format      = "[<-IMG http://URL * *]" + text;
                        select_end   = -text.length - 5;
                        select_start = select_end - 3;
                };
                break;

        case "#image_right":
                if (data)
                {
                        _format      = "[IMG-> " + data + " * *]" + text;
                        select_start = -text.length;
                        select_end   = select_start;
                }
                else
                {
                        _format      = "[IMG-> http://URL * *]" + text;
                        select_end   = -text.length - 5;
                        select_start = select_end - 3;
                };
                break;

        case "#hyperlink":
                if (data)
                {
                        if (text)
                        {
                                data.match(/^([^ \r\n]+)/);
                                _format = "[" + data.substring(0, RegExp.$1.length) + " " + text + "]";
                        }
                        else
                        {
                                _format = "[" + data + "]";
                        };

                        select_start = 0;
                        select_end   = 0;
                }
                else
                {
                        _format      = "[http://URL " + (text ? text : "click") + "]";
                        select_end   = -(text ? text.length : 5) - 2;
                        select_start = select_end - 3;
                };
                break;

        case "#email":
                if (data)
                {
                        if (text)
                        {
                                data.match(/^([^ \r\n]+)/);
                                _format = "[mailto:" + data.substring(0, RegExp.$1.length) + " " + text + "]";
                        }
                        else
                        {
                                _format = "[mailto:" + data + "]";
                        };

                        select_start = 0;
                        select_end   = 0;
                }
                else
                {
                        _format      = "[mailto:account@domain " + (text ? text : "click") + "]";
                        select_end   = -(text ? text.length : 5) - 2;
                        select_start = select_end - 14;
                };
                break;

        case "#table":
                _format      = "\n[# " + text + " ]\n";
                select_start = -text.length - 3;
                select_end   = select_start;
                break;

        case "#tablerow":
                _format      = " | \n | " + text;
                select_start = -text.length;
                select_end   = select_start;
                break;

        case "#tablecell":
                _format      = " | " + text;
                select_start = 0;
                select_end   = 0;
                break;

        case "#token":
                if (data)
                {
                        if (! data.match(/^%%.*%%$/))
                                data         = "%%" + data + "%%";

                        if (data.match(/^[^ \r\n]+$/))
                        {
                                _format      = data + text;
                                select_start = data.length - _format.length;
                                select_end   = select_start;
                                break;
                        };

                        if (text)
                        {
                                text         = text.replace(/,/g, "\\,").replace(/%%/g, "\\%%");
                                data         = data.replace(/^([^ \r\n]+[ \r\n])[^,%]+/, "$1" + text);
                                _format      = data;
                                data.match(/^(([^,]|\\,)+[^\\],[ \r\n]*|.+%%$)/);
                        }
                        else
                        {
                                _format      = data;
                                data.match(/^([^ \r\n]+[ \r\n]+)/);
                        };

                        select_start = RegExp.$1.length - _format.length;
                        data.substring(RegExp.$1.length).match(/^(([^,]|\\,)*[^\\](,)|.*(%%)$|$)/);
                        select_end   = select_start + RegExp.$1.length - RegExp.$3.length - RegExp.$4.length;
                }
                else
                {
                        _format      = "%%" + text + "%%";
                        select_end   = -2;
                        select_start = select_end - text.length;
                };
                break;

        case "#insert":
                _format      = (data ? data : "") + text;
                select_start = 0;
                select_end   = 0;
                break;

        case "#replace":
                _format      = data ? data : "";
                select_start = 0;
                select_end   = 0;
                break;

        case "#imbed":
                select_start = data.lastIndexOf("%text%");
                if (select_start == -1)
                {
                        _format      = data + text;
                        select_start = -text.length;
                }
                else
                {
                        _format      = data.replace(/%text%/, text);
                        select_start = -_format.length + select_start + text.length;
                };
                select_end   = select_start;
                break;

        default:
                _format      = "[" + format + " " + text + "]";
                select_start = -1;
                select_end   = -1;
                break;
        };

        if (document.selection != null)
        {
                with (object_handle._selection)
                {
                        text = _format;
                        collapse();
                        moveStart("character", select_start);
                        moveEnd("character", select_end);
                        select();
                };
        }
        else if (object_handle.selectionStart != null)
        {
                with (object_handle)
                {
                        var temp      = selectionStart + _format.length;
                        select_start += temp;
                        select_end   += temp;
                        value         = value.substring(0, selectionStart) +
                                        _format +
                                        value.substring(selectionEnd, textLength);
                        scrollTop     = scroll_top;
                        setSelectionRange(select_start, select_end);
                };
        }
        else
        {
                object_handle.value += _format;
        };

        object_handle.focus();
};
//--------------------------------
//    LOCATION
//--------------------------------
function load_page(url) //arguments: (0 => target, ), 1 => url
{
        if (arguments.length > 1)
        {
                var target = url;
                url        = arguments[1];
        }
        else
        {
                var target = "_blank";
        };

        var width  = 800;
        var height = 600;
        if (width  > screen.availWidth)  width  = screen.availWidth;
        if (height > screen.availHeight) height = screen.availHeight;
        var left   = parseInt((screen.availWidth  - width)  / 2);
        var top    = parseInt((screen.availHeight - height) / 2);

        var object = window.open(
                url,
                target,
                "width=" + width + "," +
                "height=" + height + "," +
                "left=" + left + "," +
                "top=" + top + "," +
                "location=no," +
                "menubar=no," +
                "resizable=yes," +
                "scrollbars=yes," +
                "status=no," +
                "toolbar=no");

        fx_event_listen(object, "load", function() { fx_adjust_window(object); });
};
//--------------------------------
//    FORM
//--------------------------------
function limit(object,
               limit)
{
        if (object.value.length > limit)
                object.value = object.value.substr(0, limit);
};
//--------------------------------
//    COOKIE
//--------------------------------
function getcookie(name)
{
        var value  = document.cookie;
        var i      = value.indexOf(name + "=");
        if (i == -1) return "";
        i         += name.length + 1;
        var c      = value.indexOf(";", i);
        if (c == -1) c = value.length;
        value      = value.substring(i, c);
        return unescape(value);
};
//................................
function setcookie(name,
                   value) //arguments: 2 => expires
{
        document.cookie = name + "=" + escape(value) +
                          ((arguments.length > 2) ? "; expires=" + arguments[2].toGMTString() : "") +
                          "; path=/";
};
//................................
function delcookie(name)
{
        document.cookie = name + "=; expires=Thu, 01-Jan-70 00:00:00 GMT; path=/";
};
//--------------------------------
//    VARIOUS
//--------------------------------
var hide_objects_state = new Array();
var hide_objects_flag  = false;

function hide_objects()
{
        var flag   = (arguments.length > 0) ? arguments[0] : true;
        if (hide_objects_flag == flag) return;

        var list   = document.getElementsByTagName("object");
        var object = null;
        var c      = list.length;

        for (var i = 0; i < c; i++)
        {
                object = list.item(i);

                if (hide_objects_flag)
                {
                        object.style.visibility = hide_objects_state[i];
                        continue;
                };

                hide_objects_state[i]   = object.style.visibility;
                object.style.visibility = "hidden";
        };

        if (hide_objects_flag) hide_objects_state = new Array();
        hide_objects_flag = flag;
};
//................................
function show_objects()
{
        hide_objects(false);
};
//................................
function load_script(url) //arguments: 1 => onload callback function
{
        var list   = document.getElementsByTagName("script");
        var object = null;
        var c      = list.length;

        for (var i = 0; i < c; i++)
        {
                object = list.item(i);
                if (object.getAttribute("src") == url) return;
        };

        var head = document.getElementsByTagName("head")[0];
        var link = document.createElement("script");
        if (arguments.length > 1) link.addEventListener("load", arguments[1]);
        link.setAttribute("src",   url);
        link.setAttribute("async", "");
        head.appendChild(link);
};
//................................
function load_css(url)
{
        var list   = document.getElementsByTagName("link");
        var object = null;
        var c      = list.length;

        for (var i = 0; i < c; i++)
        {
                object = list.item(i);
                if (object.getAttribute("href") == url) return;
        };

        var head = document.getElementsByTagName("head")[0];
        var link = document.createElement("link");
        link.setAttribute("rel",    "stylesheet");
        link.setAttribute("href",   url);
        link.setAttribute("media",  "not all");
        link.setAttribute("onload", "this.media='all';");
        head.appendChild(link);
};