/*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

//--------------------------------
//    COMMAND
//--------------------------------
function ifc_select_page(index) //arguments: 1 => popup
{
        var url = ifc_page[0] + "?ifc_message=ifc_select_page&ifc_param=" + encodeURIComponent(ifc_page[index]);

        if (arguments.length > 1)
        {
                load_page(url);
                return;
        };

        ifc_reset();
        load_page("this", url);
};
//................................
function ifc_select_menu(index)
{
        if ((ifc_menu[0][index] != "") && (! confirm(ifc_menu[0][index] + "?"))) return;
        eval(ifc_menu[1][index]);
};
//................................
function ifc_submit()
{
        ifc_memorize_position();
        document.ifc.submit();
};
//................................
function ifc_post() //arguments: 0 => message, 1 => param
{
        if (arguments.length)     document.ifc.ifc_message.value = arguments[0];
        if (arguments.length > 1) document.ifc.ifc_param.value   = arguments[1];

        ifc_submit();
};
//................................
function ifc_cancel() //arguments: 0 => offset
{
        var offset = arguments.length ? arguments[0] : 0;

        ifc_reset(offset);
        ifc_post("ifc_cancel");
};
//................................
function ifc_autopost(object) //arguments: 1 => message
{
        if (typeof object != "object") object = ifc_get_object(object);

        var message = (arguments.length > 1) ? arguments[1] : "";

        fx_event_listen(object, "change", function() { ifc_post(message); });
};
//................................
function ifc_response(value)
{
        var object = document.getElementById("ifc-response");
        if (object == null) return;

        object.className = "";
        setTimeout(function () { object.className = "ifc-response-fade"; }, 0);
        object.innerHTML = value;
};
//--------------------------------
//    VALUE
//--------------------------------
function ifc_value(object) //arguments: 1 => index
{
        if (typeof object != "object")
        {
                var index = (arguments.length > 1) ? arguments[1] : 0;
                object    = ifc_get_object(object, index);
        };

        switch (object.type)
        {
        case "checkbox":
        case "radio":
                if (object.checked) return object.value;
                break;

        case "text":
        case "textarea":
        case "password":
        case "hidden":
        case "button":
        case "submit":
        case "reset":
                return object.value;

        case "file":
                return (object.files == undefined) ? object.value : object.files;

        case "select-one":
        case "select-multiple":
                return (object.selectedIndex >= 0) ? object[object.selectedIndex].value : false;

        default:
                var _object = null;
                var i       = 0;

                while ((_object = object[i++]) && (_object.type == "radio"))
                {
                        if (_object.checked) return _object.value;
                };
                alert("object.type");
        };

        return false;
};
//................................
function ifc_reset() //arguments: 0 => offset
{
        var object = null;
        var i      = arguments.length ? arguments[0] : 0;

        while (object = document.ifc.elements[i++]) ifc_clear(object, 0, true);
};
//................................
function ifc_clear(object) //arguments: 1 => index, 2 => no focus
{
        if (typeof object != "object")
        {
                var index = (arguments.length > 1) ? arguments[1] : 0;
                object    = ifc_get_object(object, index);
        };

        var nofocus = (arguments.length > 2) ? arguments[2] : false;

        switch (object.type)
        {
        case "checkbox":
                object.value         = "";
                if (object.checked) object.click();
                break;

        case "radio":
                object.value         = "";
                object.checked       = false;
                break;

        case "text":
        case "textarea":
        case "password":
        //case "file": //can cause security exception
        case "hidden":
                object.value         = "";
                break;

        case "select-one":
        case "select-multiple":
                object.selectedIndex = -1;
                break;

        default:
                var _object          = null;
                var i                = 0;

                while ((_object = object[i++]) && (_object.type == "radio"))
                {
                        _object.value   = "";
                        _object.checked = false;
                };
        };

        if (! nofocus) ifc_focus(object);
};
//................................
function ifc_change(object) //arguments: 1 => value, 2 => index
{
        if (typeof object != "object")
        {
                var index = (arguments.length > 2) ? arguments[2] : 0;
                object    = ifc_get_object(object, index);
        };

        var value = (arguments.length > 1) ? arguments[1] : "";

        switch (object.type)
        {
        case "checkbox":
        case "radio":
        case "text":
        case "textarea":
        case "password":
        //case "file": //can cause security exception
        case "hidden":
                object.value = value;
                break;

        case "select-one":
        case "select-multiple":
                var _object  = null;
                var i        = 0;

                while (_object = object.options[i++])
                        _object.selected = _object.value == value;
                break;

        default:
                var _object  = null;
                var i        = 0;

                while ((_object = object[i++]) && (_object.type == "radio"))
                        _object.checked = _object.value == value;
        };

        ifc_focus(object);
};
//................................
function ifc_copy(source,
                  target)
{
        ifc_change(target, ifc_value(source));
};
//................................
function ifc_select(object) //arguments: 1 => index
{
        if (typeof object != "object")
        {
                var index = (arguments.length > 1) ? arguments[1] : 0;
                object    = ifc_get_object(object, index);
        };

        switch (object.type)
        {
        case "checkbox":
        case "radio":
                object.click();
                break;

        case "text":
        case "textarea":
                ifc_focus(object);
                object.select();
                return;
        };

        ifc_focus(object);
};
//................................
function ifc_limit(object,
                   limit)
{
        var value = ifc_value(object);

        if (value.length > limit) ifc_change(object, value.substring(0, limit));
};
//--------------------------------
//    LIST
//--------------------------------
function ifc_list_activate() //arguments: 0 => name (default: "list")
{
        var name   = arguments.length ? arguments[0] : "list";
        var object = null;
        var i      = 0;

        while (object = ifc_get_object(name + "[" + i++ + "]"))
        {
                if (! object.checked) object.click();
        };
};
//................................
function ifc_list_invert(name) //arguments: 0 => name (default: "list")
{
        var name   = arguments.length ? arguments[0] : "list";
        var object = null;
        var i      = 0;

        while (object = ifc_get_object(name + "[" + i++ + "]"))
                object.click();
};
//................................
function ifc_list_deactivate(name) //arguments: 0 => name (default: "list")
{
        var name   = arguments.length ? arguments[0] : "list";
        var object = null;
        var i      = 0;

        while (object = ifc_get_object(name + "[" + i++ + "]"))
        {
                if (object.checked) object.click();
        };
};
//--------------------------------
//    TEXTAREA
//--------------------------------
function ifc_linenumber(object)
{
        if (document.all)
        {
                object.onscroll = null;
                return;
        };

        object.style.backgroundPosition = (-object.scrollLeft) + "px " + (-object.scrollTop) + "px";
};
//................................
function ifc_clean(object) //arguments: 1 => index
{
        if (typeof object != "object")
        {
                var index = (arguments.length > 1) ? arguments[1] : 0;
                object    = ifc_get_object(object, index);
        };

        var value       = ifc_value(object);
        var scroll_top  = object.scrollTop;
        var scroll_left = object.scrollLeft;

        value = value.replace(/^(\s*\n)+/,          "");
        value = value.replace(/\s+$/,               "");
        value = value.replace(/[ \f\t\v]+(\r?)\n/g, "$1\n");
        value = value.replace(/\t/g,                "    ");

        ifc_change(object, value);
        _ifc_scroll(object, scroll_top, scroll_left);
};
//................................
function ifc_keydown(event)
{
        var event        = window.event ? window.event     : event;
        var object       = window.event ? event.srcElement : event.target;
        var select_start = 0;
        var select_end   = 0;
        var select_text  = "";
        var select_flag  = 0;

        if (document.selection != null)
        {
                var range       = document.selection.createRange();
                var _range      = range.duplicate();
                var __range     = range.duplicate();
                __range.moveToElementText(object);
                _range.setEndPoint("EndToEnd", __range);
                select_start    = __range.text.length - _range.text.length;
                _range.setEndPoint("StartToEnd", range);
                select_end      = __range.text.length - _range.text.length;
                select_text     = range.text;
        }
        else if (object.selectionStart != null)
        {
                select_start   = object.selectionStart;
                select_end     = object.selectionEnd;
                select_text    = object.value.substring(select_start, select_end);
                var scroll_top = object.scrollTop;
        }
        else
        {
                return true;
        };

        switch (event.keyCode)
        {
        case 9: //tab
                if (event.shiftKey || (select_text.indexOf("\n") != -1))
                {
                        //expand to start of line
                        select_start -= object.value.substr(0, select_start).match(/(\n|^)(.*)$/)[2].length;

                        //expand to end of line
                        select_end   += object.value.substr(select_end).match(/^(.*)(\r?\n|$)/)[1].length;

                        select_text   = object.value.substring(select_start, select_end);
                        select_text   = event.shiftKey ?
                                        select_text.replace(/(\r?\n|^) {1,4}/g, "$1") :
                                        select_text.replace(/(\r?\n|^)/g, "$1    ");
                        select_flag   = true;
                }
                else
                {
                        select_text   = "    ";
                };
                break;

        case 13: //newline
                var space = "";

                //expand to start of line
                for (var i = select_start - 1; i >= 0; i--)
                {
                        switch (object.value.charCodeAt(i))
                        {
                        case 10: i      = 0;   break;
                        case 32: space += " "; break;
                        default: space  = "";  break;
                        };
                };

                select_text = "\n" + space + select_text;
                break;

        case 87: //w
                if (! event.altKey) return true;
                ifc_clean(object);
                return false;

        default:
                return true;
        };

        var length    = object.value.length;
        object.value  = object.value.substring(0, select_start) +
                        select_text +
                        object.value.substring(select_end);
        select_end   += object.value.length - length;
        select_start  = select_flag ? select_start : select_end;

        if (document.selection != null)
        {
                range.collapse();
                range.moveEnd("character", object.value.substr(0, select_end).replace(/\r\n/g, "\n").length);
                range.moveStart("character", object.value.substr(0, select_start).replace(/\r\n/g, "\n").length);
                if (object.value.charCodeAt(select_end) == 10) range.moveEnd("character", -1);
                range.select();
        }
        else if (object.selectionStart != null)
        {
                event.preventDefault();
                object.selectionStart = select_start;
                object.selectionEnd   = select_end;
                object.scrollTop      = scroll_top;
        };

        return false;
};
//--------------------------------
//    LANGUAGE
//--------------------------------
var ifc_language_separator = String.fromCharCode(31);
var ifc_language_flag      = false;

function ifc_language_select_all(language)
{
        ifc_language_flag = true;

        var object    = null;
        var _id       = "";
        var _language = "";
        var i         = 0;
        var _i        = 0;

        while (object = document.links[i++])
        {
                if (object.className.substr(0, 9) != "language-") continue;
                _id       = object.id;
                _i        = _id.indexOf(":")
                if (_i == -1)                                     continue;
                _language = _id.substr(_i + 1);
                if (_language == language)                        object.onclick();
        };

        ifc_language_flag = false;
};
//................................
function ifc_language_select(source,
                             target,
                             language)
{
        if (typeof target != "object") target = ifc_get_object(target);

        if (target.language == language)
        {
                if (ifc_language_flag) return;
                ifc_language_select_all(language);
                return;
        };

        ifc_language_highlight((typeof source == "object") ? source.name : source, language);
        ifc_language_load(source, target, language);
};
//................................
function ifc_language_highlight(id,
                                language)
{
        var object    = null;
        var _id       = "";
        var _language = "";
        var length    = id.length + 1;
        var i         = 0;

        while (object = document.links[i++])
        {
                _id              = object.id;
                if (_id.substr(0, length) != id + ":") continue;
                _language        = _id.substr(length);
                object.className = "language-" + ((_language == language) ? "on" : "off");
        };
};
//................................
function ifc_language_load(source,
                           target,
                           language)
{
        if (typeof source != "object") source = ifc_get_object(source);
        if (typeof target != "object") target = ifc_get_object(target);
        var scroll_top    = target.scrollTop;
        var scroll_left   = target.scrollLeft;
        target.value      = ifc_language_get(source.value, language);
        target.language   = language;
        if (ifc_language_flag)         return;
        target.focus();
        if (target.type == "text")     target.select();
        ifc_scroll(target, scroll_top, scroll_left);
};
//................................
function ifc_language_reload(source,
                             target)
{
        var language = "";
        if (typeof source != "object") source   = ifc_get_object(source);
        if (typeof target != "object") target   = ifc_get_object(target);
        if (target.language != null)   language = target.language;
        ifc_language_load(source, target, language);
};
//................................
function ifc_language_save(source,
                           target)
{
        var language = "";
        if (typeof source != "object") source   = ifc_get_object(source);
        if (typeof target != "object") target   = ifc_get_object(target);
        if (source.language != null)   language = source.language;
        target.value = ifc_language_set(target.value, source.value, language);
};
//................................
function ifc_language_get(text,
                          language)
{
        var i  = 0;
        var _i = 0;
        if (language == "")
        {
                if ((i = text.indexOf(ifc_language_separator)) == -1) i = text.length;
                return text.substring(0, i);
        };
        if ((i = text.indexOf(ifc_language_separator + language + ":", i)) == -1) return "";
        var c  = language.length + 2;
        if ((_i = text.indexOf(ifc_language_separator, i + c)) == -1)             _i = text.length;
        return text.substring(i + c, _i);
};
//................................
function ifc_language_set(text,
                          value,
                          language)
{
        var i  = 0;
        var _i = 0;
        if (language == "")
        {
                if ((i = text.indexOf(ifc_language_separator)) == -1) i = text.length;
                return value + text.substr(i);
        };
        if (value != "")
                value = ifc_language_separator + language + ":" + value;
        if ((i = text.indexOf(ifc_language_separator + language + ":", i)) == -1)
                return text + value;
        var c  = language.length + 2;
        if ((_i = text.indexOf(ifc_language_separator, i + c)) == -1)
                _i = text.length
        return text.substring(0, i) + value + text.substr(_i);
};
//--------------------------------
//    PERMISSION
//--------------------------------
function ifc_permission_event(event)
{
        if ((event != "window_scroll") && (event != "mousemove")) return;

        var object = document.getElementById("ifc-permission");
        if (object == null)       return;

        if (fx_visible(object))
        {
                if (fx_mouse_y >= fx_height(object)) fx_visible(object, false);
        }
        else if (fx_mouse_y < 4)
        {
                fx_visible(object, true);
        };
};
//--------------------------------
//    COMMON
//--------------------------------
function ifc_get_object(name) //arguments: 1 => index, 2 => window
{
        var object = null;
        var index  = (arguments.length > 1) ? arguments[1] : 0;
        var window = (arguments.length > 2) ? arguments[2] : this;
        var i      = 0;
        var _i     = 0;

        while (object = window.document.ifc.elements[i++])
        {
                if ((object.name == name) && (_i++ == index)) return object;
        };

        return null;
};
//................................
function ifc_focus(object)
{
        if (typeof object != "object")
        {
                var index = (arguments.length > 1) ? arguments[1] : 0;
                object    = ifc_get_object(object, index);
        };

        if (object.disabled)         return;
        if (object.type == "hidden") return;

        object.focus();
};
//................................
function ifc_autofocus()
{
        var object = null;
        var offset = 2;

        while (object = document.ifc.elements[offset++])
        {
                switch (object.type)
                {
                case "file":
                case "textarea":
                        ifc_focus(object);
                        return;

                case "text":
                        ifc_focus(object);
                        object.select();
                        return;
                };
        };
};
//................................
var ifc_resize_object = null;
var ifc_resize_cols   = 0;
var ifc_resize_rows   = 0;

function ifc_resize(object)
{
        if (typeof object != "object") object = ifc_get_object(object);
        if (object.type != "textarea") return;

        if (ifc_resize_object != null)
        {
                ifc_resize_object.setAttribute("cols", ifc_resize_cols);
                ifc_resize_object.setAttribute("rows", ifc_resize_rows);

                if (object == ifc_resize_object)
                {
                        ifc_resize_object = null;
                        return;
                };
        };

        ifc_resize_object = object;
        ifc_resize_cols   = object.getAttribute("cols");
        ifc_resize_rows   = object.getAttribute("rows");

        if (ifc_resize_cols < 100) object.setAttribute("cols", "100");
        if (ifc_resize_rows < 40)  object.setAttribute("rows", "40");

        fx_adjust_window();
        object.scrollIntoView();
};
//................................
function ifc_scroll(object,
                    top,
                    left)
{
        if (typeof object != "object") object = ifc_get_object(object);
        if (object.type != "textarea") return;

        setTimeout(function() { _ifc_scroll(object, top, left); }, 10);
};
//................................
function _ifc_scroll(object,
                     top,
                     left)
{
        object.scrollTop  = top;
        object.scrollLeft = left;
};
//................................
function ifc_memorize_position()
{
        ifc_change("ifc_left", fx_page_left());
        ifc_change("ifc_top",  fx_page_top());
};
//--------------------------------
//    LOADING ANIMATION
//--------------------------------
function ifc_loading_event(event)
{
        if (event != "window_unload")  return;
        if (document.all)              return;

        var div = document.createElement("div");
        div.setAttribute("id", "ifc-loading");

        document.getElementsByTagName("body")[0].appendChild(div);
};
//................................
function _ifc_loading_event()
{
        fx_visible("ifc_loading", false);
};