/*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

var tp_ctrl_opt_value   = 0;
var tp_ctrl_opt_img_url = "";
var tp_mouseout_monitor = new Array();
var tp_dd_object        = null;

function tp_event(event)
{
        //loading animation
        if (event == "window_unload")
        {
                fx_unregister_callback(tp_event);

                if (document.all) return;

                var div = document.createElement("div");
                div.setAttribute("id", "tp-loading");
                div.appendChild(document.createElement("div"));

                document.getElementsByTagName("body")[0].appendChild(div);
                return;
        };

        if ((event == "window_scroll") || (event == "window_resize"))
        {
                fx_visible(document.getElementById("tp-ctrl"), false);
                fx_visible(document.getElementById("tp-marker"), false);
        };

        if (event != "mousemove") return;

        //monitored objects
        var i = 0;
        var c = tp_mouseout_monitor.length;

        for (; i < c; i++)
        {
                if (tp_mouseout_monitor[i] == null) continue;

                var object      = tp_mouseout_monitor[i][0];
                var no_cropping = tp_mouseout_monitor[i][2];
                var x           = 0;
                var y           = 0;

                if (
                     (fx_mouse_x < (x = no_cropping ? fx_left(object) : fx_offset_left(object)))
                     ||
                     (fx_mouse_y < (y = no_cropping ? fx_top(object)  : fx_offset_top(object)))
                     ||

                //check uncropped dimensions first to enhance performance
                     (fx_mouse_x > (x + fx_width(object, true)))
                     ||
                     (fx_mouse_y > (y + fx_height(object, true)))
                     ||

                //now check cropped dimensions if required
                     (
                       (! no_cropping)
                       &&
                       (
                         (fx_mouse_x > (x + fx_width(object)))
                         ||
                         (fx_mouse_y > (y + fx_height(object)))
                       )
                     )
                   )
                {
                        tp_mouseout_monitor[i][1](object);
                        tp_mouseout_monitor[i] = null;
                };
        };

        //highlight
        tp_dd_dsp();

        //drag drop
        if (dd_vehicle != null) return;

        //control pad
        var object = document.getElementById("tp-ctrl");
        if (object == null) return;

        var page_top = fx_page_top();

        if ((fx_mouse_y <= (page_top + 4)) && (! fx_visible(object)) && (dd_object == null))
        {
                var x1 = fx_width(object, true);
                var y1 = fx_height(object, true);
                var x2 = fx_mouse_x - x1 / 2;
                var y2 = fx_mouse_y - y1 / 2;
                var x3 = fx_page_left();
                var y3 = page_top;
                var x4 = fx_window_width  + x3;
                var y4 = fx_window_height + y3;

                if ((x2 + x1) > x4) x2 = x4 - x1;
                if ((y2 + y1) > y4) y2 = y4 - y1;
                if (x2 < x3)        x2 = x3;
                if (y2 < y3)        y2 = y3;

                hide_objects();
                fx_move(object, x2, y2);
                fx_visible(object, true);

                tp_set_mouseout_monitor(object, tp_ctrl_mouseout, true);

                //hide marker
                var object = document.getElementById("tp-marker");
                if (object == null) return;

                fx_visible(object, false);
        };

        //marker
        if (! fx_visible(object))
        {
                var object = document.getElementById("tp-marker");
                if (object == null) return;

                var x1 = fx_mouse_x - parseInt(fx_width(object, true) / 2);
                var y1 = page_top;
                var y2 = y1 + fx_height(object, true);

                if (fx_visible(object))
                {
                        if (fx_mouse_y < y2) fx_visible(object, false);
                        else                 fx_move(object, x1, y1);
                }
                else if (fx_mouse_y >= y2)
                {
                        fx_move(object, x1, y1);
                        fx_visible(object, true);
                };
        };
};
//................................
function tp_beforedragstart()
{
        //hide marker
        var object = document.getElementById("tp-marker");
        if (object == null) return;

        if (fx_visible(object)) fx_visible(object, false);

        //hide monitored objects
        var i = 0;
        var c = tp_mouseout_monitor.length;

        for (; i < c; i++)
        {
                if (tp_mouseout_monitor[i] == null) continue;

                tp_mouseout_monitor[i][1](tp_mouseout_monitor[i][0]);
                tp_mouseout_monitor[i] = null;
        };

        //hide highlight
        if (tp_dd_object != null)
        {
                var value              = tp_dd_object.className;
                tp_dd_object.className = value.substr(0, value.length - 4);
                tp_dd_object           = null;
        };
};
//................................
function tp_set_mouseout_monitor(object,
                                 callback) //arguments: 2 => no cropping
{
        var no_cropping = (arguments.length > 2) && arguments[2];

        var c = tp_mouseout_monitor.length;

        for (var i = 0; i < c; i++)
                if (tp_mouseout_monitor[i] == null)      break;

        for (var _i = i; _i < c; _i++)
        {
                if (tp_mouseout_monitor[i] == null)      continue;
                if (tp_mouseout_monitor[i][0] == object) return;
        };

        tp_mouseout_monitor[i] = new Array(object, callback, no_cropping);
};
//................................
function tp_ctrl_opt_set(value)
{
        tp_ctrl_opt_value = value;
        var object = document.getElementById("tp-ctrl-opt-apply");
        if (object == null) return;
        location.href = object.href;
};
//................................
function tp_ctrl_opt_switch(value)
{
        if ((tp_ctrl_opt_value & value) == 0)
                tp_ctrl_opt_value |= value;
        else
                tp_ctrl_opt_value &= ~value;
        tp_ctrl_opt_img();
};
//................................
function tp_ctrl_opt_apply(url)
{
        url = url.replace(/%value%/, tp_ctrl_opt_value);
        url = url.replace(/%left%/,  fx_page_left());
        url = url.replace(/%top%/,   fx_page_top());
        location.replace(url);
};
//................................
function tp_ctrl_opt_img()
{
        var array1 = new Array(     4,       8,      32,          64,     128,      1,         16,        2,        256,     512,     1024,    2048,   4096,     8192,   16384);
        var array2 = new Array("text", "value", "image", "thumbnail", "media", "href", "download", "plugin", "template", "group", "repeat", "shift", "calt", "cblock", "debug");

        for (var i = 0; i < 15; i++)
                fx_change_image("tp-ctrl-opt-img-" + i,
                                tp_ctrl_opt_img_url + "button_" + array2[i] +
                                (((tp_ctrl_opt_value & array1[i]) == 0) ? "_disabled" : "") + ".png");
};
//................................
function tp_ctrl_mouseout(object)
{
        fx_visible(object, false);
        fx_move(object, 0, 0);
        show_objects();
};
//................................
var tp_edt_dsp_flag = false;

function tp_edt_dsp(id)
{
        if (dd_vehicle != null)                      return;
        if (tp_edt_dsp_flag)                         return;

        var object = document.getElementById("tp-edt-" + id);
        if (object == null)                          return;

        if (object.className == "tp-edt-dsp-inline") return;

        tp_edt_dsp_flag  = true;
        hide_objects();
        object.className = "tp-edt-dsp-inline";

        tp_set_mouseout_monitor(object, tp_edt_dsp_mouseout, true);
};
//................................
function tp_edt_dsp_mouseout(object)
{
        object.className = "tp-edt-dsp-none";
        show_objects();
        tp_edt_dsp_flag  = false;
};
//................................
function tp_grp_dsp(object)
{
        if (object.className == "tp-grp-alt") return;
        object.className = "tp-grp-alt";

        tp_set_mouseout_monitor(object, tp_grp_dsp_mouseout);
};
//................................
function tp_grp_dsp_mouseout(object)
{
        object.className = "tp-grp";
};
//................................
function tp_dd_dsp()
{
        var list = document.getElementsByTagName("div"),
            c = list.length,
            object, parent, _object = null,
            x, y, z, _z = 0;

        for (var i = 0; i < c; i++)
        {
                object = list.item(i);

                if (
                     object.className.match(/(^| )tp-dd(100|-alt|100-alt)?($| )/)
                     &&
                     (fx_mouse_x >= (x = fx_offset_left(object)))
                     &&
                     (fx_mouse_y >= (y = fx_offset_top(object)))
                     &&

                //check uncropped dimensions first to enhance performance
                     (fx_mouse_x <= (x + fx_width(object, true)))
                     &&
                     (fx_mouse_y <= (y + fx_height(object, true)))
                     &&

                //now check cropped dimensions
                     (fx_mouse_x <= (x + fx_width(object)))
                     &&
                     (fx_mouse_y <= (y + fx_height(object)))
                   )
                {
                        parent = object;
                        z      = 0;

                        while ((parent = parent.parentNode) != null) z++;

                        if ((_object == null) || (z > _z))
                        {
                                _object = object;
                                _z      = z;
                        };
                };
        };

        if (_object == tp_dd_object) return;

        if (tp_dd_object != null)
        {
                var value              = tp_dd_object.className;
                tp_dd_object.className = value.substr(0, value.length - 4);
                tp_dd_object           = null;
        };

        if (_object == null) return;

        _object.className = _object.className + "-alt";
        tp_dd_object      = _object;
};
//................................
function tp_flp(id)
{
        var object = document.getElementById("tp-grp-" + id);
        if (object == null) return false;

        if ((fx_keyboard_key == 16) || //shift
            (fx_keyboard_key == 17) || //ctrl
            (fx_keyboard_key == 18))   //alt
        {
                var object  = document.getElementById("tp-grp-" + id);
                if (object == null) return false;

                var list    = document.getElementsByClassName("tp-grp");
                var _object = null;
                var parent  = null;
                var flag    = false;
                var _flag   = false;
                var _id     = "";
                var _switch = null;

                for (var i = 0; i < list.length; i++)
                {
                        _object = list.item(i);
                        _flag   = false;

                        if (flag)
                        {
                                parent = _object;

                                while ((parent = parent.parentNode) != null)
                                {
                                        if (parent == object)
                                        {
                                                _flag = true;
                                                break;
                                        };
                                };
                        }
                        else
                        {
                                if (_object == object)
                                {
                                        flag  = true;
                                        _flag = true;
                                }
                                else
                                {
                                        parent = object;

                                        while ((parent = parent.parentNode) != null)
                                        {
                                                if (parent == _object)
                                                {
                                                        _flag = true;
                                                        break;
                                                };
                                        };
                                };
                        };

                        _id     = _object.id.substr(7);
                        _switch = document.getElementById("tp-flp-" + _id);
                        if (_switch == null) continue;

                        _object.style.display = _flag ? "block"  : "none";
                        _switch.className     = _flag ? "tp-flp" : "tp-flp-on";
                };

                fx_scrollto(object);
        }
        else
        {
                var _switch = document.getElementById("tp-flp-" + id);
                if (_switch == null) return false;

                var flag             = object.style.display == "none";
                object.style.display = flag ? "block"  : "none";
                _switch.className    = flag ? "tp-flp" : "tp-flp-on";
        };

        tp_flp_store();
        return false;
};
//................................
function tp_flp_store()
{
        var list    = document.getElementsByClassName("tp-grp");
        var object  = null;
        var id      = "";
        var _switch = null;
        var value   = "/";

        for (var i = 0; i < list.length; i++)
        {
                object   = list.item(i);
                if (object.style.display != "none") continue;
                id       = object.id.substr(7);
                _switch  = document.getElementById("tp-flp-" + id);
                if (_switch == null) continue;
                value   += id + "/";
        };

        setcookie("cms_tp_flp_value", value);
};
//................................
function tp_flp_restore(content_index)
{
        //check page id
        var value = getcookie("cms_tp_flp_id");
        setcookie("cms_tp_flp_id", content_index);
        if (value != content_index) { delcookie("cms_tp_flp_value"); return; };

        value       = getcookie("cms_tp_flp_value");
        var list    = document.getElementsByClassName("tp-grp");
        var object  = null;
        var id      = "";
        var _switch = null;
        var flag    = false;

        for (var i = 0; i < list.length; i++)
        {
                object  = list.item(i);
                id      = object.id.substr(7);
                _switch = document.getElementById("tp-flp-" + id);
                if (_switch == null) continue;

                flag                 = value.indexOf("/" + id + "/") == -1;
                object.style.display = flag ? "block"  : "none";
                _switch.className    = flag ? "tp-flp" : "tp-flp-on";
        };
};