<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< DESKTOP INTERFACE >=============================================================================
//-----------------------------------------------------------------------------------------------------

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object  = $ifc_param;
        $initial = NULL;
        break;

case "initial":
//.....................................................................................................
        $object  = NULL;
        $initial = $ifc_param;
        break;

case "add":
//.....................................................................................................
        if ($key = $desktop->data->seek(array("#subtype" => "address")))
        {
                $name = ($ifc_param || ($initial === "-")) ? NULL : $initial;
                $desktop->data->set_buffer(array(array("name"    => $name,
                                                       "#type"   => "address",
                                                       "company" => $ifc_param)));

                if (
                     ($_object = $desktop->data->insert($key))
                     &&
                     $desktop->save()
                   )
                {
                        $object       = $_object;
                        $initial      = NULL;
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "save":
//.....................................................................................................
        $desktop->object_set($object, "name",    $ifc_param1);
        $desktop->object_set($object, "company", $ifc_param2);
        $desktop->object_set($object, "phone",   $ifc_param3);
        $desktop->object_set($object, "fax",     $ifc_param4);
        $desktop->object_set($object, "email",   $ifc_param5);
        $desktop->object_set($object, "address", $ifc_param6);
        $desktop->object_set($object, "comment", $ifc_param7);

        if ($desktop->save())
        {
                $initial      = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "delete":
//.....................................................................................................
        if ($desktop->delete_object($object))
        {
                $object       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
if (empty($initial))
{
        $initial = $desktop->object_get($object, "company") . $desktop->object_get($object, "name");
        $initial = $initial ? strtoupper($initial[0]) : "-";
        if (strpos("ABCDEFGHIJKLMNOPQRSTUVWXYZ", $initial) === FALSE) $initial = "-";
};

$array          = NULL;
$initial_count  = NULL;
$mailbox_user   = NULL;
$mailbox_object = NULL;

$desktop->data->move("first");
while($key = $desktop->data->move("next"))
{
        switch ($desktop->object_type($key))
        {
        case "address":
//.....................................................................................................
                $name    = (string)$desktop->object_get($key, "name");
                $company = (string)$desktop->object_get($key, "company");
                $char    = ($char = $company . $name) ? strtoupper($char[0]) : "-";
                if (strpos("ABCDEFGHIJKLMNOPQRSTUVWXYZ", $char) === FALSE) $char = "-";

                if (isset($initial_count[$char])) $initial_count[$char]     += 1;
                else                              $initial_count[$char]      = 1;

                if ($char === $initial)           $array[$company][$name][]  = $key;
                break;

        case "mailbox":
//.....................................................................................................
                $mailbox_user   = $user;
                $mailbox_object = $key;
        };
};

//menu
$menu = NULL;
if ($object)
{
        //return value
        if (CMS_IFC_SELECT && $desktop->object_get($object, CMS_IFC_SELECT))
        {
                switch (CMS_IFC_SELECT)
                {
                case "email":
                        $value = "\"" . $desktop->object_get($object, "name") . "\" " .
                                 "<" . $desktop->object_get($object, "email") . ">";
                        break;

                default:
                        $value = $desktop->object_get($object, "name");
                        break;
                };

                $menu[CMS_L_COMMAND_INSERT] = "javascript:ifc_return('" . q($value) . "');";
        };
        $menu[CMS_L_COMMAND_SAVE .   "|desktop/command_save"]   = "save";
        $menu[CMS_L_COMMAND_DELETE . "|desktop/command_delete"] = "#delete";
};

$ifc = new ifc(NULL,
               $ifc_page,
               $menu,
               array_merge($param,
                           array("object"  => $object,
                                 "initial" => $initial)),
               NULL,
               CMS_L_DESKTOP_ADDRESS_006);

echo("<table class=\"layout\" " .
            "style=\"WIDTH:100%\">" .
     "<tr>" .
     "<td style=\"WIDTH:1px\">");

//initial list
ifc_table_open();
for ($i = 65; $i <= 90; $i++)
{
        $char = chr($i);

        echo("<tr>" .
             "<td class=\"highlight\" " .
                 "style=\"PADDING-BOTTOM:1px;PADDING-TOP:1px\">" .
             "<a href=\"javascript:ifc_post('initial','$char');\">" .
             (($char === $initial)         ? sprintf("<strong>%s</strong>", $char)                  : $char) .
             (isset($initial_count[$char]) ? sprintf(" <small>(%d)</small>", $initial_count[$char]) : NULL) .
             "</a>" .
             "</td>" .
             "</tr>");
};
echo("<tr>" .
     "<td class=\"highlight\" " .
         "style=\"PADDING-BOTTOM:1px;PADDING-TOP:1px\">" .
     "<a href=\"javascript:ifc_post('initial','-');\">" .
     (($initial === "-")         ? "<strong>...</strong>"                               : "...") .
     (isset($initial_count["-"]) ? sprintf(" <small>(%d)</small>", $initial_count["-"]) : NULL) .
     "</a>" .
     "</td>" .
     "</tr>");
ifc_table_close();

//spacer
echo("</td>" .
     "<td style=\"WIDTH:1px\">" .
     "&nbsp;" .
     "</td>" .

//address list
     "<td>");

ifc_table_open();
echo("<tr>" .
     "<th>" .
     CMS_L_NAME .
     "</th>" .
     "<th>" .
     CMS_L_DESKTOP_ADDRESS_004 .
     "</th>" .
     "<th>" .
     CMS_L_EMAIL .
     "</th>" .
     "</tr>" .
     "<tr>" .
     "<td colspan=\"3\" " .
         "class=\"highlight2\">" .
     "<a href=\"javascript:ifc_post('add');\">" .
     "[...]" .
     "</a>" .
     "</td>" .
     "</tr>");

$company = NULL;

if ($array)
{
        ksort($array);

        reset($array);
        while (list($key, $value) = each($array))
        {
                ksort($value);

                reset($value);
                while (list($_key, $_value) = each($value))
                {
                        while (list($__key, $__value) = each($_value))
                        {
                                $_key   = x($_key);
                                $varied = ifc_varied();

                                if (nstreq($key, $company))
                                {
                                        echo("<tr>" .
                                             "<th colspan=\"3\">" .
                                             x($key) .
                                             "</th>" .
                                             "</tr>" .
                                             "<tr>" .
                                             "<td colspan=\"3\" " .
                                                 "class=\"highlight2\">" .
                                             "<a href=\"javascript:ifc_post('add','" . rqx($key) . "');\">" .
                                             "[...]" .
                                             "</a>" .
                                             "</td>" .
                                             "</tr>");

                                        $company = $key;
                                };

                                echo("<tr>" .
                                     "<td$varied>" .
                                     "<a href=\"javascript:ifc_post('select','" . rqx($__value) . "');\">" .
                                     image("desktop/icon_address") . "&nbsp;" .
                                     (streq($__value, $object) ? sprintf("<strong>%s</strong>", $_key) : $_key) .
                                     "</a>" .
                                     "</td>" .
                                     "<td$varied>" .
                                     x($desktop->object_get($__value, "phone")) .
                                     "</td>" .
                                     "<td$varied>");
                                if ($email = $desktop->object_get($__value, "email"))
                                {
                                        $_email = x($email);

                                        echo($mailbox_user ?
                                             "<a href=\"" . x(CMS_ACTIVE_URL .
                                                              querystring($param,
                                                                          array("desktop_display" => "interface",
                                                                                "user"            => $mailbox_user,
                                                                                "object"          => $mailbox_object,
                                                                                "ifc_message"     => "mail",
                                                                                "to"              => $email))) . "\">" .
                                             image("desktop/icon_mailbox") . "&nbsp;$_email" .
                                             "</a>" :
                                             $_email);
                                };
                                echo("</td>" .
                                     "</tr>");
                        };
                };
        };
};
ifc_table_close();

if ($object)
{
        //spacer
        echo("</td>" .
             "<td style=\"WIDTH:1px\">" .
             "&nbsp;" .
             "</td>" .

        //data
             "<td style=\"WIDTH:1px\">");

        ifc_table_open();
        echo("<tr>" .
             "<th>");
        $ifc->set(CMS_L_NAME,
                  "text 40 40",
                  $desktop->object_get($object, "name"));
        echo("</th>" .
             "</tr>" .
             "<tr>" .
             "<td class=\"varied\">");
        $ifc->set(CMS_L_DESKTOP_ADDRESS_003,
                  "text 40 80 b",
                  $desktop->object_get($object, "company"));
        $ifc->set(CMS_L_DESKTOP_ADDRESS_004,
                  "text 40 40 b",
                  $desktop->object_get($object, "phone"));
        $ifc->set(CMS_L_DESKTOP_ADDRESS_005,
                  "text 40 80 b",
                  $desktop->object_get($object, "fax"));
        $ifc->set(CMS_L_EMAIL,
                  "text 40 80 b",
                  $desktop->object_get($object, "email"));
        $ifc->set(CMS_L_DESKTOP_ADDRESS_001,
                  "textarea 40x4 256 b",
                  $desktop->object_get($object, "address"));
        $ifc->set(CMS_L_DESKTOP_ADDRESS_002,
                  "textarea 40x4 256",
                  $desktop->object_get($object, "comment"));
        echo("</td>" .
             "</tr>");
        ifc_table_close();
};

echo("</td>" .
     "</tr>" .
     "</table>");

$ifc->close();
?>
