<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
$mysql = new mysql();

if (! isset($object)) $object = (string)cms_cache("database." . CMS_USER . ".object");
if (! isset($list))   $list   = preg_match("/^(?:|ifc_)/", CMS_IFC_MESSAGE) ? array($object) : array();

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = $ifc_param;
        break;

case "sql_console":
//.....................................................................................................

        //retrieve last command from permanent cache
        if (! isset($ifc_param1)) $ifc_param1 = cms_cache("database." . CMS_USER . ".code");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       NULL,
                       array("object" => $object),
                       "sql_console",
                       CMS_L_IFC_DATABASE_051);

        echo("<table class=\"layout\">" .
             "<tr>" .
             "<td>");

        //command
        $ifc->set(CMS_L_IFC_DATABASE_052,
                  "textarea 60x4",
                  $ifc_param1);

        //execute flag
        $ifc->param("execute", TRUE);

        //execute button
        echo("<div style=\"TEXT-ALIGN:right\">");
        $ifc->set(CMS_L_IFC_DATABASE_081,
                  "button",
                  "sql_console");
        echo("</div>" .

             "</td>" .
             "</tr>" .
             "</table>");

        if (isset($execute))
        {
                //cache last command permanently
                cms_cache("database." . CMS_USER . ".code", $ifc_param1, TRUE);

                if (! log_report($ifc_param1, 0, "table"))
                        $ifc->set(CMS_MSG_ERROR . "<br>" .
                                  "MySQL: " . x(mysql_error()),
                                  "info");
        };

        $ifc->close();

//table editor
case "edit_table":
//.....................................................................................................

        //default values
        $ifc_param1 =  0; //page offset
        $ifc_param2 = 20; //rows per page
        $ifc_param3 = 25; //characters per field

case "_edit_table":
case "edit_table_add":
case "edit_table_update":
case "edit_table_delete":
//.....................................................................................................

        //retrieve table structure
        if (! $result = mysql_query("SHOW COLUMNS FROM `" . sqlesc($object) . "`"))
                ifc_close_external();

        $fieldname = NULL;
        $fieldtype = NULL;
        $index     = NULL;
        $_row      = NULL;

        while ($resultrow = mysql_fetch_assoc($result))
        {
                $value             = $resultrow["Field"];
                $fieldname[$value] = $value;
                $fieldtype[$value] = $resultrow["Type"];
                if (streq($resultrow["Key"], "PRI")) $index = $value;
        };

        //use primary key as index
        if ($index)
        {
                $_index = "`" . sqlesc($index) . "`";
        }

        //alternatively use record hash as index, very slow
        else
        {
                $_index = "MD5(CONCAT(";

                reset($fieldname);
                while (list(, $value) = each($fieldname))
                        $_index .= "IFNULL(`" . sqlesc($value) . "`, ''), ";

                $_index = substr($_index, 0, -2) . "))";
        };

        switch (CMS_IFC_MESSAGE)
        {
        case "edit_table_add":
//.....................................................................................................
                $query = "INSERT `" . sqlesc($object) . "` VALUES ()";

                //execute
                if (mysql_query($query))
                {
                        $ifc_response = CMS_MSG_DONE;
                        $row          = mysql_insert_id();
                        $field        = NULL;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR . "<br>" .
                                "<code>" . x($query) . "</code><br>" .
                                "MySQL: " . x(mysql_error());
                break;

        case "edit_table_update":
//.....................................................................................................
                if (empty($ifc_param8))        $ifc_param8 = NULL;
                elseif (is_array($ifc_param8)) $ifc_param8 = implode(",", $ifc_param8);

                $_ifc_param8 = preg_match("/^bit\(([1-9][0-9]*)\)$/", $fieldtype[$field], $bracket) ?
                               "b'" . sqlesc(substr($ifc_param8, 0, $bracket[1])) . "'" :
                               "'" . sqlesc($ifc_param8) . "'";

                $query = "UPDATE `" .        sqlesc($object) . "` " .
                         "SET `" .           sqlesc($field) . "`=$_ifc_param8 " .
                         "WHERE $_index='" . sqlesc($row) . "' " .
                         "LIMIT 1";

                //execute
                if (mysql_query($query))
                {
                        $ifc_response = CMS_MSG_DONE;
                        $_row         = $index ? (streq($field, $index) ? $ifc_param8 : $row) : NULL;
                        $row          = NULL;
                        $field        = NULL;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR . "<br>" .
                                "<code>" . x($query) . "</code><br>" .
                                "MySQL: " . x(mysql_error());
                break;

        case "edit_table_delete":
//.....................................................................................................
                if (count($list) === 0) break; //no selection

                $query = "DELETE FROM `" . sqlesc($object) . "` " .
                         "WHERE $_index IN (";

                reset($list);
                while (list(, $value) = each($list))
                        $query .= "'" . sqlesc($value) . "', ";

                $query = substr($query, 0, -2) . ")";

                //execute
                if (mysql_query($query))
                {
                        $ifc_response = CMS_MSG_DONE;
                        $row          = NULL;
                        $field        = NULL;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR . "<br>" .
                                "<code>" . x($query) . "</code><br>" .
                                "MySQL: " . x(mysql_error());
                break;
        };

        //selection
        if (empty($row))           $row         = NULL;
        if (empty($field))         $field       = NULL;

        //page offset
                                   $ifc_param1  = (int)$ifc_param1;
        if ($ifc_param1 < 0)       $ifc_param1  = 0;

        //rows per page
                                   $ifc_param2  = (int)$ifc_param2;
        if ($ifc_param2 < 10)      $ifc_param2  = 10;

        //characters per field
                                   $ifc_param3  = (int)$ifc_param3;
        if ($ifc_param3 < 10)      $ifc_param3  = 10;

        //sorting and filtering
        if (empty($ifc_param4))    $ifc_param4  = NULL;
        if (empty($ifc_param5))    $ifc_param5  = NULL;
        if (empty($ifc_param6))   {$ifc_param6  = NULL;
                                   $filter      = NULL;}
        else                       $filter      = " WHERE `" . sqlesc($ifc_param4) . "`$ifc_param5" .
                                                  (preg_match("/^( LIKE | NOT LIKE )$/", $ifc_param5) ?
                                                  "'%" . sqlesc($ifc_param6) . "%'" :
                                                  "'" . sqlesc($ifc_param6) . "'");
        if (! isset($ifc_param7))  $ifc_param7  = $index;
        if ($ifc_param7)           $filter     .= " GROUP BY $_index " .
                                                  " ORDER BY MIN(`" . sqlesc($ifc_param7) . "`), $_index";

        //number of rows passing filter
        if ($result = mysql_query("SELECT 1 " .
                                  "FROM `" . sqlesc($object) . "`" .
                                  $filter))
                                   $count       = mysql_num_rows($result);
        else                       $count       = 0;

        //previous page offset
                                   $_count      = $count - $ifc_param2;
        if ($_count < 0)           $_count      = 0;

        //page offset
        if ($ifc_param1 > $_count) $ifc_param1  = $_count;

        //read data
        $query = "SELECT $_index AS `#id`, " .
                 "LEFT(`" . sqlesc(implode("`, $ifc_param3), LEFT(`", $fieldname)) . "`, $ifc_param3) " .
                 "FROM `" . sqlesc($object) . "`" .
                 "$filter " .
                 "LIMIT " . sqlesc($ifc_param1) . ", " . sqlesc($ifc_param2);

        //execute
        if (! $result = mysql_query($query))
                $ifc_response = CMS_MSG_ERROR . "<br>" .
                                "<code>" . x($query) . "</code><br>" .
                                "MySQL: " . x(mysql_error());

        //menu
        $menu = NULL;
        if ($result) $menu[CMS_L_COMMAND_DELETE . "|database/command_delete"] = "#edit_table_delete";

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       $menu,
                       array("object" => $object,
                             "row"    => $row,
                             "field"  => $field),
                       "_edit_table",
                       CMS_L_IFC_DATABASE_017 . ": $object");
?>
<script>
var rowlist   = Array();
var fieldlist = Array("#id", "<?php echo(implode("\", \"", $fieldname));?>");

function s(row,
           field)
{
        var object = ifc_get_object("list[" + row + "]");

        ifc_change("row",   object.value);
        ifc_change("field", fieldlist[field]);
        ifc_submit();
};
</script>
<?php
        ifc_table_open();

        //control
        echo("<tr>" .
             "<th>" .
             CMS_L_IFC_DATABASE_018 .
             "</th>" .
             "</tr>" .

             "<tr>" .
             "<td class=\"varied\">");

        //start button
        $ifc->set(CMS_L_COMMAND_TOP,
                  "button",
                  "javascript:ifc_change('ifc_param1','0');" .
                  "ifc_submit();");

        //previous button
        $ifc->set(CMS_L_COMMAND_PREVIOUS,
                  "button",
                  "javascript:ifc_change('ifc_param1'," .
                  "parseInt(ifc_value('ifc_param1')) - parseInt(ifc_value('ifc_param2')));" .
                  "ifc_submit();");

        //page offset
        $ifc->set(CMS_L_IFC_DATABASE_019,
                  "text 5 10 :",
                  $ifc_param1);

        //apply button
        $ifc->set(CMS_L_COMMAND_CONFIRM,
                  "button");

        //next button
        $ifc->set(CMS_L_COMMAND_NEXT,
                  "button",
                  "javascript:ifc_change('ifc_param1'," .
                  "parseInt(ifc_value('ifc_param1')) + parseInt(ifc_value('ifc_param2')));" .
                  "ifc_submit();");

        //end button
        $ifc->set(CMS_L_IFC_DATABASE_020,
                  "button",
                  "javascript:ifc_change('ifc_param1','$_count');" .
                  "ifc_submit();");

        //rows per page
        $ifc->set(CMS_L_IFC_DATABASE_021, "label");
        $ifc->set(array("10"  => "10",
                        "20"  => "20",
                        "30"  => "30",
                        "40"  => "40",
                        "50"  => "50",
                        "60"  => "60",
                        "70"  => "70",
                        "80"  => "80",
                        "90"  => "90",
                        "100" => "100"),
                  "select :",
                  $ifc_param2);

        //characters per field
        $ifc->set(CMS_L_IFC_DATABASE_022, "label");
        $ifc->set(array("10"  => "10",
                        "25"  => "25",
                        "50"  => "50",
                        "75"  => "75",
                        "100" => "100",
                        "250" => "250",
                        "500" => "500"),
                  "select :",
                  $ifc_param3);
        echo("</td>" .
             "</tr>" .

        //filter
             "<tr>" .
             "<th>" .
             CMS_L_IFC_DATABASE_023 .
             "</th>" .
             "</tr>" .

             "<tr>" .
             "<td class=\"varied\">");

        //field
        $ifc->set($fieldname,
                  "select",
                  $ifc_param4);

        //operation
        $ifc->set(array(CMS_L_IFC_DATABASE_024 => " LIKE ",
                        CMS_L_IFC_DATABASE_080 => " NOT LIKE ",
                        "<"                    => "<",
                        "<="                   => "<=",
                        "="                    => "=",
                        ">="                   => ">=",
                        ">"                    => ">",
                        "!="                   => "!="),
                  "select",
                  $ifc_param5);

        //value
        $ifc->set(NULL,
                  "text 20 80 :",
                  $ifc_param6);

        //apply button
        $ifc->set(CMS_L_COMMAND_CONFIRM,
                  "button");

        //order
        $ifc->set(CMS_L_IFC_DATABASE_025, "label");
        $ifc->set(array_merge(array(" " => NULL), $fieldname),
                  "select :",
                  $ifc_param7);
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        if (! $result) $ifc->close(); //no results

        //output
        echo("<small>" .
             sprintf(CMS_L_IFC_DATABASE_026, $count) .
             "</small><br>");

        $column_count = count($fieldname);
        $colspan      = $column_count + 1;

        ifc_table_open();
        echo("<colgroup>" .
             "<col style=\"WIDTH:1px\">" .
             "<col span=\"$column_count\">" .
             "</colgroup>" .

        //header
             "<tr>" .

        //selection
             "<td rowspan=\"2\" " .
                 "class=\"highlight\">" .
             "&nbsp;" .
             "</td>");

        //field name
        reset($fieldname);
        while (list($_field) = each($fieldname))
                echo("<th>" .
                     x($_field) .
                     "</th>");
        echo("</tr>" .

        //add record
             "<tr>" .
             "<td colspan=\"$column_count\" " .
                 "class=\"highlight2\">" .
             "<a href=\"javascript:ifc_post('edit_table_add');\">" .
             "[...]" .
             "</a>" .
             "</td>" .
             "</tr>");

        $i = 0;

        while ($resultrow = mysql_fetch_row($result))
        {
                $__row        = $resultrow[0];
                $_i           = 1;
                $row_selected = streq($__row, $row) || streq($__row, $_row);
                $varied       = ifc_varied();

                echo("<tr>" .

                //selection
                     "<td class=\"highlight\">");
                $ifc->set(NULL,
                          "checkbox",
                          $__row,
                          $row_selected,
                          "list[$i]");
                echo("</td>");

                reset($fieldname);
                while (list($_field) = each($fieldname))
                {
                        //highlight
                        echo($row_selected ?
                             "<td style=\"BACKGROUND-COLOR:#FFFFCC\">" :
                             "<td$varied>");

                        //edit
                        if (
                             streq($__row, $row)
                             &&
                             streq($_field, $field)
                           )
                        {
                                $title   = $fieldtype[$_field];
                                $type    = preg_match("/^([^\( ]*)/", $title, $type)  ? $type[1]    : NULL;
                                $bracket = preg_match("/\((.*)\)/", $title, $bracket) ? $bracket[1] : NULL;

                                //analyze
                                $value   = ($_result = mysql_query("SELECT `" . sqlesc($field) . "` " .
                                                                   "FROM `" .   sqlesc($object) . "` " .
                                                                   "WHERE $_index='" . sqlesc($row) . "' " .
                                                                   "LIMIT 1")) ?
                                           mysql_result($_result, 0, 0) : NULL;

                                //line input
                                switch ($type)
                                {
                                case "bit":
//.....................................................................................................
                                        $ifc->set($title, "text 30 b", bitstring($value, $bracket));
                                        break;

                                case "tinyint":
                                case "smallint":
                                case "mediumint":
                                case "int":
                                case "bigint":
                                case "double":
                                case "float":
                                case "decimal":
                                case "date":
                                case "time":
                                case "datetime":
                                case "timestamp":
                                case "year":
//.....................................................................................................
                                        $ifc->set($title, "text 30 b", $value);
                                        break;

                                case "enum":
                                case "set":
//.....................................................................................................

                                        //selectable values
                                        $array  = streq($type, "enum") ? array(" " => NULL) : NULL;
                                        $_array = preg_split("/','/", substr($bracket, 1, -1));

                                        reset($_array);
                                        while (list(, $_value) = each($_array))
                                                $array[$_value] = $_value;

                                        $ifc->set($type, "label");

                                        //single selection
                                        if (streq($type, "enum"))
                                                $ifc->set($array,
                                                          "select 30 b",
                                                          $value);

                                        //multiple selection
                                        else
                                                $ifc->set($array,
                                                          "multiselect 30x6 b",
                                                          explode(",", $value));

                                        break;

                                default:
//.....................................................................................................
                                        $ifc->set($title, "textarea 30x10 b", $value);
                                        break;
                                };

                                echo("<div style=\"TEXT-ALIGN:right\">");

                                //apply button
                                $ifc->set(CMS_L_COMMAND_CONFIRM,
                                          "button",
                                          "edit_table_update");

                                //cancel button
                                $ifc->set(CMS_L_COMMAND_CANCEL,
                                          "button b",
                                          "javascript:ifc_clear('row');" .
                                          "ifc_clear('field');" .
                                          "ifc_clear('ifc_param8');" .
                                          "ifc_submit();");

                                echo("</div>");
                        }

                        //display
                        else
                        {
                                $value = $resultrow[$_i];

                                //value
                                if ($value)
                                {
                                        if (preg_match("/^bit\(([1-9][0-9]*)\)$/", $fieldtype[$_field], $bracket))
                                                $value = bitstring($value, $bracket[1]);

                                        $numeric = preg_match("/^[0-9,\.:-]+$/", $value);

                                        if ($numeric) echo("<div style=\"TEXT-ALIGN:right\">");
                                        echo("<a href=\"javascript:s($i,$_i);\" " .
                                                "class=\"br\">" .
                                             x($value) .
                                             "</a>");
                                        if ($numeric) echo("</div>");
                                 }

                                 //empty
                                 else
                                 {
                                        echo("<div style=\"TEXT-ALIGN:center\">" .
                                             "<a href=\"javascript:s($i,$_i);\">" .
                                             "<small>" .
                                             CMS_L_IFC_DATABASE_079 .
                                             "</small>" .
                                             "</a>" .
                                             "</div>");
                                 };
                        };

                        echo("</td>");
                        $_i++;
                };

                echo("</tr>");
                $i++;
        };

        //selection control
        echo("<tr>" .
             "<td colspan=\"$colspan\" " .
                 "class=\"highlight\" " .
                 "style=\"TEXT-ALIGN:right\">");
        $ifc->set(CMS_L_IFC_DATABASE_096, "button", "javascript:ifc_list_activate();");
        $ifc->set(CMS_L_IFC_DATABASE_097, "button", "javascript:ifc_list_invert();");
        $ifc->set(CMS_L_IFC_DATABASE_098, "button", "javascript:ifc_list_deactivate();");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        $ifc->close();

case "alter_table":
case "create_table":
case "_create_table":
//.....................................................................................................

        //get available collations / character sets
        $collation = array(CMS_L_IFC_DATABASE_090 => ".");

        if ($result = mysql_query("SHOW COLLATION"))
        {
                while ($resultrow = mysql_fetch_assoc($result))
                {
                        $_collation = $resultrow["Collation"];
                        $charset    = $resultrow["Charset"];
                        $collation[$_collation] = "$charset.$_collation";
                };

                //sort by charset / collation
                asort($collation, SORT_STRING);
        };

        //get available engines
        $engine = array();

        if ($result = mysql_query("SHOW ENGINES"))
        {
                while ($resultrow = mysql_fetch_assoc($result))
                {
                        if (streq($resultrow["Support"], "NO")) continue; //not supported

                        $_engine  = $resultrow["Engine"];
                        $__engine = strtolower($_engine);

                        switch ($resultrow["Support"])
                        {
                        case "DEFAULT":
                                if (empty($ifc_param2)) $ifc_param2 = $__engine;

                        case "YES":
                                $engine[$_engine] = $__engine;
                        };
                };

                //sort by engine
                asort($engine, SORT_STRING);
        };

        switch (CMS_IFC_MESSAGE)
        {
        case "alter_table":
//.....................................................................................................

                //apply
                if (isset($ifc_param1))
                {
                        list($charset, $_collation) = explode(".", $ifc_param3);
                        $query  = "ALTER TABLE `" .           sqlesc($object) . "` ";       //command
                        if ($ifc_param1 = utf8_trim($ifc_param1)) $query .=                 //name
                                  "RENAME TO `" .             sqlesc($ifc_param1) . "`, ";
                        if ($ifc_param2)                          $query .=                 //engine
                                  "ENGINE=" .                 sqlesc($ifc_param2) . ", ";
                        if ($charset)                             $query .=                 //charset
                                  "/*!40100 CHARACTER SET " . sqlesc($charset) . ", */";
                        if ($_collation)                          $query .=                 //collation
                                  "/*!40100 COLLATE " .       sqlesc($_collation) . ", */";
                        $query .= "COMMENT='" .               sqlesc($ifc_param4) . "'";    //comment

                        //execute
                        if (mysql_query($query))
                        {
                                $object       = $ifc_param1;
                                $ifc_response = CMS_MSG_DONE;
                                break 2;
                        };

                        $ifc_response = CMS_MSG_ERROR . "<br>" .
                                        "<code>" . x($query) . "</code><br>" .
                                        "MySQL: " . x(mysql_error());
                }

                //analyze
                else
                {
                        $ifc_param1 = $object;
                        $result     = mysql_query("SHOW TABLE STATUS");

                        //seek selected table
                        while (
                                ($resultrow = mysql_fetch_assoc($result))
                                &&
                                nstreq($resultrow["Name"], $object)
                              );

                        $ifc_param1 = $resultrow["Name"];                          //name
                        $ifc_param2 = strtolower($resultrow["Engine"]);            //engine
                        if (isset($resultrow["Collation"]) &&                      //collation
                            isset($collation[$resultrow["Collation"]]))
                                $ifc_param3 = $collation[$resultrow["Collation"]];
                        $ifc_param4 = $resultrow["Comment"];                       //comment
                };

                break;

        case "_create_table":
//.....................................................................................................
                $ifc_param1 = utf8_trim($ifc_param1);

                if (! $ifc_param1) //no name
                {
                        $ifc_response = CMS_MSG_ERROR;
                        break;
                };

                list($charset, $_collation) = explode(".", $ifc_param3);

                //no definition file
                if (empty($ifc_param5))
                {
                        $query = "CREATE TABLE `" .           sqlesc($ifc_param1) . "` " .    //command
                                 "(`id` INT UNSIGNED PRIMARY KEY AUTO_INCREMENT NOT NULL) " . //type
                                 "ENGINE=" .                  sqlesc($ifc_param2);            //engine
                        if ($charset)    $query .=                                            //charset
                                  "/*!40100 CHARACTER SET " . sqlesc($charset) . "*/";
                        if ($_collation) $query .=                                            //collation
                                  "/*!40100 COLLATE " .       sqlesc($_collation) . "*/";
                        $query .= " COMMENT='" .              sqlesc($ifc_param4) . "'";      //comment

                        //execute
                        if (mysql_query($query))
                        {
                                $ifc_response = CMS_MSG_DONE;
                                break 2;
                        };
                }

                //use definition file
                elseif ($query = read_file($ifc_param5))
                {
                        $query = preg_replace("/^(CREATE\s+(?:TEMPORARY\s+)?" .               //name
                                              "TABLE\s+(?:IF NOT EXISTS\s+)?)" .
                                              "(?:[^\(]+)/i",
                                              "\\1`$ifc_param1`",
                                              $query);

                        //execute
                        if (mysql_query($query))
                        {
                                $object       = $ifc_param1;
                                $ifc_message  = "alter_table"; //table created, change mode

                                //apply settings subsequently
                                $query        = "ALTER TABLE `" .           sqlesc($object) . "` ";       //command
                                if ($ifc_param2) $query .=                                                //engine
                                                "ENGINE=" .                 sqlesc($ifc_param2) . ", ";
                                if ($charset)    $query .=                                                //charset
                                                "/*!40100 CHARACTER SET " . sqlesc($charset) . ", */";
                                if ($_collation) $query .=                                                //collation
                                                "/*!40100 COLLATE " .       sqlesc($_collation) . ", */";
                                $query       .= "COMMENT='" .               sqlesc($ifc_param4) . "'";    //comment

                                //execute
                                if (mysql_query($query))
                                {
                                        $ifc_response = CMS_MSG_DONE;
                                        break 2;
                                };
                        };
                }

                //no query
                else
                {
                        $ifc_response = CMS_MSG_ERROR;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR . "<br>" .
                                "<code>" . x($query) . "</code><br>" .
                                "MySQL: " . x(mysql_error());
                break;
        };

case "create_table":
//.....................................................................................................

        //get available definition files
        $definition = array(" " => NULL);
        $path       = CMS_DATA_PATH . "#database";

        if (
             nstreq($ifc_message, "alter_table")
             &&
             is_dir($path)
             &&
             ($hdir = opendir($path))
           )
        {
                while ($file_object = readdir($hdir))
                {
                        if (
                             is_file("$path/$file_object")
                             &&
                             preg_match("/\.sql$/i", $file_object)
                           )
                                $definition[$file_object] = "$path/$file_object";
                };

                closedir($hdir);
        };

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object" => $object),
                       streq($ifc_message,    "alter_table") ?
                       "alter_table"          : "_create_table",
                       streq(CMS_IFC_MESSAGE, "alter_table") ?
                       CMS_L_IFC_DATABASE_014 : CMS_L_IFC_DATABASE_015);

        //name
        $ifc->set(CMS_L_NAME,
                  "text 40 256 b",
                  isset($ifc_param1) ? $ifc_param1 : NULL);

        //engine
        $ifc->set(CMS_L_IFC_DATABASE_013, "label");
        $ifc->set($engine,
                  "select 40 b",
                  isset($ifc_param2) ? $ifc_param2 : "MyISAM");

        //collation
        $ifc->set(CMS_L_IFC_DATABASE_088, "label");
        $ifc->set($collation,
                  "select 40 b",
                  isset($ifc_param3) ? $ifc_param3 : ".");

        //comment
        $ifc->set(CMS_L_IFC_DATABASE_016,
                  "textarea 40x4 60 b",
                  isset($ifc_param4) ? $ifc_param4 : NULL);

        //definition file
        if (count($definition) > 1)
        {
                asort($definition, SORT_STRING);
                $ifc->set(CMS_L_IFC_DATABASE_074, "label");
                $ifc->set($definition,            "select 40");
        };

        $ifc->close();

case "add_field":
case "_add_field":
case "change_field":
//.....................................................................................................

        //get available collations / character sets
        $collation = array(CMS_L_IFC_DATABASE_090 => ".");

        if ($result = mysql_query("SHOW COLLATION"))
        {
                while ($resultrow = mysql_fetch_assoc($result))
                {
                        $_collation = $resultrow["Collation"];
                        $charset    = $resultrow["Charset"];
                        $collation[$_collation] = "$charset.$_collation";
                };

                //sort by charset / collation
                asort($collation, SORT_STRING);
        };

        //use existing data
        if (nstreq(CMS_IFC_MESSAGE, "add_field"))
        {
                //analyze field
                if (empty($ifc_param1) && streq(CMS_IFC_MESSAGE, "change_field"))
                {
                        preg_match("/^([^\.]+)\.(.+)$/", $object, $_object);

                        $query = "SHOW FULL COLUMNS FROM `" . sqlesc($_object[1]) . "` " .
                                 "LIKE '" .                   sqlesc($_object[2]) . "'";

                        //execute
                        if (! $result = mysql_query($query))
                        {
                                $ifc_response = CMS_MSG_ERROR . "<br>" .
                                                "<code>" . x($query) . "</code><br>" .
                                                "MySQL: " . x(mysql_error());
                                break;
                        };

                        $array       = mysql_fetch_assoc($result);
                        $ifc_param1  = preg_match("/^([^\( ]*)/", $array["Type"], $ifc_param1) ? //type
                                       $ifc_param1[1] : NULL;
                        $brackets    = preg_match("/\((.*)\)/",   $array["Type"], $brackets)   ? //length
                                       $brackets[1]   : NULL;
                        $ifc_param2  = $array["Field"];                                          //name
                        if (preg_match("/^(NO)?$/", $array["Null"])) $ifc_param3 = TRUE;         //null
                        $ifc_param4  = isset($array["Default"]) ? $array["Default"] : NULL;      //default
                        $ifc_param19 = isset($array["Comment"]) ? $array["Comment"] : NULL;      //comment

                        switch ($ifc_param1)
                        {
                        case "bit":
//.....................................................................................................
                                $ifc_param5 = $brackets;                                //length
                                break;

                        case "char":
                        case "varchar":
//.....................................................................................................
                                $ifc_param6 = $brackets;                                //length
                                if (isset($array["Collation"]) &&                       //collation
                                    isset($collation[$array["Collation"]]))
                                        $ifc_param7 = $collation[$array["Collation"]];
                                break;

                        case "tinyint":
                        case "smallint":
                        case "mediumint":
                        case "int":
                        case "bigint":
//.....................................................................................................
                                $ifc_param8 = $brackets;                                //length
                                if (stristr($array["Type"], "ZEROFILL"))                //attributes
                                        $ifc_param9  = "UNSIGNED ZEROFILL";
                                elseif (stristr($array["Type"], "UNSIGNED"))
                                        $ifc_param9  = "UNSIGNED";
                                if (stristr($array["Extra"], "AUTO_INCREMENT"))         //auto increment
                                        $ifc_param10 = TRUE;
                                break;

                        case "tinytext":
                        case "text":
                        case "mediumtext":
                        case "longtext":
//.....................................................................................................
                                if (isset($array["Collation"]) &&                       //collation
                                    isset($collation[$array["Collation"]]))
                                        $ifc_param11 = $collation[$array["Collation"]];
                                break;

                        case "double":
                        case "float":
                        case "decimal":
//.....................................................................................................
                                $ifc_param12 = explode(",", $brackets, 2);
                                if (isset($ifc_param12[1]))                             //decimals
                                        $ifc_param13 = $ifc_param12[1];
                                $ifc_param12 = $ifc_param12[0];                         //length
                                if (stristr($array["Type"], "ZEROFILL"))                //attributes
                                        $ifc_param14 = "UNSIGNED ZEROFILL";
                                elseif (stristr($array["Type"], "UNSIGNED"))
                                        $ifc_param14 = "UNSIGNED";
                                break;

                        case "binary":
                        case "varbinary":
//.....................................................................................................
                                $ifc_param15 = $brackets;                               //length
                                break;

                        case "year":
//.....................................................................................................
                                $ifc_param16 = $brackets;                               //length
                                break;

                        case "enum":
                        case "set":
//.....................................................................................................
                                $ifc_param17 = preg_split("/','/", $brackets);          //values
                                $ifc_param17 = implode("\n", $ifc_param17);
                                $ifc_param17 = substr($ifc_param17, 1, -1);
                                $ifc_param17 = str_replace("''", "'", $ifc_param17);
                                if (isset($array["Collation"]) &&                       //collation
                                    isset($collation[$array["Collation"]]))
                                        $ifc_param18 = $collation[$array["Collation"]];
                                break;
                        };
                }

                //apply changes
                else
                {
                        //change field
                        if (streq(CMS_IFC_MESSAGE, "change_field"))
                        {
                                preg_match("/^([^\.]+)\.(.+)$/", $object, $_object);
                                $query = "ALTER TABLE `" . sqlesc($_object[1]) . "` " . //command
                                         "CHANGE `" .      sqlesc($_object[2]) . "` " . //old name
                                         "`" .             sqlesc($ifc_param2) . "` " . //new name
                                                           sqlesc($ifc_param1);         //type
                        }

                        //add field
                        else
                        {
                                preg_match("/^([^\.]+)/", $object, $_object);
                                $query = "ALTER TABLE `" . sqlesc($_object[1]) . "` " . //command
                                         "ADD `" .         sqlesc($ifc_param2) . "` " . //name
                                                           sqlesc($ifc_param1);         //type
                        };

                        switch ($ifc_param1)
                        {
                        case "bit":
//.....................................................................................................
                                $query .= ($ifc_param5         ? "(" .                       (int)$ifc_param5 . ")"     : NULL) . //length
                                          (isset($ifc_param3)  ? " NOT NULL"                                            : NULL) . //null
                                          ($ifc_param4         ? " DEFAULT '" .              sqlesc($ifc_param4) . "'"  : NULL);  //default

                        case "tinyint":
                        case "smallint":
                        case "mediumint":
                        case "int":
                        case "bigint":
//.....................................................................................................
                                if (isset($ifc_param10)) $ifc_param4 = NULL; //no default on auto increment
                                $query .= ($ifc_param8         ? "(" .                       (int)$ifc_param8 . ")"     : NULL) . //length
                                          ($ifc_param9         ? " " .                       sqlesc($ifc_param9)        : NULL) . //attributes
                                          (isset($ifc_param3)  ? " NOT NULL"                                            : NULL) . //null
                                          ($ifc_param4         ? " DEFAULT '" .              sqlesc($ifc_param4) . "'"  : NULL) . //default
                                          (isset($ifc_param10) ? " AUTO_INCREMENT"                                      : NULL);  //auto increment
                                break;


                        case "double":
                        case "float":
                        case "decimal":
//.....................................................................................................
                                $query .= ($ifc_param12        ? "(" .                       (int)$ifc_param12 .                  //length
                                          ($ifc_param13        ? ", " .                      (int)$ifc_param13          : NULL) . //decimals
                                                                 ")"                                                    : NULL) .
                                          ($ifc_param14        ? " " .                       sqlesc($ifc_param14)       : NULL) . //attributes
                                          (isset($ifc_param3)  ? " NOT NULL"                                            : NULL) . //null
                                          ($ifc_param4         ? " DEFAULT '" .              sqlesc($ifc_param4) . "'"  : NULL);  //default
                                break;

                        case "date":
                        case "time":
                        case "datetime":
                        case "timestamp":
//.....................................................................................................
                                $query .= (isset($ifc_param3)  ? " NOT NULL"                                            : NULL) . //null
                                          ($ifc_param4         ? " DEFAULT '" .              sqlesc($ifc_param4) . "'"  : NULL);  //default
                                break;

                        case "year":
//.....................................................................................................
                                $query .= ($ifc_param16        ? "(" .                       (int)$ifc_param16 . ")"    : NULL) . //length
                                          (isset($ifc_param3)  ? " NOT NULL"                                            : NULL) . //null
                                          ($ifc_param4         ? " DEFAULT '" .              sqlesc($ifc_param4) . "'"  : NULL);  //default
                                break;

                        case "char":
                        case "varchar":
//.....................................................................................................
                                list($charset, $_collation) = explode(".", $ifc_param7);
                                $query .= ($ifc_param6         ? "(" .                       (int)$ifc_param6 . ")"     : NULL) . //length
                                          ($charset            ? "/*!40100 CHARACTER SET " . sqlesc($charset) . "*/"    : NULL) . //charset
                                          ($_collation         ? "/*!40100 COLLATE " .       sqlesc($_collation) . "*/" : NULL) . //collation
                                          (isset($ifc_param3)  ? " NOT NULL"                                            : NULL) . //null
                                          ($ifc_param4         ? " DEFAULT '" .              sqlesc($ifc_param4) . "'"  : NULL);  //default
                                break;

                        case "tinytext":
                        case "text":
                        case "mediumtext":
                        case "longtext":
//.....................................................................................................
                                list($charset, $_collation) = explode(".", $ifc_param11);
                                $query .= ($charset            ? "/*!40100 CHARACTER SET " . sqlesc($charset) . "*/"    : NULL) . //charset
                                          ($_collation         ? "/*!40100 COLLATE " .       sqlesc($_collation) . "*/" : NULL) . //collation
                                          (isset($ifc_param3)  ? " NOT NULL"                                            : NULL);  //null
                                break;

                        case "binary":
                        case "varbinary":
//.....................................................................................................
                                $query .= ($ifc_param15        ? "(" .                       (int)$ifc_param15 . ")"    : NULL) . //length
                                          (isset($ifc_param3)  ? " NOT NULL"                                            : NULL) . //null
                                          ($ifc_param4         ? " DEFAULT '" .              sqlesc($ifc_param4) . "'"  : NULL);  //default
                                break;

                        case "tinyblob":
                        case "blob":
                        case "mediumblob":
                        case "longblob":
//.....................................................................................................
                                $query .= (isset($ifc_param3)  ? " NOT NULL"                                            : NULL);  //null
                                break;

                        case "enum":
                        case "set":
//.....................................................................................................
                                list($charset, $_collation) = explode(".", $ifc_param18);
                                $query .= "('" . str_replace("\\n", "', '",                  sqlesc($ifc_param17)) . "')" .       //values
                                          ($charset            ? "/*!40100 CHARACTER SET " . sqlesc($charset) . "*/"    : NULL) . //charset
                                          ($_collation         ? "/*!40100 COLLATE " .       sqlesc($_collation) . "*/" : NULL) . //collation
                                          (isset($ifc_param3)  ? " NOT NULL"                                            : NULL) . //null
                                          ($ifc_param4         ? " DEFAULT '" .              sqlesc($ifc_param4) . "'"  : NULL);  //default
                                break;
                        };

                        $query .= " COMMENT '" . sqlesc($ifc_param19) . "'";                                        //comment

                        //execute
                        if (mysql_query($query))
                        {
                                $object       = $_object[1] . ".$ifc_param2";
                                $ifc_response = CMS_MSG_DONE;
                                break;
                        };

                        $ifc_response = CMS_MSG_ERROR . "<br>" .
                                        "<code>" . x($query) . "</code><br>" .
                                        "MySQL: " . x(mysql_error());
                };
        };

case "add_field":
//.....................................................................................................

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object" => $object),
                       streq(CMS_IFC_MESSAGE, "change_field") ?
                       "change_field"         : "_add_field",
                       streq(CMS_IFC_MESSAGE, "change_field") ?
                       CMS_L_IFC_DATABASE_001 : CMS_L_IFC_DATABASE_002);

        //type
        $ifc->set(CMS_L_IFC_DATABASE_003, "label");
        $ifc->set(array("BIT"        => "bit",
                        "TINYINT"    => "tinyint",
                        "SMALLINT"   => "smallint",
                        "MEDIUMINT"  => "mediumint",
                        "INT"        => "int",
                        "BIGINT"     => "bigint",
                        "DOUBLE"     => "double",
                        "FLOAT"      => "float",
                        "DECIMAL"    => "decimal",
                        "DATE"       => "date",
                        "TIME"       => "time",
                        "DATETIME"   => "datetime",
                        "TIMESTAMP"  => "timestamp",
                        "YEAR"       => "year",
                        "CHAR"       => "char",
                        "VARCHAR"    => "varchar",
                        "TINYTEXT"   => "tinytext",
                        "TEXT"       => "text",
                        "MEDIUMTEXT" => "mediumtext",
                        "LONGTEXT"   => "longtext",
                        "BINARY"     => "binary",
                        "VARBINARY"  => "varbinary",
                        "TINYBLOB"   => "tinyblob",
                        "BLOB"       => "blob",
                        "MEDIUMBLOB" => "mediumblob",
                        "LONGBLOB"   => "longblob",
                        "ENUM"       => "enum",
                        "SET"        => "set"),
                  "select",
                  isset($ifc_param1)  ? $ifc_param1  : "char");

        //name
        $ifc->set(CMS_L_NAME,
                  "text 30 256",
                  isset($ifc_param2)  ? $ifc_param2  : NULL);

        //null
        $ifc->set("NOT NULL",
                  "checkbox",
                  TRUE,
                  isset($ifc_param3));

        ifc_table_open(NULL);
        echo("<tr>" .
             "<th colspan=\"4\">" .
             CMS_L_IFC_DATABASE_004 .
             "</th>" .
             "</tr>" .
             "<tr>" .

        //common
             "<td colspan=\"4\" " .
                 "class=\"varied\">");
        $ifc->set(CMS_L_IFC_DATABASE_005,
                  "text 60",
                  isset($ifc_param4)  ? $ifc_param4  : NULL);
        echo("</td>" .
             "</tr>" .
             "<tr>" .

        //bit
             "<td class=\"varied\">" .
             "BIT" .
             "</td>" .
             "<td>");

        //length
        $ifc->set(CMS_L_IFC_DATABASE_006,
                  "text 20",
                  isset($ifc_param5)  ? $ifc_param5  : NULL);
        echo("</td>" .

        //char
             "<td class=\"varied\">" .
             "CHAR<br>VARCHAR" .
             "</td>" .
             "<td>");

        //length
        $ifc->set(CMS_L_IFC_DATABASE_010,
                  "text 20 b",
                  isset($ifc_param6)  ? $ifc_param6  : NULL);

        //collation
        $ifc->set(CMS_L_IFC_DATABASE_088, "label");
        $ifc->set($collation,
                  "select 20",
                  isset($ifc_param7)  ? $ifc_param7  : ".");
        echo("</td>" .
             "</tr>" .
             "<tr>" .

        //integer
             "<td class=\"varied\">" .
             "TINYINT<br>SMALLINT<br>MEDIUMINT<br>INT<br>BIGINT" .
             "</td>" .
             "<td>");

        //length
        $ifc->set(CMS_L_IFC_DATABASE_006,
                  "text 20 b",
                  isset($ifc_param8)  ? $ifc_param8  : NULL);

        //attributes
        $ifc->set(CMS_L_IFC_DATABASE_007, "label");
        $ifc->set(array(NULL                => NULL,
                        "UNSIGNED"          => "UNSIGNED",
                        "UNSIGNED ZEROFILL" => "UNSIGNED ZEROFILL"),
                  "select 20 b",
                  isset($ifc_param9)  ? $ifc_param9  : NULL);

        //auto increment
        $ifc->set("AUTO_INCREMENT",
                  "checkbox",
                  TRUE,
                  isset($ifc_param10));
        echo("</td>" .

        //text
             "<td class=\"varied\">" .
             "TINYTEXT<br>TEXT<br>MEDIUMTEXT<br>LONGTEXT" .
             "</td>" .
             "<td>");

        //collation
        $ifc->set(CMS_L_IFC_DATABASE_088, "label");
        $ifc->set($collation,
                  "select 20",
                  isset($ifc_param11) ? $ifc_param11 : ".");
        echo("</td>" .
             "</tr>" .
             "<tr>" .

        //decimal
             "<td class=\"varied\">" .
             "DOUBLE<br>FLOAT<br>DECIMAL" .
             "</td>" .
             "<td>");

        //length
        $ifc->set(CMS_L_IFC_DATABASE_006,
                  "text 20 b",
                  isset($ifc_param12) ? $ifc_param12 : NULL);

        //decimals
        $ifc->set(CMS_L_IFC_DATABASE_008,
                  "text 20 b",
                  isset($ifc_param13) ? $ifc_param13 : NULL);

        //attributes
        $ifc->set(CMS_L_IFC_DATABASE_007, "label");
        $ifc->set(array(NULL                => NULL,
                        "UNSIGNED"          => "UNSIGNED",
                        "UNSIGNED ZEROFILL" => "UNSIGNED ZEROFILL"),
                  "select 20",
                  isset($ifc_param14) ? $ifc_param14 : NULL);
        echo("</td>" .

        //binary
             "<td class=\"varied\">" .
             "BINARY<br>VARBINARY" .
             "</td>" .
             "<td>");

        //length
        $ifc->set(CMS_L_IFC_DATABASE_010,
                  "text 20",
                  isset($ifc_param15) ? $ifc_param15 : NULL);
        echo("</td>" .
             "</tr>" .
             "<tr>" .

        //year
             "<td class=\"varied\">" .
             "YEAR" .
             "</td>" .
             "<td>");

        //length
        $ifc->set(CMS_L_IFC_DATABASE_009, "label");
        $ifc->set(array("YYYY" => 4,
                        "YY"   => 2),
                  "select 20",
                  isset($ifc_param16) ? $ifc_param16 : 4);
        echo("</td>" .

        //selection
             "<td class=\"varied\">" .
             "ENUM<br>SET" .
             "</td>" .
             "<td>");

        //values
        $ifc->set(CMS_L_IFC_DATABASE_011,
                  "textarea 20x4 b",
                  isset($ifc_param17) ? $ifc_param17 : NULL);

        //collation
        $ifc->set(CMS_L_IFC_DATABASE_088, "label");
        $ifc->set($collation,
                  "select 20",
                  isset($ifc_param18) ? $ifc_param18 : ".");
        echo("</td>" .
             "</tr>" .
             "<tr>" .

        //comment
             "<td colspan=\"4\" " .
                 "class=\"varied\">");
        $ifc->set(CMS_L_IFC_DATABASE_016,
                  "textarea 60x4 255",
                  isset($ifc_param19) ? $ifc_param19 : NULL);
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        $ifc->close();

case "_create_index":
//.....................................................................................................
        preg_match("/^([^\.]+)/", $object, $_object);

        $query  = "ALTER TABLE `" . sqlesc($_object[1]) . "` " . //command
                  "ADD " .          sqlesc($ifc_param1);         //type
        if (nstre($ifc_param2))              $query .=           //name
                  " `" .            sqlesc($ifc_param2) . "`";
        if (nstreq($ifc_param1, "FULLTEXT")) $query .=           //format
                  " USING " .       sqlesc($ifc_param3);

        //index fields
        if (count($list) > 0)
        {
                $query .= " (";

                while (list($key, $value) = each($list))
                {
                        $query .= "`" . sqlesc($value) . "`";
                        if (isset($length[$key]) && nstre($length[$key])) $query .=
                                  "(" . sqlesc($length[$key]) . ")";
                        $query .= ", ";
                };

                $query  = substr($query, 0, -2) . ")";
        };

        //execute
        if (mysql_query($query))
        {
                $ifc_response  = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR . "<br>" .
                        "<code>" . x($query) . "</code><br>" .
                        "MySQL: " . x(mysql_error());

case "create_index":
//.....................................................................................................
        preg_match("/^([^\.]+)(?:\.(.+))?$/", $object, $_object);

        $query = "SHOW COLUMNS FROM `" . sqlesc($_object[1]) . "`";

        //execute
        if (! $result = mysql_query($query))
        {
                $ifc_response = CMS_MSG_ERROR . "<br>" .
                                "<code>" . x($query) . "</code><br>" .
                                "MySQL: " . x(mysql_error());
                break;
        };

        if (! isset($_object[2])) $_object[2] = NULL;

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object" => $object),
                       "_create_index",
                       CMS_L_IFC_DATABASE_012);

        //type
        $ifc->set(CMS_L_IFC_DATABASE_091, "label");
        $ifc->set(array("INDEX"       => "INDEX",
                        "UNIQUE"      => "UNIQUE",
                        "PRIMARY KEY" => "PRIMARY KEY",
                        "FULLTEXT"    => "FULLTEXT"),
                  "select",
                  isset($ifc_param1) ? $ifc_param1 : NULL);

        //name
        $ifc->set(CMS_L_NAME,
                  "text 30 256",
                  isset($ifc_param2) ? $ifc_param2 : $_object[2]);

        //format
        $ifc->set(CMS_L_IFC_DATABASE_084, "label");
        $ifc->set(array("BTREE" => "BTREE",
                        "HASH"  => "HASH"),
                  "select b",
                  isset($ifc_param3) ? $ifc_param3 : NULL);

        //javascript
?>
<script>
function s(value)
{
        ifc_select("list[" + value + "]");
};
</script>
<?php

        //display fields
        $ifc->set(CMS_L_IFC_DATABASE_092, "description b");

        ifc_table_open(NULL);
        echo("<colgroup>" .
             "<col style=\"WIDTH:1px\">" .
             "<col span=\"3\">" .
             "</colgroup>" .

        //header
             "<tr>" .

        //selection
             "<td class=\"highlight\">" .
             "&nbsp;" .
             "</td>" .

        //name
             "<th>" .
             CMS_L_NAME .
             "</th>" .

        //type
             "<th>" .
             CMS_L_IFC_DATABASE_003 .
             "</th>" .

        //size
             "<th>" .
             CMS_L_IFC_DATABASE_010 .
             "</th>" .
             "</tr>");

        $i = 0;

        while ($resultrow = mysql_fetch_assoc($result))
        {
                $name   = $resultrow["Field"];
                $type   = $resultrow["Type"];
                $type   = preg_replace("/^(enum|set)\(.*\)/", "\\1(\xE2\x80\xA6)", $type);
                $varied = ifc_varied();

                echo("<tr>" .

                //selection
                     "<td class=\"highlight\">");
                $ifc->set(NULL,
                          "checkbox",
                          $name,
                          isset($field[$i]) || streq($name, $_object[2]),
                          "list[$i]");
                echo("</td>" .

                //name
                     "<td$varied>" .
                     "<a href=\"javascript:s($i);\">" .
                     image("database/icon_field") . "&nbsp;" . x($name) .
                     "</a>" .
                     "</td>" .

                //type
                     "<td$varied>" .
                     x($type) .
                     "</td>" .

                //length
                     "<td$varied>");
                if (preg_match("/^(char|varchar|binary|varbinary|" .
                               "tinytext|text|mediumtext|longtext|" .
                               "tinyblob|blob|mediumblob|longblob)( |\(|$)/",
                               $type))
                        $ifc->set(NULL,
                                  "text 10 :",
                                  isset($length[$i]) ? $length[$i] : 25,
                                  NULL,
                                  "length[$i]");
                else
                        echo("&nbsp;");
                echo("</td>" .
                     "</tr>");

                $i++;
        };

        //selection control
        echo("<tr>" .
             "<td colspan=\"4\" " .
                 "class=\"highlight\" " .
                 "style=\"TEXT-ALIGN:right\">");
        $ifc->set(CMS_L_IFC_DATABASE_096, "button", "javascript:ifc_list_activate();");
        $ifc->set(CMS_L_IFC_DATABASE_097, "button", "javascript:ifc_list_invert();");
        $ifc->set(CMS_L_IFC_DATABASE_098, "button", "javascript:ifc_list_deactivate();");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        $ifc->close();

case "export_definition":
//.....................................................................................................

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object" => $object),
                       "_export_definition",
                       CMS_L_IFC_DATABASE_075);

        //file
        $ifc->set(CMS_L_NAME, "text 40 80 b", $object);

        $ifc->close();

case "_export_definition":
//.....................................................................................................
        $ifc_param1   = CMS_DATA_PATH . "#database/$ifc_param1";
        $ifc_response = $mysql->export_sql($object, $ifc_param1) ?
                        CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "export_table":
//.....................................................................................................

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object" => $object),
                       "_export_table",
                       CMS_L_IFC_DATABASE_037);

        //file
        $ifc->set(CMS_L_IFC_DATABASE_027,
                  "text 40 80 b",
                  $object . "_" . date("Y-m-d"));

        //separator
        $ifc->set(CMS_L_IFC_DATABASE_028, "label");
        $ifc->set(array(CMS_L_IFC_DATABASE_029 => ",",
                        CMS_L_IFC_DATABASE_030 => ";",
                        CMS_L_IFC_DATABASE_031 => "\t",
                        CMS_L_IFC_DATABASE_032 => " "),
                  "select 40 b",
                  ",");

        //delimeter
        $ifc->set(CMS_L_IFC_DATABASE_033, "label");
        $ifc->set(array(CMS_L_IFC_DATABASE_034 => "\"",
                        CMS_L_IFC_DATABASE_035 => "'",
                        CMS_L_IFC_DATABASE_036 => ""),
                  "select 40 b",
                  "\"");

        //set fields
        $ifc->set(CMS_L_IFC_DATABASE_077, "checkbox", TRUE, TRUE);

        $ifc->close();

case "_export_table":
//.....................................................................................................
        $ifc_param1   = CMS_DATA_PATH . "#database/$ifc_param1";
        $ifc_response = $mysql->export_csv($object,              //table
                                           $ifc_param2,          //separator
                                           $ifc_param3,          //delimeter
                                           $ifc_param1,          //file
                                           isset($ifc_param4)) ? //set fields
                        CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "import_table":
//.....................................................................................................

        //get available data files
        $path = CMS_DATA_PATH . "#database";

        if ((! is_dir($path)) || (! $hdir = opendir($path)))
        {
                $ifc_response = CMS_MSG_ERROR;
                break;
        };

        $array = NULL;
        while ($file_object = readdir($hdir))
        {
                if (
                     (! is_file("$path/$file_object"))
                     ||
                     (! preg_match("/\.(csv|txt)$/i", $file_object))
                   )
                        continue;

                $array[$file_object] = "$path/$file_object";
        };

        closedir($hdir);

        if (! $array) //no files
        {
                $ifc_response = CMS_MSG_ERROR;
                break;
        };

        //order by filename
        ksort($array);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object" => $object),
                       $object ? "_import_table" : "___import_table",
                       CMS_L_IFC_DATABASE_038);

        //file
        $ifc->set(CMS_L_IFC_DATABASE_039, "label");
        $ifc->set($array,
                  "select 40 b",
                  isset($file)             ? $file             : NULL);

        //separator
        $ifc->set(CMS_L_IFC_DATABASE_028, "label");
        $ifc->set(array(CMS_L_IFC_DATABASE_029 => ",",
                        CMS_L_IFC_DATABASE_030 => ";",
                        CMS_L_IFC_DATABASE_031 => "\t",
                        CMS_L_IFC_DATABASE_032 => " "),
                  "select 40 b",
                  isset($separator)        ? $separator        : ",");

        //delimeter
        $ifc->set(CMS_L_IFC_DATABASE_033, "label");
        $ifc->set(array(CMS_L_IFC_DATABASE_034 => "\"",
                        CMS_L_IFC_DATABASE_035 => "'",
                        CMS_L_IFC_DATABASE_036 => ""),
                  "select 40 b",
                  isset($delimeter)        ? $delimeter        : "\"");

        //get fields
        $ifc->set(CMS_L_IFC_DATABASE_077,
                  "checkbox",
                  TRUE,
                  isset($ignore_first_row) ? $ignore_first_row : TRUE);

        $ifc->close();

case "_import_table":
//.....................................................................................................

        //get available fields from table
        $fields = array(" " => NULL);

        if ($result = mysql_query("SHOW COLUMNS FROM `" . sqlesc($object) . "`"))
        {
                $i = 0;

                while ($resultrow = mysql_fetch_assoc($result))
                {
                        //name
                        $name   = $resultrow["Field"];
                        $_name  = strabridge($name, 20);
                        $_name .= str_repeat(" ", 20 - utf8_strlen($_name));

                        //type
                        $type   = $resultrow["Type"];
                        $type   = strabridge($type, 17);

                        $fields["$_name \xE2\x94\x82 $type"] = $name;
                        $_fields[$i++]                       = $name;
                };
        };

        //get first row from file
        $contents = $mysql->import_csv($ifc_param1, //file
                                       $ifc_param2, //separator
                                       $ifc_param3, //delimeter
                                       NULL,        //table
                                       TRUE);       //get fields

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       array(CMS_L_COMMAND_CONFIRM .  "|database/command_apply"    => "__import_table",
                             CMS_L_COMMAND_PREVIOUS . "|database/command_previous" => "import_table",
                             CMS_L_COMMAND_CANCEL .   "|database/command_cancel"   => FALSE),
                       array("object" => $object),
                       "__import_table",
                       CMS_L_IFC_DATABASE_038);

        //settings from previous screen
        $ifc->param(array("file"             => $ifc_param1,
                          "separator"        => $ifc_param2,
                          "delimeter"        => $ifc_param3,
                          "ignore_first_row" => isset($ifc_param4)));

        $ifc->set(CMS_L_IFC_DATABASE_095, "description b");

        ifc_table_open(NULL);
        echo("<tr>" .

        //column number
             "<th>" .
             "&nbsp;" .
             "</th>" .

        //field
             "<th>" .
             CMS_L_IFC_DATABASE_093 .
             "</th>" .

        //content
             "<th>" .
             CMS_L_IFC_DATABASE_094 .
             "</th>" .
             "</tr>");

        reset($contents);
        while (list($key, $value) = each($contents))
        {
                $varied = ifc_varied();

                echo("<tr>" .

                //column number
                     "<td$varied style=\"TEXT-ALIGN:right\">" .
                     x($key + 1) .
                     "</td>" .

                //field
                     "<td$varied>");
                $ifc->set($fields,
                          "select 40",
                          isset($_fields[$key]) ? $_fields[$key] : NULL,
                          NULL,
                          "mapping[$key]");
                echo("</td>" .

                //content
                     "<td class=\"info\">" .
                     x(strabridge($value, 100)) .
                     "</td>" .
                     "</tr>");
        };
        ifc_table_close();

        $ifc->close();

case "__import_table":
//.....................................................................................................

        //import data into existing table
        if ($mysql->import_csv($file,             //file
                               $separator,        //separator
                               $delimeter,        //delimeter
                               $object,           //table
                               NULL,              //get fields
                               $ignore_first_row, //ignore first row
                               $mapping))         //mapping
        {
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "___import_table":
//.....................................................................................................
        if (

        //get first row from file
             (! $field = $mysql->import_csv($ifc_param1, //file
                                            $ifc_param2, //separator
                                            $ifc_param3, //delimeter
                                            NULL,        //table
                                            TRUE))       //get fields
             ||

        //get number of fields from file
             (! $count = count($field))
           )
        {
                $ifc_response = CMS_MSG_ERROR;
                break;
        };

        $_ifc_param1 = strtoalphanum(basename($ifc_param1));
        $query       = "CREATE TABLE `" . sqlesc($_ifc_param1) . "` (";

        //first row contains field names
        if (isset($ifc_param4))
        {
                for ($i = 0; $i < $count; $i++) $query .= "`" . $field[$i] . "` BLOB NOT NULL, ";
        }

        //no field names, enumerate
        else
        {
                for ($i = 1; $i < $count; $i++) $query .= "`$i` BLOB NOT NULL, ";
        };

        $query       = substr($query, 0, -2) . ")";

        //execute
        if (
             mysql_query($query)
             &&
             $mysql->import_csv($ifc_param1,  //file
                                $ifc_param2,  //separator
                                $ifc_param3,  //delimeter
                                $_ifc_param1, //table
                                NULL,         //get fields
                                TRUE)         //ignore first row
           )
        {
                $object       = $_ifc_param1;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR . "<br>" .
                        "<code>" . x($query) . "</code><br>" .
                        "MySQL: " . x(mysql_error());
        break;

case "delete":
//.....................................................................................................
        if (count($list) === 0) break; //no selection

        reset($list);
        while (list(, $value) = each($list))
        {
                //split object
                $value = explode(".", $value);
                $table = isset($value[0]) ? $value[0] : NULL;
                $field = isset($value[1]) ? $value[1] : NULL;
                $index = isset($value[2]) ? $value[2] : NULL;

                //delete index
                if ($index)
                        $query = "ALTER TABLE `" . sqlesc($table) . "` " .
                                 (streq($index, "PRIMARY") ?
                                 "DROP PRIMARY KEY" :
                                 "DROP INDEX `" . sqlesc($index) . "`");

                //delete field
                elseif ($field)
                        $query = "ALTER TABLE `" . sqlesc($table) . "` " .
                                 "DROP COLUMN `" . sqlesc($field) . "`";

                //delete table
                elseif ($table)
                        $query = "DROP TABLE IF EXISTS `" . sqlesc($table) . "`";

                //no object
                else
                        continue;

                //execute
                if (! mysql_query($query))
                {
                        if (! $ifc_response) $ifc_response = CMS_MSG_ERROR;
                        $ifc_response .= "<br><code>" . x($query) . "</code><br>" .
                                         "MySQL: " . x(mysql_error());
                };
        };

        //deselect object if deleted
        while (in_array($object, $list))
                $object = preg_replace("/\.?[^\.]+$/", "", $object);

        if (! $ifc_response) $ifc_response = CMS_MSG_DONE;
        break;

case "backup":
//.....................................................................................................
        $ifc_response = $mysql->backup() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "restore":
//.....................................................................................................
        $ifc_response = $mysql->restore() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "maintain":
//.....................................................................................................

        //get tables
        if (! $result = mysql_query("SHOW TABLES"))
        {
                $ifc_response = CMS_MSG_ERROR;
                break;
        };

        if (! mysql_num_rows($result)) break; //no tables

        //repair tables
        while ($resultrow = mysql_fetch_row($result))
        {
                $query = "REPAIR TABLE `" . sqlesc($resultrow[0]) . "`";

                //execute
                if (! mysql_query($query))
                {
                        if (! $ifc_response) $ifc_response = CMS_MSG_ERROR;
                        $ifc_response .= "<br><code>" . x($query) . "</code><br>" .
                                         "MySQL: " . x(mysql_error());
                };
        };

        //reset record pointer
        mysql_data_seek($result, 0);

        //optimize tables
        while ($resultrow = mysql_fetch_row($result))
        {
                $query = "OPTIMIZE TABLE `" . sqlesc($resultrow[0]) . "`";

                //execute
                if (! mysql_query($query))
                {
                        if (! $ifc_response) $ifc_response = CMS_MSG_ERROR;
                        $ifc_response .= "<br><code>" . x($query) . "</code><br>" .
                                         "MySQL: " . x(mysql_error());
                };
        };

        if (! $ifc_response) $ifc_response = CMS_MSG_DONE;
        break;

case "config":
//.....................................................................................................

        //get values
        $system     = new system();
        $ifc_param1 = $system->getval("mysql", "host");
        $ifc_param2 = $system->getval("mysql", "database");
        $ifc_param3 = $system->getval("mysql", "user");
        $ifc_param4 = $system->getval("mysql", "password");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       NULL,
                       "_config",
                       CMS_L_IFC_DATABASE_050);

        $ifc->set(CMS_L_IFC_DATABASE_041, "text 40 b",   $ifc_param1);
        $ifc->set(CMS_L_IFC_DATABASE_042, "text 40 b",   $ifc_param2);
        $ifc->set(CMS_L_IFC_DATABASE_043, "text 40 b",   $ifc_param3);
        $ifc->set(CMS_L_IFC_DATABASE_044, "password 40", $ifc_param4);

        $ifc->close();

case "_config":
//.....................................................................................................

        //set values
        $system = new system();
        $system->setval($ifc_param1,        "mysql", "host");
        $system->setval($ifc_param2,        "mysql", "database");
        $system->setval($ifc_param3,        "mysql", "user");
        $system->setval($ifc_param4,        "mysql", "password");

        if ($system->save())
        {
                $mysql        = new mysql();
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array("" => CMS_L_ACCESS));

//cache selected object permanently
cms_cache("database." . CMS_USER . ".object", $object, TRUE);

//no connection
if (! $mysql->connection())
{
        $ifc = new ifc(CMS_L_IFC_DATABASE_040,
                       $ifc_page,
                       NULL);

        echo("&nbsp;<br>");
        $ifc->set(CMS_L_IFC_DATABASE_050, "button", "config");

        $ifc->close();
};

if (streq($ifc_response, CMS_MSG_ERROR) && ($error = mysql_error()))
        $ifc_response .= "<br>MySQL: " . x($error);

//split object
$_object = explode(".", $object);
$table   = isset($_object[0]) ? $_object[0] : NULL;
$field   = isset($_object[1]) ? $_object[1] : NULL;
$index   = isset($_object[2]) ? $_object[2] : NULL;

//determine selected object type
if ($index)     $type = "index";
elseif ($field) $type = "field";
elseif ($table) $type = "table";
else            $type = NULL;

//menu
$menu = array(CMS_L_IFC_DATABASE_051 . "|database/command_code"
              => "javascript:load_page('" .
                 q(CMS_ACTIVE_URL) .
                 "?ifc_page=" . rq(CMS_IFC_PAGE) .
                 "&ifc_message=sql_console" .
                 "&ifc_option=external');");
if ($object)
{
        $menu[CMS_L_IFC_DATABASE_017 . "|database/command_editor"] =
                "javascript:load_page('" .
                q(CMS_ACTIVE_URL) .
                "?ifc_page=" . rq(CMS_IFC_PAGE) .
                "&ifc_message=edit_table" .
                "&ifc_option=external" .
                "&object=" . rq($table) . "');";

        switch ($type)
        {
        case "table":
//.....................................................................................................
                $menu[CMS_L_IFC_DATABASE_014 . "|database/command_edit"]          = "alter_table";
                $menu[CMS_L_IFC_DATABASE_002 . "|database/command_create_field"]  = "add_field";
                $menu[CMS_L_IFC_DATABASE_012 . "|database/command_create_index"]  = "create_index";
                $menu[CMS_L_IFC_DATABASE_075 . "|database/command_export_schema"] = "export_definition";
                $menu[CMS_L_IFC_DATABASE_037 . "|database/command_export_data"]   = "export_table";
                $menu[CMS_L_IFC_DATABASE_038 . "|database/command_import_data"]   = "import_table";
                break;

        case "field":
//.....................................................................................................
                $menu[CMS_L_IFC_DATABASE_002 . "|database/command_create_field"]  = "add_field";
                $menu[CMS_L_IFC_DATABASE_001 . "|database/command_edit"]          = "change_field";
                $menu[CMS_L_IFC_DATABASE_012 . "|database/command_create_index"]  = "create_index";
                break;

        case "index":
//.....................................................................................................
                $menu[CMS_L_IFC_DATABASE_002 . "|database/command_create_field"]  = "add_field";
                break;
        };

        $menu[CMS_L_COMMAND_DELETE . "|database/command_delete"]          = "#delete";
}
else
{
        $menu[CMS_L_IFC_DATABASE_015 . "|database/command_create_table"]  = "create_table";
        $menu[CMS_L_IFC_DATABASE_038 . "|database/command_import_data"]   = "import_table";
        $menu[CMS_L_COMMAND_DELETE .   "|database/command_delete"]        = "#delete";
        $menu[CMS_L_IFC_DATABASE_082 . "|database/command_backup"]        = "#backup";
        $menu[CMS_L_IFC_DATABASE_083 . "|database/command_restore"]       = "#restore";
        $menu[CMS_L_IFC_DATABASE_053 . "|database/command_repair"]        = "#maintain";
        $menu[CMS_L_IFC_DATABASE_050 . "|database/command_configuration"] = "config";
};

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object" => $object));

echo("<table class=\"layout\" " .
            "style=\"WIDTH:100%\">" .

     "<colgroup>" .
     "<col>");
if ($object)
        echo("<col span=\"2\" " .
                  "style=\"WIDTH:1px\">");
echo("</colgroup>" .

     "<tr>" .
     "<td>");

ifc_table_open();
echo("<colgroup>" .
     "<col style=\"WIDTH:1px\">" .
     "<col span=\"3\">" .
     "</colgroup>");

$i = 0;

//display structure of table
if ($table)
{
        $_table = $table;
        $value  = $_table;
        $name   = x($_table);
        if (streq($value, $object)) $name = "<strong>$name</strong>";

        echo("<tr>" .

        //selection
             "<td rowspan=\"3\" " .
                 "class=\"highlight\">" .
             "&nbsp;" .
             "</td>" .

        //name
             "<td colspan=\"2\" " .
                 "class=\"special\">" .
             "<a href=\"javascript:ifc_post('select','" . rqx($value) . "');\">" .
             image("database/icon_table") . "&nbsp;$name" .
             "</a>" .
             "</td>" .

        //up
             "<td class=\"highlight\" " .
                 "style=\"TEXT-ALIGN:center\">" .
             "<a href=\"javascript:ifc_post('select');\">" .
             image("database/icon_up") . "&nbsp;" . CMS_L_COMMAND_CLOSE .
             "</a>" .
             "</td>" .
             "</tr>" .
             "<tr>" .

        //name
             "<th>" .
             CMS_L_NAME .
             "</th>" .

        //type
             "<th>" .
             CMS_L_IFC_DATABASE_003 .
             "</th>" .

        //index
             "<th>" .
             CMS_L_IFC_DATABASE_068 .
             "</th>" .
             "</tr>" .

        //add field button
             "<tr>" .
             "<td colspan=\"3\" " .
                 "class=\"highlight2\">" .
             "<a href=\"javascript:ifc_post('add_field');\">" .
             "[...]" .
             "</a>" .
             "</td>" .
             "</tr>");

        //field
        $_result = mysql_query("SHOW COLUMNS FROM `" . sqlesc($_table) . "`");

        while ($_resultrow = mysql_fetch_assoc($_result))
        {
                $_field = $_resultrow["Field"];
                $_value = "$value.$_field";
                $name   = x($_field);
                if ($flag = streq($_value, $object)) $name = "<strong>$name</strong>";
                $varied = ifc_varied();

                echo("<tr>" .

                //selection
                     "<td class=\"highlight\">");
                $ifc->set(NULL,
                          "checkbox",
                          $_value,
                          streq($_value, $object),
                          "list[" . $i++ . "]");
                echo("</td>" .

                //name
                     "<td$varied>" .
                     "<a href=\"javascript:ifc_post('select','" . rqx($_value) . "');\">" .
                     image("database/icon_field") . "&nbsp;$name" .
                     "</a>" .
                     "</td>" .

                //type
                     "<td$varied>" .
                     x(preg_replace("/^(enum|set)\(.*\)/", "\\1(\xE2\x80\xA6)", $_resultrow["Type"])) .
                     "</td>" .

                //index
                     "<td$varied>" .
                     x($_resultrow["Key"]) .
                     "</td>" .
                     "</tr>");

                if ($flag)
                        echo("<tr>" .

                //selection
                             "<td class=\"highlight\">" .
                             "&nbsp;" .
                             "</td>" .

                //add index button
                             "<td colspan=\"3\" " .
                                 "class=\"highlight2\">" .
                             "<a href=\"javascript:ifc_post('create_index');\">" .
                             "[...]" .
                             "</a>" .
                             "</td>" .
                             "</tr>");

                //index
                if (streq($_field, $field))
                {
                        $__result = mysql_query("SHOW INDEX FROM `" . sqlesc($table) . "`");

                        while ($__resultrow = mysql_fetch_assoc($__result))
                        {
                                if (nstreq($__resultrow["Column_name"], $_field)) continue;

                                $_index  = $__resultrow["Key_name"];
                                $__value = "$_value.$_index";
                                $name    = x($_index);
                                if (streq($__value, $object)) $name = "<strong>$name</strong>";

                                echo("<tr>" .

                                //selection
                                     "<td class=\"highlight\">");
                                $ifc->set(NULL,
                                          "checkbox",
                                          $__value,
                                          streq($__value, $object),
                                          "list[" . $i++ . "]");
                                echo("</td>" .

                                //name
                                     "<td colspan=\"3\" " .
                                         "class=\"varied2\">" .
                                     "<a href=\"javascript:ifc_post('select','" . rqx($__value) . "');\">" .
                                     image("database/icon_index") . "&nbsp;$name" .
                                     "</a>" .
                                     "</td>" .
                                     "</tr>");
                        };
                };
        };
}

//display table list
else
{
        //header
        echo("<tr>" .

        //selection
             "<td rowspan=\"2\" " .
                 "class=\"highlight\">" .
             "&nbsp;" .
             "</td>" .

        //name
             "<th colspan=\"3\">" .
             CMS_L_IFC_DATABASE_054 .
             "</th>" .
             "</tr>" .

        //create table button
             "<tr>" .
             "<td colspan=\"3\" " .
                 "class=\"highlight2\">" .
             "<a href=\"javascript:ifc_post('create_table');\">" .
             "[...]" .
             "</a>" .
             "</td>" .
             "</tr>");

        $result = mysql_query("SHOW TABLES");

        while ($resultrow = mysql_fetch_row($result))
        {
                $_table = $resultrow[0];
                $name   = x($_table);
                $value  = $_table;
                $varied = ifc_varied();

                echo("<tr>" .

                //selection
                     "<td class=\"highlight\">");
                $ifc->set(NULL,
                          "checkbox",
                          $_table,
                          NULL,
                          "list[" . $i++ . "]");
                echo("</td>" .

                //name
                     "<td colspan=\"3\"$varied>" .
                     "<a href=\"javascript:ifc_post('select','" . rqx($value) . "');\">" .
                     image("database/icon_table") . "&nbsp;$name" .
                     "</a>" .
                     "</td>" .
                     "</tr>");
        };
};

//selection control
echo("<tr>" .
     "<td colspan=\"4\" " .
         "class=\"highlight\" " .
         "style=\"TEXT-ALIGN:right\">");
$ifc->set(CMS_L_IFC_DATABASE_096, "button", "javascript:ifc_list_activate();");
$ifc->set(CMS_L_IFC_DATABASE_097, "button", "javascript:ifc_list_invert();");
$ifc->set(CMS_L_IFC_DATABASE_098, "button", "javascript:ifc_list_deactivate();");
echo("</td>" .
     "</tr>");
ifc_table_close();

echo("</td>");

//no information
if (! $object)
{
        echo("</tr>" .
             "</table>");

        $ifc->close();
};

//spacer
echo("<td>" .
     "&nbsp;" .
     "</td>" .

//data
     "<td>");

switch ($type)
{
case "table":
//.....................................................................................................
        $result    = mysql_query("SHOW TABLE STATUS " .
                                 "LIKE '" . sqlesc($table) . "'");
        $resultrow = mysql_fetch_assoc($result);

        ifc_table_open();
        echo("<tr>" .
             "<th colspan=\"2\">" .
             x($resultrow["Name"]) .
             "</th>" .
             "</tr>" .

             (isset($resultrow["Engine"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_013 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Engine"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Version"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_086 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Version"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Row_format"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_056 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Row_format"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Rows"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_057 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Rows"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Avg_row_length"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_058 . ":" .
             "</td>" .
             "<td>" .
             format_bytesize($resultrow["Avg_row_length"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Data_length"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_059 . ":" .
             "</td>" .
             "<td>" .
             format_bytesize($resultrow["Data_length"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Max_data_length"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_060 . ":" .
             "</td>" .
             "<td>" .
             format_bytesize($resultrow["Max_data_length"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Index_length"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_061 . ":" .
             "</td>" .
             "<td>" .
             format_bytesize($resultrow["Index_length"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Data_free"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_062 . ":" .
             "</td>" .
             "<td>" .
             format_bytesize($resultrow["Data_free"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Auto_increment"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_063 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Auto_increment"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Create_time"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_064 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Create_time"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Update_time"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_065 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Update_time"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Check_time"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_066 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Check_time"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Collation"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_088 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Collation"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Checksum"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_087 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Checksum"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Create_options"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_069 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Create_options"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Comment"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_016 . ":" .
             "</td>" .
             "<td class=\"br\">" .
             x($resultrow["Comment"]) .
             "</td>" .
             "</tr>" :
             NULL));
        ifc_table_close();
        break;

case "field":
//.....................................................................................................
        $result    = mysql_query("SHOW FULL COLUMNS FROM `" . sqlesc($table) . "` " .
                                 "LIKE '" .                   sqlesc($field) . "'");
        $resultrow = mysql_fetch_assoc($result);

        ifc_table_open();
        echo("<tr>" .
             "<th colspan=\"2\">" .
             x($resultrow["Field"]) .
             "</th>" .
             "</tr>" .

             (isset($resultrow["Type"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_003 . ":" .
             "</td>" .
             "<td>" .
             x(preg_replace("/^(enum|set)\(.*\)/", "\\1(\xE2\x80\xA6)", $resultrow["Type"])) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Collation"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_088 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Collation"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Null"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_067 . ":" .
             "</td>" .
             "<td>" .
             yesno(! preg_match("/^(NO)?$/", $resultrow["Null"])) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Key"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_068 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Key"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Default"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_005 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Default"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Extra"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_069 . ":" .
             "</td>" .
             "<td>" .
             x($resultrow["Extra"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Privileges"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_089 . ":" .
             "</td>" .
             "<td>" .
             str_replace(",", "<br>", x($resultrow["Privileges"])) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($resultrow["Comment"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_016 . ":" .
             "</td>" .
             "<td class=\"br\">" .
             x($resultrow["Comment"]) .
             "</td>" .
             "</tr>" :
             NULL));
        ifc_table_close();
        break;

case "index":
//.....................................................................................................
        $array = $mysql->report("SHOW INDEX FROM `" . sqlesc($table) . "`");

        //seek selected index
        reset($array);
        while (
                (list($key, $value) = each($array))
                &&
                nstreq($value["Key_name"], $index)
              );

        ifc_table_open();
        echo("<tr>" .
             "<th colspan=\"2\">" .
             x($value["Key_name"]) .
             "</th>" .
             "</tr>" .

             (isset($value["Non_unique"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_070 . ":" .
             "</td>" .
             "<td>" .
             yesno(! $value["Non_unique"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($value["Seq_in_index"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_071 . ":" .
             "</td>" .
             "<td>" .
             x($value["Seq_in_index"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($value["Collation"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_025 . ":" .
             "</td>" .
             "<td>" .
             yesno($value["Collation"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($value["Cardinality"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_073 . ":" .
             "</td>" .
             "<td>" .
             x($value["Cardinality"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($value["Sub_part"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_010 . ":" .
             "</td>" .
             "<td>" .
             x($value["Sub_part"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($value["Packed"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_085 . ":" .
             "</td>" .
             "<td>" .
             x($value["Packed"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($value["Null"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_067 . ":" .
             "</td>" .
             "<td>" .
             yesno(! preg_match("/^(NO)?$/", $value["Null"])) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($value["Index_type"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_084 . ":" .
             "</td>" .
             "<td>" .
             x($value["Index_type"]) .
             "</td>" .
             "</tr>" :
             NULL) .

             (isset($value["Comment"]) ?
             "<tr>" .
             "<td>" .
             CMS_L_IFC_DATABASE_016 . ":" .
             "</td>" .
             "<td class=\"br\">" .
             x($value["Comment"]) .
             "</td>" .
             "</tr>" :
             NULL));
        ifc_table_close();
        break;
};

echo("</td>" .
     "</tr>" .
     "</table>");

$ifc->close();
?>
