<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (! cms_load("directory")) ifc_inactive($ifc_page);

if (! isset($object)) $object = (string)cms_cache("directory." . CMS_USER . ".object");
if (! isset($list))   $list   = preg_match("/^(?:|ifc_)/", CMS_IFC_MESSAGE) ? array($object) : array();
if (! isset($target)) $target = NULL;
if (! isset($status)) $status = NULL;

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "type":
case "type_select":
case "type_add":
case "type_save":
case "type_delete":
//.....................................................................................................
        if (empty($type_object)) $type_object = 0;

        $data = new data("#system/directory.type");

        switch (CMS_IFC_MESSAGE)
        {
        case "type_select":
//.....................................................................................................
                $type_object = $ifc_param;
                break;

        case "type_add":
//.....................................................................................................
                $data->set_buffer(array(array("name" => CMS_L_IFC_DIRECTORY_017)));
                $_type_object = $data->append();
                $data->set($_type_object, $_type_object, "#subtype");

                if ($data->save())
                {
                        $type_object  = $_type_object;
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR;
                break;

        case "type_save":
//.....................................................................................................
                mkpath(CMS_DATA_PATH . "directory.type");

                //name
                if ($ifc_param1) $data->set($ifc_param1, $type_object, "name");

                //icon normal
                if ($ifc_file1 && preg_match("/\.(?:gif|jpg|jpeg|png)$/i", $ifc_file1_name, $extension))
                {
                        $extension = strtolower($extension[0]);
                        if (streq($extension, ".jpeg")) $extension = ".jpg";

                        $ifc_file1_name = CMS_DATA_PATH . "directory.type/$type_object$extension";

                        if (move_uploaded_file($ifc_file1, $ifc_file1_name))
                                $data->set($extension, $type_object, "format");
                };

                //icon selected
                if ($ifc_file2 && preg_match("/\.(?:gif|jpg|jpeg|png)$/i", $ifc_file2_name, $extension))
                {
                        $extension = strtolower($extension[0]);
                        if (streq($extension, ".jpeg")) $extension = ".jpg";

                        $ifc_file2_name = CMS_DATA_PATH . "directory.type/+$type_object$extension";

                        if (move_uploaded_file($ifc_file2, $ifc_file2_name))
                                $data->set($extension, $type_object, "+format");
                };

                $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
                break;

        case "type_delete":
//.....................................................................................................
                if (empty($_list)) break; //no selection

                reset($_list);
                while (list(, $value) = each($_list))
                {
                        //icon normal
                        if (
                             ($format = $data->get($value, "format"))
                             &&
                             is_file(CMS_DATA_PATH . "directory.type/$value$format")
                           )
                                unlink(CMS_DATA_PATH . "directory.type/$value$format");

                        //icon selected
                        if (
                             ($format = $data->get($value, "+format"))
                             &&
                             is_file(CMS_DATA_PATH . "directory.type/+$value$format")
                           )
                                unlink(CMS_DATA_PATH . "directory.type/+$value$format");

                        $data->del($value);
                };

                //remove deleted objects from directory
                $data_directory = new data("#system/directory");

                $data_directory->move("first");
                while ($key = $data_directory->move("next"))
                {
                        $subtype = $data_directory->get($key, "#subtype");
                        if (in_array($subtype, $_list)) $data_directory->del($key, "#subtype");
                };

                $data_directory->save();

                //deselect object if deleted
                if (in_array($type_object, $_list)) $type_object = 0;

                $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
                break;
        };

        //menu
        $menu = array(CMS_L_COMMAND_ADD .    "|directory/command_add"    => "type_add",
                      CMS_L_COMMAND_DELETE . "|directory/command_delete" => "#type_delete",
                      CMS_L_COMMAND_CLOSE .  "|directory/command_cancel" => NULL);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       $menu,
                       array("object"      => $object,
                             "list"        => $list,
                             "type_object" => $type_object),
                       NULL,
                       CMS_L_IFC_DIRECTORY_062);

        echo("<table class=\"layout\" " .
                    "style=\"WIDTH:100%\">" .

             "<colgroup>" .
             "<col>");
        if ($type_object)
                echo("<col span=\"2\" " .
                          "style=\"WIDTH:1px\">");
        echo("</colgroup>" .

             "<tr>" .
             "<td>");

        ifc_table_open();
        echo("<colgroup>" .
             "<col style=\"WIDTH:1px\">" .
             "<col span=\"3\">" .
             "</colgroup>" .

        //header
             "<tr>" .

        //selection
             "<td rowspan=\"2\" " .
                 "class=\"highlight\">" .
             "&nbsp;" .
             "</td>" .

        //name
             "<th>" .
             CMS_L_NAME .
             "</th>" .

        //icon normal
             "<th>" .
             CMS_L_IFC_DIRECTORY_064 .
             "</th>" .

        //icon selected
             "<th>" .
             CMS_L_IFC_DIRECTORY_065 .
             "</th>" .
             "</tr>" .

        //type add button
             "<tr>" .
             "<td colspan=\"3\" " .
                 "class=\"highlight2\">" .
             "<a href=\"javascript:ifc_post('type_add');\">" .
             "[...]" .
             "</a>" .
             "</td>" .
             "</tr>");

        $i = 0;

        $data->move("first");
        while ($key = $data->move("next"))
        {
                $name   = $data->get($key, "name");
                $_name  = x($name);
                if (streq($key, $type_object)) $_name = "<strong>$_name</strong>";
                $varied = ifc_varied();

                echo("<tr>" .

                //selection
                     "<td class=\"highlight\">");
                $ifc->set(NULL,
                          "checkbox",
                          $key,
                          streq($key, $type_object),
                          "_list[" . $i++ . "]");
                echo("</td>" .

                //name
                     "<td$varied>" .
                     "<a href=\"javascript:ifc_post('type_select','" . rqx($key) . "');\">" .
                     $_name .
                     "</a>" .

                //icon normal
                     "</td>" .
                     "<td$varied>" .
                     image(CMS_DATA_URL . "directory.type/$key" . $data->get($key, "format")) .
                     "</td>" .

                //icon selected
                     "<td$varied>" .
                     image(CMS_DATA_URL . "directory.type/+$key" . $data->get($key, "format")) .
                     "</td>" .
                     "</tr>");
        };

        //selection control
        echo("<tr>" .
             "<td colspan=\"4\" " .
                 "class=\"highlight\" " .
                 "style=\"TEXT-ALIGN:right\">");
        $ifc->set(CMS_L_IFC_DIRECTORY_018, "button", "javascript:ifc_list_activate(\"_list\");");
        $ifc->set(CMS_L_IFC_DIRECTORY_019, "button", "javascript:ifc_list_invert(\"_list\");");
        $ifc->set(CMS_L_IFC_DIRECTORY_020, "button", "javascript:ifc_list_deactivate(\"_list\");");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        if ($type_object)
        {
                //spacer
                echo("<td>" .
                     "&nbsp;" .
                     "</td>" .

                //data
                     "<td>");

                ifc_table_open();

                //title
                echo("<tr>" .
                     "<th>" .
                     CMS_L_IFC_DIRECTORY_007 .
                     "</th>" .
                     "</tr>" .

                     "<tr>" .
                     "<td class=\"varied\">");

                //name
                $ifc->set(CMS_L_NAME,                                    "text 40 50", $name);

                //save button
                $ifc->set(CMS_L_COMMAND_SAVE,                            "button b",   "type_save");

                //icon normal
                $ifc->set(CMS_L_IFC_DIRECTORY_064 . " (GIF, JPG, PNG)",  "file b");

                //icon selected
                $ifc->set(CMS_L_IFC_DIRECTORY_065 . " (GIF, JPG, PNG)",  "file b");

                //info
                $ifc->set(CMS_L_IFC_DIRECTORY_066,                       "info");
                echo("</td>" .
                     "</tr>");
                ifc_table_close();
        };
        echo("</tr>" .
             "</table>");

        $ifc->close();

case "select":
//.....................................................................................................
        $object = $ifc_param;
        $list   = array($object);
        $status = NULL;
        break;

case "save":
//.....................................................................................................
        $directory = new directory();

        //process canonical
        $language = nstre(CMS_LANGUAGE_ENABLED) ? explode(",", "," . CMS_LANGUAGE_ENABLED) : array("");
        $source   = analyze_url(CMS_ROOT_URL);

        reset($language);
        while (list(, $value) = each($language))
        {
                $_value = language_get($ifc_param12, $value, TRUE);
                if (stre($_value))          continue; //no value

                //complete imperfect address
                $target = analyze_url($_value);
                if (stre($target["scheme"])) $target["scheme"] = $source["scheme"];
                if (stre($target["host"]))   $target["host"]   = $source["host"];

                $_value = url($target["scheme"],
                              $target["user"],
                              $target["pass"],
                              $target["host"],
                              $target["port"],
                              $target["path"],
                              $target["query"],
                              $target["fragment"]);

                $ifc_param12 = language_set($ifc_param12, $_value, $value);
        };

        //set values
        $directory->set($object,            //key
                        $ifc_param1,        //name
                        $ifc_param5,        //description
                        $ifc_param6,        //url
                        $ifc_param7,        //subtype
                        isset($ifc_param2), //hidden
                        isset($ifc_param3), //placeholder
                        isset($ifc_param4), //dynamic
                        $ifc_param8,        //image_button
                        $ifc_param9,        //image_hover
                        $ifc_param10,       //image_active
                        $ifc_param11,       //path
                        $ifc_param12);      //canonical

        if ($directory->save())
        {
                $list         = array($object);
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "add":
//.....................................................................................................
        $ifc_param  = $object;                                                           //target
        $ifc_param1 = CMS_L_IFC_DIRECTORY_001;                                           //name
        $ifc_param2 = cms_cache("directory." . CMS_USER . ".hidden")      ? TRUE : NULL; //hidden
        $ifc_param3 = cms_cache("directory." . CMS_USER . ".placeholder") ? TRUE : NULL; //placeholder
        $ifc_param4 = cms_cache("directory." . CMS_USER . ".dynamic")     ? TRUE : NULL; //dynamic
        $ifc_param5 = NULL;                                                              //description
        $ifc_param6 = NULL;                                                              //url
        $ifc_param7 = cms_cache("directory." . CMS_USER . ".subtype");                   //subtype

case "add_target":
//.....................................................................................................
        $data     = new data("#system/directory");
        $flexview = new flexview();

        $flexview->import_data($data);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       array(CMS_L_COMMAND_CANCEL . "|directory/command_cancel" => FALSE),
                       array("object" => $object,
                             "list"   => $list),
                       NULL,
                       CMS_L_COMMAND_ADD);

        ifc_table_open();
        echo("<colgroup>" .
             "<col style=\"WIDTH:1px\">" .
             "<col>" .
             "</colgroup>" .

             "<tr>" .

        //data
             "<th>" .
             CMS_L_IFC_DIRECTORY_003 .
             "</th>" .

        //target
             "<th>" .
             CMS_L_IFC_DIRECTORY_004 .
             "</th>" .
             "</tr>" .
             "<tr>" .

        //data
             "<td class=\"varied\">");

        //name
        $ifc->set(CMS_L_IFC_DIRECTORY_008,     "text 50 256 bl",             $ifc_param1);

        //hidden
        $ifc->set(CMS_L_IFC_DIRECTORY_005,     "checkbox",   TRUE,           isset($ifc_param2));

        //placeholder
        $ifc->set(CMS_L_IFC_DIRECTORY_010,     "checkbox",   TRUE,           isset($ifc_param3));

        //dynamic
        $ifc->set(CMS_L_IFC_DIRECTORY_016,     "checkbox b", TRUE,           isset($ifc_param4));

        //description
        $ifc->set(CMS_L_DESCRIPTION,           "texteditor 50x8 2048 bilrt", $ifc_param5);

        //url
        $ifc->set(CMS_L_URL,                   "text 40",                    $ifc_param6);
        $ifc->set("...",                       "button b",                   "javascript:load_page('" .
                                                                             q(CMS_ACTIVE_URL) .
                                                                             "?ifc_page=content" .
                                                                             "&ifc_message=edit_href" .
                                                                             "&ifc_option=external" .
                                                                             "&ifc_select=__value" .
                                                                             "&ifc_select_action=javascript:ifc_change(" .
                                                                             "this.opener.document.ifc.ifc_param6,\\'%return%\\');');");

        //subtype
        $ifc->set(CMS_L_IFC_DIRECTORY_063,     "label");
        $ifc->set(directory_get_type_select(), "select 50",                  $ifc_param7);
        echo("</td>" .

        //target
             "<td class=\"target\">");
        $flexview->set_encoding_function(__NAMESPACE__ . "\\qr");
        $flexview->set_display_function(__NAMESPACE__ . "\\directory_flexview_display_function");
        $flexview->show_target($ifc_param,
                               "javascript:ifc_post('add_target','%index%');",
                               "javascript:ifc_post('add_insert','%index%');",
                               "javascript:ifc_post('add_append','%index%');");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        $ifc->close();

case "add_insert":
case "add_append":
//.....................................................................................................

        //set name if none is given
        if (! language_get($ifc_param1, FALSE))
                $ifc_param1 = language_set($ifc_param1, CMS_L_UNKNOWN, FALSE);

        $directory = new directory();
        $_object   = streq(CMS_IFC_MESSAGE, "add_insert") ?
                     $directory->insert($ifc_param,           //key
                                        $ifc_param1,          //name
                                        $ifc_param5,          //description
                                        $ifc_param6,          //url
                                        $ifc_param7,          //subtype
                                        isset($ifc_param2),   //hidden
                                        isset($ifc_param3),   //placeholder
                                        isset($ifc_param4)) : //dynamic
                     $directory->append($ifc_param,           //key
                                        $ifc_param1,          //name
                                        $ifc_param5,          //description
                                        $ifc_param6,          //url
                                        $ifc_param7,          //subtype
                                        isset($ifc_param2),   //hidden
                                        isset($ifc_param3),   //placeholder
                                        isset($ifc_param4));  //dynamic

        if ($directory->save())
        {
                $object       = $_object;
                $list         = array($object);
                $ifc_response = CMS_MSG_DONE;
                cms_cache("directory." . CMS_USER . ".hidden",      isset($ifc_param2), TRUE);
                cms_cache("directory." . CMS_USER . ".placeholder", isset($ifc_param3), TRUE);
                cms_cache("directory." . CMS_USER . ".dynamic",     isset($ifc_param4), TRUE);
                cms_cache("directory." . CMS_USER . ".subtype",     $ifc_param7,        TRUE);
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "copy":
case "cut":
//.....................................................................................................
        $target = $object;
        $status = CMS_IFC_MESSAGE;
        break;

case "target":
//.....................................................................................................
        $target = $ifc_param;
        break;

case "copy_insert":
case "copy_append":
case "cut_insert":
case "cut_append":
//.....................................................................................................
        if (count($list) === 0) break; //no selection;

        $directory = new directory();
        $data      = clone $directory->data; //use clone of data structure as source
        $_list     = NULL;

        //transverse reversely
        $list      = array_reverse($list);

        reset($list);
        while (list(, $value) = each($list))
        {
                //copy / cut
                switch (CMS_IFC_MESSAGE)
                {
                case "copy_insert":
                case "copy_append":

                        //buffer section in clone
                        $data->copy($value);
                        break;

                case "cut_insert":
                case "cut_append":

                        //target is contained in source
                        if ($directory->data->is_child($ifc_param, $value))
                        {
                                //buffer section in clone
                                $data->copy($value);
                        }
                        else
                        {
                                //remove section in master
                                $directory->data->del($value);

                                //buffer section in clone
                                $data->cut($value);
                        };
                        break;
                };

                //transmit buffer from clone to master
                $directory->data->buffer = $data->buffer;

                //paste
                switch (CMS_IFC_MESSAGE)
                {
                case "copy_insert":
                case "cut_insert":

                        //insert buffer in master
                        $_object = $directory->data->insert($ifc_param);
                        break;

                case "copy_append":
                case "cut_append":

                        //append buffer in master
                        $_object = $directory->data->append($ifc_param);
                        break;
                };

                $_list[] = $_object;
        };

        //save changes
        if ($directory->save())
        {
                //set target as selection
                switch (CMS_IFC_MESSAGE)
                {
                case "copy_insert":
                case "cut_insert":
                        $object = $ifc_param;
                        break;

                case "copy_append":
                case "cut_append":
                        $object = $directory->data->move("parent", $ifc_param);
                        break;
                };

                $list         = $_list;
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "sort":
//.....................................................................................................

        //sort directory tree branches below selected entry by name

        if (count($list) === 0) break; //no selection;

        $directory = new directory();

        //order by name
        reset($list);
        while (list(, $value) = each($list))
                data_sort($directory->data, "name", $value);

        $ifc_response = $directory->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "clean":
//.....................................................................................................

        //cut directory tree branch endings below selected entry
        //that are no placeholder and have no url

        if (count($list) === 0) break; //no selection;

        $directory = new directory();
        $stack     = array();
        $_object   = $object;

        //get path to object
        while ($_object = $directory->data->move("parent", $_object))
                array_unshift($stack, $_object);
        array_unshift($stack, 0);

        reset($list);
        while (list(, $value) = each($list))
        {
                $array     = array();
                $depth     = 0;
                $limit     = 0;

                $key       = $value ?
                             $directory->data->move("to", $value) :
                             $directory->data->move("first");
                while ($key)
                {
                        switch ($directory->data->get($key, "#type"))
                        {
                        case "container":
                                $array[++$depth] = $key;
                                if (
                                     $directory->data->get($key, "url")
                                     ||
                                     $directory->data->get($key, "placeholder")
                                   )
                                        $limit = $depth;
                                break;

                        case "/container":
                                if ($depth > $limit)               $directory->data->del($array[$depth]);
                                if (streq($array[$depth], $value)) break 2;
                                if (--$depth < $limit)             $limit = $depth;
                        };

                        $key = $directory->data->move("next");
                };
        };

        if ($directory->save())
        {
                //select rightmost existing object in path
                while (! $directory->data->get($object))
                {
                        $object = array_pop($stack);
                        if ($object === 0) break;
                };

                $list         = array($object);
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "delete":
//.....................................................................................................
        if (count($list) === 0) break; //no selection;

        $directory = new directory();
        $stack     = array();
        $_object   = $object;

        //get path to object
        while ($_object = $directory->data->move("parent", $_object))
                array_unshift($stack, $_object);
        array_unshift($stack, 0);

        //delete
        reset($list);
        while (list(, $value) = each($list))
                $directory->del($value);

        //save changes
        if ($directory->save())
        {
                //select last existing object in path
                while (! $directory->data->get($object))
                {
                        $object = array_pop($stack);
                        if ($object === 0) break;
                };

                $list         = array($object);
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array("" => CMS_L_ACCESS));

//cache selected object permanently
if (CMS_IFC_MESSAGE !== "") cms_cache("directory." . CMS_USER . ".object", $object, TRUE);

$data     = new data("#system/directory");
$flexview = new flexview();
$flexview->import_data($data);

//menu
$menu = NULL;
if (CMS_IFC_SELECT && $object)
        $menu[CMS_L_COMMAND_INSERT . "|image/command_apply"] = "javascript:ifc_return();";
$menu[CMS_L_COMMAND_ADD .       "|directory/command_add"]    = "add";
if ($object && cms_load("template"))
{
        $url = translate_url("directory://$object",
                             array("content_option" => CMS_TEMPLATE_OPTION_ALL,
                                   "cms_instance"   => NULL));

        $menu[CMS_L_COMMAND_SHOW . "|directory/command_view"] = "javascript:load_page('" . q($url) . "');";
};
$menu[CMS_L_COMMAND_COPY .      "|directory/command_copy"]   = "copy";
$menu[CMS_L_COMMAND_CUT .       "|directory/command_cut"]    = "cut";
$menu[CMS_L_COMMAND_DELETE .    "|directory/command_delete"] = "#delete";
$menu[CMS_L_IFC_DIRECTORY_072 . "|directory/command_sort"]   = "#sort";
$menu[CMS_L_IFC_DIRECTORY_002 . "|directory/command_clear"]  = "#clean";
$menu[CMS_L_IFC_DIRECTORY_062 . "|directory/command_icon"]   = "type";

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object" => $object,
                     "status" => $status));

echo("<table class=\"layout\" " .
            "style=\"WIDTH:100%\">" .

     "<colgroup>" .
     "<col>");
if ($status)
        echo("<col style=\"WIDTH:1px\">" .
             "<col style=\"WIDTH:200px\">");
if ($object)
        echo("<col span=\"2\" " .
                "style=\"WIDTH:1px\">");
echo("</colgroup>" .

     "<tr>" .
     "<td>");

ifc_table_open();

//add button
echo("<tr>" .
     "<td class=\"highlight2\">" .
     "<a href=\"javascript:ifc_post('add');\">" .
     "[...]" .
     "</a>" .
     "</td>" .
     "</tr>" .

//directory
     "<tr>" .
     "<td class=\"varied2\">");
$flexview->set_encoding_function(__NAMESPACE__ . "\\qr");
$flexview->set_display_function(__NAMESPACE__ . "\\directory_flexview_display_function");
$flexview->set_checkbox_identifier("list");
$flexview->set_checkbox_list($list);
$flexview->show_tree($object,                                    //index
                     "javascript:ifc_post('select','%index%');", //action
                     "name",                                     //name key
                     NULL,                                       //mark
                     directory_get_type());                      //icon
echo("</td>" .
     "</tr>");

//canonical address
$url = directory_get_canonical($object);
echo("<tr>" .
     "<td class=\"highlight2\">" .
     "<a href=\"" . x($url) . "\" " .
        "title=\"" . CMS_L_IFC_DIRECTORY_022 . "\" " .
        "onclick=\"load_page('" . qx($url) . "');return false;\">" .
     x($url) .
     "</a>" .
     "</td>" .
     "</tr>" .

//selection control
     "<tr>" .
     "<td class=\"highlight\" " .
         "style=\"TEXT-ALIGN:right\">");
$ifc->set(CMS_L_IFC_DIRECTORY_018, "button", "javascript:ifc_list_activate();");
$ifc->set(CMS_L_IFC_DIRECTORY_019, "button", "javascript:ifc_list_invert();");
$ifc->set(CMS_L_IFC_DIRECTORY_020, "button", "javascript:ifc_list_deactivate();");
echo("</td>" .
     "</tr>");
ifc_table_close();

echo("</td>");

if ($status)
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //target
             "<td>");

        ifc_table_open();
        echo("<tr>" .
             "<th>" .
             (streq($status, "copy") ? CMS_L_COMMAND_COPY : CMS_L_COMMAND_CUT) .
             "</th>" .
             "</tr>" .
             "<tr>" .
             "<td class=\"target\">");
        $flexview->show_target($target,
                               "javascript:ifc_post('target','%index%');",
                               "javascript:ifc_post('" . $status . "_insert','%index%');",
                               "javascript:ifc_post('" . $status . "_append','%index%');");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");
};

//data
if ($object)
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //data
             "<td>");

        ifc_table_open();
        echo("<tr>" .
             "<th>" .
             CMS_L_IFC_DIRECTORY_007 .
             "</th>" .
             "</tr>" .
             "<tr>" .
             "<td class=\"varied\">");

        $active_url = q(CMS_ACTIVE_URL);

        //name
        $ifc->set(CMS_L_IFC_DIRECTORY_008,     "text 40 256 l",              $data->get($object, "name"));

        //save button
        $ifc->set(CMS_L_COMMAND_SAVE,          "button b",                   "save");

        //hidden
        $ifc->set(CMS_L_IFC_DIRECTORY_005,     "checkbox",   TRUE,           $data->get($object, "hidden"));

        //placeholder
        $ifc->set(CMS_L_IFC_DIRECTORY_010,     "checkbox",   TRUE,           $data->get($object, "placeholder"));

        //dynamic
        $ifc->set(CMS_L_IFC_DIRECTORY_016,     "checkbox b", TRUE,           $data->get($object, "dynamic"));

        //description
        $ifc->set(CMS_L_DESCRIPTION,           "texteditor 50x8 2048 bilrt", $data->get($object, "description"));

        //url
        $ifc->set(CMS_L_URL,                   "text 40",                    $data->get($object, "url"));
        $ifc->set("...",                       "button b",                   "javascript:load_page('" .
                                                                             $active_url .
                                                                             "?ifc_page=content" .
                                                                             "&ifc_message=edit_href" .
                                                                             "&ifc_option=external" .
                                                                             "&value=address:' + escape(ifc_value('ifc_param6')) + '" .
                                                                             "&ifc_select=__value" .
                                                                             "&ifc_select_action=javascript:ifc_change(" .
                                                                             "this.opener.document.ifc.ifc_param6,\\'%return%\\');');");

        //graphics
        $ifc->set(CMS_L_IFC_DIRECTORY_011,     "title");

        //subtype
        $ifc->set(CMS_L_IFC_DIRECTORY_063,     "label");
        $ifc->set(directory_get_type_select(), "select 50 b",                $data->get($object, "#subtype"));

        //image button
        $ifc->set(CMS_L_IFC_DIRECTORY_012,     "text 40 l",                  $data->get($object, "image_button"));
        $ifc->set("...",                       "button b",                   "javascript:load_page('" .
                                                                             $active_url .
                                                                             "?ifc_page=image" .
                                                                             "&ifc_option=external" .
                                                                             "&object=' + escape(ifc_value('ifc_param8')) + '" .
                                                                             "&ifc_select=object" .
                                                                             "&ifc_select_action=javascript:" .
                                                                             "ifc_change(this.opener.document.ifc.ifc_param8,\\'%return%\\');" .
                                                                             "ifc_language_reload(" .
                                                                             "this.opener.document.ifc.ifc_param8," .
                                                                             "this.opener.document.ifc.l_ifc_param8);');");

        //image hover
        $ifc->set(CMS_L_IFC_DIRECTORY_013,     "text 40 l",                  $data->get($object, "image_hover"));
        $ifc->set("...",                       "button b",                   "javascript:load_page('" .
                                                                             $active_url .
                                                                             "?ifc_page=image" .
                                                                             "&ifc_option=external" .
                                                                             "&ifc_select=object" .
                                                                             "&object=' + escape(ifc_value('ifc_param9')) + '" .
                                                                             "&ifc_select_action=javascript:" .
                                                                             "ifc_change(this.opener.document.ifc.ifc_param9,\\'%return%\\');" .
                                                                             "ifc_language_reload(" .
                                                                             "this.opener.document.ifc.ifc_param9," .
                                                                             "this.opener.document.ifc.l_ifc_param9);');");

        //image active
        $ifc->set(CMS_L_IFC_DIRECTORY_009,     "text 40 l",                  $data->get($object, "image_active"));
        $ifc->set("...",                       "button b",                   "javascript:load_page('" .
                                                                             $active_url .
                                                                             "?ifc_page=image" .
                                                                             "&ifc_option=external" .
                                                                             "&ifc_select=object" .
                                                                             "&object=' + escape(ifc_value('ifc_param10')) + '" .
                                                                             "&ifc_select_action=javascript:" .
                                                                             "ifc_change(this.opener.document.ifc.ifc_param10,\\'%return%\\');" .
                                                                             "ifc_language_reload(" .
                                                                             "this.opener.document.ifc.ifc_param10," .
                                                                             "this.opener.document.ifc.l_ifc_param10);');");

        //extended
        $ifc->set(CMS_L_IFC_DIRECTORY_014,     "title");

        //overwrite path
        $ifc->set(CMS_L_IFC_DIRECTORY_015,     "text 40 256 l",              $data->get($object, "path"));
        echo(".php<br>");

        //canonical base
        $canonical = $data->get($object, "canonical");
        $ifc->set(CMS_L_IFC_DIRECTORY_021,     "text 40 256 bl",             $canonical);

        echo("</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");
};
echo("</tr>" .
     "</table>");

$ifc->close();
?>
