<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (! cms_load("download")) ifc_inactive($ifc_page);

if (empty($object))     $object   = cms_cache("download." . CMS_USER . ".object");
if (! isset($language)) $language = NULL;

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = language_set($object, $ifc_param, $language);
        break;

case "select_language":
//.....................................................................................................
        $language = $ifc_param;
        break;

case "display":
//.....................................................................................................
        $ifc = new ifc(NULL, NULL, NULL);
        if (! $object) $ifc->close();

        cms_cache("download." . CMS_USER . ".object", $object, TRUE);

        $download = new download();
        $path     = CMS_DATA_PATH . "#download/$object";

        if (
             ($name = $download->data->get($object, "name"))
             &&
             is_file($path)
           )
        {
                ifc_table_open();
                echo("<colgroup>" .
                     "<col style=\"WIDTH:1px\">" .
                     "<col>" .
                     "</colgroup>" .

                //info
                     "<tr>" .
                     "<th colspan=\"2\">" .
                     CMS_L_IFC_DOWNLOAD_005 .
                     "</th>" .
                     "</tr>" .

                //name
                     "<tr>" .
                     "<td" . ($varied = ifc_varied()) . ">" .
                     CMS_L_NAME . ":" .
                     "</td>" .
                     "<td$varied>" .
                     "<strong>" .
                     x(l($download->data->get($object, "name"))) .
                     "</strong>" .
                     "</td>" .
                     "</tr>");

                //format
                if ($buffer = utf8_strtoupper(substr(strrchr($object, "."), 1)))
                        echo("<tr>" .
                             "<td" . ($varied = ifc_varied()) . ">" .
                             CMS_L_IFC_DOWNLOAD_011 . ":" .
                             "</td>" .
                             "<td$varied>" .
                             x($buffer) .
                             " (" . x(get_mime_type($object)) . ")" .
                             "</td>" .
                             "</tr>");

                //size
                if ($buffer = filesize($path))
                        echo("<tr>" .
                             "<td" . ($varied = ifc_varied()) . ">" .
                             CMS_L_IFC_DOWNLOAD_012 . ":" .
                             "</td>" .
                             "<td$varied>" .
                             format_bytesize($buffer) .
                             "</td>" .
                             "</tr>");

                //description
                if ($buffer = l($download->data->get($object, "description")))
                        echo("<tr>" .
                             "<td" . ($varied = ifc_varied()) . ">" .
                             CMS_L_DESCRIPTION . ":" .
                             "</td>" .
                             "<td class=\"info\">" .
                             parse_text($buffer) .
                             "</td>" .
                             "</tr>");

                //download
                if (cms_permission("download", NULL, NULL))
                {
                        //spacer
                        echo("<tr>" .
                             "<td class=\"highlight\">" .
                             "&nbsp;" .
                             "</td>" .

                        //download button
                             "<td class=\"highlight\" " .
                                 "style=\"FONT-WEIGHT:bold\">");
                        $ifc->set(CMS_L_IFC_DOWNLOAD_013,
                                  "button",
                                  "javascript:load_page('" .
                                  q(CMS_MODULES_URL) . "download.php" .
                                  "?download_index=" . rq($object) . "');");
                        echo("</td>" .
                             "</tr>");
                };

                ifc_table_close();
        };

        $ifc->close();

case "upload":
//.....................................................................................................
        $download = new download();
        $_object  = language_get($object, $language, TRUE);
        $category = $download->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_upload",
                       CMS_L_IFC_DOWNLOAD_001);

        //name
        $ifc->set(CMS_L_NAME,             "text 40 40 bl");

        //description
        $ifc->set(CMS_L_DESCRIPTION,      "texteditor 40x8 1024 bilrt");

        //file
        $ifc->set(CMS_L_IFC_DOWNLOAD_002, "file b");

//javascript
?>
<script>
ifc_get_object("ifc_file1").click();
</script>
<?php

        //category
        $ifc->set(CMS_L_IFC_DOWNLOAD_003, "title");
        $ifc->set(CMS_L_IFC_DOWNLOAD_009, "text 40 40 b");
        $ifc->set(CMS_L_IFC_DOWNLOAD_003, "label");
        $ifc->set(download_get_select(),  "select 40", $category);

        $ifc->close();

case "_upload":
//.....................................................................................................
        if (isset($ifc_file1_name))
        {
                $download = new download();

                if ($_object = $download->add($ifc_file1,                               //file
                                              $ifc_file1_name,                          //filename
                                              $ifc_param1,                              //name
                                              $ifc_param2,                              //description
                                              $ifc_param3 ? $ifc_param3 : $ifc_param4)) //category
                {
                        $object       = language_set($object, $_object, $language);
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "upload_multi":
//.....................................................................................................
        $download = new download();
        $_object  = language_get($object, $language, TRUE);
        $category = $download->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_upload_multi",
                       CMS_L_IFC_DOWNLOAD_014);

        //info
        $ifc->set(CMS_L_IFC_DOWNLOAD_015, "info b");

        //file
        $ifc->set(CMS_L_IFC_DOWNLOAD_002, "multifile b");

        //category
        $ifc->set(CMS_L_IFC_DOWNLOAD_003, "title");
        $ifc->set(CMS_L_IFC_DOWNLOAD_009, "text 40 40 b");
        $ifc->set(CMS_L_IFC_DOWNLOAD_010, "label");
        $ifc->set(download_get_select(),  "select 40", $category);

//javascript
?>
<script>
ifc_get_object("ifc_file1[]").click();
</script>
<?php

        $ifc->close();

case "_upload_multi":
//.....................................................................................................
        if (is_array($ifc_file1)) $array = array_combine($ifc_file1, $ifc_file1_name);
        else                      $array = array($ifc_file1 => $ifc_file1_name);

        $download = new download();
        $_object  = "";
        $error    = FALSE;

        reset($array);
        while (list($key, $value) = each($array))
        {
                if ($__object = $download->add($key,                                     //file
                                               $value,                                   //filename
                                               NULL,                                     //name
                                               NULL,                                     //description
                                               $ifc_param1 ? $ifc_param1 : $ifc_param2)) //category
                        $_object = $__object;
                else
                        $error   = TRUE;
        };

        $object       = language_set($object, $_object, $language);
        $ifc_response = $error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "edit":
//.....................................................................................................
        $download = new download();
        $_object  = language_get($object, $language, TRUE);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_edit",
                       CMS_L_COMMAND_EDIT);

        //name
        $ifc->set(CMS_L_NAME,
                  "text 40 40 bl",
                  $download->data->get($_object, "name"));

        //description
        $ifc->set(CMS_L_DESCRIPTION,
                  "texteditor 40x8 1024 bilrt",
                  $download->data->get($_object, "description"));

        //category
        $ifc->set(CMS_L_IFC_DOWNLOAD_009, "text 40 40 b");
        $ifc->set(CMS_L_IFC_DOWNLOAD_003, "label");
        $ifc->set(download_get_select(),
                  "select 40",
                  $download->data->get($_object, "category"));

        $ifc->close();

case "_edit":
//.....................................................................................................
        $download = new download();
        $_object  = language_get($object, $language, TRUE);

        if ($download->set($_object,                                 //index
                           $ifc_param1,                              //name
                           $ifc_param2,                              //description
                           $ifc_param3 ? $ifc_param3 : $ifc_param4)) //category
        {
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "replace":
//.....................................................................................................
        $_object = language_get($object, $language, TRUE);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_replace",
                       CMS_L_IFC_DOWNLOAD_008);

        //file
        $type = utf8_strtoupper(substr(strrchr($_object, "."), 1));
        $ifc->set(CMS_L_IFC_DOWNLOAD_002 . " ($type)", "file b");

//javascript
?>
<script>
ifc_autopost("ifc_file1", "_replace");
ifc_get_object("ifc_file1").click();
</script>
<?php

        $ifc->close();

case "_replace":
//.....................................................................................................
        if (isset($ifc_file1_name))
        {
                $download     = new download();
                $_object      = language_get($object, $language, TRUE);
                $ifc_response = $download->replace($_object,          //index
                                                   $ifc_file1,        //file
                                                   $ifc_file1_name) ? //filename
                                CMS_MSG_DONE : CMS_MSG_ERROR;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "delete":
//.....................................................................................................
        if (empty($_object)) break; //no selection

        reset($_object);
        list(, $value) = each($_object);

        $download   = new download();
        $category   = $download->data->get($value, "category");
        $flag_error = TRUE;

        //delete selected images
        do
        {
                $flag_error &= ! $download->unlink($value);
        }
        while (list(, $value) = each($_object));

        //remove invalid download links from selection
        $array = explode(",", CMS_LANGUAGE_ENABLED);
        if (CMS_LANGUAGE_ENABLED) $array[] = FALSE;

        reset($array);
        while (list(, $value) = each($array))
        {
                $_object = language_get($object, $value, TRUE);

                if (! $download->data->get($_object))
                {
                        //active language
                        if (streq($value, $language))
                        {
                                $download->data->move("first");
                                $_object = $download->data->seek(array("category" => $category));
                                $object  = language_set($object, $_object, $value);
                        }

                        //inactive language(s)
                        else
                        {
                                $object  = language_set($object, NULL, $value);
                        };
                };
        };

        $ifc_response = $flag_error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "category_rename":
//.....................................................................................................
        $download = new download();
        $_object  = language_get($object, $language, TRUE);
        $category = $download->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_category_rename",
                       CMS_L_IFC_DOWNLOAD_006);

        //category
        $ifc->set(CMS_L_NAME, "text 40 40 b", $category);

        $ifc->close();

case "_category_rename":
//.....................................................................................................
        $download = new download();
        $_object  = language_get($object, $language, TRUE);
        $category = $download->data->get($_object, "category");

        $download->data->move("first");
        while ($key = $download->data->move("next"))
        {
                $_category = $download->data->get($key, "category");
                if (streq($_category, $category))
                        $download->data->set($ifc_param1, $key, "category");
        };

        $ifc_response = $download->data->save() ? CMS_MSG_DONE : CMS_MSG_DONE;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array(""                               => CMS_L_ACCESS,
                     CMS_DOWNLOAD_PERMISSION_OPERATOR => CMS_L_OPERATOR));

$download = new download();
$_object  = language_get($object, $language, TRUE);
$array    = download_get_array();

//get category from object
if ($_object && in_array_recursive($_object, $array))
{
        $category = $download->data->get($_object, "category");
        if (! $category) $category = "";
        cms_cache("download." . CMS_USER . ".category", $category, TRUE);
}

//get object from category
else
{
        $category = (string)cms_cache("download." . CMS_USER . ".category");
        if ((! $category) || (! isset($array[$category]))) $category = "";

        if (is_array($array[$category]))
        {
                $_object = current($array[$category]);
                $object  = language_set($object, $_object, $language);
        };
};

//menu
$menu = NULL;
if (CMS_IFC_SELECT && $_object)
        $menu[CMS_L_COMMAND_INSERT .   "|download/command_apply"]        = "javascript:ifc_return();";
if ($download->operator)
{
        $menu[CMS_L_IFC_DOWNLOAD_001 . "|download/command_upload"]       = "upload";
        $menu[CMS_L_IFC_DOWNLOAD_014 . "|download/command_upload_multi"] = "upload_multi";
        if ($_object)
        {
                $menu[CMS_L_COMMAND_EDIT .     "|download/command_edit"]      = "edit";
                $menu[CMS_L_IFC_DOWNLOAD_008 . "|download/command_overwrite"] = "replace";
                $menu[CMS_L_COMMAND_DELETE .   "|download/command_delete"]    = "#delete";
                $menu[CMS_L_IFC_DOWNLOAD_006 . "|download/command_rename"]    = "category_rename";
        };
};

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object"   => $object,
                     "language" => $language));

//javascript
?>
<script>
function download_select(value)
{
        var language              = "<?php echo(q($language));?>";
        if (ifc_language_get(document.ifc.object.value, language) == value) return;
        document.ifc.object.value = ifc_language_set(document.ifc.object.value, value, language);
        value                     = "<?php echo(q(CMS_ACTIVE_URL) .
                                    "?ifc_page=" . rq(CMS_IFC_PAGE) .
                                    "&ifc_message=display" .
                                    "&object=");?>" + value;
        if (document.getElementById) document.getElementById("download-display").src = value;
};
</script>
<?php

ifc_table_open();
echo("<colgroup>" .
     "<col style=\"WIDTH:1px\">" .
     "<col>" .
     "</colgroup>" .

     "<tr>" .
     "<td class=\"varied2\">");

//category
$ifc->set(CMS_L_IFC_DOWNLOAD_003, "description b");
echo("<select onchange=\"if (this.selectedIndex != -1) " .
             "ifc_post('select',this[this.selectedIndex].value);\">");
$flag = NULL;
reset($array);
while (list($key, $value) = each($array))
{
        $name  = strabridge($key, 40);
        $value = is_array($value) ? current($value) : NULL;
        echo("<option value=\"" . x($value) . "\"" .
                      (streq($key, $category) ? " selected>" : ">") .
             whitechartostring(x($name), "&nbsp;") .
             ($flag ? NULL : str_repeat("&nbsp;", 40 - utf8_strlen($name))) .
             "</option>");
        $flag  = TRUE;
};
echo("</select>");

//list
if (is_array($array[$category]))
{
        echo("<br>");

        $ifc->set(CMS_L_IFC_DOWNLOAD_007, "description b");
        echo("<select name=\"_object[]\" " .
                     "size=\"15\" " .
                     "multiple " .
                     "onchange=\"if (this.selectedIndex != -1) " .
                     "download_select(this[this.selectedIndex].value);\" " .
                     "ondblclick=\"ifc_return();\">");
        $flag = NULL;
        reset($array[$category]);
        while (list($key, $value) = each($array[$category]))
        {
                $name = strabridge($key, 40);
                echo("<option value=\"" . x($value) . "\"" .
                              (streq($value, $_object) ? " selected>" : ">") .
                     whitechartostring(x($name), "&nbsp;") .
                     ($flag ? NULL : str_repeat("&nbsp;", 40 - utf8_strlen($name))) .
                     "</option>");
                $flag = TRUE;
        };
        echo("</select>");
};

//language
if (CMS_IFC_SELECT && CMS_LANGUAGE_ENABLED)
{
        echo("<div class=\"language\">" .
             "<a href=\"javascript:ifc_post('select_language','');\" " .
                "class=\"language-" . (streq($language, "") ? "on" : "off") . "\">" .
             image("language/default_small", 16, 12, CMS_L_LANGUAGE_DEFAULT) .
             "</a>");

        $_language = explode(",", CMS_LANGUAGE_ENABLED);

        reset($_language);
        while (list(, $value) = each($_language))
                echo("<a href=\"javascript:ifc_post('select_language','" . rqx($value) . "');\" " .
                        "class=\"language-" . (streq($language, $value) ? "on" : "off") . "\">" .
                     image(is_file(CMS_DATA_PATH . "language/" . $value . "_small.gif") ?
                           CMS_DATA_URL . "language/" . $value . "_small.gif" :
                           "language/default_small",
                           16, 12, $value) .
                     "</a>");

        echo("</div>");
};
echo("</td>");

//display download
if ($_object)
        $_object = CMS_ACTIVE_URL .
                   "?ifc_page=" . r(CMS_IFC_PAGE) .
                   "&ifc_message=display" .
                   "&object=" . r($_object);
else
        $_object = CMS_URL . "blank.htm";

echo("<td class=\"iframe\">" .
     "<iframe id=\"download-display\" " .
             "src=\"" . x($_object) . "\">" .
     CMS_L_IFC_DOWNLOAD_004 .
     "</iframe>" .
     "</td>" .
     "</tr>");
ifc_table_close();

$ifc->close();
?>