<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< MODULE >========================================================================================
//-----------------------------------------------------------------------------------------------------
if (! cms_load("content"))   ifc_inactive($ifc_page);
if (! cms_load("directory")) ifc_inactive($ifc_page);
if (! cms_load("template"))  ifc_inactive($ifc_page);

$content = new content();
if (! $content->enabled) ifc_inactive($ifc_page);

if (! isset($object)) $object = cms_cache("directory." . CMS_USER . ".object");
if (! isset($target)) $target = NULL;

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = $ifc_param;
        break;

case "add":
//.....................................................................................................
        $ifc_param  = $object;
        $ifc_param1 = CMS_L_IFC_EASYPAGE_007;
        $ifc_param2 = cms_cache("directory." . CMS_USER . ".hidden") ? TRUE : NULL;
        $ifc_param3 = (string)cms_cache("template." . CMS_USER . ".page");

case "add_target":
//.....................................................................................................
        $data     = new data("#system/directory");
        $flexview = new flexview();

        $flexview->import_data($data);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       array(CMS_L_COMMAND_CANCEL . "|easypage/command_cancel" => FALSE),
                       array("object" => $object),
                       NULL,
                       CMS_L_COMMAND_ADD);

        //javascript
?>
<script>
function easypage_template_preview()
{
        var value = ifc_value("ifc_param3");
        if (value) load_page("<?php echo(q(CMS_ACTIVE_URL) . "?ifc_page=" . rq(CMS_IFC_PAGE));?>" +
                             "&ifc_message=template_preview&object=" + encodeURIComponent(value));
};
</script>
<?php

        ifc_table_open();
        echo("<colgroup>" .
             "<col style=\"WIDTH:1px\">" .
             "<col>" .
             "</colgroup>" .

             "<tr>" .

        //data
             "<th>" .
             CMS_L_IFC_EASYPAGE_003 .
             "</th>" .

        //target
             "<th>" .
             CMS_L_IFC_EASYPAGE_006 .
             "</th>" .
             "</tr>" .
             "<tr>" .

        //data
             "<td class=\"varied\">");
        $ifc->set(CMS_L_IFC_EASYPAGE_022,    "info b");

        //title
        $ifc->set(CMS_L_IFC_EASYPAGE_009,    "text 50 256 bl",   $ifc_param1);

        //hidden
        $ifc->set(CMS_L_IFC_EASYPAGE_011,    "checkbox b", TRUE, isset($ifc_param2));

        //template
        $ifc->set(CMS_L_IFC_EASYPAGE_015,    "label");
        $ifc->set(content_template_select(), "select 40",        $ifc_param3);
        $ifc->set(CMS_L_COMMAND_SHOW,        "button",           "javascript:easypage_template_preview();");
        echo("</td>" .

        //target
             "<td class=\"target\">");
        $ifc->set(CMS_L_IFC_EASYPAGE_021,    "info b");
        $flexview->set_encoding_function(__NAMESPACE__ . "\\qr");
        $flexview->set_display_function(__NAMESPACE__ . "\\directory_flexview_display_function");
        $flexview->show_target($ifc_param,
                               "javascript:ifc_post('add_target','%index%');",
                               "javascript:ifc_post('add_insert','%index%');",
                               "javascript:ifc_post('add_append','%index%');");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        $ifc->close();

case "add_insert":
case "add_append":
//.....................................................................................................

        //set name if none is given
        if (! language_get($ifc_param1, FALSE))
                $ifc_param1 = language_set($ifc_param1, CMS_L_UNKNOWN, FALSE);

        $content->writer = TRUE; //temporary permission

        //create
        if ($index = $content->create($ifc_param1, $ifc_param3))
        {
                //temporary permission
                $content->editor    = TRUE;
                $content->publisher = TRUE;

                //publish, implies authorisation
                if (($index = $content->publish($index,                     //index
                                                NULL,                       //comment
                                                0,                          //time_publish
                                                0,                          //time_withdraw
                                                $ifc_param,                 //directory_index
                                                substr(CMS_IFC_MESSAGE, 4), //directory_action
                                                $ifc_param1))               //directory_title
                     !== FALSE)
                {
                        //link publication
                        $object    = $index;
                        $directory = new directory();

                        $directory->data->set(isset($ifc_param2), $object, "hidden");
                        $directory->data->del($object, "placeholder");

                        if ($directory->data->save())
                        {
                                cms_cache("directory." . CMS_USER . ".hidden", isset($ifc_param2), TRUE);
                                cms_cache("template." . CMS_USER . ".page",    $ifc_param3, TRUE);
                                $ifc_response = CMS_MSG_DONE;
                                break;
                        };
                };
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "save":
//.....................................................................................................
        $directory = new directory();

        $directory->data->set($ifc_param1,        $object, "name");
        $directory->data->set(isset($ifc_param2), $object, "hidden");
        $directory->data->set($ifc_param3,        $object, "description");

        if ($directory->save())
        {
                //set name if none is given
                if (! language_get($ifc_param1, FALSE))
                        $ifc_param1 = language_set($ifc_param1, CMS_L_UNKNOWN, FALSE);

                $url = $directory->data->get($object, "url");

                //entry links content
                if (streq(substr($url, 0, 10), "content://"))
                {
                        //get content index
                        $index = substr($url, 10);
                        $index = substr($index, 0, strspn($index, "1234567890"));
                        $index = sqlesc($index);

                        //retrieve linked content from database
                        if (
                             ($result = mysql_query("SELECT COUNT(*) " .
                                                    "FROM " . CMS_DB_CONTENT . " " .
                                                    "WHERE " .  CMS_DB_CONTENT_INDEX . "='$index' " .
                                                    "LIMIT 1"))
                             &&
                             mysql_result($result, 0)
                           )
                        {
                                $ifc_param1 = sqlesc($ifc_param1);
                                $ifc_param3 = sqlesc($ifc_param3);
                                $ifc_param4 = sqlesc($ifc_param4);

                                //update linked content
                                mysql_query("UPDATE " . CMS_DB_CONTENT . " " .
                                            "SET " .    CMS_DB_CONTENT_TITLE .              "='$ifc_param1', " .
                                                        CMS_DB_CONTENT_DESCRIPTION .        "='$ifc_param3', " .
                                                        CMS_DB_CONTENT_KEYWORD .            "='$ifc_param4', " .
                                                        CMS_DB_CONTENT_BUFFER_TITLE .       "='$ifc_param1', " .
                                                        CMS_DB_CONTENT_BUFFER_DESCRIPTION . "='$ifc_param3', " .
                                                        CMS_DB_CONTENT_BUFFER_KEYWORD .     "='$ifc_param4' " .
                                            "WHERE " .  CMS_DB_CONTENT_INDEX .              "='$index' " .
                                            "LIMIT 1");
                        };
                };

                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "delete":
//.....................................................................................................
        $directory      = new directory();
        $_object        = $directory->data->move("parent", $object);
        $array_document = NULL;
        $array_schedule = NULL;
        $depth          = 0;
        $error          = FALSE;

        //collect linked content and schedules in directory branch
        $key = $directory->data->move("to", $object);
        do
        {
                $type = $directory->data->get($key, "#type");
                switch ($type)
                {
                case "container":
                        $depth++;

                default:
                        $url = $directory->data->get($key, "url");
                        if (streq(substr($url, 0, 10), "content://"))
                        {
                                //get content index
                                $index = substr($url, 10);
                                $index = substr($index, 0, strspn($index, "1234567890"));

                                $array_document[$index]       = TRUE;
                                $array_schedule[sqlesc($key)] = TRUE;
                        };
                        break;

                case "/container":
                        if (--$depth <= 0) break 2;
                        break;
                };
        }
        while ($key = $directory->data->move("next"));

        //delete branch
        $directory->data->del($object);
        $error |= ! $directory->save();

        //go through directory tree and remove linked content from collection
        if (is_array($array_document))
        {
                $directory->data->move("first");
                while ($key = $directory->data->move("next"))
                {
                        $type = $directory->data->get($key, "#type");
                        if (streq($type, "/container")) continue; //skip closing containers

                        $url  = $directory->data->get($key, "url");
                        if (streq(substr($url, 0, 10), "content://"))
                        {
                                //get content index
                                $index = substr($url, 10);
                                $index = substr($index, 0, strspn($index, "1234567890"));

                                //collection match
                                if (isset($array_document[$index]))
                                        unset($array_document[$index]); //remove
                        };
                };

                //go through remaining content and delete entries from database
                if (count($array_document))
                {
                        $content->publisher = TRUE; //temporary permission

                        reset($array_document);
                        while (list($key) = each($array_document))
                                $error |= ! $content->delete($key, TRUE);
                };
        };

        //delete schedule entries
        if (is_array($array_schedule))
                $error |= ! mysql_query("DELETE FROM " . CMS_DB_CONTENT_SCHEDULE . " " .
                                        "WHERE " .       CMS_DB_CONTENT_SCHEDULE_TYPE . " " .
                                        "IN ('" .        CMS_CONTENT_SCHEDULE_TYPE_PUBLISH . "', " .
                                        "'" .            CMS_CONTENT_SCHEDULE_TYPE_WITHDRAW . "') " .
                                        "AND " .         CMS_DB_CONTENT_SCHEDULE_VALUE_1 . " " .
                                        "IN ('" .        implode("', '", array_keys($array_schedule)) . "')");

        $object       = $_object;
        $ifc_response = $error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "cut":
//.....................................................................................................
        $target = $object;
        break;

case "target":
//.....................................................................................................
        $target = $ifc_param;
        break;

case "insert":
case "append":
//.....................................................................................................
        $directory = new directory();

        //target may not be below selected entry
        if (! $directory->data->is_child($ifc_param, $object))
        {
                //cut and paste
                $directory->data->cut($object);
                $_object = streq(CMS_IFC_MESSAGE, "append") ?
                           $directory->data->append($ifc_param) :
                           $directory->data->insert($ifc_param);

                if ($directory->save())
                {
                        $object       = $_object;
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "template_preview":
//.....................................................................................................
        template_preview($object);
        exit();
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array("" => CMS_L_ACCESS));

//cache selected object permanently
if (CMS_IFC_MESSAGE !== "") cms_cache("directory." . CMS_USER . ".object", $object, TRUE);

$data     = new data("#system/directory");
$flexview = new flexview();

$flexview->import_data($data);

//menu
$menu = array(CMS_L_COMMAND_ADD . "|easypage/command_create" => "add");
$mark = NULL;
if ($object)
{
        $url         = $data->get($object, "url");
        $description = $data->get($object, "description");
        $flag        = FALSE;

        if (streq(substr($url, 0, 10), "content://"))
        {
                //get content index
                $index = substr($url, 10);
                $index = substr($index, 0, strspn($index, "1234567890"));

                //retrieve keywords from database
                if (
                     ($result = mysql_query("SELECT " . CMS_DB_CONTENT_KEYWORD . " " .
                                            "FROM " .   CMS_DB_CONTENT . " " .
                                            "WHERE " .  CMS_DB_CONTENT_INDEX . "='" . sqlesc($index) . "' " .
                                            "LIMIT 1"))
                     &&
                     ($resultrow = mysql_fetch_assoc($result))
                   )
                {
                        $flag    = TRUE;
                        $keyword = $resultrow[CMS_DB_CONTENT_KEYWORD];
                };

                //only linked content may be deleted
                $menu[CMS_L_COMMAND_DELETE . "|easypage/command_delete"] = "#delete";
        };

        $menu[CMS_L_COMMAND_CUT . "|easypage/command_cut"] = "cut";
        if ($target) $mark[$object] = "easypage/icon_cut";
};

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object" => $object));

echo("<table class=\"layout\" " .
            "style=\"WIDTH:100%\">" .

     "<colgroup>" .
     "<col>");
if ($target)
        echo("<col style=\"WIDTH:1px\">" .
             "<col style=\"WIDTH:200px\">");
if ($object)
        echo("<col span=\"2\" " .
                  "style=\"WIDTH:1px\">");
echo("</colgroup>" .

     "<tr>" .
     "<td>");

ifc_table_open();

//header
echo("<tr>" .
     "<th>" .
     CMS_L_IFC_EASYPAGE_001 .
     "</th>" .
     "</tr>" .

//add button
     "<tr>" .
     "<td class=\"highlight2\">" .
     "<a href=\"javascript:ifc_post('add');\">" .
     "[...]" .
     "</a>" .
     "</td>" .
     "</tr>" .

//directory
     "<tr>" .
     "<td class=\"varied2\">");
$ifc->set(CMS_L_IFC_EASYPAGE_010, "info b");
$flexview->set_encoding_function(__NAMESPACE__ . "\\qr");
$flexview->set_display_function(__NAMESPACE__ . "\\directory_flexview_display_function");
$flexview->show_tree($object,
                     "javascript:ifc_post('select','%index%');",
                     "name",
                     $mark);
echo("</td>" .
     "</tr>");
ifc_table_close();

echo("</td>");

if ($target)
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //target
             "<td>");

        ifc_table_open();

        //header
        echo("<tr>" .
             "<th>" .
             CMS_L_COMMAND_CUT .
             "</th>" .
             "</tr>" .

        //target
             "<tr>" .
             "<td class=\"target\">");
        $flexview->show_target($target,
                               "javascript:ifc_post('target','%index%');",
                               "javascript:ifc_post('insert','%index%');",
                               "javascript:ifc_post('append','%index%');");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");
};

if ($object)
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //data
             "<td>");

        ifc_table_open();

        //header
        echo("<tr>" .
             "<th>" .
             CMS_L_IFC_EASYPAGE_002 .
             "</th>" .
             "</tr>" .

        //settings
             "<tr>" .
             "<td class=\"varied\">");
        $ifc->set(CMS_L_IFC_EASYPAGE_008, "info b");

        //name
        $ifc->set(CMS_L_IFC_EASYPAGE_009, "text 50 256 bl",             $data->get($object, "name"));

        echo("<div style=\"FLOAT:right\">");

        //save button
        $url = translate_url("directory://$object",
                             array("content_option" => CMS_TEMPLATE_OPTION_ALL,
                                   "cms_instance"   => NULL));

        $ifc->set(CMS_L_COMMAND_EDIT,     "button",                     "javascript:load_page('" . q($url) . "');");

        //edit button
        $ifc->set(CMS_L_COMMAND_SAVE,     "button b",                   "save");

        echo("</div>");

        //hidden
        $ifc->set(CMS_L_IFC_EASYPAGE_011, "checkbox b", TRUE,           $data->get($object, "hidden"));

        //description
        $ifc->set(CMS_L_IFC_EASYPAGE_012, "texteditor 50x8 2048 bilrt", $description);

        //keywords
        if ($flag) $ifc->set(CMS_L_IFC_EASYPAGE_005, "text 50 256 l",   $keyword);
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");
};
echo("</tr>" .
     "</table>");

$ifc->close();
?>