<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (! cms_load("image")) ifc_inactive($ifc_page);

if (empty($object))     $object   = cms_cache("image." . CMS_USER . ".object");
if (! isset($language)) $language = NULL;

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = language_set($object, $ifc_param, $language);
        break;

case "select_language":
//.....................................................................................................
        $language = $ifc_param;
        break;

case "display":
//.....................................................................................................
        if ($object)
        {
                cms_cache("image." . CMS_USER . ".object", $object, TRUE);
                //header("Location: " . translate_url($object));
                $image  = translate_url($object);
                $_image = image_process($image, 600);

                echo(CMS_DOCTYPE_HTML .
                     "<html>" .
                     "<head>" .
                     "<title>" . CMS_L_IFC_IMAGE_005 . "</title>" .
                     "</head>" .
                     "<body>" .
                     "<a href=\"" . x($image) . "\" " .
                        "onclick=\"window.open(this.href);return false;\">" .
                     "<img src=\"" . x($_image) . "\" " .
                          "alt=\"" . CMS_L_IFC_IMAGE_005 . "\" " .
                          "style=\"MAX-WIDTH:100%\">" .
                     "</a>" .
                     "</body>" .
                     "</html>");
        };

        exit();

case "upload":
//.....................................................................................................
        $image    = new image();
        $_object  = language_get($object, $language, TRUE);
        $category = $image->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_upload",
                       CMS_L_IFC_IMAGE_001);

        //name
        $ifc->set(CMS_L_NAME,                               "text 40 40 bl");

        //file
        $ifc->set(CMS_L_IFC_IMAGE_002 . " (GIF, JPG, PNG)", "file b");

        //category
        $ifc->set(CMS_L_IFC_IMAGE_014,                      "title");
        $ifc->set(CMS_L_IFC_IMAGE_009,                      "text 40 40 b");
        $ifc->set(CMS_L_IFC_IMAGE_003,                      "label");
        $ifc->set(image_get_select(),                       "select 40 b", $category);

        //filename
        $ifc->set(CMS_L_IFC_IMAGE_015,                      "title");
        $ifc->set(CMS_L_IFC_IMAGE_013,                      "text 35 40");
        echo(".ext");

//javascript
?>
<script>
ifc_get_object("ifc_file1").click();
</script>
<?php

        $ifc->close();

case "_upload":
//.....................................................................................................
        if (isset($ifc_file1_name))
        {
                $image = new image();

                if ($_object = $image->add($ifc_file1,                              //uploaded file
                                           $ifc_file1_name,                         //uploaded filename
                                           $ifc_param1,                             //name
                                           $ifc_param2 ? $ifc_param2 : $ifc_param3, //category
                                           $ifc_param4))                            //filename
                {
                        $object       = language_set($object, $_object, $language);
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "upload_multi":
//.....................................................................................................
        $image    = new image();
        $_object  = language_get($object, $language, TRUE);
        $category = $image->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_upload_multi",
                       CMS_L_IFC_IMAGE_016);

        //info
        $ifc->set(CMS_L_IFC_IMAGE_017,                      "info b");

        //file
        $ifc->set(CMS_L_IFC_IMAGE_002 . " (GIF, JPG, PNG)", "multifile b");

        //category
        $ifc->set(CMS_L_IFC_IMAGE_014,                      "title");
        $ifc->set(CMS_L_IFC_IMAGE_009,                      "text 40 40 b");
        $ifc->set(CMS_L_IFC_IMAGE_003,                      "label");
        $ifc->set(image_get_select(),                       "select 40 b", $category);

//javascript
?>
<script>
ifc_get_object("ifc_file1[]").click();
</script>
<?php

        $ifc->close();

case "_upload_multi":
//.....................................................................................................
        if (is_array($ifc_file1)) $array = array_combine($ifc_file1, $ifc_file1_name);
        else                      $array = array($ifc_file1 => $ifc_file1_name);

        $image   = new image();
        $_object = "";
        $error   = FALSE;

        reset($array);
        while (list($key, $value) = each($array))
        {
                if ($__object = $image->add($key,                                     //uploaded file
                                            $value,                                   //uploaded filename
                                            NULL,                                     //name
                                            $ifc_param1 ? $ifc_param1 : $ifc_param2)) //category
                        $_object = $__object;
                else
                        $error   = TRUE;
        };

        $object       = language_set($object, $_object, $language);
        $ifc_response = $error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "add":
case "edit":
//.....................................................................................................
        $image   = new image();
        $_object = language_get($object, $language, TRUE);

        $flag    = NULL;
        if (streq(CMS_IFC_MESSAGE, "edit"))
        {
                $ifc_param1 = $image->data->get($_object, "name");
                $ifc_param2 = $image->data->get($_object, "url");
                $flag       = $image->internal($_object);
        };

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_" . CMS_IFC_MESSAGE,
                       streq(CMS_IFC_MESSAGE, "add") ? CMS_L_COMMAND_ADD : CMS_L_COMMAND_EDIT);

        //name
        $ifc->set(CMS_L_NAME,           "text 40 40 bl", isset($ifc_param1) ? $ifc_param1 : NULL);

        //url
        if ($flag) $ifc->dummy();
        else       $ifc->set(CMS_L_URL, "text 40 256 b", isset($ifc_param2) ? $ifc_param2 : "http://");

        //category
        $ifc->set(CMS_L_IFC_IMAGE_014,  "title");
        $ifc->set(CMS_L_IFC_IMAGE_009,  "text 40 40 b",  isset($ifc_param3) ? $ifc_param3 : NULL);
        $ifc->set(CMS_L_IFC_IMAGE_003,  "label");
        $ifc->set(image_get_select(),   "select 40",     $image->data->get($_object, "category"));

        if ($flag)
        {
                //extract extension and filename
                $filename  = $image->data->get($_object, "filename");
                if ($filename === NULL) $filename = substr($_object, 8);
                $extension = utf8_strtolower(strrchr($filename, "."));
                $filename  = substr($filename, 0, -strlen($extension));

                //filename
                $ifc->set(CMS_L_IFC_IMAGE_015, "title");
                $ifc->set(CMS_L_IFC_IMAGE_013, "text 35 40", $filename);
                echo(x($extension));
        };

        $ifc->close();

case "_add":
//.....................................................................................................
        $image = new image();

        if ($_object = $image->link($ifc_param2,                              //url
                                    $ifc_param1,                              //name
                                    $ifc_param3 ? $ifc_param3 : $ifc_param4)) //category
        {
                $object       = language_set($object, $_object, $language);
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "_edit":
//.....................................................................................................
        $image   = new image();
        $_object = language_get($object, $language, TRUE);
        $flag    = $image->internal($_object); //internal

        if ($_object = $image->set($_object,                                 //index
                                   $ifc_param1,                              //name
                                   $ifc_param3 ? $ifc_param3 : $ifc_param4,  //category
                                   $flag       ? $ifc_param5 : $ifc_param2)) //filename or url
        {
                $object       = language_set($object, $_object, $language);
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "replace":
//.....................................................................................................
        $image   = new image();
        $_object = language_get($object, $language, TRUE);

        //external
        if (! $image->internal($_object))
        {
                $ifc_response = CMS_L_IFC_IMAGE_012;
                break;
        };

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_replace",
                       CMS_L_IFC_IMAGE_008);

        //file
        $ifc->set(CMS_L_IFC_IMAGE_002, "file");

//javascript
?>
<script>
ifc_autopost("ifc_file1", "_replace");
ifc_get_object("ifc_file1").click();
</script>
<?php

        $ifc->close();

case "_replace":
//.....................................................................................................
        if (isset($ifc_file1_name))
        {
                $image        = new image();
                $_object      = language_get($object, $language, TRUE);
                $ifc_response = $image->replace($_object,          //index
                                                $ifc_file1,        //file
                                                $ifc_file1_name) ? //filename
                                CMS_MSG_DONE : CMS_MSG_ERROR;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "delete":
//.....................................................................................................
        if (empty($_object)) break; //no selection

        reset($_object);
        list(, $value) = each($_object);

        $image      = new image();
        $category   = $image->data->get($value, "category");
        $flag_error = TRUE;

        //delete selected images
        do
        {
                $flag_error &= ! $image->unlink($value);
        }
        while (list(, $value) = each($_object));

        //remove invalid image links from selection
        $array = explode(",", CMS_LANGUAGE_ENABLED);
        if (CMS_LANGUAGE_ENABLED) $array[] = FALSE;

        reset($array);
        while (list(, $value) = each($array))
        {
                $_object = language_get($object, $value, TRUE);

                if (! $image->data->get($_object))
                {
                        //active language
                        if (streq($value, $language))
                        {
                                $image->data->move("first");
                                $_object = $image->data->seek(array("category" => $category));
                                $object  = language_set($object, $_object, $value);
                        }

                        //inactive language(s)
                        else
                        {
                                $object  = language_set($object, NULL, $value);
                        };
                };
        };

        $ifc_response = $flag_error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "category_rename":
//.....................................................................................................
        $image    = new image();
        $_object  = language_get($object, $language, TRUE);
        $category = $image->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_category_rename",
                       CMS_L_IFC_IMAGE_010);

        //category
        $ifc->set(CMS_L_NAME, "text 40 40", $category);

        $ifc->close();

case "_category_rename":
//.....................................................................................................
        $image    = new image();
        $_object  = language_get($object, $language, TRUE);
        $category = $image->data->get($_object, "category");

        $image->data->move("first");
        while ($key = $image->data->move("next"))
        {
                $_category = $image->data->get($key, "category");
                if (streq($_category, $category))
                        $image->data->set($ifc_param1, $key, "category");
        };

        $ifc_response = $image->data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "clear_cache":
//.....................................................................................................
        $image = new image();

        if (

        //verify permission
             $image->operator
             &&

        //delete cache
             cms_load("filemanager")
             &&
             (
               (! is_dir(CMS_DATA_PATH . "image/cache"))
               ||
               filemanager_delete(CMS_DATA_PATH . "image/cache")
             )
             &&
             (
               (! is_dir(CMS_DATA_PATH . "#content/cache"))
               ||
               filemanager_delete(CMS_DATA_PATH . "#content/cache")
             )
           )
        {
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array(""                            => CMS_L_ACCESS,
                     CMS_IMAGE_PERMISSION_OPERATOR => CMS_L_OPERATOR));

$image   = new image();
$_object = language_get($object, $language, TRUE);
$array   = image_get_array();

//get category from object
if (nstre($_object) && in_array_recursive($_object, $array))
{
        $category = $image->data->get($_object, "category");
        if ($category === NULL) $category = "";
        cms_cache("image." . CMS_USER . ".category", $category, TRUE);
}

//get object from category
else
{
        $category = cms_cache("image." . CMS_USER . ".category");
        if ((! $category) || (! isset($array[$category]))) $category = "";

        if (is_array($array[$category]))
        {
                $_object = current($array[$category]);
                $object  = language_set($object, $_object, $language);
        };
};

//menu
$menu = NULL;
if (CMS_IFC_SELECT && $_object)
        $menu[CMS_L_COMMAND_INSERT . "|image/command_apply"]       = "javascript:ifc_return();";
if ($image->operator)
{
        $menu[CMS_L_COMMAND_ADD .   "|image/command_add"]          = "add";
        $menu[CMS_L_IFC_IMAGE_001 . "|image/command_upload"]       = "upload";
        $menu[CMS_L_IFC_IMAGE_016 . "|image/command_upload_multi"] = "upload_multi";
        if ($_object)
        {
                $menu[CMS_L_COMMAND_EDIT .   "|image/command_edit"]      = "edit";
                $menu[CMS_L_IFC_IMAGE_008 .  "|image/command_overwrite"] = "replace";
                $menu[CMS_L_COMMAND_DELETE . "|image/command_delete"]    = "#delete";
                $menu[CMS_L_IFC_IMAGE_010 .  "|image/command_rename"]    = "category_rename";
        };
        $menu[CMS_L_IFC_IMAGE_011 . "|image/command_clear"]        = "clear_cache";
};

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object"   => $object,
                     "language" => $language));

//javascript
?>
<script>
function image_select(value)
{
        var language              = "<?php echo(q($language));?>";
        if (ifc_language_get(document.ifc.object.value, language) == value) return;
        document.ifc.object.value = ifc_language_set(document.ifc.object.value, value, language);
        if (document.getElementById)
                document.getElementById("image-display").src =
                        "<?php echo(q(CMS_ACTIVE_URL) . "?ifc_page=" . rq(CMS_IFC_PAGE));?>" +
                        "&ifc_message=display&object=" + encodeURIComponent(value);
};
</script>
<?php

ifc_table_open();
echo("<colgroup>" .
     "<col style=\"WIDTH:1px\">" .
     "<col>" .
     "</colgroup>" .

     "<tr>" .
     "<td class=\"varied2\">");

//category
$ifc->set(CMS_L_IFC_IMAGE_014, "description b");
echo("<select onchange=\"if (this.selectedIndex != -1) " .
             "ifc_post('select',this[this.selectedIndex].value);\">");
$flag = NULL;
reset($array);
while (list($key, $value) = each($array))
{
        $name  = strabridge($key, 40);
        $value = is_array($value) ? current($value) : NULL;
        echo("<option value=\"" . x($value) . "\"" .
                      (streq($key, $category) ? " selected>" : ">") .
             whitechartostring(x($name), "&nbsp;") .
             ($flag ? NULL : str_repeat("&nbsp;", 40 - utf8_strlen($name))) .
             "</option>");
        $flag  = TRUE;
};
echo("</select>");

//list
if ($flag = is_array($array[$category]))
{
        echo("<br>");

        $ifc->set(CMS_L_IFC_IMAGE_007, "description b");
        echo("<select name=\"_object[]\" " .
                     "size=\"9\" " .
                     "multiple " .
                     "onchange=\"if (this.selectedIndex != -1) " .
                     "image_select(this[this.selectedIndex].value);\" " .
                     "ondblclick=\"ifc_return();\">");
        $_flag = NULL;
        reset($array[$category]);
        while (list($key, $value) = each($array[$category]))
        {
                $name   = strabridge($key, 32);
                $_image = image_process(translate_url($value), 54, 40);
                echo("<option value=\"" . x($value) . "\" " .
                              option(streq($value, $_object), "selected ") .
                             "class=\"image-list\" " .
                             "style=\"BACKGROUND-IMAGE:url(" . x($_image) . ");\">" .
                     x($name) .
                     ($_flag ? "" : str_repeat("&nbsp;", 32 - utf8_strlen($name))) .
                     "</option>");
                $_flag = TRUE;
        };
        echo("</select>");
};

//language
if (CMS_IFC_SELECT && CMS_LANGUAGE_ENABLED)
{
        echo("<div class=\"language\">" .
             "<a href=\"javascript:ifc_post('select_language','');\" " .
                "class=\"language-" . (streq($language, "") ? "on" : "off") . "\">" .
             image("language/default_small", 16, 12, CMS_L_LANGUAGE_DEFAULT) .
             "</a>");

        $_language = explode(",", CMS_LANGUAGE_ENABLED);

        reset($_language);
        while (list(, $value) = each($_language))
                echo("<a href=\"javascript:ifc_post('select_language','" . rqx($value) . "');\" " .
                        "class=\"language-" . (streq($language, $value) ? "on" : "off") . "\">" .
                     image(is_file(CMS_DATA_PATH . "language/" . $value . "_small.gif") ?
                           CMS_DATA_URL . "language/" . $value . "_small.gif" :
                           "language/default_small",
                           16, 12, $value) .
                     "</a>");

        echo("</div>");
};
echo("</td>" .

//display image
     "<td class=\"iframe\">" .
     "<iframe id=\"image-display\" " .
             "src=\"" . x(CMS_ACTIVE_URL) .
             "?ifc_page=" . r(CMS_IFC_PAGE) .
             "&amp;ifc_message=display" .
             "&amp;object=" . r($_object) . "\">" .
     CMS_L_IFC_IMAGE_004 .
     "</iframe>" .
     "</td>" .
     "</tr>");
ifc_table_close();

$ifc->close();
?>
