<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (! isset($object)) $object = (string)cms_cache("insert." . CMS_USER . ".object");
if (! isset($list))   $list   = preg_match("/^(?:|ifc_)/", CMS_IFC_MESSAGE) ? array($object) : array();

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "insert":
case "insert_select":
case "insert_display":
case "insert_add":
case "insert_save":
case "insert_delete":
//.....................................................................................................
        if (empty($insert_object)) $insert_object = "";

        $data = new data("#system/insert.code");

        switch (CMS_IFC_MESSAGE)
        {
        case "insert_select":
//.....................................................................................................
                $insert_object = $ifc_param;
                break;

        case "insert_display":
//.....................................................................................................
                $code = l($data->get($insert_object, "code"));

                echo(CMS_DOCTYPE_HTML .
                     "<html>" .
                     "<head>" .
                     CMS_HTML_HEADER . CMS_JAVASCRIPT . CMS_STYLESHEET .
                     "</head>" .
                     "<body>" .
                     "<div>" .
                     ($data->get($insert_object, "html") ? $code : parse_text($code)) .
                     "</div>" .
                     "</body>" .
                     "</html>");

                exit();

        case "insert_add":
//.....................................................................................................

                //create new entry at top
                $data->set_buffer(array(array("name" => CMS_L_IFC_INSERT_002)));
                $_insert_object = $data->append();

                if ($data->save())
                {
                        $insert_object = $_insert_object;
                        $ifc_response  = CMS_MSG_DONE;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR;
                break;

        case "insert_save":
//.....................................................................................................

                //keep name if none is given
                if (stre($ifc_param1 = utf8_trim($ifc_param1)))
                        $ifc_param1 = $data->get($insert_object, "name");

                $data->set(array("name" => $ifc_param1,
                                 "html" => isset($ifc_param2),
                                 "code" => $ifc_param3),
                           $insert_object);

                $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
                break;

        case "insert_delete":
//.....................................................................................................
                if (empty($_list)) break; //no selection

                reset($_list);
                while (list(, $value) = each($_list)) $data->del($value);

                if ($data->save())
                {
                        //remove deleted objects from positions
                        $data_insert = new data("#system/insert");

                        $data_insert->move("first");
                        while ($key = $data_insert->move("next"))
                        {
                                $_key = $data_insert->get($key, "insert");
                                if ($data->get($_key) === NULL) $data_insert->del($key, "insert");
                        };

                        $data_insert->save();

                        //deselect object if deleted
                        if (in_array($insert_object, $_list)) $insert_object = "";

                        $ifc_response = CMS_MSG_DONE;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR;
                break;
        };

        //menu
        $menu = array(CMS_L_COMMAND_ADD .    "|insert/command_add"    => "insert_add",
                      CMS_L_COMMAND_DELETE . "|insert/command_delete" => "#insert_delete",
                      CMS_L_COMMAND_CLOSE .  "|insert/command_cancel" => NULL);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       $menu,
                       array("object"        => $object,
                             "list"          => $list,
                             "insert_object" => $insert_object),
                       NULL,
                       CMS_L_IFC_INSERT_004);

        echo("<table class=\"layout\" " .
                    "style=\"WIDTH:100%\">" .

             "<colgroup>" .
             "<col>");
        if (nstre($insert_object))
                echo("<col span=\"2\" " .
                          "style=\"WIDTH:1px\">");
        echo("</colgroup>" .

             "<tr>" .
             "<td>");

        ifc_table_open();
        echo("<colgroup>" .
             "<col style=\"WIDTH:1px\">" .
             "<col>" .
             "</colgroup>" .

        //header
             "<tr>" .

        //selection
             "<td rowspan=\"2\" " .
                 "class=\"highlight\">" .
             "&nbsp;" .
             "</td>" .

        //name
             "<th>" .
             CMS_L_IFC_INSERT_004 .
             "</th>" .
             "</tr>" .

        //insert add button
             "<tr>" .
             "<td class=\"highlight2\">" .
             "<a href=\"javascript:ifc_post('insert_add');\">" .
             "[...]" .
             "</a>" .
             "</td>" .
             "</tr>");

        $i = 0;

        $data->move("first");
        while ($key = $data->move("next"))
        {
                $name   = x($data->get($key, "name"));
                if (streq($key, $insert_object)) $name = "<strong>$name</strong>";
                $varied = ifc_varied();

                echo("<tr>" .

                //selection
                     "<td class=\"highlight\">");
                $ifc->set(NULL,
                          "checkbox",
                          $key,
                          streq($key, $insert_object),
                          "_list[" . $i++ . "]");
                echo("</td>" .

                //name
                     "<td$varied>" .
                     "<a href=\"javascript:ifc_post('insert_select','" . rqx($key) . "');\">" .
                     image("insert/icon_insert") . "&nbsp;$name" .
                     "</a>" .
                     "</td>" .
                     "</tr>");
        };

        //selection control
        echo("<tr>" .
             "<td colspan=\"2\" " .
                 "class=\"highlight\" " .
                 "style=\"TEXT-ALIGN:right\">");
        $ifc->set(CMS_L_IFC_INSERT_001, "button", "javascript:ifc_list_activate(\"_list\");");
        $ifc->set(CMS_L_IFC_INSERT_009, "button", "javascript:ifc_list_invert(\"_list\");");
        $ifc->set(CMS_L_IFC_INSERT_010, "button", "javascript:ifc_list_deactivate(\"_list\");");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");

        if (nstre($insert_object))
        {
                //spacer
                echo("<td>" .
                     "&nbsp;" .
                     "</td>" .

                //data
                     "<td>");

                ifc_table_open();

                //header
                echo("<tr>" .
                     "<th>" .
                     CMS_L_IFC_INSERT_005 .
                     "</th>" .
                     "</tr>" .

                //settings
                     "<tr>" .
                     "<td class=\"varied\">");

                //name
                $ifc->set(CMS_L_NAME,           "text 40 80",             $data->get($insert_object, "name"));

                //html
                $ifc->set(CMS_L_IFC_INSERT_006, "checkbox b", TRUE,       $data->get($insert_object, "html"));

                //code
                $ifc->set(CMS_L_IFC_INSERT_007, "texteditor 50x20 bilrt", $data->get($insert_object, "code"));

                //javascript
?>
<script>
function insert_display()
{
        var value = ifc_value("insert_object");
        load_page("<?php echo(q(CMS_ACTIVE_URL));?>" +
                  "?ifc_page=<?php echo(rq(CMS_IFC_PAGE));?>" +
                  "&ifc_message=insert_display" +
                  "&insert_object=" + encodeURIComponent(value));
};
</script>
<?php

                echo("<div style=\"TEXT-ALIGN:right\">");

                //display button
                $ifc->set(CMS_L_COMMAND_SHOW,
                          "button",
                          "javascript:insert_display();");

                //save button
                $ifc->set(CMS_L_COMMAND_SAVE,
                          "button",
                          "insert_save");
                echo("</div>" .
                     "</td>" .
                     "</tr>");
                ifc_table_close();

                echo("</td>");
        };
        echo("</tr>" .
             "</table>");

        $ifc->close();

case "select":
//.....................................................................................................
        $object = $ifc_param;
        $list   = array($object);
        break;

case "_add":
//.....................................................................................................
        if (nstre($ifc_param1 = utf8_trim($ifc_param1)))
        {
                $data  = new data("#system/insert");
                $array = explode(".", "$object.$ifc_param1");
                $value = NULL;

                reset($array);
                while (list(, $_value) = each($array))
                {
                        if (stre($_value)) continue;

                        $__value = $value;
                        if ($value === NULL) $value  = $_value;
                        else                 $value .= ".$_value";

                        if ($data->get($value) === NULL)
                        {
                                $data->buffer = array($value    => array("name"  => $_value,
                                                                         "#type" => "container"),
                                                      "/$value" => array("#type" => "/container"));
                                $data->insert($__value);
                        };
                };

                if ($data->save())
                {
                        $object       = $value;
                        $list         = array($value);
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };
        };

        $ifc_response = CMS_MSG_ERROR;

case "add":
//.....................................................................................................
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object" => $object,
                             "list"   => $list),
                       "_add",
                       CMS_L_COMMAND_ADD);

        $ifc->set(CMS_L_NAME, "text 40 256 b");

        $ifc->close();

case "delete":
//.....................................................................................................
        if (count($list) === 0) break; //no selection;

        $data    = new data("#system/insert");
        $stack   = array();
        $_object = $object;

        //get path to object
        while (($_object = $data->move("parent", $_object)) !== FALSE)
                array_unshift($stack, $_object);
        array_unshift($stack, "");

        //delete
        reset($list);
        while (list(, $value) = each($list))
                $data->del($value);

        if ($data->save())
        {
                //select last existing object in path
                while ($data->get($object) === NULL)
                {
                        $object = array_pop($stack);
                        if (stre($object)) break;
                };

                $list         = array($object);
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "save":
//.....................................................................................................
        $data = new data("#system/insert");

        $data->set($insert_object, $object, "insert");

        $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================

//access permission
ifc_permission(array("" => CMS_L_ACCESS));

//load data
$data = new data("#system/insert");
if ($data->get($object) === NULL) $object = ""; //check selected object

//cache selected object permanently
if (nstre(CMS_IFC_MESSAGE)) cms_cache("insert." . CMS_USER . ".object", $object, TRUE);

//menu
$menu = array(CMS_L_COMMAND_ADD .    "|insert/command_add"    => "add",
              CMS_L_IFC_INSERT_004 . "|insert/command_code"   => "insert",
              CMS_L_COMMAND_DELETE . "|insert/command_delete" => "#delete");

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object" => $object));

echo("<table class=\"layout\" " .
            "style=\"WIDTH:100%\">" .

     "<colgroup>" .
     "<col>");
if (nstre($object))
        echo("<col span=\"2\" " .
                "style=\"WIDTH:1px\">");
echo("</colgroup>" .

     "<tr>" .
     "<td>");

ifc_table_open();

//header
echo("<tr>" .
     "<th>" .
     CMS_L_IFC_INSERT_008 .
     "</th>" .
     "</tr>" .

//add button
     "<tr>" .
     "<td class=\"highlight2\">" .
     "<a href=\"javascript:ifc_post('add');\">" .
     "[...]" .
     "</a>" .
     "</td>" .
     "</tr>" .

//position
     "<tr>" .
     "<td class=\"varied2\">");
$flexview = new flexview();
$flexview->import_data($data);
$flexview->set_encoding_function(__NAMESPACE__ . "\\qr");
$flexview->set_checkbox_identifier("list");
$flexview->set_checkbox_list($list);
$flexview->show_tree($object,                                    //index
                     "javascript:ifc_post('select','%index%');", //action
                     "name");                                    //name key
echo("</td>" .
     "</tr>" .

//selection control
     "<tr>" .
     "<td class=\"highlight\" " .
         "style=\"TEXT-ALIGN:right\">");
$ifc->set(CMS_L_IFC_INSERT_001, "button", "javascript:ifc_list_activate();");
$ifc->set(CMS_L_IFC_INSERT_009, "button", "javascript:ifc_list_invert();");
$ifc->set(CMS_L_IFC_INSERT_010, "button", "javascript:ifc_list_deactivate();");
echo("</td>" .
     "</tr>");
ifc_table_close();

echo("</td>");

//data
if (nstre($object))
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //data
             "<td>");

        ifc_table_open();

        //header
        echo("<tr>" .
             "<th>" .
             CMS_L_IFC_INSERT_005 .
             "</th>" .
             "</tr>" .

        //settings
             "<tr>" .
             "<td class=\"varied\">");

        //collect inserts
        $_data = new data("#system/insert.code");
        $array = array(" " => NULL);

        $_data->move("first");
        while ($key = $_data->move("next"))
        {
                $name  = $_data->get($key, "name");
                $_name = $name;
                $i     = 1;

                while (isset($array[$_name])) $_name = "$name (" . $i++ . ")";

                $array[$_name] = $key;
        };

        //insert selection
        $insert = $data->get($object, "insert");

        $ifc->set(CMS_L_IFC_INSERT_003, "label");
        $ifc->set($array,               "select 40x20 b", $insert, NULL, "insert_object");

        //javascript
?>
<script>
function insert_display()
{
        var value = ifc_value("insert_object");
        if (value == "") return;
        load_page("<?php echo(q(CMS_ACTIVE_URL));?>" +
                  "?ifc_page=<?php echo(rq(CMS_IFC_PAGE));?>" +
                  "&ifc_message=insert_display" +
                  "&insert_object=" + encodeURIComponent(value));
};
</script>
<?php

        echo("<div style=\"TEXT-ALIGN:right\">");

        //display button
        $ifc->set(CMS_L_COMMAND_SHOW,
                  "button",
                  "javascript:insert_display();");

        //save button
        $ifc->set(CMS_L_COMMAND_SAVE,
                  "button",
                  "save");
        echo("</div>" .
             "</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");
};
echo("</tr>" .
     "</table>");

$ifc->close();
?>
