<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (! isset($object)) $object = (string)cms_cache("language." . CMS_USER . ".object");
if (! isset($list))   $list   = array();

$system = new system();
$data   = new data("#system/language");

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = $ifc_param;
        break;

case "add":
//.....................................................................................................
        if (! $data->get("x-undefined"))
                $data->set(array("name" => CMS_L_IFC_LANGUAGE_010), "x-undefined");
        $object       = "x-undefined";
        $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "set":
//.....................................................................................................
        mkpath(CMS_DATA_PATH . "language");

        //tag
        $ifc_param1 = preg_replace("/[^-0-9A-Za-z]+/", "", $ifc_param1);
        $ifc_param1 = strtolower($ifc_param1);

        //no name given, keep current name
        if (stre($ifc_param1))
        {
                $ifc_param1 = $object;
        }

        //name changed
        elseif (nstreq($object, $ifc_param1))
        {
                //delete target icon 1 if already existing
                if (is_file(CMS_DATA_PATH . "language/" . $ifc_param1 . "_small.gif"))
                        unlink(CMS_DATA_PATH . "language/" . $ifc_param1 . "_small.gif");

                //rename source icon 1 to target icon
                if (is_file(CMS_DATA_PATH . "language/" . $object . "_small.gif"))
                        rename(CMS_DATA_PATH . "language/" . $object . "_small.gif",
                               CMS_DATA_PATH . "language/" . $ifc_param1 . "_small.gif");

                //delete target icon 2 if already existing
                if (is_file(CMS_DATA_PATH . "language/$ifc_param1.gif"))
                        unlink(CMS_DATA_PATH . "language/$ifc_param1.gif");

                //rename source icon 2 to target icon
                if (is_file(CMS_DATA_PATH . "language/$object.gif"))
                        rename(CMS_DATA_PATH . "language/$object.gif",
                               CMS_DATA_PATH . "language/$ifc_param1.gif");

                //remove target language if already existing
                $data->del($object);
                $object = $ifc_param1;
        };

        //name
        if (! $ifc_param2) $ifc_param2 = $object;
        $data->set($ifc_param2, $object, "name");

        //default language
        if (isset($ifc_param3))
        {
                $language = $system->getval("language", "default");

                if (stre($language))
                {
                        $language = $object;
                }
                else
                {
                        $array    = explode(",", $language);
                        array_unshift($array, $object);
                        $array    = array_unique($array);
                        $language = implode(",", $array);
                };

                $system->setval($language, "language", "default");
                $system->save();
        };

        //delete icon 1 if new icon is uploaded or delete option selected
        if (
             (isset($ifc_param4) || $ifc_file1)
             &&
             is_file(CMS_DATA_PATH . "language/" . $object . "_small.gif")
           )
                unlink(CMS_DATA_PATH . "language/" . $object . "_small.gif");

        //process upload of icon 1
        if (
             $ifc_file1
             &&
             ($extension = strtolower(strrchr($ifc_file1_name, ".")))
             &&
             streq($extension, ".gif")
           )
        {
                $ifc_file1_name = CMS_DATA_PATH . "language/" . $object . "_small.gif";
                move_uploaded_file($ifc_file1, $ifc_file1_name);
        };

        //delete icon 2 if new icon is uploaded or delete option selected
        if (
             (isset($ifc_param5) || $ifc_file2)
             &&
             is_file(CMS_DATA_PATH . "language/$object.gif")
           )
                unlink(CMS_DATA_PATH . "language/$object.gif");

        //process upload of icon 2
        if (
             $ifc_file2
             &&
             ($extension = strtolower(strrchr($ifc_file2_name, ".")))
             &&
             streq($extension, ".gif")
           )
        {
                $ifc_file2_name = CMS_DATA_PATH . "language/$object.gif";
                move_uploaded_file($ifc_file2, $ifc_file2_name);
        };

        //stopwords
        $data->set($ifc_param6, $object, "stopword");

        $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "del":
//.....................................................................................................
        if (empty($list)) break; //no selection

        reset($list);
        while (list(, $value) = each($list))
        {
                //delete icons
                if (is_file(CMS_DATA_PATH . "language/" . $object . "_small.gif"))
                        unlink(CMS_DATA_PATH . "language/" . $object . "_small.gif");
                if (is_file(CMS_DATA_PATH . "language/$object.gif"))
                        unlink(CMS_DATA_PATH . "language/$object.gif");

                //delete language
                $data->del($value);
        };

        $object       = NULL;
        $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "enable":
//.....................................................................................................
        if (isset($list) && count($list))
        {
                $array   = explode(",", $system->getval("language", "default"));
                $primary = reset($array);
                if (in_array($primary, $list)) array_unshift($list, $primary);
                $list    = array_unique($list);
                $list    = implode(",", $list);

                $system->setval($list, "language", "default");
        }
        else
        {
                $system->setval(NULL,  "language", "default");
        };

        $ifc_response = $system->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array("" => CMS_L_ACCESS));

//cache selected object permanently
if (CMS_IFC_MESSAGE !== "") cms_cache("language." . CMS_USER . ".object", $object, TRUE);

$array   = array_flip(explode(",", $system->getval("language", "default")));
reset($array);
$primary = key($array);

//menu
$menu = array(CMS_L_COMMAND_ADD .      "|language/command_add"    => "add",
              CMS_L_COMMAND_DELETE .   "|language/command_delete" => "#del",
              CMS_L_IFC_LANGUAGE_009 . "|language/command_enable" => "#enable");

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object" => $object));

//javascript
?>
<script>
function s(index) //select
{
        ifc_post('select', index);
};
//................................
function language_select_active()
{
        var object = null;
        var i      = 0;

        while (object = ifc_get_object("list[" + i++ + "]"))
        {
                switch (object.value)
                {
<?php
while (list($key) = each($array))
        echo("                case \"" . q($key) . "\":\n");
?>
                        if (! object.checked) object.click();
                        break;
                default:
                        if (object.checked)   object.click();
                };
        };
};
</script>
<?php

echo("<table class=\"layout\" " .
            "style=\"WIDTH:100%\">" .

     "<colgroup>" .
     "<col>");
if ($object)
        echo("<col span=\"2\" " .
                  "style=\"WIDTH:1px\">");
echo("</colgroup>" .

     "<tr>" .
     "<td>");

ifc_table_open();
echo("<colgroup>" .
     "<col style=\"WIDTH:1px\">" .
     "<col span=\"2\">" .
     "</colgroup>" .

//header
     "<tr>" .

//selection
     "<td rowspan=\"2\" " .
         "class=\"highlight\">" .
     "&nbsp;" .
     "</td>" .

//tag
     "<th>" .
     CMS_L_IFC_LANGUAGE_004 .
     "</th>" .

//name
     "<th>" .
     CMS_L_IFC_LANGUAGE_005 .
     "</th>" .
     "</tr>" .

//add button
     "<tr>" .
     "<td colspan=\"2\" " .
         "class=\"highlight2\">" .
     "<a href=\"javascript:ifc_post('add');\">" .
     "[...]" .
     "</a>" .
     "</td>" .
     "</tr>");

$i = 0;

if (is_array($data->data)) ksort($data->data);

$data->move("first");
while ($key = $data->move("next"))
{
        $name   = x($data->get($key, "name"));
        if (streq($object, $key)) $name = "<strong>$name</strong>";
        $varied = ifc_varied();

        echo("<tr>" .

        //selection
             "<td class=\"" . (isset($array[$key]) ? "special" : "highlight") . "\">");
        $ifc->set(NULL, "checkbox", $key, streq($key, $object), "list[" . $i++ . "]");
        echo("</td>" .

        //tag
             "<td$varied>" .
             x($key) .
             "</td>" .

        //name
             "<td$varied>" .
             "<a href=\"javascript:s('" . rqx($key) . "');\">" .
             image(is_file(CMS_DATA_PATH . "language/" . $key . "_small.gif") ?
                   CMS_DATA_URL . "language/" . $key . "_small.gif" :
                   "language/default_small") . "&nbsp;" .
             $name .
             "</a>" .
             "</td>" .

             "</tr>");
};

//selection control
echo("<tr>" .
     "<td colspan=\"3\" " .
         "class=\"highlight\" " .
         "style=\"TEXT-ALIGN:right\">");
$ifc->set(CMS_L_IFC_LANGUAGE_001, "button", "javascript:ifc_list_activate();");
$ifc->set(CMS_L_IFC_LANGUAGE_002, "button", "javascript:ifc_list_invert();");
$ifc->set(CMS_L_IFC_LANGUAGE_003, "button", "javascript:ifc_list_deactivate();");
$ifc->set(CMS_L_IFC_LANGUAGE_011, "button", "javascript:language_select_active();");
echo("</td>" .
     "</tr>");
ifc_table_close();

echo("</td>");

if ($object)
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //data
             "<td>");

        ifc_table_open();

        //header
        echo("<tr>" .
             "<th>" .
             CMS_L_IFC_LANGUAGE_006 .
             "</th>" .
             "</tr>" .

        //settings
             "<tr>" .
             "<td class=\"varied\">");

        //tag
        $ifc->set(CMS_L_IFC_LANGUAGE_004, "text 30 40",   $object);

        //save button
        $ifc->set(CMS_L_COMMAND_SAVE,     "button b",     "set");

        //name
        $ifc->set(CMS_L_IFC_LANGUAGE_005, "text 40 40 b", $data->get($object, "name"));

        //primary language
        $ifc->set(CMS_L_IFC_LANGUAGE_013, "checkbox b",   TRUE, streq($object, $primary));

        //icon 1
        echo("<table class=\"layout\" " .
                    "style=\"WIDTH:100%\">" .
             "<tr>" .

        //icon 1 display
             "<td style=\"TEXT-ALIGN:center;VERTICAL-ALIGN:middle;WIDTH:40px\">" .
             image(($flag = is_file(CMS_DATA_PATH . "language/" . $object . "_small.gif")) ?
                   CMS_DATA_URL . "language/" . $object . "_small.gif" :
                   "language/default_small") .
             "</td>" .

        //spacer
             "<td>" .
             "&nbsp;" .
             "</td>" .
             "<td>");

        //icon 1 delete option
        if ($flag) $ifc->set(CMS_L_COMMAND_DELETE, "checkbox b");
        else       $ifc->dummy();

        //icon 1 file upload
        $ifc->set(CMS_L_IFC_LANGUAGE_007 . " (16x12px) (GIF)", "file");
        echo("</td>" .
             "</tr>" .
             "</table>");

        //icon 2
        echo("<table class=\"layout\" " .
                    "style=\"WIDTH:100%\">" .
             "<tr>" .

        //icon 2 display
             "<td style=\"TEXT-ALIGN:center;VERTICAL-ALIGN:middle;WIDTH:40px\">" .
             image(($flag = is_file(CMS_DATA_PATH . "language/$object.gif")) ?
                   CMS_DATA_URL . "language/$object.gif" :
                   "language/default") .
             "</td>" .

        //spacer
             "<td>" .
             "&nbsp;" .
             "</td>" .
             "<td>");

        //icon 2 delete option
        if ($flag) $ifc->set(CMS_L_COMMAND_DELETE, "checkbox b");
        else       $ifc->dummy();

        //icon 2 file upload
        $ifc->set(CMS_L_IFC_LANGUAGE_008 . " (24x18px) (GIF)", "file");
        echo("</td>" .
             "</tr>" .
             "</table>");

        //stopwords
        $ifc->set(CMS_L_IFC_LANGUAGE_012, "textarea 40x20", $data->get($object, "stopword"));

        ifc_table_close();

        echo("</td>");
};
echo("</tr>" .
     "</table>");

$ifc->close();
?>
