<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
$log = new log();
if (! $log->enabled) ifc_inactive($ifc_page);

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "profile":
case "profile_select":
case "profile_add":
case "profile_edit":
case "_profile_add":
case "_profile_edit":
case "profile_del":
//.....................................................................................................
        if (empty($profile_object)) $profile_object = NULL;

        switch (CMS_IFC_MESSAGE)
        {
        case "profile_select":
//.....................................................................................................
                $profile_object = $ifc_param1;
                break;

        case "profile_add":
        case "profile_edit":
//.....................................................................................................
                $index = log_report("SELECT DISTINCT " . CMS_DB_LOG_ACCESS . "." .
                                                         CMS_DB_LOG_ACCESS_USERID . " " .
                                    "FROM " .            CMS_DB_LOG_ACCESS . " " .
                                    "LEFT JOIN " .       CMS_DB_LOG_USER . " " .
                                    "ON " .              CMS_DB_LOG_ACCESS . "." .
                                                         CMS_DB_LOG_ACCESS_USERID .
                                    "=" .                CMS_DB_LOG_USER . "." .
                                                         CMS_DB_LOG_USER_USERID . " " .
                                    "WHERE " .           CMS_DB_LOG_USER . "." .
                                                         CMS_DB_LOG_USER_USERID . " IS NULL " .
                                    "ORDER BY " .        CMS_DB_LOG_ACCESS . "." .
                                                         CMS_DB_LOG_ACCESS_USERID);
                if (
                     streq(CMS_IFC_MESSAGE, "profile_add")
                     &&
                     (! isset($index[0][CMS_DB_LOG_ACCESS_USERID]))
                   )
                {
                        $ifc_response = CMS_MSG_ERROR;
                        break;
                };

                reset($index);
                while (list($key, $value) = each($index))
                        $_index[$value[CMS_DB_LOG_ACCESS_USERID]] = $value[CMS_DB_LOG_ACCESS_USERID];

                //display
                $ifc   = new ifc($ifc_response,
                                 $ifc_page,
                                 array(CMS_L_COMMAND_CONFIRM . "|log/command_apply"  => "_" . CMS_IFC_MESSAGE,
                                       CMS_L_COMMAND_CANCEL .  "|log/command_cancel" => "profile"),
                                 array("profile_object" => $profile_object),
                                 NULL,
                                 streq(CMS_IFC_MESSAGE, "profile_add") ?
                                 CMS_L_IFC_LOG_046 : CMS_L_COMMAND_EDIT);

                if (streq(CMS_IFC_MESSAGE, "profile_edit"))
                {
                        $_index[$profile_object] = $profile_object;

                        $user = log_report("SELECT " . CMS_DB_LOG_USER_NAME . ", " .
                                                       CMS_DB_LOG_USER_COMPANY . ", " .
                                                       CMS_DB_LOG_USER_ADDRESS . ", " .
                                                       CMS_DB_LOG_USER_PHONE . ", " .
                                                       CMS_DB_LOG_USER_FAX . ", " .
                                                       CMS_DB_LOG_USER_EMAIL . ", " .
                                                       CMS_DB_LOG_USER_COMMENT . " " .
                                           "FROM " .   CMS_DB_LOG_USER . " " .
                                           "WHERE " .  CMS_DB_LOG_USER_USERID .
                                           "='" .      sqlesc($profile_object) . "' " .
                                           "LIMIT 1");

                        $ifc->set(CMS_L_IFC_LOG_003, "label");
                        $ifc->set($_index,           "select 40 b",        $profile_object);
                        $ifc->set(CMS_L_NAME,        "text 40 80 b",       $user[0][CMS_DB_LOG_USER_NAME]);
                        $ifc->set(CMS_L_IFC_LOG_012, "text 40 80 b",       $user[0][CMS_DB_LOG_USER_COMPANY]);
                        $ifc->set(CMS_L_IFC_LOG_013, "textarea 40x4 80 b", $user[0][CMS_DB_LOG_USER_ADDRESS]);
                        $ifc->set(CMS_L_IFC_LOG_014, "text 40 80 b",       $user[0][CMS_DB_LOG_USER_PHONE]);
                        $ifc->set(CMS_L_IFC_LOG_015, "text 40 80 b",       $user[0][CMS_DB_LOG_USER_FAX]);
                        $ifc->set(CMS_L_EMAIL,       "text 40 80 b",       $user[0][CMS_DB_LOG_USER_EMAIL]);
                        $ifc->set(CMS_L_IFC_LOG_047, "textarea 40x6 255",  $user[0][CMS_DB_LOG_USER_COMMENT]);
                }
                else
                {
                        $ifc->set(CMS_L_IFC_LOG_003, "label");
                        $ifc->set($_index,           "select 40 b",        CMS_USERID);
                        $ifc->set(CMS_L_NAME,        "text 40 80 b");
                        $ifc->set(CMS_L_IFC_LOG_012, "text 40 80 b");
                        $ifc->set(CMS_L_IFC_LOG_013, "textarea 40x4 80 b");
                        $ifc->set(CMS_L_IFC_LOG_014, "text 40 80 b");
                        $ifc->set(CMS_L_IFC_LOG_015, "text 40 80 b");
                        $ifc->set(CMS_L_EMAIL,       "text 40 80 b");
                        $ifc->set(CMS_L_IFC_LOG_047, "textarea 40x6 255");
                };

                $ifc->close();

        case "_profile_add":
//.....................................................................................................
                if (mysql_query("INSERT " . CMS_DB_LOG_USER .
                                     " (" . CMS_DB_LOG_USER_USERID . ", " .
                                            CMS_DB_LOG_USER_NAME . ", " .
                                            CMS_DB_LOG_USER_COMPANY . ", " .
                                            CMS_DB_LOG_USER_ADDRESS . ", " .
                                            CMS_DB_LOG_USER_PHONE . ", " .
                                            CMS_DB_LOG_USER_FAX . ", " .
                                            CMS_DB_LOG_USER_EMAIL . ", " .
                                            CMS_DB_LOG_USER_COMMENT . ") " .
                                "VALUES (" .
                                      "'" . sqlesc($ifc_param1) . "', " .
                                      "'" . sqlesc($ifc_param2) . "', " .
                                      "'" . sqlesc($ifc_param3) . "', " .
                                      "'" . sqlesc($ifc_param4) . "', " .
                                      "'" . sqlesc($ifc_param5) . "', " .
                                      "'" . sqlesc($ifc_param6) . "', " .
                                      "'" . sqlesc($ifc_param7) . "', " .
                                      "'" . sqlesc($ifc_param8) . "')"))
                {
                        $profile_object = $ifc_param1;
                        $ifc_response   = CMS_MSG_DONE;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR;
                break;

        case "_profile_edit":
//.....................................................................................................
                if (mysql_query("UPDATE " . CMS_DB_LOG_USER . " " .
                                "SET " .    CMS_DB_LOG_USER_USERID .  "='" . sqlesc($ifc_param1) . "', " .
                                            CMS_DB_LOG_USER_NAME .    "='" . sqlesc($ifc_param2) . "', " .
                                            CMS_DB_LOG_USER_COMPANY . "='" . sqlesc($ifc_param3) . "', " .
                                            CMS_DB_LOG_USER_ADDRESS . "='" . sqlesc($ifc_param4) . "', " .
                                            CMS_DB_LOG_USER_PHONE .   "='" . sqlesc($ifc_param5) . "', " .
                                            CMS_DB_LOG_USER_FAX .     "='" . sqlesc($ifc_param6) . "', " .
                                            CMS_DB_LOG_USER_EMAIL .   "='" . sqlesc($ifc_param7) . "', " .
                                            CMS_DB_LOG_USER_COMMENT . "='" . sqlesc($ifc_param8) . "' " .
                                "WHERE " .  CMS_DB_LOG_USER_USERID .  "='" . sqlesc($profile_object) . "' " .
                                "LIMIT 1"))
                {
                        $profile_object = $ifc_param1;
                        $ifc_response   = CMS_MSG_DONE;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR;
                break;

        case "profile_del":
//.....................................................................................................
                if (mysql_query("DELETE FROM " . CMS_DB_LOG_USER . " " .
                                "WHERE " .       CMS_DB_LOG_USER_USERID .
                                "='" .           sqlesc($profile_object) . "' " .
                                "LIMIT 1"))
                {
                        $profile_object = NULL;
                        $ifc_response   = CMS_MSG_DONE;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR;
        };

        $user = log_report("SELECT " .   CMS_DB_LOG_USER_USERID . ", " .
                                         CMS_DB_LOG_USER_NAME . " " .
                           "FROM " .     CMS_DB_LOG_USER . " " .
                           "ORDER BY " . CMS_DB_LOG_USER_USERID);

        //userlist
        if (isset($user[0][CMS_DB_LOG_USER_USERID]))
        {
                if (! $profile_object) $profile_object = $user[0][CMS_DB_LOG_USER_USERID];

                reset($user);
                while (list($key, $value) = each($user))
                {
                        if ($position = strpos($value[CMS_DB_LOG_USER_NAME], "|", 1))
                                $_value = substr($value[CMS_DB_LOG_USER_NAME], 0, $position);
                        else
                                $_value = $value[CMS_DB_LOG_USER_NAME];
                        $key            = str_pad($value[CMS_DB_LOG_USER_USERID] . " ", 11, ".") . "... $_value";
                        $userlist[$key] = $value[CMS_DB_LOG_USER_USERID];
                };
        };

        //menu
        $menu[CMS_L_IFC_LOG_046 . "|log/command_add"]      = "profile_add";
        if ($profile_object)
        {
                $menu[CMS_L_COMMAND_REFRESH . "|log/command_refresh"] = "profile_select";
                $menu[CMS_L_COMMAND_EDIT .    "|log/command_edit"]    = "profile_edit";
                $menu[CMS_L_COMMAND_DELETE .  "|log/command_delete"]  = "#profile_del";
        };
        $menu[CMS_L_COMMAND_CLOSE . "|log/command_cancel"] = NULL;

        //display
        $ifc  = new ifc($ifc_response,
                        $ifc_page,
                        $menu,
                        array("profile_object" => $profile_object),
                        "profile_select",
                        CMS_L_IFC_LOG_045);

        if (! $profile_object)
        {
                echo("&nbsp;");
                $ifc->close();
        };

        $ifc->set(CMS_L_IFC_LOG_048, "label");
        $ifc->set($userlist,         "select 60 b", $profile_object);
        echo(jscript("document.ifc.ifc_param1.onchange = ifc_submit;"));

        //user data
        $user = log_report("SELECT " .    CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_USERID . ", " .
                                          CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_NAME . ", " .
                                          CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_COMPANY . ", " .
                                          CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_ADDRESS . ", " .
                                          CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_PHONE . ", " .
                                          CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_FAX . ", " .
                                          CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_EMAIL . ", " .
                                          CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_COMMENT . ", " .
                                          CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_IP . ", " .
                                          CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_COMPUTER . ", " .
                                          CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_CLIENT . ", " .
                                          CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_LANGUAGE . " " .
                           "FROM " .      CMS_DB_LOG_USER . " " .
                           "LEFT JOIN " . CMS_DB_LOG_ACCESS . " " .
                           "ON " .        CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_USERID .
                           "=" .          CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_USERID . " " .
                           "WHERE " .     CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_USERID .
                           "='" .         sqlesc($profile_object) . "' " .
                           "ORDER BY " .  CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_DATE . " DESC, " .
                                          CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_TIME . " DESC " .
                           "LIMIT 1");

        ifc_table_open();
        echo("<tr>" .
             "<th colspan=\"6\">" .
             CMS_L_IFC_LOG_049 .
             "</th>" .
             "</tr>" .
             "<tr>" .
             "<td>" .
             CMS_L_NAME . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             "<strong>" .
             x($user[0][CMS_DB_LOG_USER_NAME]) .
             "</strong>" .
             "</td>" .
             "<td>" .
             CMS_L_IFC_LOG_014 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             x($user[0][CMS_DB_LOG_USER_PHONE]) .
             "</td>" .
             "<td>" .
             CMS_L_IFC_LOG_004 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             x($user[0][CMS_DB_LOG_ACCESS_IP]) .
             "</td>" .
             "</tr>" .
             "<tr>" .
             "<td>" .
             CMS_L_IFC_LOG_012 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             x($user[0][CMS_DB_LOG_USER_COMPANY]) .
             "</td>" .
             "<td>" .
             CMS_L_IFC_LOG_015 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             x($user[0][CMS_DB_LOG_USER_FAX]) .
             "</td>" .
             "<td>" .
             CMS_L_IFC_LOG_008 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             x($user[0][CMS_DB_LOG_ACCESS_COMPUTER]) .
             "</td>" .
             "</tr>" .
             "<tr>" .
             "<td>" .
             CMS_L_IFC_LOG_013 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             nl2br(x($user[0][CMS_DB_LOG_USER_ADDRESS])) .
             "</td>" .
             "<td>" .
             CMS_L_EMAIL . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             x($user[0][CMS_DB_LOG_USER_EMAIL]) .
             "</td>" .
             "<td>" .
             CMS_L_IFC_LOG_009 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             x($user[0][CMS_DB_LOG_ACCESS_CLIENT]) .
             "</td>" .
             "</tr>" .
             "<tr>" .
             "<td>" .
             CMS_L_IFC_LOG_047 . ":" .
             "</td>" .
             "<td colspan=\"3\" " .
                 "class=\"varied\">" .
             nl2br(x($user[0][CMS_DB_LOG_USER_COMMENT])) .
             "</td>" .
             "<td>" .
             CMS_L_IFC_LOG_010 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             x($user[0][CMS_DB_LOG_ACCESS_LANGUAGE]) .
             "</td>" .
             "</tr>");
        ifc_table_close();

        //recent actions
        $ifc->set(CMS_L_IFC_LOG_050, "description b");
        log_report("SELECT " .   CMS_DB_LOG_ACCESS_DATE . ", " .
                                 CMS_DB_LOG_ACCESS_TIME . ", " .
                                 CMS_DB_LOG_ACCESS_ACTION . " " .
                   "FROM " .     CMS_DB_LOG_ACCESS . " " .
                   "WHERE " .    CMS_DB_LOG_ACCESS_USERID .  "='" . sqlesc($profile_object) . "' " .
                   "AND " .      CMS_DB_LOG_ACCESS_ACTION . "!=''" .
                   "ORDER BY " . CMS_DB_LOG_ACCESS_DATE . " DESC, " .
                                 CMS_DB_LOG_ACCESS_TIME . " DESC " .
                   "LIMIT 20",
                   0,
                   "table",
                   array(CMS_DB_LOG_ACCESS_DATE   => CMS_L_IFC_LOG_001,
                         CMS_DB_LOG_ACCESS_TIME   => CMS_L_IFC_LOG_002,
                         CMS_DB_LOG_ACCESS_ACTION => CMS_L_IFC_LOG_006));

        //action statistics
        $ifc->set(CMS_L_IFC_LOG_051, "description b");
        log_report("SELECT " . CMS_DB_LOG_ACCESS_ACTION . " " .
                   "FROM " .   CMS_DB_LOG_ACCESS . " " .
                   "WHERE " .  CMS_DB_LOG_ACCESS_USERID .  "='" . sqlesc($profile_object) . "' " .
                   "AND " .    CMS_DB_LOG_ACCESS_ACTION . "!=''",
                   20,
                   "statistics",
                   array(CMS_DB_LOG_ACCESS_ACTION => CMS_L_IFC_LOG_006));

        $ifc->close();

case "report":
case "report_previous":
case "report_next":
//.....................................................................................................

        //date input
        if (! empty($ifc_param1))
        {
                if (preg_match("/^([0-9]{1,2})\.([0-9]{1,2})\.([0-9]{2,4})$/", $ifc_param1, $_ifc_param1))
                        $date = mktime(1, 0, 0, $_ifc_param1[2], $_ifc_param1[1], $_ifc_param1[3]);
                else
                        $date = strtotime($ifc_param1);
        };
        if (empty($date) || ($date < 1)) $date = strtotime("now");

        switch (CMS_IFC_MESSAGE)
        {
        case "report_previous":
//.....................................................................................................
                $date -= 86400;
                break;

        case "report_next":
//.....................................................................................................
                $date += 86400;
        };

        $date_prev  = $date - 86400;
        $_date      = date("Y-m-d", $date);
        $_date_prev = date("Y-m-d", $date_prev);
        $_host      = sqlesc(CMS_HOST);
        $_userid    = sqlesc(CMS_USERID);

        //display
        $ifc        = new ifc($ifc_response,
                              $ifc_page,
                              array(CMS_L_COMMAND_CLOSE . "|log/command_cancel" => NULL),
                              NULL,
                              NULL,
                              CMS_L_IFC_LOG_044);

        $ifc->set(CMS_L_IFC_LOG_001,      "text 10 10 :", date("d.m.Y", $date));
        $ifc->set(CMS_L_COMMAND_SHOW,     "button",       "report");
        $ifc->set(CMS_L_COMMAND_PREVIOUS, "button",       "report_previous");
        $ifc->set(CMS_L_COMMAND_NEXT,     "button",       "report_next");

        //accesses today
        $access_count =
                log_report("SELECT COUNT(" . CMS_DB_LOG_ACCESS_INDEX . ") AS '#count' " .
                           "FROM " .         CMS_DB_LOG_ACCESS . " " .
                           "WHERE " .        CMS_DB_LOG_ACCESS_DATE .             "='$_date' " .
                           "AND " .          CMS_DB_LOG_ACCESS_REFERER . " NOT LIKE '$_host%' " .
                           "AND " .          CMS_DB_LOG_ACCESS_USERID .          "!='$_userid'");

        //users today
        $access_count_users =
                log_report("SELECT COUNT(DISTINCT " . CMS_DB_LOG_ACCESS_USERID . ") AS '#count' " .
                           "FROM " .                  CMS_DB_LOG_ACCESS . " " .
                           "WHERE " .                 CMS_DB_LOG_ACCESS_DATE .    "='$_date' " .
                           "AND " .                   CMS_DB_LOG_ACCESS_USERID . "!='$_userid'");

        //accesses yesterday
        $access_prev_count =
                log_report("SELECT COUNT(" . CMS_DB_LOG_ACCESS_INDEX . ") AS '#count' " .
                           "FROM " .         CMS_DB_LOG_ACCESS . " " .
                           "WHERE " .        CMS_DB_LOG_ACCESS_DATE .             "='$_date_prev' " .
                           "AND " .          CMS_DB_LOG_ACCESS_REFERER . " NOT LIKE '$_host%' " .
                           "AND " .          CMS_DB_LOG_ACCESS_USERID .          "!='$_userid'");

        //users yesterday
        $access_prev_count_users =
                log_report("SELECT COUNT(DISTINCT " . CMS_DB_LOG_ACCESS_USERID . ") AS '#count' " .
                           "FROM " .                  CMS_DB_LOG_ACCESS . " " .
                           "WHERE " .                 CMS_DB_LOG_ACCESS_DATE .    "='$_date_prev' " .
                           "AND " .                   CMS_DB_LOG_ACCESS_USERID . "!='$_userid'");

        //actions today
        $action_count =
                log_report("SELECT COUNT(" . CMS_DB_LOG_ACCESS_INDEX . ") AS '#count' " .
                           "FROM " .         CMS_DB_LOG_ACCESS . " " .
                           "WHERE " .        CMS_DB_LOG_ACCESS_DATE .    "='$_date' " .
                           "AND " .          CMS_DB_LOG_ACCESS_ACTION . "!='access' " .
                           "AND " .          CMS_DB_LOG_ACCESS_USERID . "!='$_userid'");

        //actions yesterday
        $action_prev_count =
                log_report("SELECT COUNT(" . CMS_DB_LOG_ACCESS_INDEX . ") AS '#count' " .
                           "FROM " .         CMS_DB_LOG_ACCESS . " " .
                           "WHERE " .        CMS_DB_LOG_ACCESS_DATE .    "='$_date_prev' " .
                           "AND " .          CMS_DB_LOG_ACCESS_ACTION . "!='access' " .
                           "AND " .          CMS_DB_LOG_ACCESS_USERID . "!='$_userid'");

        ifc_table_open();
        echo("<tr>" .
             "<th colspan=\"4\">" .
             weekday(date("w", $date)) . ", $_date" .
             "</th>" .
             "</tr>" .
             "<tr>" .
             "<td style=\"WIDTH:1px\">" .
             "&nbsp;" .
             "</td>" .
             "<td>" .
             CMS_L_IFC_LOG_033 .
             "</td>" .
             "<td>" .
             CMS_L_IFC_LOG_034 .
             "</td>" .
             "<td>" .
             CMS_L_IFC_LOG_035 .
             "</td>" .
             "</tr>" .
             "<tr>" .
             "<td>" .
             CMS_L_IFC_LOG_036 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             "<strong>" .
             $access_count[0]["#count"] .
             "</strong>" .
             " <small>" .
             "/ " . $access_count_users[0]["#count"] . " " . CMS_L_IFC_LOG_037 .
             "</small>" .
             "</td>" .
             "<td class=\"varied\">" .
             $action_count[0]["#count"] .
             "</td>" .
             "<td class=\"varied\">");
        if ($access_count[0]["#count"])
                echo(number_format($action_count[0]["#count"] / $access_count[0]["#count"],
                                   2,
                                   CMS_L_DECIMAL_SEPARATOR,
                                   CMS_L_THOUSAND_SEPARATOR));
        echo("</td>" .
             "</tr>" .
             "<tr>" .
             "<td>" .
             CMS_L_IFC_LOG_038 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             $access_prev_count[0]["#count"] .
             " <small>" .
             "/ " . $access_prev_count_users[0]["#count"] . " " . CMS_L_IFC_LOG_037 .
             "</small>" .
             "</td>" .
             "<td class=\"varied\">" .
             $action_prev_count[0]["#count"] .
             "</td>" .
             "<td class=\"varied\">");
        if ($access_prev_count[0]["#count"])
                echo(number_format($action_prev_count[0]["#count"] / $access_prev_count[0]["#count"],
                                   2,
                                   CMS_L_DECIMAL_SEPARATOR,
                                   CMS_L_THOUSAND_SEPARATOR));
        echo("</td>" .
             "</tr>" .
             "<tr>" .
             "<td>" .
             CMS_L_IFC_LOG_039 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             ($access_count[0]["#count"] - $access_prev_count[0]["#count"]) .
             "</td>" .
             "<td class=\"varied\">" .
             ($action_count[0]["#count"] - $action_prev_count[0]["#count"]) .
             "</td>" .
             "<td class=\"varied\">");
        if (
             $access_count[0]["#count"]
             &&
             $action_prev_count[0]["#count"]
           )
                echo(number_format(  $action_count[0]["#count"]      / $access_count[0]["#count"]
                                   - $action_prev_count[0]["#count"] / $action_prev_count[0]["#count"],
                                   2,
                                   CMS_L_DECIMAL_SEPARATOR,
                                   CMS_L_THOUSAND_SEPARATOR));
        echo("</td>" .
             "</tr>" .
             "<tr>" .
             "<td>" .
             CMS_L_IFC_LOG_040 . ":" .
             "</td>" .
             "<td class=\"varied\">" .
             diffpercent($access_prev_count[0]["#count"], $access_count[0]["#count"]) .
             "</td>" .
             "<td class=\"varied\">" .
             diffpercent($action_prev_count[0]["#count"], $action_count[0]["#count"]) .
             "</td>" .
             "<td class=\"varied\">");
        if (
             $action_prev_count[0]["#count"]
             &&
             $access_count[0]["#count"]
           )
                echo(diffpercent($action_prev_count[0]["#count"] / $access_prev_count[0]["#count"],
                                 $action_count[0]["#count"]      / $access_count[0]["#count"]));
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        $ifc->set(CMS_L_IFC_LOG_041, "description b");
        log_report("SELECT SUBSTRING_INDEX(" . CMS_DB_LOG_ACCESS_REFERER . ", '?', 1) " .
                   "AS '" .                    CMS_DB_LOG_ACCESS_REFERER . "' " .
                   "FROM " .                   CMS_DB_LOG_ACCESS . " " .
                   "WHERE " .                  CMS_DB_LOG_ACCESS_DATE .             "='$_date' " .
                   "AND " .                    CMS_DB_LOG_ACCESS_REFERER . " NOT LIKE '$_host%' " .
                   "AND " .                    CMS_DB_LOG_ACCESS_USERID .          "!='$_userid'",
                   20,
                   "statistics",
                   array(CMS_DB_LOG_ACCESS_REFERER => CMS_L_IFC_LOG_007));

        $ifc->set(CMS_L_IFC_LOG_042, "description b");
        log_report("SELECT " .      CMS_DB_LOG_ACCESS_ACTION . " " .
                   "FROM " .        CMS_DB_LOG_ACCESS . " " .
                   "WHERE " .       CMS_DB_LOG_ACCESS_DATE .    "='$_date' " .
                   "AND " .         CMS_DB_LOG_ACCESS_ACTION . "!='access' " .
                   "AND " .         CMS_DB_LOG_ACCESS_USERID . "!='$_userid'",
                   20,
                   "statistics",
                   array(CMS_DB_LOG_ACCESS_ACTION => CMS_L_IFC_LOG_006));

        $ifc->set(CMS_L_IFC_LOG_043, "description b");
        log_report("SELECT " .    CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_NAME . " " .
                   "FROM " .      CMS_DB_LOG_ACCESS . " " .
                   "LEFT JOIN " . CMS_DB_LOG_USER . " " .
                   "ON " .        CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_USERID .
                   "=" .          CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_USERID . " " .
                   "WHERE " .     CMS_DB_LOG_ACCESS_DATE .                            "='$_date' " .
                   "AND " .       CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_USERID . "!='$_userid'",
                   20,
                   "statistics",
                   array(CMS_DB_LOG_USER_NAME => CMS_L_NAME));

        $ifc->close();

case "load":
//.....................................................................................................
        $data         = new data("#system/log.settings");

        for ($i = 1; $i < 24; $i++)
                eval("\$ifc_param$i = \"" . $data->get(CMS_USER, "ifc_param$i") . "\";");

        $ifc_response = CMS_MSG_DONE;
        break;

case "save":
//.....................................................................................................
        $data         = new data("#system/log.settings");

        $data->del(CMS_USER);

        for ($i = 1; $i < 24; $i++)
                eval("if (isset(\$ifc_param$i))" .
                     "\$data->set(\$ifc_param$i, \"" . CMS_USER . "\", \"ifc_param$i\");");

        $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "config":
//.....................................................................................................

        //get values
        $system     = new system();
        $ifc_param1 = $system->getval("log", "limit");
        $ifc_param2 = $system->getval("log", "anonymize");
        $ifc_param3 = $system->getval("log", "privacy");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       NULL,
                       "_config",
                       CMS_L_IFC_LOG_052);

        $ifc->set(CMS_L_IFC_LOG_053, "label");
        $ifc->set(array(CMS_L_IFC_LOG_054 => NULL,
                        CMS_L_IFC_LOG_055 => 1095,
                        CMS_L_IFC_LOG_056 =>  730,
                        CMS_L_IFC_LOG_057 =>  365,
                        CMS_L_IFC_LOG_058 =>  180,
                        CMS_L_IFC_LOG_059 =>   90,
                        CMS_L_IFC_LOG_060 =>   30,
                        CMS_L_IFC_LOG_061 =>   14,
                        CMS_L_IFC_LOG_062 =>    7,
                        CMS_L_IFC_LOG_063 =>    3,
                        CMS_L_IFC_LOG_064 =>    2,
                        CMS_L_IFC_LOG_065 =>    1,
                        CMS_L_IFC_LOG_066 =>   -1),
                  "select 40 b",
                  $ifc_param1);
        $ifc->set(CMS_L_IFC_LOG_067, "checkbox b", TRUE, $ifc_param2);
        $ifc->set(CMS_L_IFC_LOG_068, "checkbox",   TRUE, $ifc_param3);

        $ifc->close();

case "_config":
//.....................................................................................................

        //set values
        $system       = new system();
        $system->setval($ifc_param1,        "log", "limit");
        $system->setval(isset($ifc_param2), "log", "anonymize");
        $system->setval(isset($ifc_param3), "log", "privacy");

        //clear values
        unset($ifc_param1);
        unset($ifc_param2);
        unset($ifc_param3);

        $ifc_response = $system->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array("" => CMS_L_ACCESS));

$field        = array(CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_DATE     => CMS_L_IFC_LOG_001,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_TIME     => CMS_L_IFC_LOG_002,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_USERID   => CMS_L_IFC_LOG_003,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_IP       => CMS_L_IFC_LOG_004,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_USER     => CMS_L_IFC_LOG_005,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_ACTION   => CMS_L_IFC_LOG_006,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_URL      => CMS_L_URL,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_REFERER  => CMS_L_IFC_LOG_007,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_COMPUTER => CMS_L_IFC_LOG_008,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_CLIENT   => CMS_L_IFC_LOG_009,
                      CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_LANGUAGE => CMS_L_IFC_LOG_010,

                      CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_NAME       => CMS_L_NAME,
                      CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_COMPANY    => CMS_L_IFC_LOG_012,
                      CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_ADDRESS    => CMS_L_IFC_LOG_013,
                      CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_PHONE      => CMS_L_IFC_LOG_014,
                      CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_FAX        => CMS_L_IFC_LOG_015,
                      CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_EMAIL      => CMS_L_EMAIL);

$ifc_param18  = isset($ifc_param18) ? $ifc_param18      : NULL;
$ifc_param19  = isset($ifc_param19) ? $ifc_param19      : NULL;
$ifc_param20  = isset($ifc_param20) ? $ifc_param20      : NULL;
$ifc_param21  = isset($ifc_param21) ? (int)$ifc_param21 : 40;
$ifc_param22  = isset($ifc_param22) ? $ifc_param22      : NULL;
$ifc_param23  = isset($ifc_param23) ? $ifc_param23      : NULL;
$ifc_response = $ifc_response       ? $ifc_response     : sprintf(CMS_L_IFC_LOG_011, CMS_USERID);
$selection    = NULL;
$i            = 0;

//display
$ifc          = new ifc($ifc_response,
                        $ifc_page,
                        array(CMS_L_IFC_LOG_044 . "|log/command_report"        => "report",
                              CMS_L_IFC_LOG_045 . "|log/command_profile"       => "profile",
                              CMS_L_IFC_LOG_017 . "|log/command_restore"       => "load",
                              CMS_L_IFC_LOG_018 . "|log/command_save"          => "save",
                              CMS_L_IFC_LOG_052 . "|log/command_configuration" => "config"));

//fields
ifc_table_open();
echo("<tr>" .
     "<th>" .
     CMS_L_IFC_LOG_019 .
     "</th>" .
     "</tr>" .
     "<tr>" .
     "<td class=\"varied\">" .
     "<table class=\"layout\" " .
            "style=\"WIDTH:100%\">");
reset($field);
while (list($key, $value) = each($field))
{
        if (! ($i % 6)) echo("<tr>");
        $i++;
        echo("<td>");
        eval("if (empty(\$ifc_param$i)) \$ifc_param$i = NULL;" .
             "else                      \$selection  .= \", $key\";" .
             "\$ifc->set(\"$value\", \"checkbox\", \", $value\", \$ifc_param$i);");
        echo("</td>");
        if (! ($i % 6)) echo("</tr>");
};
echo("</table>" .
     "</td>" .
     "</tr>" .

//filter
     "<tr>" .
     "<th>" .
     CMS_L_IFC_LOG_020 .
     "</th>" .
     "</tr>" .
     "<tr>" .
     "<td class=\"varied\">");
$field        = array_flip($field);
$ifc->set($field, "select", $ifc_param18);
$ifc->set(array(CMS_L_IFC_LOG_021 => " LIKE ",
                CMS_L_IFC_LOG_022 => "<",
                CMS_L_IFC_LOG_023 => "<=",
                CMS_L_IFC_LOG_024 => "=",
                CMS_L_IFC_LOG_025 => ">=",
                CMS_L_IFC_LOG_026 => ">",
                CMS_L_IFC_LOG_027 => "!="),
                "select",
                $ifc_param19);
$ifc->set(NULL, "text 25 80 :", $ifc_param20);
echo("</td>" .
     "</tr>" .

//display style
     "<tr>" .
     "<th>" .
     CMS_L_IFC_LOG_028 .
     "</th>" .
     "</tr>" .
     "<tr>" .
     "<td class=\"varied\">");
$ifc->set(CMS_L_IFC_LOG_029, "text 3 10 :", $ifc_param21);
$ifc->set(CMS_L_IFC_LOG_030, "description :");
$ifc->set(array(CMS_L_IFC_LOG_031 => "table",
                CMS_L_IFC_LOG_032 => "statistics",
                CMS_L_IFC_LOG_016 => "assignment"),
          "select",
          $ifc_param22);
$ifc->set($field, "select", $ifc_param23);
$ifc->set(CMS_L_COMMAND_REFRESH, "button");
echo("</td>" .
     "</tr>");
ifc_table_close();

//filter
if ($ifc_param20)
{
        if (streq($ifc_param19, " LIKE ")) $ifc_param20 = "%$ifc_param20%";
        $ifc_param20 = " WHERE $ifc_param18$ifc_param19'" . sqlesc($ifc_param20) . "'";
};

//sql limit
if (streq($ifc_param22, "table") && $ifc_param21)
{
        $limit       = "LIMIT " . $ifc_param21;
        $ifc_param21 = NULL;
}
else
{
        $limit       = NULL;
};

if (streq($ifc_param22, "assignment"))
        $selection = "  $ifc_param23$selection";

if ($selection = substr($selection, 2))
{
        log_report("SELECT $selection " .
                   "FROM " .            CMS_DB_LOG_ACCESS . " " .
                   "LEFT OUTER JOIN " . CMS_DB_LOG_USER . " " .
                   "ON " .              CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_USERID .
                   "=" .                CMS_DB_LOG_USER .   "." . CMS_DB_LOG_USER_USERID .
                   "$ifc_param20 " . //filter
                   "ORDER BY " .        CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_DATE . " DESC, " .
                                        CMS_DB_LOG_ACCESS . "." . CMS_DB_LOG_ACCESS_TIME . " DESC " .
                   $limit,
                   $ifc_param21,
                   $ifc_param22,
                   array(CMS_DB_LOG_ACCESS_DATE     => CMS_L_IFC_LOG_001,
                         CMS_DB_LOG_ACCESS_TIME     => CMS_L_IFC_LOG_002,
                         CMS_DB_LOG_ACCESS_USERID   => CMS_L_IFC_LOG_003,
                         CMS_DB_LOG_ACCESS_IP       => CMS_L_IFC_LOG_004,
                         CMS_DB_LOG_ACCESS_USER     => CMS_L_IFC_LOG_005,
                         CMS_DB_LOG_ACCESS_ACTION   => CMS_L_IFC_LOG_006,
                         CMS_DB_LOG_ACCESS_REFERER  => CMS_L_IFC_LOG_007,
                         CMS_DB_LOG_ACCESS_URL      => CMS_L_URL,
                         CMS_DB_LOG_ACCESS_COMPUTER => CMS_L_IFC_LOG_008,
                         CMS_DB_LOG_ACCESS_CLIENT   => CMS_L_IFC_LOG_009,
                         CMS_DB_LOG_ACCESS_LANGUAGE => CMS_L_IFC_LOG_010,
                         CMS_DB_LOG_USER_NAME       => CMS_L_NAME,
                         CMS_DB_LOG_USER_COMPANY    => CMS_L_IFC_LOG_012,
                         CMS_DB_LOG_USER_ADDRESS    => CMS_L_IFC_LOG_013,
                         CMS_DB_LOG_USER_PHONE      => CMS_L_IFC_LOG_014,
                         CMS_DB_LOG_USER_FAX        => CMS_L_IFC_LOG_015,
                         CMS_DB_LOG_USER_EMAIL      => CMS_L_EMAIL));
};

$ifc->close();
?>
