<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------

//permission
define("CMS_MAILFORM_PERMISSION_OPERATOR", "operator");

if (! isset($object)) $object = (string)cms_cache("mailform." . CMS_USER . ".object");
if (! isset($list))   $list   = preg_match("/^(?:|ifc_)/", CMS_IFC_MESSAGE) ? array($object) : array();
if (! isset($target)) $target = NULL;
if (! isset($status)) $status = NULL;

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = $ifc_param;
        $list   = array($object);
        $status = NULL;
        break;

case "add_receiver":
case "add_element":
//.....................................................................................................
        $ifc_param = $object; //target

        switch (CMS_IFC_MESSAGE)
        {
        case "add_receiver":
                $ifc_param1 = CMS_L_IFC_MAILFORM_001; //name
                break;

        case "add_element":
                $ifc_param1 = CMS_L_IFC_MAILFORM_009; //name
                $ifc_param2 = "text";                 //subtype
                break;
        };

case "add_receiver_target":
case "add_element_target":
//.....................................................................................................
        $data     = new data("#system/mailform");
        $flexview = new flexview();

        $flexview->import_data($data);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       array(CMS_L_COMMAND_CANCEL . "|mailform/command_cancel" => FALSE),
                       array("object" => $object,
                             "list"   => $list),
                       NULL,
                       streq(substr(CMS_IFC_MESSAGE, 0, 13), "add_receiver") ?
                       CMS_L_IFC_MAILFORM_010 : CMS_L_IFC_MAILFORM_002);

        ifc_table_open();
        echo("<colgroup>" .
             "<col style=\"WIDTH:1px\">" .
             "<col>" .
             "</colgroup>" .

             "<tr>" .

        //data
             "<th>" .
             CMS_L_IFC_MAILFORM_038 .
             "</th>" .

        //target
             "<th>" .
             CMS_L_IFC_MAILFORM_039 .
             "</th>" .
             "</tr>" .
             "<tr>" .

        //data
             "<td class=\"varied\">");

        switch (CMS_IFC_MESSAGE)
        {
        case "add_receiver":
        case "add_receiver_target":

                //name
                $ifc->set(CMS_L_NAME, "text 50 256 l",  $ifc_param1);
                break;

        case "add_element":
        case "add_element_target":

                //name
                $ifc->set(CMS_L_NAME, "text 50 256 bl", $ifc_param1);

                //type
                $ifc->set(CMS_L_IFC_MAILFORM_003, "label");
                $ifc->set(array(CMS_L_IFC_MAILFORM_004 => "checkbox",
                                CMS_L_IFC_MAILFORM_005 => "radio",
                                CMS_L_IFC_MAILFORM_006 => "select",
                                CMS_L_IFC_MAILFORM_007 => "text",
                                CMS_L_IFC_MAILFORM_008 => "textarea",
                                CMS_L_IFC_MAILFORM_047 => "code",
                                CMS_L_IFC_MAILFORM_029 => "hidden",
                                CMS_L_IFC_MAILFORM_033 => "pagebreak"),
                          "select 50",
                          $ifc_param2);
                break;
        };

        echo("</td>" .

        //target
             "<td class=\"target\">");

        $flexview->set_encoding_function(__NAMESPACE__ . "\\qr");

        switch (CMS_IFC_MESSAGE)
        {
        case "add_receiver":
        case "add_receiver_target":
                $flexview->show_target($ifc_param,
                                       "javascript:ifc_post('add_receiver_target','%index%');",
                                       "javascript:ifc_post('add_receiver_insert','%index%');",
                                       "javascript:ifc_post('add_receiver_append','%index%');",
                                       "name",
                                       0,
                                       TRUE,                        //insert type list
                                       NULL,                        //insert subtype list
                                       array("base"      => TRUE,   //append type list
                                             "container" => TRUE));
                break;

        case "add_element":
        case "add_element_target":
                $flexview->show_target($ifc_param,
                                       "javascript:ifc_post('add_element_target','%index%');",
                                       "javascript:ifc_post('add_element_insert','%index%');",
                                       "javascript:ifc_post('add_element_append','%index%');",
                                       "name",
                                       0,
                                       array("container" => TRUE), //insert type list
                                       NULL,                       //insert subtype list
                                       array("checkbox"  => TRUE,  //append type list
                                             "radio"     => TRUE,
                                             "select"    => TRUE,
                                             "text"      => TRUE,
                                             "textarea"  => TRUE,
                                             "code"      => TRUE,
                                             "hidden"    => TRUE,
                                             "pagebreak" => TRUE));
                break;
        };

        echo("</td>" .
             "</tr>");
        ifc_table_close();

        $ifc->close();

case "add_receiver_insert":
case "add_receiver_append":
//.....................................................................................................

        //set name if none is given
        if (! language_get($ifc_param1, FALSE))
                $ifc_param1 = language_set($ifc_param1, CMS_L_IFC_MAILFORM_001, FALSE);

        $data = new data("#system/mailform");
        $data->set_buffer(array(array("name"  => $ifc_param1,
                                      "#type" => "container"),
                                array("#type" => "/container")));

        switch (CMS_IFC_MESSAGE)
        {
        case "add_receiver_insert":
                $_object = $data->insert($ifc_param);
                break;

        case "add_receiver_append":
                $_object = $data->append($ifc_param);
                break;
        };

        //create template
        if (cms_load("template"))
        {
                $template           = new template();
                $template->operator = TRUE;

                if ($template_index = $template->add(language_get($ifc_param1, FALSE), //name
                                                     NULL,                             //category
                                                     NULL,                             //page
                                                     "<CMS:nocache>" .                 //code
                                                     "<?php\n" .
                                                     "\$GLOBALS[\"mailform_form\"] = \"$_object\";\n" .
                                                     "cms_application(\"mailform\");\n" .
                                                     "?>" .
                                                     "</CMS:nocache>"))
                        $data->set($template_index, $_object, "template");
        };

        if ($data->save())
        {
                $object       = $_object;
                $list         = array($object);
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        if (! empty($template_index)) $template->delete($template_index);
        $ifc_response = CMS_MSG_ERROR;
        break;

case "add_element_insert":
case "add_element_append":
//.....................................................................................................

        //set name in default language if not given
        if (! language_get($ifc_param1, FALSE))
                $ifc_param1 = language_set($ifc_param1, CMS_L_IFC_MAILFORM_009, FALSE);

        //set default values
        switch ($ifc_param2)
        {
        case "code":
                $code = "<input id=\"%id%\"\n" .
                        "       name=\"%name%\"\n" .
                        "       type=\"text\"\n" .
                        "       value=\"%value%\"\n" .
                        "       placeholder=\"%label%\">";
                break;

        default:
                $code = NULL;
        };

        $data = new data("#system/mailform");
        $data->set_buffer(array(array("name"  => $ifc_param1,
                                      "#type" => $ifc_param2,
                                      "code"  => $code)));

        switch (CMS_IFC_MESSAGE)
        {
        case "add_element_insert":
                $_object = $data->insert($ifc_param);
                break;

        case "add_element_append":
                $_object = $data->append($ifc_param);
                break;
        };

        if ($data->save())
        {
                $object       = $_object;
                $list         = array($object);
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "save":
//.....................................................................................................

        //set name in default language if not given
        if (! language_get($ifc_param1, FALSE))
                $ifc_param1 = language_set($ifc_param1, CMS_L_UNKNOWN, FALSE);

        $data = new data("#system/mailform");
        $type = $data->get($object, "#type");

        $data->set($ifc_param1, $object, "name");

        switch ($type)
        {
        case "container":
//.....................................................................................................
                $data->set($ifc_param2,        $object, "description");
                $data->set($ifc_param3,        $object, "email");
                $data->set($ifc_param4,        $object, "url");
                $data->set($ifc_param5,        $object, "confirmation");
                $data->set($ifc_param6,        $object, "submit");
                $data->set(isset($ifc_param7), $object, "captcha");

                //update template
                if (
                     ($template_index = $data->get($object, "template"))
                     &&
                     cms_load("template")
                   )
                {
                        $template           = new template();
                        $template->operator = TRUE;

                        if ($array = $template->get($template_index))
                                $template->set($template_index,                                        //index
                                               language_get($ifc_param1, FALSE),                       //name
                                               isset($array["category"]) ? $array["category"] : NULL,  //category
                                               isset($array["page"])     ? $array["page"]     : NULL); //page
                };

                break;

        case "checkbox":
        case "radio":
//.....................................................................................................
                $data->set($ifc_param2,         $object, "id");
                $data->set($ifc_param3,         $object, "description");
                $data->set($ifc_param4,         $object, "option");
                $data->set($ifc_param5,         $object, "column");
                $data->set(isset($ifc_param6),  $object, "required");
                $data->set(isset($ifc_param7),  $object, "secret");
                break;

        case "select":
//.....................................................................................................
                $data->set($ifc_param2,         $object, "id");
                $data->set($ifc_param3,         $object, "description");
                $data->set($ifc_param4,         $object, "option");
                $data->set(isset($ifc_param5),  $object, "required");
                $data->set(isset($ifc_param6),  $object, "secret");
                break;

        case "text":
//.....................................................................................................
                $data->set($ifc_param2,         $object, "id");
                $data->set($ifc_param3,         $object, "description");
                $data->set((int)$ifc_param4,    $object, "width");
                $data->set((int)$ifc_param5,    $object, "length");
                $data->set($ifc_param6,         $object, "default");
                $data->set(empty($ifc_param9) ? $ifc_param7 : $ifc_param9,
                           $object,
                           "match");
                $data->set(isset($ifc_param8),  $object, "required");
                $data->set(isset($ifc_param10), $object, "confirm");
                $data->set(isset($ifc_param11), $object, "secret");
                break;

        case "textarea":
//.....................................................................................................
                $data->set($ifc_param2,         $object, "id");
                $data->set($ifc_param3,         $object, "description");
                $data->set((int)$ifc_param4,    $object, "width");
                $data->set((int)$ifc_param5,    $object, "height");
                $data->set($ifc_param6,         $object, "default");
                $data->set(isset($ifc_param7),  $object, "required");
                $data->set(isset($ifc_param8),  $object, "secret");
                break;

        case "code":
//.....................................................................................................
                $data->set($ifc_param2,         $object, "id");
                $data->set($ifc_param3,         $object, "description");
                $data->set($ifc_param4,         $object, "code");
                $data->set(isset($ifc_param5),  $object, "codeonly");
                $data->set($ifc_param6,         $object, "default");
                $data->set(empty($ifc_param9) ? $ifc_param7 : $ifc_param9,
                           $object,
                           "match");
                $data->set(isset($ifc_param8),  $object, "required");
                $data->set(isset($ifc_param9),  $object, "secret");
                break;

        case "hidden":
//.....................................................................................................
                $data->set($ifc_param2,         $object, "id");
                $data->set($ifc_param3,         $object, "default");
                $data->set(isset($ifc_param4),  $object, "confirm");
                $data->set(isset($ifc_param5),  $object, "secret");
                break;
        };

        if ($data->save())
        {
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "copy":
case "cut":
//.....................................................................................................
        $target = $object;
        $status = CMS_IFC_MESSAGE;
        break;

case "target":
//.....................................................................................................
        $target = $ifc_param;
        break;

case "copy_insert":
case "copy_append":
case "cut_insert":
case "cut_append":
//.....................................................................................................
        if (count($list) === 0) break; //no selection;

        $data  = new data("#system/mailform");
        $_data = clone $data; //use clone of data structure as source
        $_list = NULL;

        //load template extension
        if ($flag_template = cms_load("template"))
        {
                $template           = new template();
                $template->operator = TRUE;
        };

        //transverse reversely
        $list = array_reverse($list);

        $target_is_container = $data->is_container($ifc_param);

        reset($list);
        while (list(, $value) = each($list))
        {
                $flag_copy = FALSE;

                $source_is_container = $data->is_container($value);

                //copy / cut
                switch (CMS_IFC_MESSAGE)
                {
                case "copy_insert":

                        //containers may not be inserted
                        if ($source_is_container) continue 2;

                case "copy_append":

                        //containers may only be appended to containers
                        if ($source_is_container && (! $target_is_container)) continue 2;

                        //buffer section in clone
                        $_data->copy($value);
                        $flag_copy = TRUE;
                        break;

                case "cut_insert":

                        //containers may not be inserted
                        if ($source_is_container) continue 2;

                case "cut_append":

                        //containers may only be appended to containers
                        if ($source_is_container && (! $target_is_container)) continue 2;

                        //target is contained in source
                        if ($data->is_child($ifc_param, $value))
                        {
                                //buffer section in clone
                                $_data->copy($value);
                                $flag_copy = TRUE;
                        }
                        else
                        {
                                //remove section in master
                                $data->del($value);

                                //buffer section in clone
                                $_data->cut($value);
                        };
                        break;
                };

                //transmit buffer from clone to master
                $data->buffer = $_data->buffer;

                //paste
                switch (CMS_IFC_MESSAGE)
                {
                case "copy_insert":
                case "cut_insert":

                        //insert buffer in master
                        $_object = $data->insert($ifc_param);
                        break;

                case "copy_append":
                case "cut_append":

                        //append buffer in master
                        $_object = $data->append($ifc_param);
                        break;
                };

                //create template on copy
                if (
                     $source_is_container
                     &&
                     $flag_template
                     &&
                     $flag_copy
                   )
                {
                        if ($template_index = $template->add($data->get($_object, "name"), //name
                                                             NULL,                         //category
                                                             NULL,                         //base
                                                             "<CMS:nocache>" .             //code
                                                             "<?php\n" .
                                                             "\$GLOBALS[\"mailform_form\"] = \"$_object\";\n" .
                                                             "cms_application(\"mailform\");\n" .
                                                             "?>" .
                                                             "</CMS:nocache>"))
                                $data->set($template_index, $_object, "template");
                };

                $_list[] = $_object;
        };

        //save changes
        if ($data->save())
        {
                //set target as selection
                switch (CMS_IFC_MESSAGE)
                {
                case "copy_insert":
                case "cut_insert":
                        $object = $ifc_param;
                        break;

                case "copy_append":
                case "cut_append":
                        $object = $data->move("parent", $ifc_param);
                        break;
                };

                $list         = $_list;
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "del":
//.....................................................................................................
        if (count($list) === 0) break; //no selection;

        $data    = new data("#system/mailform");
        $array   = array();
        $stack   = array();
        $_object = $object;

        //get path to object
        while ($_object = $data->move("parent", $_object))
                array_unshift($stack, $_object);
        array_unshift($stack, 0);

        //delete
        reset($list);
        while (list(, $value) = each($list))
        {
                if ($_value = $data->get($value, "template")) $array[] = $_value;
                $data->del($value);
        };

        if ($data->save())
        {
                //select last existing object in path
                while (! $data->get($object))
                {
                        $object = array_pop($stack);
                        if ($object === 0) break;
                };

                //delete templates
                if (cms_load("template"))
                {
                        $template           = new template();
                        $template->operator = TRUE;

                        reset($array);
                        while (list(, $value) = each($array))
                                $template->delete($value);
                };

                $list         = array($object);
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "config":
//.....................................................................................................
        if (! cms_permission(CMS_MAILFORM_PERMISSION_OPERATOR)) break; //no permission

        //get values
        if (streq(CMS_IFC_MESSAGE, "config"))
        {
                $system     = new system();
                $ifc_param1 = $system->getval("email", "address");
                $ifc_param2 = $system->getval("email", "method");
                $ifc_param3 = $system->getval("email", "smtp");
                $ifc_param4 = $system->getval("email", "username");
                $ifc_param5 = $system->getval("email", "password");
        };

        //display
        $ifc = new ifc(empty($smtp) ? $ifc_response : $smtp->response,
                       $ifc_page,
                       TRUE,
                       array("object" => $object,
                             "list"   => $list),
                       "_config",
                       CMS_L_IFC_MAILFORM_040);

        $ifc->set(CMS_L_IFC_MAILFORM_042, "text 40 b",   $ifc_param1 ? $ifc_param1 : CMS_EMAIL_AGENT);
        $ifc->set(CMS_L_IFC_MAILFORM_052, "radio b",     "mail", streq($ifc_param2, "mail"));
        $ifc->set(CMS_L_IFC_MAILFORM_054, "title");
        $ifc->set(CMS_L_IFC_MAILFORM_053, "radio b",     NULL,   stre($ifc_param2));
        $ifc->set(CMS_L_IFC_MAILFORM_041, "text 40 b",   $ifc_param3);
        $ifc->set(CMS_L_IFC_MAILFORM_043, "text 40 b",   $ifc_param4);
        $ifc->set(CMS_L_IFC_MAILFORM_044, "password 40", $ifc_param5);

        $ifc->close();

case "_config":
//.....................................................................................................
        if (! cms_permission(CMS_MAILFORM_PERMISSION_OPERATOR)) break; //no permission

        //set values
        $system = new system();
        $system->setval($ifc_param1, "email", "address");
        $system->setval($ifc_param2, "email", "method");
        $system->setval($ifc_param3, "email", "smtp");
        $system->setval($ifc_param4, "email", "username");
        $system->setval($ifc_param5, "email", "password");

        $ifc_response = $system->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "test":
//.....................................................................................................
        if (! cms_permission(CMS_MAILFORM_PERMISSION_OPERATOR)) break; //no permission

        $ifc_response = CMS_MSG_ERROR;

        if (! cms_load("smtp")) break;

        $smtp = new smtp();

        if (! $smtp->enabled)
        {
                $ifc_response = CMS_MSG_ERROR . "<br>SMTP: " . x($smtp->response);
        }

        elseif (cms_load("mime"))
        {
                $mime = new mime();
                $mime->add_text(CMS_L_IFC_MAILFORM_055,  //subject
                                CMS_L_IFC_MAILFORM_055); //body

                $ifc_response = $smtp->send($mime,             //mime
                                            CMS_EMAIL_AGENT,   //from
                                            CMS_EMAIL_AGENT) ? //to
                                CMS_MSG_DONE :
                                CMS_MSG_ERROR . "<br>SMTP: " . x($smtp->response);

                $smtp->quit();
        };

        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array(""                               => CMS_L_ACCESS,
                     CMS_MAILFORM_PERMISSION_OPERATOR => CMS_L_OPERATOR));

//cache selected object permanently
if (CMS_IFC_MESSAGE !== "") cms_cache("mailform." . CMS_USER . ".object", $object, TRUE);

$data           = new data("#system/mailform");
$type           = $data->get($object, "#type");
$flag_pagebreak = nstreq($type, "pagebreak");
$flexview       = new flexview();

$flexview->import_data($data);

//menu
$menu = array(CMS_L_IFC_MAILFORM_010 . "|mailform/command_add_form"    => "add_receiver",
              CMS_L_IFC_MAILFORM_002 . "|mailform/command_add_element" => "add_element",
              CMS_L_COMMAND_COPY .     "|mailform/command_copy"        => "copy",
              CMS_L_COMMAND_CUT .      "|mailform/command_cut"         => "cut",
              CMS_L_COMMAND_DELETE .   "|mailform/command_delete"      => "#del");
if (cms_permission(CMS_MAILFORM_PERMISSION_OPERATOR))
{
        $menu[CMS_L_IFC_MAILFORM_040 . "|mailform/command_configuration"] = "config";
        $menu[CMS_L_IFC_MAILFORM_045 . "|mailform/command_test"]          = "test";
};

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object" => $object,
                     "status" => $status));

echo("<table class=\"layout\" " .
            "style=\"WIDTH:100%\">" .

     "<colgroup>" .
     "<col>");
if ($status)
        echo("<col style=\"WIDTH:1px\">" .
             "<col style=\"WIDTH:200px\">");
if ($object && $flag_pagebreak)
        echo("<col span=\"2\" " .
                  "style=\"WIDTH:1px\">");
echo("</colgroup>" .

     "<tr>" .
     "<td>");

ifc_table_open();

//add receiver or element button
echo("<tr>" .
     "<td class=\"highlight2\">" .
     "<a href=\"javascript:ifc_post('" . ($object ? "add_element" : "add_receiver") . "');\">" .
     "[...]" .
     "</a>" .
     "</td>" .
     "</tr>" .

//folder
     "<tr>" .
     "<td class=\"varied2\">");
$flexview->set_encoding_function(__NAMESPACE__ . "\\qr");
$flexview->set_checkbox_identifier("list");
$flexview->set_checkbox_list($list);
$flexview->show_folder($object,
                       "javascript:ifc_post('select','%index%');",
                       "name",
                       NULL,
                       array("container" => "mailform/icon_form",
                             "checkbox"  => "mailform/icon_checkbox",
                             "radio"     => "mailform/icon_radio",
                             "select"    => "mailform/icon_select",
                             "text"      => "mailform/icon_text",
                             "textarea"  => "mailform/icon_textarea",
                             "code"      => "mailform/icon_code",
                             "hidden"    => "mailform/icon_hidden",
                             "pagebreak" => "mailform/icon_pagebreak"));
echo("</td>" .
     "</tr>" .

//selection control
     "<tr>" .
     "<td class=\"highlight\" " .
         "style=\"TEXT-ALIGN:right\">");
$ifc->set(CMS_L_IFC_MAILFORM_011, "button", "javascript:ifc_list_activate();");
$ifc->set(CMS_L_IFC_MAILFORM_036, "button", "javascript:ifc_list_invert();");
$ifc->set(CMS_L_IFC_MAILFORM_037, "button", "javascript:ifc_list_deactivate();");
echo("</td>" .
     "</tr>");
ifc_table_close();

echo("</td>");

if ($status)
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //target
             "<td>");

        ifc_table_open();
        echo("<tr>" .
             "<th>" .
             (streq($status, "copy") ? CMS_L_COMMAND_COPY : CMS_L_COMMAND_CUT) .
             "</th>" .
             "</tr>" .
             "<tr>" .
             "<td class=\"target\">");
        if ($object && ((! $data->is_container($object)) || $data->has_children($object)))
        {
                $flexview->show_target($target,
                                       "javascript:ifc_post('target','%index%');",
                                       "javascript:ifc_post('" . $status . "_insert','%index%');",
                                       "javascript:ifc_post('" . $status . "_append','%index%');",
                                       "name",
                                       0,
                                       array("container" => TRUE), //insert type list
                                       NULL,                       //insert subtype list
                                       array("checkbox"  => TRUE,  //append type list
                                             "radio"     => TRUE,
                                             "select"    => TRUE,
                                             "text"      => TRUE,
                                             "textarea"  => TRUE,
                                             "code"      => TRUE,
                                             "hidden"    => TRUE,
                                             "pagebreak" => TRUE));
        }
        else
        {
                $flexview->show_target($target,
                                       "javascript:ifc_post('target','%index%');",
                                       NULL,
                                       "javascript:ifc_post('" . $status . "_append','%index%');",
                                       "name",
                                       0,
                                       TRUE,                        //insert type list
                                       NULL,                        //insert subtype list
                                       array("base"      => TRUE,   //append type list
                                             "container" => TRUE));
        };
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");
};


//data
if ($object && $flag_pagebreak)
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //data
             "<td>");

        ifc_table_open();
        echo("<tr>" .
             "<th>" .
             CMS_L_IFC_MAILFORM_012 .
             "</th>" .
             "</tr>" .
             "<tr>" .
             "<td class=\"varied\">");

        //get active form object
        $_object = $object;

        while (! $data->is_container($_object))
        {
                $_object = $data->move("parent", $_object);
                if (! $_object) break;
        };

        //name
        $ifc->set(CMS_L_NAME, "text 50 256 bl", $data->get($object, "name"));

        echo("<div style=\"TEXT-ALIGN:right\">");

        //get active form object
        $_object = $object;

        while (! $data->is_container($_object))
        {
                $_object = $data->move("parent", $_object);
                if (! $_object) break;
        };

        //display button
        if ($_object)
                $ifc->set(CMS_L_COMMAND_SHOW,
                          "button",
                          "javascript:load_page('" .
                          q(CMS_MODULES_URL) . "mailform.php" .
                          "?mailform_form=" . rq($_object) . "');");

        //save button
        $ifc->set(CMS_L_COMMAND_SAVE, "button", "save");
        echo("</div>");

        //field id
        if (nstreq($type, "container"))
                $ifc->set(CMS_L_IFC_MAILFORM_030, "text 50 256 b",         $data->get($object, "id"));

        switch ($type)
        {
        case "container":
//.....................................................................................................

                //description
                $ifc->set(CMS_L_IFC_MAILFORM_025, "texteditor 50x8 bilrt", $data->get($object, "description"));

                //receiver address
                $ifc->set(CMS_L_IFC_MAILFORM_013, "text 50 256 bl",        $data->get($object, "email"));

                //target address
                $ifc->set(CMS_L_IFC_MAILFORM_027, "text 50 256 bl",        $data->get($object, "url"));

                //confirmation text
                $ifc->set(CMS_L_IFC_MAILFORM_028, "info b");
                $ifc->set(CMS_L_IFC_MAILFORM_026, "texteditor 50x8 bilrt", $data->get($object, "confirmation"));

                //submit button
                $ifc->set(CMS_L_IFC_MAILFORM_050, "text 50 256 bl",        $data->get($object, "submit"));

                //captcha
                $ifc->set(CMS_L_IFC_MAILFORM_046, "checkbox b", TRUE,      $data->get($object, "captcha"));
                break;

        case "checkbox":
        case "radio":
//.....................................................................................................

                //description
                $ifc->set(CMS_L_IFC_MAILFORM_025, "texteditor 50x8 bilrt", $data->get($object, "description"));

                //option list
                $ifc->set(CMS_L_IFC_MAILFORM_014, "textarea 50x16 bl",     $data->get($object, "option"));
                $ifc->set(CMS_L_IFC_MAILFORM_015, "info b");
                $ifc->set(CMS_L_IFC_MAILFORM_034, "label");
                $ifc->set(array(1 => 1,
                                2 => 2,
                                3 => 3,
                                4 => 4),
                          "select :",
                          $data->get($object, "column"));

                //required flag
                $ifc->set(CMS_L_IFC_MAILFORM_023, "checkbox b", TRUE,      $data->get($object, "required"));

                //do not send data in confirmation flag
                $ifc->set(CMS_L_IFC_MAILFORM_056, "checkbox", TRUE,        $data->get($object, "secret"));
                break;

        case "select":
//.....................................................................................................

                //description
                $ifc->set(CMS_L_IFC_MAILFORM_025, "texteditor 50x8 bilrt", $data->get($object, "description"));

                //option list
                $ifc->set(CMS_L_IFC_MAILFORM_014, "textarea 50x16 bl",     $data->get($object, "option"));
                $ifc->set(CMS_L_IFC_MAILFORM_015, "info b");

                //required flag
                $ifc->set(CMS_L_IFC_MAILFORM_023, "checkbox b", TRUE,      $data->get($object, "required"));

                //do not send data in confirmation flag
                $ifc->set(CMS_L_IFC_MAILFORM_056, "checkbox", TRUE,        $data->get($object, "secret"));
                break;

        case "text":
//.....................................................................................................

                //description
                $ifc->set(CMS_L_IFC_MAILFORM_025, "texteditor 50x8 bilrt", $data->get($object, "description"));

                //field width in characters
                $ifc->set(CMS_L_IFC_MAILFORM_016, "text 3 3 :",            $data->get($object, "width"));

                //maximum text length
                $ifc->set(CMS_L_IFC_MAILFORM_017, "text 3 3 :b",           $data->get($object, "length"));

                //default value
                $ifc->set(CMS_L_IFC_MAILFORM_018, "text 50 256 bl",        $data->get($object, "default"));

                //prefab verifications
                $array = array(" "                    => "",
                               CMS_L_IFC_MAILFORM_020 => "/^[\p{L}\p{P}\p{Zs}]*$/u",
                               CMS_L_IFC_MAILFORM_058 => "/^[\p{L}\p{P}\p{Zs}\p{Nd}]*$/u",
                               CMS_L_IFC_MAILFORM_022 => "/^[ \/\(\)0-9\+\-]*$/",
                               CMS_L_IFC_MAILFORM_021 => "/^.+@.+\..+$/",
                               CMS_L_IFC_MAILFORM_057 => "/^(?:[!#$&-;=?-[\]_a-z~]|%[0-9a-fA-F]{2})*$/",
                               CMS_L_IFC_MAILFORM_031 => "/^\p{Nd}*$/u");
                $match = $data->get($object, "match");
                $flag  = in_array($match, $array);

                $ifc->set(CMS_L_IFC_MAILFORM_019, "label");
                $ifc->set($array,                 "select",                $flag ? $match : NULL);

                //required flag
                $ifc->set(CMS_L_IFC_MAILFORM_023, "checkbox b", TRUE,      $data->get($object, "required"));

                //custom verification
                $ifc->set(CMS_L_IFC_MAILFORM_035, "text 50 b",             $flag ? NULL   : $match);

                //send confirmation flag, interprets field as email address
                $ifc->set(CMS_L_IFC_MAILFORM_032, "checkbox b", TRUE,      $data->get($object, "confirm"));

                //do not send data in confirmation flag
                $ifc->set(CMS_L_IFC_MAILFORM_056, "checkbox", TRUE,        $data->get($object, "secret"));
                break;

        case "textarea":
//.....................................................................................................

                //description
                $ifc->set(CMS_L_IFC_MAILFORM_025, "texteditor 50x8 bilrt", $data->get($object, "description"));

                //field width in characters
                $ifc->set(CMS_L_IFC_MAILFORM_016, "text 3 3 :",            $data->get($object, "width"));

                //field height in characters
                $ifc->set(CMS_L_IFC_MAILFORM_024, "text 3 3 :b",           $data->get($object, "height"));

                //default value
                $ifc->set(CMS_L_IFC_MAILFORM_018, "textarea 50x8 bl",      $data->get($object, "default"));

                //required flag
                $ifc->set(CMS_L_IFC_MAILFORM_023, "checkbox b", TRUE,      $data->get($object, "required"));

                //do not send data in confirmation flag
                $ifc->set(CMS_L_IFC_MAILFORM_056, "checkbox", TRUE,        $data->get($object, "secret"));
                break;

        case "code":
//.....................................................................................................

                //description
                $ifc->set(CMS_L_IFC_MAILFORM_025, "texteditor 50x8 bilrt", $data->get($object, "description"));

                //code
                $ifc->set(CMS_L_IFC_MAILFORM_048, "textarea 50x16 bl",     $data->get($object, "code"));
                $ifc->set(CMS_L_IFC_MAILFORM_049, "info b");

                //hidden flag
                $ifc->set(CMS_L_IFC_MAILFORM_051, "checkbox b", TRUE,      $data->get($object, "codeonly"));

                //default value
                $ifc->set(CMS_L_IFC_MAILFORM_018, "textarea 50x8 bl",      $data->get($object, "default"));

                //prefab verifications
                $array = array(" "                    => "",
                               CMS_L_IFC_MAILFORM_020 => "/^[\p{L}\p{P}\p{Zs}]*$/u",
                               CMS_L_IFC_MAILFORM_058 => "/^[\p{L}\p{P}\p{Zs}\p{Nd}]*$/u",
                               CMS_L_IFC_MAILFORM_022 => "/^[ \/\(\)0-9\+\-]*$/",
                               CMS_L_IFC_MAILFORM_021 => "/^.+@.+\..+$/",
                               CMS_L_IFC_MAILFORM_057 => "/^(?:[!#$&-;=?-[\]_a-z~]|%[0-9a-fA-F]{2})*$/",
                               CMS_L_IFC_MAILFORM_031 => "/^\p{Nd}*$/u");
                $match = $data->get($object, "match");
                $flag  = in_array($match, $array);

                $ifc->set(CMS_L_IFC_MAILFORM_019, "label");
                $ifc->set($array,                 "select",                $flag ? $match : NULL);

                //required flag
                $ifc->set(CMS_L_IFC_MAILFORM_023, "checkbox b", TRUE,      $data->get($object, "required"));

                //custom verification
                $ifc->set(CMS_L_IFC_MAILFORM_035, "text 50 b",             $flag ? NULL   : $match);

                //do not send data in confirmation flag
                $ifc->set(CMS_L_IFC_MAILFORM_056, "checkbox", TRUE,        $data->get($object, "secret"));
                break;

        case "hidden":
//.....................................................................................................

                //default value
                $ifc->set(CMS_L_IFC_MAILFORM_018, "textarea 50x8 b",       $data->get($object, "default"));

                //send confirmation flag, interprets field as email address
                $ifc->set(CMS_L_IFC_MAILFORM_032, "checkbox b", TRUE,      $data->get($object, "confirm"));

                //do not send data in confirmation flag
                $ifc->set(CMS_L_IFC_MAILFORM_056, "checkbox", TRUE,        $data->get($object, "secret"));
                break;
        };

        echo("</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");
};
echo("</tr>");
ifc_table_close();

$ifc->close();

