<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (! cms_load("media"))      ifc_inactive($ifc_page);
if (! cms_load("media_type")) ifc_inactive($ifc_page);

if (empty($object))     $object   = cms_cache("media." . CMS_USER . ".object");
if (! isset($language)) $language = NULL;

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = language_set($object, $ifc_param, $language);
        break;

case "select_language":
//.....................................................................................................
        $language = $ifc_param;
        break;

case "display":
//.....................................................................................................
        if ($object)
        {
                cms_cache("media." . CMS_USER . ".object", $object, TRUE);
                media_preview($object);
        };

        exit();

case "upload":
//.....................................................................................................
        $media    = new media();
        $_object  = language_get($object, $language, TRUE);
        $category = $media->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_upload",
                       CMS_L_IFC_MEDIA_001);

        //name
        $ifc->set(CMS_L_NAME,              "text 40 40 bl");

        //file
        $ifc->set(CMS_L_IFC_MEDIA_002,     "file b");

        //type
        $ifc->set(CMS_L_IFC_MEDIA_012,     "label");
        $ifc->set(media_type_get_select(), "select 40 b");

        //category
        $ifc->set(CMS_L_IFC_MEDIA_019,     "title");
        $ifc->set(CMS_L_IFC_MEDIA_009,     "text 40 40 b");
        $ifc->set(CMS_L_IFC_MEDIA_003,     "label");
        $ifc->set(media_get_select(),      "select 40", $category);

        //filename
        $ifc->set(CMS_L_IFC_MEDIA_017,     "title");
        $ifc->set(CMS_L_IFC_MEDIA_018,     "text 35 40");
        echo(".ext");

//javascript
?>
<script>
ifc_get_object("ifc_file1").click();
</script>
<?php

        $ifc->close();

case "_upload":
//.....................................................................................................
        if (isset($ifc_file1_name))
        {
                $media = new media();

                if ($_object = $media->add($ifc_file1,                              //uploaded file
                                           $ifc_file1_name,                         //uploaded filename
                                           $ifc_param1,                             //name
                                           $ifc_param2,                             //type
                                           $ifc_param3 ? $ifc_param3 : $ifc_param4, //category
                                           $ifc_param5))                            //filename
                {
                        $object       = language_set($object, $_object, $language);
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "upload_multi":
//.....................................................................................................
        $media    = new media();
        $_object  = language_get($object, $language, TRUE);
        $category = $media->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_upload_multi",
                       CMS_L_IFC_MEDIA_020);

        //info
        $ifc->set(CMS_L_IFC_MEDIA_021,     "info b");

        //file
        $ifc->set(CMS_L_IFC_MEDIA_002,     "multifile b");

        //type
        $ifc->set(CMS_L_IFC_MEDIA_012,     "label");
        $ifc->set(media_type_get_select(), "select 40 b");

        //category
        $ifc->set(CMS_L_IFC_MEDIA_019,     "title");
        $ifc->set(CMS_L_IFC_MEDIA_009,     "text 40 40 b");
        $ifc->set(CMS_L_IFC_MEDIA_003,     "label");
        $ifc->set(media_get_select(),      "select 40", $category);

//javascript
?>
<script>
ifc_get_object("ifc_file1[]").click();
</script>
<?php

        $ifc->close();

case "_upload_multi":
//.....................................................................................................
        if (is_array($ifc_file1)) $array = array_combine($ifc_file1, $ifc_file1_name);
        else                      $array = array($ifc_file1 => $ifc_file1_name);

        $media   = new media();
        $_object = "";
        $error   = FALSE;

        reset($array);
        while (list($key, $value) = each($array))
        {
                if ($__object = $media->add($key,                                     //uploaded file
                                            $value,                                   //uploaded filename
                                            NULL,                                     //name
                                            $ifc_param1,                              //type
                                            $ifc_param2 ? $ifc_param2 : $ifc_param3)) //category
                        $_object = $__object;
                else
                        $error   = TRUE;
        };

        $object       = language_set($object, $_object, $language);
        $ifc_response = $error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "add":
case "edit":
//.....................................................................................................
        $media   = new media();
        $_object = language_get($object, $language, TRUE);

        $flag    = NULL;
        if (streq(CMS_IFC_MESSAGE, "edit"))
        {
                $ifc_param1 = $media->data->get($_object, "name");
                $ifc_param2 = $media->data->get($_object, "url");
                $ifc_param3 = $media->data->get($_object, "type");
                $flag       = $media->internal($_object);
        };

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_" . CMS_IFC_MESSAGE,
                       streq(CMS_IFC_MESSAGE, "add") ? CMS_L_COMMAND_ADD : CMS_L_COMMAND_EDIT);

        //name
        $ifc->set(CMS_L_NAME,              "text 40 40 bl",      isset($ifc_param1) ? $ifc_param1 : NULL);

        //url
        if ($flag) $ifc->dummy();
        else       $ifc->set(CMS_L_URL,    "text 40 256 b$flag", isset($ifc_param2) ? $ifc_param2 : "http://");

        //type
        $ifc->set(CMS_L_IFC_MEDIA_012,     "label");
        $ifc->set(media_type_get_select(), "select 40 b",        isset($ifc_param3) ? $ifc_param3 : NULL);

        //category
        $ifc->set(CMS_L_IFC_MEDIA_019,     "title");
        $ifc->set(CMS_L_IFC_MEDIA_009,     "text 40 40 b",       isset($ifc_param4) ? $ifc_param4 : NULL);
        $ifc->set(CMS_L_IFC_MEDIA_003,     "label");
        $ifc->set(media_get_select(),      "select 40",          $media->data->get($_object, "category"));

        if ($flag)
        {
                //extract extension and filename
                $filename  = $media->data->get($_object, "filename");
                if ($filename === NULL) $filename = substr($_object, 8);
                $extension = utf8_strtolower(strrchr($filename, "."));
                $filename  = substr($filename, 0, -strlen($extension));

                //filename
                $ifc->set(CMS_L_IFC_MEDIA_017, "title");
                $ifc->set(CMS_L_IFC_MEDIA_018, "text 35 40", $filename);
                echo(x($extension));
        };

        $ifc->close();

case "_add":
//.....................................................................................................
        $media = new media();

        if ($_object = $media->link($ifc_param2,                              //url
                                    $ifc_param1,                              //name
                                    $ifc_param3,                              //type
                                    $ifc_param4 ? $ifc_param4 : $ifc_param5)) //category
        {
                $object       = language_set($object, $_object, $language);
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "_edit":
//.....................................................................................................
        $media   = new media();
        $_object = language_get($object, $language, TRUE);
        $flag    = $media->internal($_object); //internal

        if ($_object = $media->set($_object,                                 //index
                                   $ifc_param1,                              //name
                                   $ifc_param3,                              //type
                                   $ifc_param4 ? $ifc_param4 : $ifc_param5,  //category
                                   $flag       ? $ifc_param6 : $ifc_param2)) //filename or url
        {
                $object       = language_set($object, $_object, $language);
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "replace":
//.....................................................................................................
        $media   = new media();
        $_object = language_get($object, $language, TRUE);

        //external
        if (! $media->internal($_object))
        {
                $ifc_response = CMS_L_IFC_MEDIA_016;
                break;
        };

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_replace",
                       CMS_L_IFC_MEDIA_008);

        //file
        $ifc->set(CMS_L_IFC_MEDIA_002, "file");

//javascript
?>
<script>
ifc_autopost("ifc_file1", "_replace");
ifc_get_object("ifc_file1").click();
</script>
<?php

        $ifc->close();

case "_replace":
//.....................................................................................................
        if (isset($ifc_file1_name))
        {
                $media        = new media();
                $_object      = language_get($object, $language, TRUE);
                $ifc_response = $media->replace($_object,          //index
                                                $ifc_file1,        //file
                                                $ifc_file1_name) ? //filename
                                CMS_MSG_DONE : CMS_MSG_ERROR;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "delete":
//.....................................................................................................
        if (empty($_object)) break; //no selection

        reset($_object);
        list(, $value) = each($_object);

        $media      = new media();
        $category   = $media->data->get($value, "category");
        $flag_error = TRUE;

        //delete selected media
        do
        {
                $flag_error &= ! $media->unlink($value);
        }
        while (list(, $value) = each($_object));

        //remove invalid media links from selection
        $array = explode(",", CMS_LANGUAGE_ENABLED);
        if (CMS_LANGUAGE_ENABLED) $array[] = FALSE;

        reset($array);
        while (list(, $value) = each($array))
        {
                $_object = language_get($object, $value, TRUE);

                if (! $media->data->get($_object))
                {
                        //active language
                        if (streq($value, $language))
                        {
                                $media->data->move("first");
                                $_object = $media->data->seek(array("category" => $category));
                                $object  = language_set($object, $_object, $value);
                        }

                        //inactive language(s)
                        else
                        {
                                $object  = language_set($object, NULL, $value);
                        };
                };
        };

        $ifc_response = $flag_error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "category_rename":
//.....................................................................................................
        $media    = new media();
        $_object  = language_get($object, $language, TRUE);
        $category = $media->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_category_rename",
                       CMS_L_IFC_MEDIA_005);

        //category
        $ifc->set(CMS_L_NAME, "text 40 40 b", $category);

        $ifc->close();

case "_category_rename":
//.....................................................................................................
        $media    = new media();
        $_object  = language_get($object, $language, TRUE);
        $category = $media->data->get($_object, "category");

        $media->data->move("first");
        while ($key = $media->data->move("next"))
        {
                $_category = $media->data->get($key, "category");
                if (streq($_category, $category))
                        $media->data->set($ifc_param1, $key, "category");
        };

        $ifc_response = $media->data->save() ? CMS_MSG_DONE : CMS_MSG_DONE;
        break;

case "type":
case "type_add":
case "type_set":
case "type_delete":
//.....................................................................................................
        $media_type = new media_type();

        switch (CMS_IFC_MESSAGE)
        {
        case "type_add":
//.....................................................................................................
                if ($_type_object = $media_type->add(CMS_L_IFC_MEDIA_011))
                {
                        $type_object  = $_type_object;
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR;
                break;

        case "type_set":
//.....................................................................................................
                $ifc_response = $media_type->set($type_object, $ifc_param1, $ifc_param2, $ifc_param3) ?
                                CMS_MSG_DONE : CMS_MSG_ERROR;
                break;

        case "type_delete":
//.....................................................................................................
                if ($media_type->delete($type_object))
                {
                        $type_object  = NULL;
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };

                $ifc_response = CMS_MSG_ERROR;
                break;
        };

        if (empty($type_object))
        {
                if ($object)
                {
                        $media       = new media();
                        $type_object = $media->data->get($object, "type");

                        if (! $type_object)
                        {
                                $type_object = substr(strrchr($object, "."), 1);
                                $type_object = $media_type->get_index($type_object);
                        };
                };

                if (empty($type_object))
                        $type_object = $media_type->data->move("first");
        };

        //menu
        $menu = NULL;
        if ($media_type->operator)
        {
                $menu[CMS_L_COMMAND_ADD . "|media/command_add"] = "type_add";

                if ($type_object)
                        $menu[CMS_L_COMMAND_DELETE . "|media/command_delete"] = "#type_delete";
        };
        $menu[CMS_L_COMMAND_CLOSE . "|media/command_cancel"] = FALSE;

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       $menu,
                       array("object"   => $object,
                             "language" => $language),
                       "type",
                       CMS_L_IFC_MEDIA_010);

        if (! $media_type->data->move("first")) $ifc->close();

        //list
        echo("<label class=\"element\">");
        $ifc->set(CMS_L_IFC_MEDIA_010, "description b");
        echo("<select name=\"type_object\" " .
                     "onchange=\"if (this.selectedIndex != -1) ifc_submit();\">");
        $flag = NULL;
        while ($key = $media_type->data->move("next"))
        {
                //name
                $name = $media_type->data->get($key, "name");
                $name = strabridge($name, 40);

                echo("<option value=\"" . x($key) . "\"" .
                              (streq($key, $type_object) ? " selected>" : ">") .
                     whitechartostring(x($name), "&nbsp;") .
                     ($flag ? NULL : str_repeat("&nbsp;", 40 - utf8_strlen($name))) .
                     "</option>");
                $flag = TRUE;
        };
        echo("</select>" .
             "</label><br>");

        //name
        $ifc->set(CMS_L_NAME,          "text 40 40",        $media_type->data->get($type_object, "name"));

        //save button
        $ifc->set(CMS_L_COMMAND_SAVE,  "button b",          "type_set");

        //file extensions
        $ifc->set(CMS_L_IFC_MEDIA_013, "text 60 256 b",     $media_type->data->get($type_object, "type"));

        echo("<table class=\"layout\">" .
             "<tr>" .
             "<td>");

        //code
        $ifc->set(CMS_L_IFC_MEDIA_014, "textarea 60x20 ln", $media_type->get_code($type_object));
        echo("</td>" .
             "<td>" .
             "&nbsp;" .
             "</td>" .
             "<td>");

        //javascript
?>
<script>
function media_type_insert(value)
{
        textcontrol_set("document.ifc.l_ifc_param3", "#replace", value);
};
//................................
function media_type_select()
{
        textcontrol_select(document.ifc.l_ifc_param3);
};

document.ifc.l_ifc_param3.onselect = media_type_select;
document.ifc.l_ifc_param3.onchange = media_type_select;
</script>
<?php

        //placeholders
        echo("<label class=\"element\">");
        $ifc->set(CMS_L_IFC_MEDIA_015, "description b");
        echo("<select size=\"10\" " .
                     "onclick=\"media_type_insert(this[this.selectedIndex].value);\">" .
             "<option value=\"%id%\">id</option>" .
             "<option value=\"%src%\">src</option>" .
             "<option value=\"%type%\">type</option>" .
             "<option value=\"%width%\">width</option>" .
             "<option value=\"%height%\">height</option>" .
             "<option value=\"%alt%\">alt</option>" .
             "<option value=\"%title%\">title</option>" .
             "<option value=\"%class%\">class</option>" .
             "<option value=\"%style%\">style</option>" .
             "</select>" .
             "</label>" .
             "</td>" .
             "</tr>" .
             "</table>");

        $ifc->close();
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array(""                            => CMS_L_ACCESS,
                     CMS_MEDIA_PERMISSION_OPERATOR => CMS_L_OPERATOR));

$media   = new media();
$_object = language_get($object, $language, TRUE);
$array   = media_get_array();

//get category from object
if ($_object && in_array_recursive($_object, $array))
{
        $category = $media->data->get($_object, "category");
        if (! $category) $category = "";
        cms_cache("media." . CMS_USER . ".category", $category, TRUE);
}

//get object from category
else
{
        $category = (string)cms_cache("media." . CMS_USER . ".category");
        if ((! $category) || (! isset($array[$category]))) $category = "";

        if (is_array($array[$category]))
        {
                $_object = current($array[$category]);
                $object  = language_set($object, $_object, $language);
        };
};

//menu
$menu = NULL;
if (CMS_IFC_SELECT && $_object)
        $menu[CMS_L_COMMAND_INSERT . "|media/command_apply"]        = "javascript:ifc_return();";
if ($media->operator)
{
        $menu[CMS_L_COMMAND_ADD .    "|media/command_add"]          = "add";
        $menu[CMS_L_IFC_MEDIA_001 .  "|media/command_upload"]       = "upload";
        $menu[CMS_L_IFC_MEDIA_020 .  "|media/command_upload_multi"] = "upload_multi";
        if ($_object)
        {
                $menu[CMS_L_COMMAND_EDIT .   "|media/command_edit"]      = "edit";
                $menu[CMS_L_IFC_MEDIA_008 .  "|media/command_overwrite"] = "replace";
                $menu[CMS_L_COMMAND_DELETE . "|media/command_delete"]    = "#delete";
                $menu[CMS_L_IFC_MEDIA_005 .  "|media/command_rename"]    = "category_rename";
        };
        $menu[CMS_L_IFC_MEDIA_010 . "|media/command_code"]          = "type";
};

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object"   => $object,
                     "language" => $language));

//javascript
?>
<script>
function media_select(value)
{
        var language              = "<?php echo(q($language));?>";
        if (ifc_language_get(document.ifc.object.value, language) == value) return;
        document.ifc.object.value = ifc_language_set(document.ifc.object.value, value, language);
        if (document.getElementById)
                document.getElementById("media-display").src =
                        "<?php echo(q(CMS_ACTIVE_URL) . "?ifc_page=" . rq(CMS_IFC_PAGE));?>" +
                        "&ifc_message=display&object=" + encodeURIComponent(value);
};
</script>
<?php

ifc_table_open();
echo("<colgroup>" .
     "<col style=\"WIDTH:1px\">" .
     "<col>" .
     "</colgroup>" .

     "<tr>" .
     "<td class=\"varied2\">");

//category
$ifc->set(CMS_L_IFC_MEDIA_019, "description b");
echo("<select onchange=\"if (this.selectedIndex != -1) " .
             "ifc_post('select',this[this.selectedIndex].value);\">");
$flag = NULL;
reset($array);
while (list($key, $value) = each($array))
{
        $name  = strabridge($key, 40);
        $value = is_array($value) ? current($value) : NULL;
        echo("<option value=\"" . x($value) . "\"" .
                      (streq($key, $category) ? " selected>" : ">") .
             whitechartostring(x($name), "&nbsp;") .
             ($flag ? NULL : str_repeat("&nbsp;", 40 - utf8_strlen($name))) .
             "</option>");
        $flag  = TRUE;
};
echo("</select>");

//list
if ($flag = is_array($array[$category]))
{
        $media_type = new media_type();

        echo("<br>");

        $ifc->set(CMS_L_IFC_MEDIA_007, "description b");
        echo("<select name=\"_object[]\" " .
                     "size=\"15\" " .
                     "multiple " .
                     "onchange=\"if (this.selectedIndex != -1) " .
                     "media_select(this[this.selectedIndex].value);\" " .
                     "ondblclick=\"ifc_return();\">");
        reset($array[$category]);
        while (list($key, $value) = each($array[$category]))
        {
                //type
                $type  = $media->data->get($value, "type");
                if (! $type)
                {
                        $type = substr(strrchr($value, "."), 1);
                        $type = $media_type->get_index($type);
                };
                $type  = $media_type->data->get($type, "name");
                $type  = strabridge($type, 10);
                $type  = str_repeat(" ", 10 - utf8_strlen($type)) . $type;

                //name
                $name  = strabridge($key, 27);
                $name .= str_repeat(" ", 27 - utf8_strlen($name));

                echo("<option value=\"" . x($value) . "\"" .
                              (streq($value, $_object) ? " selected>" : ">") .
                     whitechartostring(x("$name \xE2\x94\x82 $type"), "&nbsp;") .
                     "</option>");
        };
        echo("</select>");
};

//language
if (CMS_IFC_SELECT && CMS_LANGUAGE_ENABLED)
{
        echo("<div class=\"language\">" .
             "<a href=\"javascript:ifc_post('select_language','');\" " .
                "class=\"language-" . (streq($language, "") ? "on" : "off") . "\">" .
             image("language/default_small", 16, 12, CMS_L_LANGUAGE_DEFAULT) .
             "</a>");

        $_language = explode(",", CMS_LANGUAGE_ENABLED);

        reset($_language);
        while (list(, $value) = each($_language))
                echo("<a href=\"javascript:ifc_post('select_language','" . rqx($value) . "');\" " .
                        "class=\"language-" . (streq($language, $value) ? "on" : "off") . "\">" .
                     image(is_file(CMS_DATA_PATH . "language/" . $value . "_small.gif") ?
                           CMS_DATA_URL . "language/" . $value . "_small.gif" :
                           "language/default_small",
                           16, 12, $value) .
                     "</a>");

        echo("</div>");
};
echo("</td>" .

//display media
     "<td class=\"iframe\">" .
     "<iframe id=\"media-display\" " .
             "src=\"" . x(CMS_ACTIVE_URL) .
             "?ifc_page=" . r(CMS_IFC_PAGE) .
             "&amp;ifc_message=display" .
             "&amp;object=" . r($_object) . "\">" .
     CMS_L_IFC_MEDIA_004 .
     "</iframe>" .
     "</td>" .
     "</tr>");
ifc_table_close();

$ifc->close();
?>