<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (! cms_load("search")) ifc_inactive($ifc_page);

$search = new search();
if (! $search->enabled)   ifc_inactive($ifc_page);

if (empty($object))             $object            = NULL;
if (empty($sql_table))          $sql_table         = CMS_DB_SEARCH_ENTRY;
if (isset($_sql_filter_field))  $sql_filter_field  = $_sql_filter_field;
if (empty($sql_filter_field))   $sql_filter_field  = CMS_DB_SEARCH_ENTRY_ADDRESS;
if (isset($_sql_filter_option)) $sql_filter_option = $_sql_filter_option;
if (empty($sql_filter_option))  $sql_filter_option = " LIKE '%#value#%'";
if (isset($_sql_filter_value))  $sql_filter_value  = $_sql_filter_value;
if (empty($sql_filter_value))   $sql_filter_value  = "";
if (isset($_sql_order))         $sql_order         = $_sql_order;
if (empty($sql_order))          $sql_order         = CMS_DB_SEARCH_ENTRY_TIME . " DESC";
if (isset($page))               $page              = (int)$page;
if (empty($page))               $page              = 0;
if (isset($_limit))             $limit             = (int)$_limit;
if (empty($limit))              $limit             = 25;

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "scan":
//.....................................................................................................
        $array = array(CMS_SEARCH_SCAN_UNKNOWN_ERROR               => CMS_L_IFC_SEARCH_043,
                       CMS_SEARCH_SCAN_REDIRECTION_LIMIT_EXCEEDED  => CMS_L_IFC_SEARCH_013,
                       CMS_SEARCH_SCAN_INVALID_ADDRESS             => CMS_L_IFC_SEARCH_033,
                       CMS_SEARCH_SCAN_ADDRESS_REJECTED            => CMS_L_IFC_SEARCH_051,
                       CMS_SEARCH_SCAN_NO_CONNECTION               => CMS_L_IFC_SEARCH_034,
                       CMS_SEARCH_SCAN_UNSUPPORTED_RESOURCE_FORMAT => CMS_L_IFC_SEARCH_035,
                       CMS_SEARCH_SCAN_NO_MODIFICATION             => CMS_L_IFC_SEARCH_036,
                       CMS_SEARCH_SCAN_UPDATE_OMITTED              => CMS_L_IFC_SEARCH_037,
                       CMS_SEARCH_SCAN_DATA_FETCH_FAILED           => CMS_L_IFC_SEARCH_038,
                       CMS_SEARCH_SCAN_NO_CONTENT                  => CMS_L_IFC_SEARCH_039,
                       CMS_SEARCH_SCAN_INDEXING_UNDESIRED          => CMS_L_IFC_SEARCH_040,
                       CMS_SEARCH_SCAN_INDEXED                     => CMS_L_IFC_SEARCH_041,
                       CMS_SEARCH_SCAN_INDEXING_FAILED             => CMS_L_IFC_SEARCH_042);

        $ifc_param1 = translate_url($ifc_param1);
        $result     = $search->scan($ifc_param1, isset($ifc_param2));

        $ifc_response = (CMS_SEARCH_SCAN_ERROR & $result) ? CMS_MSG_ERROR : CMS_MSG_DONE;
        if (isset($array[$result])) $ifc_response .= $array[$result];
        break;

case "queue_add":
//.....................................................................................................
        if (empty($list)) break; //no selection

        $error = FALSE;

        if ($result = mysql_query("SELECT " . CMS_DB_SEARCH_ENTRY_ADDRESS . " " .
                                  "FROM " .   CMS_DB_SEARCH_ENTRY . " " .
                                  "WHERE " .  CMS_DB_SEARCH_ENTRY_INDEX . " " .
                                  "IN ('" .   implode("', '", $list) . "')"))
        {
                while ($resultrow = mysql_fetch_row($result))
                        $error |= ! $search->queue_add($resultrow[0], CMS_SEARCH_QUEUE_TYPE_SELECTION);
        };

        $ifc_response = $error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "queue_add_all":
//.....................................................................................................
        $ifc_response = $search->queue_add_all() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "queue_add_internal":
//.....................................................................................................
        $language = (CMS_LANGUAGE_ENABLED != "") ? explode(",", CMS_LANGUAGE_ENABLED) : array("");
        $error    = FALSE;

        reset($language);
        while (list(, $value) = each($language))
        {
                $value = stre($value) ? "" : "$value.";
                $map   = new map("#system/" . $value . "directory");
                $list  = $map->get_value_list();

                reset($list);
                while (list(, $_value) = each($list))
                        $error |= ! $search->queue_add(CMS_ROOT_URL . cms_path_urlencode($_value),
                                                       CMS_SEARCH_QUEUE_TYPE_INTERNAL);
        };

        $ifc_response = $error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "queue_remove":
//.....................................................................................................
        $ifc_response = $search->queue_remove($ifc_param) ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "queue_process":
//.....................................................................................................
        $array = array(CMS_L_IFC_SEARCH_019 => CMS_SEARCH_QUEUE_TYPE_ALL,
                       CMS_L_IFC_SEARCH_020 => CMS_SEARCH_QUEUE_TYPE_INTERNAL,
                       CMS_L_IFC_SEARCH_027 => CMS_SEARCH_QUEUE_TYPE_SELECTION,
                       CMS_L_IFC_SEARCH_021 => CMS_SEARCH_QUEUE_TYPE_SUBMISSION,
                       CMS_L_IFC_SEARCH_022 => CMS_SEARCH_QUEUE_TYPE_REFERENCE,
                       CMS_L_IFC_SEARCH_023 => CMS_SEARCH_QUEUE_TYPE_UPDATE);

        //display
        $ifc = new ifc(NULL, NULL, NULL);

        //javascript
?>
<script>
function queue_process_start()
{
        var type         = ifc_value("ifc_param1");
        var follow_links = ifc_value("ifc_param2") ? "1" : "0";
        var force_update = ifc_value("ifc_param3") ? "1" : "0";

        location.replace("<?php echo(q(CMS_ACTIVE_URL));?>" +
                         "?ifc_page=<?php echo(q(CMS_IFC_PAGE));?>" +
                         "&ifc_message=_queue_process" +
                         "&ifc_param=" + escape(type) +
                         "&ifc_option=external" +
                         "&follow_links=" + escape(follow_links) +
                         "&force_update=" + escape(force_update));
};
</script>
<?php

        $ifc->set($array,               "select b",   $ifc_param);
        $ifc->set(CMS_L_IFC_SEARCH_016, "checkbox b", TRUE, FALSE);
        $ifc->set(CMS_L_IFC_SEARCH_056, "checkbox b", TRUE, FALSE);
        $ifc->set(CMS_L_IFC_SEARCH_057, "button",     "javascript:queue_process_start();");

        $ifc->close();

case "_queue_process":
//.....................................................................................................
        $array = array(CMS_SEARCH_QUEUE_TYPE_INTERNAL   => CMS_L_IFC_SEARCH_020,
                       CMS_SEARCH_QUEUE_TYPE_SELECTION  => CMS_L_IFC_SEARCH_027,
                       CMS_SEARCH_QUEUE_TYPE_SUBMISSION => CMS_L_IFC_SEARCH_021,
                       CMS_SEARCH_QUEUE_TYPE_REFERENCE  => CMS_L_IFC_SEARCH_022,
                       CMS_SEARCH_QUEUE_TYPE_UPDATE     => CMS_L_IFC_SEARCH_023,
                       CMS_SEARCH_QUEUE_TYPE_ALL        => CMS_L_IFC_SEARCH_019);

        $follow_links = (bool)$follow_links;
        $force_update = (bool)$force_update;

        $menu = array(CMS_L_IFC_SEARCH_024 . "|search/command_window_clone"
                      => "javascript:load_page(document.URL);");

        //display
        $ifc = new ifc(NULL, NULL, $menu);

        //description
        echo("<strong>" .
             $array[$ifc_param] .
             ($follow_links ? " - " . CMS_L_IFC_SEARCH_016 : "") .
             ($force_update ? " - " . CMS_L_IFC_SEARCH_056 : "") .
             "..." .
             "</strong><br>");

        //threads
        for ($i = 0; $i < 4; $i++)
                echo("<object data=\"" . x(CMS_ACTIVE_URL) .
                             "?ifc_page=" . r(CMS_IFC_PAGE) .
                             "&amp;ifc_message=queue_process_thread" .
                             "&amp;ifc_param=" . r($ifc_param) .
                             "&amp;follow_links=" . r($follow_links) .
                             "&amp;force_update=" . r($force_update) . "\" " .
                             "type=\"text/html\" " .
                             "class=\"search-thread\">" .
                     "</object>");

        $ifc->close();

case "queue_process_thread":
//.....................................................................................................
        echo(CMS_DOCTYPE_HTML .
             "<html>" .
             "<head>" .
             "<title></title>" .
             stylesheet(CMS_URL . "stylesheet/ifc.css") .
             "</head>" .
             "<body class=\"search-thread\">" .
             "<div id=\"loader\" " .
                  "class=\"search-thread\">" .
             CMS_L_IFC_SEARCH_029 .
             "</div>" .
             "</body>" .
             "</html>");

        flush();

        if (! isset($ifc_param))    $ifc_param    = CMS_SEARCH_QUEUE_TYPE_ALL;
        if (! isset($follow_links)) $follow_links = FALSE;
        else                        $follow_links = (bool)$follow_links;
        if (! isset($force_update)) $force_update = FALSE;
        else                        $force_update = (bool)$force_update;

        //process queue
        if (($value = $search->queue_process($ifc_param, $follow_links, $force_update)) !== FALSE)
        {
                if (CMS_SEARCH_SCAN_ERROR & $value) { $color = "red";   $text = CMS_L_IFC_SEARCH_030; }
                else                                { $color = "green"; $text = CMS_L_IFC_SEARCH_031; };
                $time = 1000;
        }
        else
        {
                $color = "blue";
                $text  = CMS_L_IFC_SEARCH_032;
                $time  = 300000;
        };

        $buffer = jscript("var object = document.getElementById(\"loader\");" .
                          "object.style.backgroundColor = \"%s\";" .
                          "object.textContent = \"%s\";" .
                          "setTimeout(\"location.reload(true);\", %d);");

        printf($buffer, $color, $text, $time);
        exit();

case "entry_remove":
//.....................................................................................................
        if (empty($list)) break; //no selection

        $error = FALSE;

        reset($list);
        while (list(, $value) = each($list))
                $error |= ! $search->entry_remove($value);

        $ifc_response = $error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "data_process":
//.....................................................................................................
        //display
        $ifc  = new ifc(NULL, NULL, FALSE);

        //description
        echo("<strong>" .
             CMS_L_IFC_SEARCH_046 . "..." .
             "</strong><br>" .

        //thread
             "<object data=\"" . x(CMS_ACTIVE_URL) .
                     "?ifc_page=" . r(CMS_IFC_PAGE) .
                     "&amp;ifc_message=data_process_thread" .
                     "&amp;_" . r(unique_id()) . "=1\" " .
                     "type=\"text/html\" " .
                     "class=\"search-thread\" " .
                     "style=\"WIDTH:100%\">" .
             "</object>");

        $ifc->close();

case "data_process_thread":
//.....................................................................................................
        if (empty($action)) $action = 0;

        switch ($action)
        {
        case 0: //initialize page score

                $iteration = 1;
                $image     = "data_processing.png";
                $info      = CMS_L_IFC_SEARCH_047;
                break;

        case 1: //compute page score

                if ($iteration <= $search->score_compute_iteration_number)
                {
                        $image = "data_processing.png";
                        $info  = sprintf(CMS_L_IFC_SEARCH_048,
                                         $iteration,
                                         $search->score_compute_iteration_number);
                        break;
                };

                $action++;

        case 2: //finalize page score

                $iteration = $search->score_compute_link_level();
                $image     = "data_processing.png";
                $info      = CMS_L_IFC_SEARCH_049;
                break;

        case 3: //integrate dangling links

                if ($iteration > 0)
                {
                        $level = $search->score_compute_link_level();
                        $image = "data_processing.png";
                        $info  = sprintf(CMS_L_IFC_SEARCH_050,
                                         $level - $iteration + 1,
                                         $level);
                        break;
                };

                $action++;

        case 4; //complete

                $image = "data_success.png";
                $info  = CMS_L_IFC_SEARCH_032;
                break;
        };

        echo(CMS_DOCTYPE_HTML .
             "<html>" .
             "<head>" .
             "<title></title>" .
             stylesheet(CMS_URL . "stylesheet/ifc.css") .
             "</head>" .
             "<body class=\"search-thread\">" .
             "<div>" .
             "<img id=\"loader\" " .
                  "src=\"" . x(CMS_IMAGES_URL) . "search/$image\" " .
                  "alt=\"\"> " .
             "<span id=\"info\" " .
                   "class=\"br\">" .
             $info .
             "</span>" .
             "</div>" .
             "</body>" .
             "</html>");

        ob_flush();
        flush();

        switch ($action)
        {
        case 0: //initialize page score

                $result = $search->score_compute_initialize();
                $action++;
                break;

        case 1: //compute page score

                $result = $search->score_compute_iterate();
                $iteration++;
                break;

        case 2: //finalize

                $result = $search->score_compute_finalize();
                $action++;
                break;

        case 3: //integrate dangling links

                $result = $search->score_compute_iterate($iteration);
                $iteration--;
                break;

        case 4: //complete

                exit();
        };

        //success
        if ($result === TRUE)
        {
                echo(jscript("location.replace(\"" .
                             q(CMS_ACTIVE_URL) .
                             "?ifc_page=" . r(CMS_IFC_PAGE) .
                             "&ifc_message=data_process_thread" .
                             "&action=" . r($action) .
                             "&iteration=" . r($iteration) .
                             "&_" . r(unique_id()) . "=1\");"));
                exit();
        };

        //failure
        $image = q(CMS_IMAGES_URL) . "search/data_failure.png";
        echo(jscript("document.getElementById(\"loader\").src = \"$image\";" .
                     "document.getElementById(\"info\").textContent = \"" . qx($result) . "\";"));
        exit();

case "filter":
//.....................................................................................................
        $system    = new system();
        $blacklist = $system->getval("search", "blacklist");
        $whitelist = $system->getval("search", "whitelist");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("sql_table"         => $sql_table,
                             "sql_filter_field"  => $sql_filter_field,
                             "sql_filter_option" => $sql_filter_option,
                             "sql_filter_value"  => $sql_filter_value,
                             "sql_order"         => $sql_order,
                             "page"              => $page,
                             "limit"             => $limit),
                       "_filter",
                       CMS_L_IFC_SEARCH_052);

        $ifc->set(CMS_L_IFC_SEARCH_055, "info b");
        $ifc->set(CMS_L_IFC_SEARCH_053, "textarea 60x12 b", $blacklist);
        $ifc->set(CMS_L_IFC_SEARCH_054, "textarea 60x12",   $whitelist);

        $ifc->close();

case "_filter":
//.....................................................................................................
        $system = new system();

        $system->setval($ifc_param1, "search", "blacklist");
        $system->setval($ifc_param2, "search", "whitelist");

        $ifc_response = $system->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "stopword":
//.....................................................................................................
        $data  = new data("#system/language");
        $array = array();

        $data->move("first");
        while ($key = $data->move("next"))
                $array[$key] = $data->get($key, "stopword");

        $language = array_keys($array);
        sort($language);
        $language = implode(",", $language);

        $value = language_set_array($array);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("sql_table"         => $sql_table,
                             "sql_filter_field"  => $sql_filter_field,
                             "sql_filter_option" => $sql_filter_option,
                             "sql_filter_value"  => $sql_filter_value,
                             "sql_order"         => $sql_order,
                             "page"              => $page,
                             "limit"             => $limit),
                       "_stopword",
                       CMS_L_IFC_SEARCH_059);

        $ifc->set(CMS_L_IFC_SEARCH_061, "info b");
        $ifc->set(CMS_L_IFC_SEARCH_060, "textarea 60x24 bl", $value, NULL, NULL, $language);

        $ifc->close();

case "_stopword":
//.....................................................................................................
        $data  = new data("#system/language");
        $array = language_get_array($ifc_param1);

        $data->move("first");
        while ($key = $data->move("next"))
        {
                $value = isset($array[$key]) ? $array[$key] : "";
                $data->set($value, $key, "stopword");
        };

        $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "clean":
//.....................................................................................................
        $ifc_response = $search->clean() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "page":
//.....................................................................................................
        $page = $ifc_param;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array("" => CMS_L_ACCESS));

//menu
$menu = array(CMS_L_IFC_SEARCH_028 . "|search/command_queue_add"
              => "queue_add",
              CMS_L_IFC_SEARCH_026 . "|search/command_queue_add_internal"
              => "queue_add_internal",
              CMS_L_IFC_SEARCH_015 . "|search/command_queue_add_all"
              => "queue_add_all",
              CMS_L_COMMAND_DELETE . "|search/command_entry_remove"
              => "#entry_remove",
              CMS_L_IFC_SEARCH_017 . "|search/command_data_process"
              => "javascript:load_page('" .
                 q(CMS_ACTIVE_URL) .
                 "?ifc_page=" . r(CMS_IFC_PAGE) .
                 "&ifc_message=data_process" .
                 "&ifc_option=external);');",
              CMS_L_IFC_SEARCH_052 . "|search/command_filter"
              => "filter",
              CMS_L_IFC_SEARCH_059 . "|search/command_stopword"
              => "stopword",
              CMS_L_IFC_SEARCH_025 . "|search/command_clean"
              => "#clean");

//display
$ifc  = new ifc($ifc_response,
                $ifc_page,
                $menu,
                array("sql_table"         => $sql_table,
                      "sql_filter_field"  => $sql_filter_field,
                      "sql_filter_option" => $sql_filter_option,
                      "sql_filter_value"  => $sql_filter_value,
                      "sql_order"         => $sql_order,
                      "page"              => $page,
                      "limit"             => $limit));

//javascript
?>
<script>
function qp(type)
{
        load_page("<?php echo(q(CMS_ACTIVE_URL));?>" +
                  "?ifc_page=<?php echo(q(CMS_IFC_PAGE));?>" +
                  "&ifc_message=queue_process" +
                  "&ifc_param=" + escape(type) +
                  "&ifc_option=external");
};
//................................
function qr(type)
{
        if (confirm("<?php echo(q(CMS_L_COMMAND_DELETE));?>?")) ifc_post("queue_remove", type);
};
</script>
<?php

echo("<div class=\"info\">" .
     sprintf(CMS_L_IFC_SEARCH_003,
             $search->queue_length(),
             "javascript:qp('" . qx(CMS_SEARCH_QUEUE_TYPE_ALL) . "');",
             "javascript:qr('" . qx(CMS_SEARCH_QUEUE_TYPE_ALL) . "');",
             $search->queue_length(CMS_SEARCH_QUEUE_TYPE_INTERNAL),
             "javascript:qp('" . qx(CMS_SEARCH_QUEUE_TYPE_INTERNAL) . "');",
             "javascript:qr('" . qx(CMS_SEARCH_QUEUE_TYPE_INTERNAL) . "');",
             $search->queue_length(CMS_SEARCH_QUEUE_TYPE_SELECTION),
             "javascript:qp('" . qx(CMS_SEARCH_QUEUE_TYPE_SELECTION) . "');",
             "javascript:qr('" . qx(CMS_SEARCH_QUEUE_TYPE_SELECTION) . "');",
             $search->queue_length(CMS_SEARCH_QUEUE_TYPE_SUBMISSION),
             "javascript:qp('" . qx(CMS_SEARCH_QUEUE_TYPE_SUBMISSION) . "');",
             "javascript:qr('" . qx(CMS_SEARCH_QUEUE_TYPE_SUBMISSION) . "');",
             $search->queue_length(CMS_SEARCH_QUEUE_TYPE_REFERENCE),
             "javascript:qp('" . qx(CMS_SEARCH_QUEUE_TYPE_REFERENCE) . "');",
             "javascript:qr('" . qx(CMS_SEARCH_QUEUE_TYPE_REFERENCE) . "');",
             $search->queue_length(CMS_SEARCH_QUEUE_TYPE_UPDATE),
             "javascript:qp('" . qx(CMS_SEARCH_QUEUE_TYPE_UPDATE) . "');",
             "javascript:qr('" . qx(CMS_SEARCH_QUEUE_TYPE_UPDATE) . "');") .
     "</div>");

//search filter
ifc_table_open();
echo("<tr>" .
     "<td class=\"varied\">");
$ifc->set(CMS_L_IFC_SEARCH_001, "description b");

//field
$ifc->set(array(CMS_L_URL            => CMS_DB_SEARCH_ENTRY_ADDRESS,
                CMS_L_IFC_SEARCH_002 => CMS_DB_SEARCH_ENTRY_TITLE,
                CMS_L_IFC_SEARCH_004 => CMS_DB_SEARCH_ENTRY_TEXT,
                CMS_L_IFC_SEARCH_005 => CMS_DB_SEARCH_ENTRY_TIME,
                CMS_L_IFC_SEARCH_058 => CMS_DB_SEARCH_ENTRY_SCORE),
          "select",
          $sql_filter_field,
          NULL,
          "_sql_filter_field");

//condition
$ifc->set(array(CMS_L_IFC_SEARCH_006 => " LIKE '#value#%'",
                CMS_L_IFC_SEARCH_007 => " LIKE '%#value#%'",
                CMS_L_IFC_SEARCH_008 => " LIKE '%#value#'",
                CMS_L_IFC_SEARCH_009 => ">'#value#'",
                CMS_L_IFC_SEARCH_010 => "='#value#'",
                CMS_L_IFC_SEARCH_011 => "<'#value#'"),
          "select",
          $sql_filter_option,
          NULL,
          "_sql_filter_option");

//value
$ifc->set(NULL,                  "text 20 40 :", $sql_filter_value, NULL, "_sql_filter_value");

//apply button
$ifc->set(CMS_L_COMMAND_CONFIRM, "button");

//reset button
$ifc->set(CMS_L_IFC_SEARCH_044,  "button b",     "javascript:ifc_reset(1);ifc_submit();");

//order by
$ifc->set(CMS_L_IFC_SEARCH_045,  "description b");
$ifc->set(array(CMS_L_URL            => CMS_DB_SEARCH_ENTRY_ADDRESS,
                CMS_L_IFC_SEARCH_002 => CMS_DB_SEARCH_ENTRY_TITLE,
                CMS_L_IFC_SEARCH_004 => CMS_DB_SEARCH_ENTRY_TEXT,
                CMS_L_IFC_SEARCH_005 => CMS_DB_SEARCH_ENTRY_TIME . " DESC",
                CMS_L_IFC_SEARCH_058 => CMS_DB_SEARCH_ENTRY_SCORE . " DESC"),
          "select",
          $sql_order,
          NULL,
          "_sql_order");

//row display limit per page
$ifc->set(array( 10 => "10",
                 25 => "25",
                 50 => "50",
                 75 => "75",
                100 => "100",
                250 => "250",
                500 => "500"),
          "select",
          $limit,
          NULL,
          "_limit");
echo(CMS_L_IFC_SEARCH_012 .
     "</td>" .
     "</tr>");
ifc_table_close();

//retrieve data
$query   = "SELECT " .   CMS_DB_SEARCH_ENTRY_INDEX . ", " .
                         CMS_DB_SEARCH_ENTRY_ADDRESS . ", " .
                         CMS_DB_SEARCH_ENTRY_TITLE . ", " .
                         CMS_DB_SEARCH_ENTRY_TIME . ", " .
                         CMS_DB_SEARCH_ENTRY_SCORE . ", " .
                         CMS_DB_SEARCH_ENTRY_ERROR . " " .
           "FROM " .     CMS_DB_SEARCH_ENTRY . " ";
if ($sql_filter_value) $query .=
           "WHERE " .    sqlesc($sql_filter_field) .
                         str_replace("#value#", sqlesc($sql_filter_value), $sql_filter_option) . " ";
$query  .= "ORDER BY " . sqlesc($sql_order);
$result  = mysql_query($query);

//javascript
?>
<script>
function p(number)
{
        ifc_post("page", number);
};
</script>
<?php

//page selection
$count = mysql_num_rows($result);

if ($count > $limit)
{
        $count  = ceil($count / $limit) - 1;
        if ($page > $count) $page    = $count;
        $offset = $page - 5;
        $end    = $page + 5;
        if ($offset < 0)    $end    += 0 - $offset;
        if ($end > $count)
        {
                $offset += $count - $end;
                $end     = $count;
        };
        if ($offset < 0)    $offset  = 0;

        echo("<span class=\"br\">" .
             CMS_L_IFC_CONTENT_082 . ": ");

        //start
        if ($offset)
                echo("<a href=\"javascript:p(0);\" " .
                        "title=\"" . CMS_L_COMMAND_START . "\">" .
                     "&#171;&#171;" .
                     "</a> ");

        //previous
        if ($page)
                echo("<a href=\"javascript:p(" . ($page - 1) . ");\" " .
                        "title=\"" . CMS_L_COMMAND_PREVIOUS . "\">" .
                     "&#171;" .
                     "</a> ");

        if ($offset)        echo("... ");

        //page
        for ($i = $offset; $i <= $end; )
                echo("<a href=\"javascript:p($i);\">" .
                     (($i++ == $page) ?
                      "<strong>" .
                      $i .
                      "</strong>" :
                      $i) .
                     "</a> ");

        if ($end < $count)  echo("...");

        //next
        if ($page < $count)
                echo(" <a href=\"javascript:p(" . ($page + 1) . ");\" " .
                         "title=\"" . CMS_L_COMMAND_NEXT . "\">" .
                     "&#187;" .
                     "</a>");

        //start
        if ($end < $count)
                echo(" <a href=\"javascript:p($count);\" " .
                         "title=\"" . CMS_L_COMMAND_END . "\">" .
                     "&#187;&#187;" .
                     "</a>");

        echo("</span>");

        mysql_data_seek($result, $page * $limit);
};

ifc_table_open();
echo("<colgroup>" .
     "<col style=\"WIDTH:1px\">" .
     "<col span=\"4\">" .
     "</colgroup>" .

//header
     "<tr>" .

//selection
     "<td rowspan=\"2\" " .
         "class=\"highlight\">" .
     "&nbsp;" .
     "</td>" .

//address
     "<th>" .
     CMS_L_URL .
     "</th>" .

//score
     "<th>" .
     CMS_L_IFC_SEARCH_058 .
     "</th>" .

//title
     "<th>" .
     CMS_L_IFC_SEARCH_002 .
     "</th>" .

//time
     "<th>" .
     CMS_L_IFC_SEARCH_005 .
     "</th>" .
     "</tr>" .

//add button
     "<tr>" .
     "<td colspan=\"4\" " .
         "class=\"highlight2\">");
$ifc->set(CMS_L_IFC_SEARCH_018, "text 30",  CMS_PROTOCOL . "://");
$ifc->set("...",                "button",   "javascript:load_page('" .
                                            q(CMS_ACTIVE_URL) .
                                            "?ifc_page=content" .
                                            "&ifc_message=edit_href" .
                                            "&ifc_option=external" .
                                            "&ifc_select=__value" .
                                            "&ifc_select_action=javascript:ifc_change(" .
                                            "this.opener.document.ifc.ifc_param1,\\'%return%\\');');");
$ifc->set(CMS_L_IFC_SEARCH_016, "checkbox", TRUE);
$ifc->set(CMS_L_IFC_SEARCH_014, "button",   "scan");
echo("</td>" .
     "</tr>");

$i = 0;

while (
        ($i < $limit)
        &&
        ($resultrow = mysql_fetch_assoc($result))
      )
{
        $varied = ifc_varied();

        //icon
        $image = ((int)$resultrow[CMS_DB_SEARCH_ENTRY_ERROR] > 0) ?
                 "search/icon_page_error" : "search/icon_page";

        echo("<tr>" .

        //selection
             "<td class=\"highlight\">");
        $ifc->set(NULL, "checkbox", $resultrow[CMS_DB_SEARCH_ENTRY_INDEX], FALSE, "list[" . $i++ . "]");
        echo("</td>" .

        //address
             "<td$varied>" .
             "<a href=\"" . x($resultrow[CMS_DB_SEARCH_ENTRY_ADDRESS]) . "\" " .
                "onclick=\"load_page(this.href);return false;\">" .
             image($image) . " " . x(strabridge($resultrow[CMS_DB_SEARCH_ENTRY_ADDRESS], 40)) .
             "</a>" .
             "</td>" .

        //score
             "<td$varied>" .
             x(number_format($resultrow[CMS_DB_SEARCH_ENTRY_SCORE], 2,
                             CMS_L_DECIMAL_SEPARATOR,
                             CMS_L_THOUSAND_SEPARATOR)) .
             "</td>" .

        //title
             "<td$varied>" .
             x(strabridge($resultrow[CMS_DB_SEARCH_ENTRY_TITLE], 80)) .
             "</td>" .

        //time
             "<td$varied>" .
             x(friendly_date($resultrow[CMS_DB_SEARCH_ENTRY_TIME])) .
             "</td>" .
             "</tr>");
};

//selection control
echo("<tr>" .
     "<td colspan=\"5\" " .
         "class=\"highlight\" " .
         "style=\"TEXT-ALIGN:right\">");
$ifc->set(CMS_L_IFC_PERMISSION_023, "button", "javascript:ifc_list_activate();");
$ifc->set(CMS_L_IFC_PERMISSION_024, "button", "javascript:ifc_list_invert();");
$ifc->set(CMS_L_IFC_PERMISSION_025, "button", "javascript:ifc_list_deactivate();");
echo("</td>" .
     "</tr>");
ifc_table_close();

$ifc->close();
?>