<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
ifc_permission(array("" => CMS_L_ACCESS));

switch (CMS_IFC_MESSAGE)
{
case "setup_password":
//.....................................................................................................
        $data      = new data("#system/permission");
        $superuser = "user." . CMS_SUPERUSER;

        //password empty
        if (stre($ifc_param1))
        {
                $ifc_response = CMS_MSG_ERROR . "<br>" . CMS_L_IFC_SETUP_020;
                break;
        };

        //confirmation mismatch
        if (nstreq($ifc_param1, $ifc_param2))
        {
                $ifc_response = CMS_MSG_ERROR . "<br>" . CMS_L_IFC_SETUP_021;
                break;
        };

        $ifc_param1 = md5($ifc_param1);
        $data->set($ifc_param1, $superuser, "password");

        //generate obfuscation string
        $secret1    = cms_cache("cms.5c080f9d6448aa7514a2842e1ae732d7");
        $secret2    = "11f544779d678530603c344c5381d2b1";
        $ifc_param1 = md5(md5("$secret1|$secret2") . "|$ifc_param1");

        setcookie("cms_password",   //name
                  $ifc_param1,      //value
                  NULL,             //expire
                  CMS_RELATIVE_URL, //path
                  NULL,             //domain
                  FALSE,            //secure
                  TRUE);            //httponly

        $ifc_response = $data->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "setup_database":
//.....................................................................................................

        //set values
        $system = new system();
        $system->setval($ifc_param1, "mysql", "host");
        $system->setval($ifc_param2, "mysql", "database");
        $system->setval($ifc_param3, "mysql", "user");
        $system->setval($ifc_param4, "mysql", "password");

        $ifc_response = $system->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "setup_smtp":
//.....................................................................................................

        //set values
        $system = new system();
        $system->setval($ifc_param1, "email", "address");
        $system->setval($ifc_param2, "email", "method");
        $system->setval($ifc_param3, "email", "smtp");
        $system->setval($ifc_param4, "email", "username");
        $system->setval($ifc_param5, "email", "password");

        $ifc_response = $system->save() ? CMS_MSG_DONE : CMS_MSG_ERROR;
        break;

case "do_not_show":
//.....................................................................................................
        if (nstreq(CMS_USER, "admin")) break; //administrator only

        //do not show setup after login anymore
        $system = new system();
        $system->setval(TRUE, "setup", "done");
        $system->setval(NULL, "mysql", "restore");
        $system->save();
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================

//display
$ifc = new ifc(NULL,
               $ifc_page,
               NULL);

$system     = new system();
$setup_done = $system->getval("setup", "done");

//change administrator passwort
if (streq(CMS_SUPERUSER, "admin")) //user is administrator
{
        $data = new data("#system/permission");

        if (

        //password is empty
             stre($password = $data->get("user." . CMS_SUPERUSER, "password"))
             ||

        //password matches default
             streq($password, "21232f297a57a5a743894a0e4a801fc3") //md5("admin");
           )
        {
                if (streq(CMS_IFC_MESSAGE, "setup_password"))
                        $ifc->set($ifc_response, "info");

                ifc_table_open(NULL);

                //title
                echo("<tr>" .
                     "<th>" .
                     CMS_L_IFC_SETUP_001 .
                     "</th>" .
                     "</tr>" .

                //description
                     "<tr>" .
                     "<td class=\"info\">" .
                     CMS_L_IFC_SETUP_002 .
                     "</td>" .
                     "</tr>" .

                //values
                     "<tr>" .
                     "<td>");
                $ifc->set(CMS_L_IFC_SETUP_003, "password 40 40 b");
                $ifc->set(CMS_L_IFC_SETUP_004, "password 40 40");
                echo("</td>" .
                     "</tr>" .

                //submit button
                     "<tr>" .
                     "<td class=\"special\" " .
                         "style=\"FONT-WEIGHT:bold;TEXT-ALIGN:center\">");
                $ifc->set(CMS_L_COMMAND_NEXT,  "button", "setup_password");
                echo("</td>" .
                     "</tr>");
                ifc_table_close();

                //do not show setup after login anymore
                if (! $setup_done) $ifc->set(CMS_L_IFC_SETUP_024, "button b", "do_not_show");

                $ifc->close();
        };
};

//set up database connection
$mysql = new mysql();
if (! $mysql->connection()) //no connection
{
        //display error
        if (streq(CMS_IFC_MESSAGE, "setup_database"))
        {
                $ifc->set(CMS_MSG_ERROR . "<br>" .
                          CMS_L_IFC_SETUP_022,
                          "info");
        }

        //get values
        else
        {
                $system     = new system();
                $ifc_param1 = $system->getval("mysql", "host");
                $ifc_param2 = $system->getval("mysql", "database");
                $ifc_param3 = $system->getval("mysql", "user");
                $ifc_param4 = $system->getval("mysql", "password");
        };

        ifc_table_open(NULL);

        //title
        echo("<tr>" .
             "<th>" .
             CMS_L_IFC_SETUP_005 .
             "</th>" .
             "</tr>" .

        //description
             "<tr>" .
             "<td class=\"info\">" .
             CMS_L_IFC_SETUP_006 .
             "</td>" .
             "</tr>" .

        //values
             "<tr>" .
             "<td>");
        $ifc->set(CMS_L_IFC_SETUP_007, "text 40 b",   $ifc_param1);
        $ifc->set(CMS_L_IFC_SETUP_008, "text 40 b",   $ifc_param2);
        $ifc->set(CMS_L_IFC_SETUP_009, "text 40 b",   $ifc_param3);
        $ifc->set(CMS_L_IFC_SETUP_010, "password 40", $ifc_param4);
        echo("</td>" .
             "</tr>" .

        //submit button
             "<tr>" .
             "<td class=\"special\" " .
                 "style=\"FONT-WEIGHT:bold;TEXT-ALIGN:center\">");
        $ifc->set(CMS_L_COMMAND_NEXT,  "button", "setup_database");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        //do not show setup after login anymore
        if (! $setup_done) $ifc->set(CMS_L_IFC_SETUP_024, "button b", "do_not_show");

        $ifc->close();
};

//restore database
if ($system->getval("mysql", "restore"))
{
        //success
        if ($mysql->restore())
        {
                $ifc->set(CMS_MSG_DONE . "<br>" .
                          CMS_L_IFC_SETUP_018,
                          "info b");

                //remove restore flag
                $system->setval(NULL, "mysql", "restore");
                $system->save();
        }

        //failed
        else
        {
                $ifc->set(CMS_MSG_ERROR . "<br>" .
                          CMS_L_IFC_SETUP_019,
                          "info b");
        };
};

//ask user to set up smtp connection
while (TRUE)
{
        //get values
        if (nstreq(CMS_IFC_MESSAGE, "setup_smtp"))
        {
                $system     = new system();
                $ifc_param1 = $system->getval("email", "address");
                $ifc_param2 = $system->getval("email", "method");
                $ifc_param3 = $system->getval("email", "smtp");
                $ifc_param4 = $system->getval("email", "username");
                $ifc_param5 = $system->getval("email", "password");
        };

        //set default email
        if (! $ifc_param1) $ifc_param1 = CMS_EMAIL_AGENT;

        if (
             (
        //method is mail function
               streq($ifc_param2, "mail")
               ||

        //or host is not empty
               nstre($ifc_param3)
             )
             &&

        //library can be loaded
             cms_load("smtp")
           )
        {
                $response = NULL;

                //try to connect
                $smtp = new smtp();

                if (! $smtp->enabled) //error
                {
                        $response = $smtp->response;
                }

                elseif (cms_load("mime")) //success
                {
                        //generate test message
                        $mime = new mime();
                        $mime->add_text(CMS_L_IFC_SETUP_028,  //subject
                                        CMS_L_IFC_SETUP_028); //body

                        //send test message
                        if (! $smtp->send($mime,        //mime
                                          $ifc_param1,  //from
                                          $ifc_param1)) //to
                                $response = $smtp->response;

                        $smtp->quit();
                };

                if (stre($response)) break;

                //display error
                if (streq(CMS_IFC_MESSAGE, "setup_smtp"))
                        $ifc->set(CMS_MSG_ERROR . "<br>SMTP: " . x($response), "info");
        };

        ifc_table_open(NULL);

        //title
        echo("<tr>" .
             "<th>" .
             CMS_L_IFC_SETUP_012 .
             "</th>" .
             "</tr>" .

        //description
             "<tr>" .
             "<td class=\"info\">" .
             CMS_L_IFC_SETUP_013 .
             "</td>" .
             "</tr>" .

        //values
             "<tr>" .
             "<td>");
        $ifc->set(CMS_L_IFC_SETUP_015, "text 40 b",   $ifc_param1);
        $ifc->set(CMS_L_IFC_SETUP_025, "radio b",     "mail", streq($ifc_param2, "mail"));
        $ifc->set(CMS_L_IFC_SETUP_027, "title");
        $ifc->set(CMS_L_IFC_SETUP_026, "radio b",     NULL,   stre($ifc_param2));
        $ifc->set(CMS_L_IFC_SETUP_014, "text 40 b",   $ifc_param3);
        $ifc->set(CMS_L_IFC_SETUP_016, "text 40 b",   $ifc_param4);
        $ifc->set(CMS_L_IFC_SETUP_017, "password 40", $ifc_param5);
        echo("</td>" .
             "</tr>" .

        //submit button
             "<tr>" .
             "<td class=\"special\" " .
                 "style=\"FONT-WEIGHT:bold;TEXT-ALIGN:center\">");
        $ifc->set(CMS_L_COMMAND_NEXT,  "button", "setup_smtp");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        //do not show setup after login anymore
        if (! $setup_done) $ifc->set(CMS_L_IFC_SETUP_024, "button b", "do_not_show");

        $ifc->close();

};

//setup complete
$ifc->set(CMS_L_IFC_SETUP_011, "info");

//do not show setup after login anymore
if (! $setup_done)
{
        $system->setval(TRUE, "setup", "done");
        $system->setval(NULL, "mysql", "restore");
        $system->save();
};

$ifc->close()
?>
