<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (empty($file) || (! is_file($file)))                $file   = CMS_DATA_PATH . "#system/system.dat";

$data = new data($file);

if (empty($object) || (! isset($data->data[$object]))) $object = 0;
if (empty($list))                                      $list   = array();
if (empty($target))                                    $target = NULL;
if (empty($status))                                    $status = NULL;

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
ifc_permission(array("" => CMS_L_ACCESS));

switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = $ifc_param;
        $list   = array($object);
        $status = NULL;
        break;

case "save":
//.....................................................................................................

        //add attribute
        if ($ifc_param1) $data->set($ifc_param2, $object, $ifc_param1);

        //change attributes
        $i = 3;
        while (eval("return isset(\$attribute$i);"))
                eval("\$data->set(\$ifc_param$i, \$object, \$attribute" . $i++ . ");");

        //save changes
        if ($data->save())
        {
                //remove entry if no attributes are left
                if (! count($data->data[$object]))
                {
                        unset($data->data[$object]);
                        $object = 0;
                };

                $list         = array($object);
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "add":
//.....................................................................................................
        $ifc_param  = $object; //target
        $ifc_param1 = NULL;    //key
        $ifc_param2 = NULL;    //container flag

case "add_target":
//.....................................................................................................

        //add name property
        while ($key = $data->move("next"))
        {
                if (! $data->get($key, "name"))
                        $data->set($key, $key, "name");
        };

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       array(CMS_L_COMMAND_CANCEL . "|system/command_cancel" => FALSE),
                       array("object" => $object,
                             "list"   => $list),
                       NULL,
                       CMS_L_COMMAND_ADD);

        ifc_table_open();
        echo("<colgroup>" .
             "<col style=\"WIDTH:1px\">" .
             "<col>" .
             "</colgroup>" .

             "<tr>" .

        //data
             "<th>" .
             CMS_L_IFC_SYSTEM_006 .
             "</th>" .

        //target
             "<th>" .
             CMS_L_IFC_SYSTEM_008 .
             "</th>" .
             "</tr>" .
             "<tr>" .

        //data
             "<td class=\"varied\">");

        //key
        $ifc->set(CMS_L_IFC_SYSTEM_009, "text 40 b",      $ifc_param1);

        //container flag
        $ifc->set(CMS_L_IFC_SYSTEM_002, "checkbox", TRUE, isset($ifc_param2));
        echo("</td>" .

        //target
             "<td class=\"target\">");
        $flexview = new flexview();
        $flexview->import_data($data);
        $flexview->set_encoding_function(__NAMESPACE__ . "\\qr");
        $flexview->show_target($ifc_param,
                               "javascript:ifc_post('add_target','%index%');",
                               "javascript:ifc_post('add_insert','%index%');",
                               "javascript:ifc_post('add_append','%index%');");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        $ifc->close();

case "add_insert":
case "add_append":
//.....................................................................................................

        //set key if none is given
        if (! $ifc_param1) $ifc_param1 = unique_id();

        $data->buffer = empty($ifc_param2) ?

        //no container
                        array($ifc_param1    => array("name" => $ifc_param1)) :

        //container
                        array($ifc_param1    => array("name"  => $ifc_param1,
                                                      "#type" => "container"),
                              "/$ifc_param1" => array("#type" => "/container"));

        $ifc_param1   = $data->insert($ifc_param);

        //save changes
        if ($data->save())
        {
                $object       = $ifc_param1;
                $list         = array($object);
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "copy":
case "cut":
//.....................................................................................................
        $target = $object;
        $status = CMS_IFC_MESSAGE;
        break;

case "target":
//.....................................................................................................
        $target = $ifc_param;
        break;

case "copy_insert":
case "copy_append":
case "cut_insert":
case "cut_append":
//.....................................................................................................
        if (empty($list)) break; //no selection;

        $_data = clone $data; //use clone of data structure as source
        $_list = NULL;

        //transverse reversely
        $list  = array_reverse($list);

        reset($list);
        while (list(, $value) = each($list))
        {
                //copy / cut
                switch (CMS_IFC_MESSAGE)
                {
                case "copy_insert":
                case "copy_append":

                        //buffer section in clone
                        $_data->copy($value);
                        break;

                case "cut_insert":
                case "cut_append":

                        //target is contained in source
                        if ($data->is_child($ifc_param, $value))
                        {
                                //buffer section in clone
                                $_data->copy($value);
                        }
                        else
                        {
                                //remove section in master
                                $data->del($value);

                                //buffer section in clone
                                $_data->cut($value);
                        };
                        break;
                };

                //transmit buffer from clone to master
                $data->buffer = $_data->buffer;

                //paste
                switch (CMS_IFC_MESSAGE)
                {
                case "copy_insert":
                case "cut_insert":

                        //insert buffer in master
                        $_object = $data->insert($ifc_param);
                        break;

                case "copy_append":
                case "cut_append":

                        //append buffer in master
                        $_object = $data->append($ifc_param);
                        break;
                };

                $_list[] = $_object;
        };

        //save changes
        if ($data->save())
        {
                //set target as selection
                switch (CMS_IFC_MESSAGE)
                {
                case "copy_insert":
                case "cut_insert":
                        $object = $ifc_param;
                        break;

                case "copy_append":
                case "cut_append":
                        $object = $data->move("parent", $ifc_param);
                        break;
                };

                $list         = $_list;
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "delete":
//.....................................................................................................
        if (empty($list)) break; //no selection;

        $stack   = array();
        $_object = $object;

        //get path to object
        while ($_object = $data->move("parent", $_object))
                array_unshift($stack, $_object);
        array_unshift($stack, 0);

        //delete
        reset($list);
        while (list(, $value) = each($list))
                $data->del($value);

        //save changes
        if ($data->save())
        {
                //select last existing object in path
                while (! $data->get($object))
                {
                        $object = array_pop($stack);
                        if ($object === 0) break;
                };

                $list         = array($object);
                $status       = NULL;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================

//menu
$menu = array(CMS_L_COMMAND_ADD .    "|system/command_add"    => "add",
              CMS_L_COMMAND_COPY .   "|system/command_copy"   => "copy",
              CMS_L_COMMAND_CUT .    "|system/command_cut"    => "cut",
              CMS_L_COMMAND_DELETE . "|system/command_delete" => "#delete");

//add name property
while ($key = $data->move("next"))
{
        if (! $data->get($key, "name"))
                $data->set($key, $key, "name");
};

//temporary caching
cms_cache("data." . $data->file, $data->data);

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object" => $object,
                     "status" => $status,
                     "file"   => $file));

echo("<table class=\"layout\" " .
            "style=\"WIDTH:100%\">" .

     "<colgroup>" .
     "<col>");
if ($status)
        echo("<col style=\"WIDTH:1px\">" .
             "<col style=\"WIDTH:200px\">");
if ($object)
        echo("<col span=\"2\" " .
                "style=\"WIDTH:1px\">");
echo("</colgroup>" .

     "<tr>" .
     "<td>");

ifc_table_open();

//add button
echo("<tr>" .
     "<td class=\"highlight2\">" .
     "<a href=\"javascript:ifc_post('add');\">" .
     "[...]" .
     "</a>" .
     "</td>" .
     "</tr>" .

//treeview
     "<tr>" .
     "<td class=\"varied2\">");
$flexview = new flexview();
$flexview->import_data($data);
$flexview->set_encoding_function(__NAMESPACE__ . "\\qr");
$flexview->set_checkbox_identifier("list");
$flexview->set_checkbox_list($list);
$flexview->show_tree($object,                                              //index
                     "javascript:ifc_post('select','%index%');",           //action
                     "name",                                               //name key
                     NULL,                                                 //mark
                     array("container"  => "flexview/icon_entrycontainer", //icon
                           "+container" => "flexview/icon_entryopen"));
echo("</td>" .
     "</tr>" .

//selection control
     "<tr>" .
     "<td class=\"highlight\" " .
         "style=\"TEXT-ALIGN:right\">");
$ifc->set(CMS_L_IFC_SYSTEM_003, "button", "javascript:ifc_list_activate();");
$ifc->set(CMS_L_IFC_SYSTEM_004, "button", "javascript:ifc_list_invert();");
$ifc->set(CMS_L_IFC_SYSTEM_005, "button", "javascript:ifc_list_deactivate();");
echo("</td>" .
     "</tr>");
ifc_table_close();

echo("</td>");

if ($status)
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //target
             "<td>");

        ifc_table_open();
        echo("<tr>" .
             "<th>" .
             (streq($status, "copy") ? CMS_L_COMMAND_COPY : CMS_L_COMMAND_CUT) .
             "</th>" .
             "</tr>" .
             "<tr>" .
             "<td class=\"target\">");
        $flexview->show_target($target,
                               "javascript:ifc_post('target','%index%');",
                               "javascript:ifc_post('" . $status . "_insert','%index%');",
                               "javascript:ifc_post('" . $status . "_append','%index%');");
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");
};

//data
if ($object)
{
        //spacer
        echo("<td>" .
             "&nbsp;" .
             "</td>" .

        //data
             "<td>");

        ifc_table_open();
        echo("<tr>" .
             "<th>" .
             CMS_L_IFC_SYSTEM_009 . ": " . x($object) .
             "</th>" .
             "</tr>" .
             "<tr>" .
             "<td class=\"varied\">");

        //new attribute name
        $ifc->set(CMS_L_IFC_SYSTEM_001, "text 50 b");

        //new attribute value
        $ifc->set(CMS_L_IFC_SYSTEM_007, "textarea 50x4 bl");

        //apply button
        echo("<div style=\"TEXT-ALIGN:right\">");
        $ifc->set(CMS_L_COMMAND_SAVE,   "button", "save");
        echo("</div>");

        $i = 3;
        ksort($data->data[$object]); //order by attribute name
        reset($data->data[$object]);
        while (list($key, $value) = each($data->data[$object]))
        {
                //container
                if (
                     streq($key, "#type")
                     &&
                     streq($value, "container")
                   )
                {
                        echo("<br>" .
                             "<strong>" .
                             "#type" .
                             "</strong>" .
                             "<pre>" .
                             "container" .
                             "</pre>" .
                             "<br>");

                        continue;
                };

                //attribute name
                $ifc->param("attribute" . $i++, $key);

                //attribute value
                $ifc->set($key, "textarea 50x4 bl", $value);
        };
        echo("</td>" .
             "</tr>");
        ifc_table_close();

        echo("</td>");
};
echo("</tr>" .
     "</table>");

$ifc->close();
?>
