<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (! cms_load("template")) ifc_inactive($ifc_page);

if (empty($object))     $object   = cms_cache("template." . CMS_USER . ".object");
if (! isset($language)) $language = NULL;

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = language_set($object, $ifc_param, $language);
        break;

case "select_language":
//.....................................................................................................
        $language = $ifc_param;
        break;

case "display":
//.....................................................................................................
        $template = new template();
        if ($object)
        {
                cms_cache("template." . CMS_USER . ".object", $object, TRUE);
                template_preview($object);
        };
        $category = $template->data->get($object, "category");
        cms_cache("template." . CMS_USER . ".category", (string)$category, TRUE);
        exit();

case "add":
case "edit":
//.....................................................................................................
        $template = new template();
        $_object  = language_get($object, $language, TRUE);

        if ($flag = streq(CMS_IFC_MESSAGE, "edit"))
        {
                $ifc_param1 = $template->data->get($_object, "name");
                $ifc_param2 = $template->data->get($_object, "page");
        };

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_" . CMS_IFC_MESSAGE,
                       streq(CMS_IFC_MESSAGE, "add") ? CMS_L_COMMAND_ADD : CMS_L_COMMAND_EDIT);

        //name
        $ifc->set(CMS_L_NAME,             "text 40 40 b",   isset($ifc_param1) ? $ifc_param1 : NULL);

        //page
        $ifc->set(CMS_L_IFC_TEMPLATE_008, "checkbox b",     TRUE, ! empty($ifc_param2));

        echo("<hr>");

        //keep code
        $ifc->set($flag ? CMS_L_IFC_TEMPLATE_012 : CMS_L_IFC_TEMPLATE_002,
                                          "radio b",        1, TRUE);

        //retrieve code from url
        echo("<label class=\"element\">");
        $ifc->set(NULL,                   "radio",          2);
        echo(CMS_L_IFC_TEMPLATE_001 . "<br>");
        $ifc->set(NULL,                   "text 40 256 b:", isset($ifc_param4) ? $ifc_param4 : "http://");
        echo("</label><br>" .

        //upload code
             "<label class=\"element\">");
        $ifc->set(NULL,                   "radio",          3);
        echo(CMS_L_IFC_TEMPLATE_003 . "<br>");
        $ifc->set(NULL,                   "file b:");
        echo("</label>" .

             "<hr>");

        //category
        $ifc->set(CMS_L_IFC_TEMPLATE_004, "text 40 40 b");
        $ifc->set(CMS_L_IFC_TEMPLATE_005, "label");
        $ifc->set(template_get_select(),  "select 40",      $template->data->get($_object, "category"));

        $ifc->close();

case "_add":
case "_edit":
//.....................................................................................................
        $template = new template();
        $_object  = language_get($object, $language, TRUE);
        $code     = FALSE;

        switch ($ifc_param3)
        {
        case 1: //empty template / keep template
                $code = streq(CMS_IFC_MESSAGE, "_edit") ?
                        read_file(CMS_DATA_PATH . "#template/$_object.htm") : "";
                break;

        case 2: //read from address
                $code = template_read_plugin($ifc_param4);

                if (! $ifc_param1) $ifc_param1 = basename($ifc_param4);
                break;

        case 3: //read from file
                if ($ifc_file1_name && is_file($ifc_file1))
                {
                        $code = read_file($ifc_file1);
                        unlink($ifc_file1);

                        if (! $ifc_param1) $ifc_param1 = $ifc_file1_name;
                };
                break;
        };

        if (streq(CMS_IFC_MESSAGE, "_add"))
        {
                if ($_object = $template->add($ifc_param1,                             //name
                                              $ifc_param5 ? $ifc_param5 : $ifc_param6, //category
                                              isset($ifc_param2),                      //page
                                              $code))                                  //code
                {
                        $object       = language_set($object, $_object, $language);
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };
        }
        else
        {
                if (
                     $template->set($_object,                                //index
                                    $ifc_param1,                             //name
                                    $ifc_param5 ? $ifc_param5 : $ifc_param6, //category
                                    isset($ifc_param2))                      //page
                     &&
                     $template->set_code($_object, $code)                    //code
                   )
                {
                        $ifc_response = CMS_MSG_DONE;
                        break;
                };
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "export":
//.....................................................................................................
        if (
             cms_available("content")
             &&
             isset($content_index)
           )
        {
                //param
                $param = array("object"        => $object,
                               "language"      => $language,
                               "content_index" => $content_index);
                if (isset($content_range)) $param["content_range"] = $content_range;

                //display
                $ifc = new ifc($ifc_response,
                               $ifc_page,
                               TRUE,
                               $param,
                               "_export",
                               CMS_L_COMMAND_EXPORT);

                //name
                $ifc->set(CMS_L_NAME,             "text 40 40 b");

                //category
                $ifc->set(CMS_L_IFC_TEMPLATE_004, "text 40 40 b");
                $ifc->set(CMS_L_IFC_TEMPLATE_005, "label");
                $ifc->set(template_get_select(),  "select 40");

                $ifc->close();
        };

case "_export":
//.....................................................................................................
        if (cms_load("content"))
        {
                $content = new content();

                if ($content->enabled)
                {
                        $buffer   = content_template_export($content,                                       //content
                                                            $content_index,                                 //index
                                                            isset($content_range) ? $content_range : NULL); //range
                        $template = new template();

                        if ($_object = $template->add($ifc_param1,                             //name
                                                      $ifc_param2 ? $ifc_param2 : $ifc_param3, //category
                                                      ! isset($content_range),                 //page
                                                      $buffer["code"],                         //code
                                                      $buffer["stylesheet"]))                  //stylesheet
                        {
                                $object       = language_set($object, $_object, $language);
                                $ifc_response = CMS_MSG_DONE;
                                break;
                        };
                };
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "source":
case "_source":
case "__source":
case "___source":
//.....................................................................................................
        $template   = new template();
        $_object    = language_get($object, $language, TRUE);
        $active_url = q(CMS_ACTIVE_URL);

        switch (CMS_IFC_MESSAGE)
        {
        case "_source":
        case "__source":
        case "___source":

                if (
                     $template->set_code($_object, $ifc_param2)
                     &&
                     $template->set_stylesheet($_object, $ifc_param1)
                   )
                        $ifc_response = CMS_MSG_DONE;
                else
                        $ifc_response = CMS_MSG_ERROR;

                //save and close
                if (streq(CMS_IFC_MESSAGE, "_source"))
                        break 2; //exit source editor

                echo($ifc_response);
                exit();
        };

        //menu
        $menu = array(CMS_L_COMMAND_CONFIRM .  "|template/command_apply"
                      => "javascript:template_source_save(\"_source\");",
                      CMS_L_COMMAND_SAVE .     "|template/command_save"
                      => "javascript:template_source_save(\"__source\");",
                      CMS_L_IFC_TEMPLATE_044 . "|template/command_show"
                      => "javascript:template_source_save(\"___source\");");
        if (
             ifc_available("directory")
             &&
             cms_permission("directory", TRUE, NULL)
           )
        {
                $menu[CMS_L_IFC_TEMPLATE_042 . "|template/command_directory"] =
                        "javascript:load_page(" .
                        "'template'," .
                        "'$active_url" .
                        "?ifc_page=directory" .
                        "&ifc_option=external" .
                        "&ifc_select=object" .
                        "&ifc_select_action=" .
                        "javascript:textcontrol_set(" .
                        "\\'this.opener.document.ifc.l_ifc_param2\\'," .
                        "\\'%23insert\\'," .
                        "\\'<CMS:href default=\"directory:%return%\">" .
                        qr(CMS_L_IFC_TEMPLATE_021) .
                        "</CMS:href>\\');');";
                $menu[CMS_L_IFC_TEMPLATE_047 . "|template/command_directory_code"] =
                        "javascript:load_page(" .
                        "'template'," .
                        "'$active_url" .
                        "?ifc_page=directory" .
                        "&ifc_option=external" .
                        "&ifc_select=object" .
                        "&ifc_select_action=" .
                        "javascript:textcontrol_set(" .
                        "\\'this.opener.document.ifc.l_ifc_param2\\'," .
                        "\\'%23insert\\'," .
                        "\\'<?=x(translate_url(\"directory://%return%\"))?>\\');');";
        };
        if (
             ifc_available("image")
             &&
             cms_permission("image", TRUE, NULL)
           )
        {
                $menu[CMS_L_IFC_TEMPLATE_010 . "|template/command_image"] =
                        "javascript:load_page(" .
                        "'template'," .
                        "'$active_url" .
                        "?ifc_page=image" .
                        "&ifc_option=external" .
                        "&ifc_select=_object[]" .
                        "&ifc_select_action=" .
                        "javascript:textcontrol_set(" .
                        "\\'this.opener.document.ifc.l_ifc_param2\\'," .
                        "\\'%23insert\\'," .
                        "\\'<CMS:image default=\"%return%\"/>\\');');";
                $menu[CMS_L_IFC_TEMPLATE_048 . "|template/command_image_code"] =
                        "javascript:load_page(" .
                        "'template'," .
                        "'$active_url" .
                        "?ifc_page=image" .
                        "&ifc_option=external" .
                        "&ifc_select=_object[]" .
                        "&ifc_select_action=" .
                        "javascript:textcontrol_set(" .
                        "\\'this.opener.document.ifc.l_ifc_param2\\'," .
                        "\\'%23insert\\'," .
                        "\\'<?=x(translate_url(\"%return%\"))?>\\');');";
        };
        if (
             ifc_available("media")
             &&
             cms_permission("media", TRUE, NULL)
           )
                $menu[CMS_L_IFC_TEMPLATE_024 . "|template/command_media"] =
                        "javascript:load_page(" .
                        "'template'," .
                        "'$active_url" .
                        "?ifc_page=media" .
                        "&ifc_option=external" .
                        "&ifc_select=_object[]" .
                        "&ifc_select_action=" .
                        "javascript:textcontrol_set(" .
                        "\\'this.opener.document.ifc.l_ifc_param2\\'," .
                        "\\'%23insert\\'," .
                        "\\'<CMS:media default=\"%return%\"/>\\');');";
        if (
             ifc_available("download")
             &&
             cms_permission("download", TRUE, NULL)
           )
                $menu[CMS_L_IFC_TEMPLATE_046 . "|template/command_download"] =
                        "javascript:load_page(" .
                        "'template'," .
                        "'$active_url" .
                        "?ifc_page=download" .
                        "&ifc_option=external" .
                        "&ifc_select=_object[]" .
                        "&ifc_select_action=" .
                        "javascript:textcontrol_set(" .
                        "\\'this.opener.document.ifc.l_ifc_param2\\'," .
                        "\\'%23insert\\'," .
                        "\\'<CMS:download default=\"%return%\">" .
                        qr(CMS_L_IFC_TEMPLATE_025) .
                        "</CMS:download>\\');');";
        if (
             ifc_available("template")
             &&
             cms_permission("template", TRUE, NULL)
           )
                $menu[CMS_L_IFC_TEMPLATE_007 . "|template/command_template"] =
                        "javascript:load_page(" .
                        "'template'," .
                        "'$active_url" .
                        "?ifc_page=template" .
                        "&ifc_option=external" .
                        "&ifc_select=_object[]" .
                        "&ifc_select_action=" .
                        "javascript:textcontrol_set(" .
                        "\\'this.opener.document.ifc.l_ifc_param2\\'," .
                        "\\'%23insert\\'," .
                        "\\'<CMS:template default=\"%return%\"/>\\');');";
        if (
             ifc_available("token")
             &&
             cms_permission("token", TRUE, NULL)
           )
                $menu[CMS_L_IFC_TEMPLATE_013 . "|template/command_token"] =
                        "javascript:load_page(" .
                        "'template'," .
                        "'$active_url" .
                        "?ifc_page=token" .
                        "&ifc_option=external" .
                        "&ifc_select=token" .
                        "&ifc_select_action=" .
                        "javascript:textcontrol_set(" .
                        "\\'this.opener.document.ifc.l_ifc_param2\\'," .
                        "\\'%23token\\'," .
                        "\\'%return%\\');');";
        $menu[CMS_L_COMMAND_CANCEL . "|template/command_cancel"] = FALSE;

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       $menu,
                       array("object"   => $object,
                             "language" => $language),
                       "_source",
                       CMS_L_IFC_TEMPLATE_006);

        echo("<table class=\"layout\">" .
             "<tr>" .
             "<td>");

        //stylesheet
        $ifc->set(CMS_L_IFC_TEMPLATE_041,
                  "textarea 80x12 bln",
                  $template->get_stylesheet($_object, FALSE));

        //code
        $ifc->set($template->data->get($_object, "name"),
                  "textarea 80x27 ln",
                  $template->get_code($_object, FALSE));

        echo("</td>" .

        //spacer
             "<td>" .
             "&nbsp;" .
             "</td>" .

        //tools
             "<td>");

        //javascript
?>
<script>
var template_source_stylesheet = ifc_get_object("l_ifc_param1");
var template_source_code       = ifc_get_object("l_ifc_param2");
var template_source_message    = "";

function template_source_save(message)
{
        template_source_message = message;

        var flag = (message != "_source");
        if (flag)
        {
                var target          = document.ifc.target;
                document.ifc.target = asr_create_frame(template_source_save_callback);
        }
        else
        {
                ifc_clean(template_source_stylesheet);
                ifc_clean(template_source_code);
        };

        ifc_post(message);

        if (flag) document.ifc.target = target;
};
//................................
function template_source_save_callback(value)
{
        ifc_response(value);

        //display after saving
        if (template_source_message == "___source")
                load_page("template",
                          "<?php echo($active_url)?>" +
                          "?ifc_page=template" +
                          "&ifc_message=display" +
                          "&object=<?php echo(q($object));?>");
};
//................................
function template_source_insert(value)
{
        var code   = "";
        var action = "";

        switch (value)
        {
<?php
        if ($flag_page = $template->data->get($_object, "page"))
        {
?>
        case "page":
                code   = "<?php echo(q(CMS_DOCTYPE_HTML));?>\n" +
                         "<html lang=\"<" + "?=x(CMS_LANGUAGE)?>\">\n" +
                         "<head>\n" +
                         "\n" +
                         "<CMS:head/>\n" +
                         "\n" +
                         "<meta name=\"robots\" content=\"index, follow\">\n" +
                         "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1, maximum-scale=1\">\n" +
                         "\n" +
                         "<\/head>\n" +
                         "<body><CMS:control/>\n" +
                         "\n" +
                         "<div>\n" +
                         "\n" +
                         "  <CMS:template id=\"tp1\"/>\n" +
                         "\n" +
                         "  <CMS:backlink/>\n" +
                         "\n" +
                         "</div>\n" +
                         "\n" +
                         "<\/body>\n" +
                         "<\/html>";
                ifc_change("l_ifc_param2", code);
                return;

        case "head":
                code   = "\n" +
                         "<CMS:head [base=\"{url}\"]\n" +
                         "          [stylesheet=\"on|yes|true|off|no|false|{url}\"]\n" +
                         "          [title=\"{text}\"]/>\n";
                action = "#replace";
                break;

        case "control":
                code   = "\n" +
                         "<CMS:control/>\n";
                action = "#replace";
                break;
<?php
        };
?>
        case "menu":
                code   = "\n" +
                         "<CMS:menu [base=\"{id}\"]\n" +
                         "          [level=\"{number}|+{number}|-{number}\"]\n" +
                         "          [depth=\"off|no|false|{number}\"]\n" +
                         "          [filter=\"normal|open|active|active-open\"]\n" +
                         "          [show-icons=\"on|yes|true|off|no|false\"]\n" +
                         "          [show-images=\"on|yes|true|off|no|false\"]\n" +
                         "          [show-description=\"on|yes|true|off|no|false\"]\n" +
                         "          [exclude=\"{id}[ {id}]\"]/>";
                action = "#replace";
                break;

        case "backlink":
                code   = "\n" +
                         "<CMS:backlink/>\n";
                action = "#replace";
                break;

        case "cblock":
                code   = "\n" +
                         "<CMS:cblock [idref=\"+{number}|-{number}|{alphanumeric_.}\"]>\n" +
                         "%text%\n" +
                         "<\/CMS:cblock>\n";
                action = "#imbed";
                break;

        case "calt":
                code   = "\n" +
                         "<CMS:calt [idref=\"+{number}|-{number}|{alphanumeric_.}\"]>\n" +
                         "%text%\n" +
                         "<\/CMS:calt>\n";
                action = "#imbed";
                break;

        case "group":
                code   = "\n" +
                         "<CMS:group [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "           [edit=\"on|yes|true|off|no|false\"]\n" +
                         "           [title=\"{text}\"]>\n" +
                         "%text%\n" +
                         "<\/CMS:group>\n";
                action = "#imbed";
                break;

        case "base":
                code   = "\n" +
                         "<CMS:base [id=\"+{number}|-{number}|{alphanumeric_.}\"]>\n" +
                         "%text%\n" +
                         "<\/CMS:base>\n";
                action = "#imbed";
                break;

        case "namespace":
                code   = "\n" +
                         "<CMS:namespace [id=\"+{number}|-{number}|{alphanumeric_.}\"]>\n" +
                         "%text%\n" +
                         "<\/CMS:namespace>\n";
                action = "#imbed";
                break;

        case "repeat":
                code   = "\n" +
                         "<CMS:repeat [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "            [default=\"{number}\"]\n" +
                         "            [edit=\"on|yes|true|off|no|false\"]\n" +
                         "            [title=\"{text}\"]>\n" +
                         "%text%\n" +
                         "<\/CMS:repeat>\n";
                action = "#imbed";
                break;

        case "shift":
                code   = "\n" +
                         "<CMS:shift [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "           [default=\"{number}\"]\n" +
                         "           [edit=\"on|yes|true|off|no|false\"]\n" +
                         "           [title=\"{text}\"]>\n" +
                         "%text%\n" +
                         "<\/CMS:shift>\n";
                action = "#imbed";
                break;

        case "template":
                code   = "\n" +
                         "<CMS:template [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "              [default=\"{identifier}\"]\n" +
                         "              [edit=\"on|yes|true|off|no|false\"]\n" +
                         "              [title=\"{text}\"]/>\n";
                action = "#replace";
                break;

        case "text":
                code   = "\n" +
                         "<CMS:text [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "          [default=\"{text}\"]\n" +
                         "          [edit=\"on|yes|true|off|no|false\"]\n" +
                         "          [title=\"{text}\"]/>\n";
                action = "#replace";
                break;

        case "value":
                code   = "\n" +
                         "<CMS:value [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "           [default=\"{text}\"]\n" +
                         "           [regex=\"{text}\"]\n" +
                         "           [edit=\"on|yes|true|off|no|false\"]\n" +
                         "           [title=\"{text}\"]/>\n";
                action = "#replace";
                break;

        case "href":
                code   = "\n" +
                         "<CMS:href [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "          [_id=\"{text}\"]\n" +
                         "          [default=\"{url}\"]\n" +
                         "          [target=\"{identifier}\"]\n" +
                         "          [rel=\"{text}\"]\n" +
                         "          [edit=\"on|yes|true|off|no|false\"]\n" +
                         "          [title=\"{text}\"]\n" +
                         "          [class=\"{text}\"]\n" +
                         "          [style=\"{text}\"]>\n" +
                         "%text%\n" +
                         "<\/CMS:href>\n";
                action = "#imbed";
                break;

        case "image":
                code   = "\n" +
                         "<CMS:image [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "           [_id=\"{text}\"]\n" +
                         "           [default=\"{url}\"]\n" +
                         "           [width=\"{width}[%]\"]\n" +
                         "           [height=\"{height}[%]\"]\n" +
                         "           [alt=\"{text}\"]\n" +
                         "           [edit=\"on|yes|true|off|no|false\"]\n" +
                         "           [title=\"{text}\"]\n" +
                         "           [class=\"{text}\"]\n" +
                         "           [style=\"{text}\"]/>\n";
                action = "#replace";
                break;

        case "thumbnail":
                code   = "\n" +
                         "<CMS:thumbnail [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "               [_id=\"{text}\"]\n" +
                         "               [default=\"{url}\"]\n" +
                         "               [twidth=\"{width}[%]\"]\n" +
                         "               [theight=\"{height}[%]\"]\n" +
                         "               [width=\"{width}[%]\"]\n" +
                         "               [height=\"{height}[%]\"]\n" +
                         "               [alt=\"{text}\"]\n" +
                         "               [edit=\"on|yes|true|off|no|false\"]\n" +
                         "               [title=\"{text}\"]\n" +
                         "               [class=\"{text}\"]\n" +
                         "               [style=\"{text}\"]/>\n";
                action = "#replace";
                break;

        case "media":
                code   = "\n" +
                         "<CMS:media [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "           [_id=\"{text}\"]\n" +
                         "           [default=\"{url}\"]\n" +
                         "           [width=\"{width}[%]\"]\n" +
                         "           [height=\"{height}[%]\"]\n" +
                         "           [alt=\"{text}\"]\n" +
                         "           [edit=\"on|yes|true|off|no|false\"]\n" +
                         "           [title=\"{text}\"]\n" +
                         "           [class=\"{text}\"]\n" +
                         "           [style=\"{text}\"]/>\n";
                action = "#replace";
                break;

        case "download":
                code   = "\n" +
                         "<CMS:download [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "              [_id=\"{text}\"]\n" +
                         "              [default=\"{identifier}\"]\n" +
                         "              [edit=\"on|yes|true|off|no|false\"]\n" +
                         "              [title=\"{text}\"]\n" +
                         "              [class=\"{text}\"]\n" +
                         "              [style=\"{text}\"]>\n" +
                         "%text%\n" +
                         "<\/CMS:download>\n";
                action = "#imbed";
                break;

        case "plugin":
                code   = "\n" +
                         "<CMS:plugin [id=\"+{number}|-{number}|{alphanumeric_.}\"]\n" +
                         "            [default=\"{url}\"]\n" +
                         "            [edit=\"on|yes|true|off|no|false\"]\n" +
                         "            [title=\"{text}\"]/>\n";
                action = "#replace";
                break;

        case "nocache":
                code   = "\n" +
                         "<CMS:nocache>\n" +
                         "%text%\n" +
                         "<\/CMS:nocache>\n";
                action = "#imbed";
                break;

        case "comment":
                code   = "\n" +
                         "<!--\n" +
                         "%text%\n" +
                         "-->\n";
                action = "#imbed";
                break;

        case "layout":
                code   = "\n" +
                         "<table class=\"layout\"\n" +
                         "       style=\"WIDTH:100%\">\n" +
                         "\n" +
                         "  <tr>\n" +
                         "    <td>\n" +
                         "\n" +
                         "      %text%\n" +
                         "\n" +
                         "    <\/td>\n" +
                         "\n" +
                         "    <td>\n" +
                         "\n" +
                         "      <?php echo(CMS_L_IFC_TEMPLATE_032);?> 1/2\n" +
                         "\n" +
                         "    <\/td>\n" +
                         "  <\/tr>\n" +
                         "\n" +
                         "  <tr>\n" +
                         "    <td>\n" +
                         "\n" +
                         "      <?php echo(CMS_L_IFC_TEMPLATE_032);?> 2/1\n" +
                         "\n" +
                         "    <\/td>\n" +
                         "\n" +
                         "    <td>\n" +
                         "\n" +
                         "      <?php echo(CMS_L_IFC_TEMPLATE_032);?> 2/2\n" +
                         "\n" +
                         "    <\/td>\n" +
                         "  <\/tr>\n" +
                         "\n" +
                         "<\/table>";
                action = "#imbed";
                break;

        case "php":
                code   = "\n" +
                         "<" + "?php\n" +
                         "%text%\n" +
                         "?>\n";
                action = "#imbed";
                break;

        case "include":
                code   = "\n" +
                         "<" + "?php\n" +
                         "include(CMS_ROOT_PATH . \"path/to/filename.inc\");\n" +
                         "?>\n";
                action = "#replace";
                break;

        case "echo":
                code   = "<" + "?=" +
                         "%text%" +
                         "?>";
                action = "#imbed";
                break;

        default:
                code   = value;
                action = "#replace";
                break;
        };

        textcontrol_set("document.ifc.l_ifc_param2", action, code);
};
//................................
function template_source_select()
{
        textcontrol_select(template_source_code);
};

template_source_code.onselect = template_source_select;
template_source_code.onchange = template_source_select;
</script>
<?php

        //prefabs
        echo("<label class=\"element\">");
        $ifc->set(CMS_L_IFC_TEMPLATE_011, "description b");
        echo("<select size=\"30\" " .
                     "onclick=\"template_source_insert(this.options[this.selectedIndex].value);\">" .
             option($flag_page,
             "<option value=\"page\">" .      CMS_L_IFC_TEMPLATE_030 . "</option>" .
             "<option value=\"head\">" .      CMS_L_IFC_TEMPLATE_014 . "</option>" .
             "<option value=\"control\">" .   CMS_L_IFC_TEMPLATE_015 . "</option>") .
             "<option value=\"menu\">" .      CMS_L_IFC_TEMPLATE_045 . "</option>" .
             "<option value=\"backlink\">" .  CMS_L_IFC_TEMPLATE_031 . "</option>" .
             "<option value=\"cblock\">" .    CMS_L_IFC_TEMPLATE_016 . "</option>" .
             "<option value=\"calt\">" .      CMS_L_IFC_TEMPLATE_017 . "</option>" .
             "<option value=\"group\">" .     CMS_L_IFC_TEMPLATE_037 . "</option>" .
             "<option value=\"base\">" .      CMS_L_IFC_TEMPLATE_039 . "</option>" .
             "<option value=\"namespace\">" . CMS_L_IFC_TEMPLATE_038 . "</option>" .
             "<option value=\"repeat\">" .    CMS_L_IFC_TEMPLATE_018 . "</option>" .
             "<option value=\"shift\">" .     CMS_L_IFC_TEMPLATE_035 . "</option>" .
             "<option value=\"template\">" .  CMS_L_IFC_TEMPLATE_019 . "</option>" .
             "<option value=\"text\">" .      CMS_L_IFC_TEMPLATE_020 . "</option>" .
             "<option value=\"value\">" .     CMS_L_IFC_TEMPLATE_040 . "</option>" .
             "<option value=\"href\">" .      CMS_L_IFC_TEMPLATE_021 . "</option>" .
             "<option value=\"image\">" .     CMS_L_IFC_TEMPLATE_022 . "</option>" .
             "<option value=\"thumbnail\">" . CMS_L_IFC_TEMPLATE_023 . "</option>" .
             "<option value=\"media\">" .     CMS_L_IFC_TEMPLATE_024 . "</option>" .
             "<option value=\"download\">" .  CMS_L_IFC_TEMPLATE_025 . "</option>" .
             "<option value=\"plugin\">" .    CMS_L_IFC_TEMPLATE_026 . "</option>" .
             "<option value=\"nocache\">" .   CMS_L_IFC_TEMPLATE_036 . "</option>" .
             "<option value=\"comment\">" .   CMS_L_IFC_TEMPLATE_029 . "</option>" .
             "<option value=\"layout\">" .    CMS_L_IFC_TEMPLATE_032 . "</option>" .
             "<option value=\"php\">" .       CMS_L_IFC_TEMPLATE_027 . "</option>" .
             "<option value=\"include\">" .   CMS_L_IFC_TEMPLATE_033 . "</option>" .
             "<option value=\"echo\">" .      CMS_L_IFC_TEMPLATE_043 . "</option>" .
             "<option value=\"\$cms_template_document\">\$cms_template_document</option>" .
             "<option value=\"\$cms_template_base_id\">\$cms_template_base_id</option>" .
             "<option value=\"\$cms_template_path_id\">\$cms_template_path_id</option>" .
             "<option value=\"\$cms_template_temp_id\">\$cms_template_temp_id</option>" .
             "</select>" .
             "</label>" .
             "</td>" .
             "</tr>" .
             "</table>");

        $ifc->close();

case "delete":
//.....................................................................................................
        if (empty($_object)) break; //no selection

        reset($_object);
        list(, $value) = each($_object);

        $template   = new template();
        $category   = $template->data->get($value, "category");
        $flag_error = TRUE;

        //delete selected templates
        do
        {
                $flag_error &= ! $template->delete($value);
        }
        while (list(, $value) = each($_object));

        //remove invalid templates from selection
        $array = explode(",", CMS_LANGUAGE_ENABLED);
        if (CMS_LANGUAGE_ENABLED) $array[] = FALSE;

        reset($array);
        while (list(, $value) = each($array))
        {
                $_object = language_get($object, $value, TRUE);

                if (! $template->data->get($_object))
                {
                        //active language
                        if (streq($value, $language))
                        {
                                $template->data->move("first");
                                $_object = $template->data->seek(array("category" => $category));
                                $object  = language_set($object, $_object, $value);
                        }

                        //inactive language(s)
                        else
                        {
                                $object  = language_set($object, NULL, $value);
                        };
                };
        };

        $ifc_response = $flag_error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "category_rename":
//.....................................................................................................
        $template = new template();
        $_object  = language_get($object, $language, TRUE);
        $category = $template->data->get($_object, "category");

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object,
                             "language" => $language),
                       "_category_rename",
                       CMS_L_IFC_TEMPLATE_034);

        //category
        $ifc->set(CMS_L_NAME, "text 40 40 b", $category);

        $ifc->close();

case "_category_rename":
//.....................................................................................................
        $template = new template();
        $_object  = language_get($object, $language, TRUE);
        $category = $template->data->get($_object, "category");

        $template->data->move("first");
        while ($key = $template->data->move("next"))
        {
                $_category = $template->data->get($key, "category");
                if (streq($_category, $category))
                        $template->data->set($ifc_param1, $key, "category");
        };

        $ifc_response = $template->data->save() ? CMS_MSG_DONE : CMS_MSG_DONE;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array(""                               => CMS_L_ACCESS,
                     CMS_TEMPLATE_PERMISSION_OPERATOR => CMS_L_OPERATOR));

$template = new template();
$_object  = language_get($object, $language, TRUE);
$array    = template_get_array(CMS_IFC_SELECT ? FALSE : NULL);

//get category from object
if ($_object && in_array_recursive($_object, $array))
{
        $category = $template->data->get($_object, "category");
        if (! $category) $category = "";
}

//get object from category
else
{
        $category = (string)cms_cache("template." . CMS_USER . ".category");
        if ((! $category) || (! isset($array[$category]))) $category = "";

        if (is_array($array[$category]))
        {
                $_object = current($array[$category]);
                $object  = language_set($object, $_object, $language);
        };
};

//menu
$menu = NULL;
if (CMS_IFC_SELECT && $_object)
        $menu[CMS_L_COMMAND_INSERT . "|template/command_apply"] = "javascript:ifc_return();";
if ($template->operator)
{
        $menu[CMS_L_COMMAND_ADD .    "|template/command_add"]   = "add";
        if ($_object)
        {
                $menu[CMS_L_COMMAND_EDIT .     "|template/command_edit"]   = "edit";
                $menu[CMS_L_IFC_TEMPLATE_006 . "|template/command_code"]   = "source";
                $menu[CMS_L_COMMAND_DELETE .   "|template/command_delete"] = "#delete";
                $menu[CMS_L_IFC_TEMPLATE_034 . "|template/command_rename"] = "category_rename";
        };
};

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object"   => $object,
                     "language" => $language));

//javascript
?>
<script>
function template_select(value)
{
        var language              = "<?php echo(q($language));?>";
        if (ifc_language_get(document.ifc.object.value, language) == value) return;
        document.ifc.object.value = ifc_language_set(document.ifc.object.value, value, language);
        if (document.getElementById)
                document.getElementById("template-display").src =
                        "<?php echo(q(CMS_ACTIVE_URL) . "?ifc_page=" . rq(CMS_IFC_PAGE));?>" +
                        "&ifc_message=display&object=" + encodeURIComponent(value);
};
</script>
<?php

ifc_table_open();
echo("<colgroup>" .
     "<col style=\"WIDTH:1px\">" .
     "<col>" .
     "</colgroup>" .

     "<tr>" .
     "<td class=\"varied2\">");

//category
$ifc->set(CMS_L_IFC_TEMPLATE_005, "description b");
echo("<select onchange=\"if (this.selectedIndex != -1) " .
             "ifc_post('select',this[this.selectedIndex].value);\">");
$flag = NULL;
reset($array);
while (list($key, $value) = each($array))
{
        $name  = strabridge($key, 40);
        $value = is_array($value) ? current($value) : NULL;
        echo("<option value=\"" . x($value) . "\"" .
                      (streq($key, $category) ? " selected>" : ">") .
             whitechartostring(x($name), "&nbsp;") .
             ($flag ? NULL : str_repeat("&nbsp;", 40 - utf8_strlen($name))) .
             "</option>");
        $flag  = TRUE;
};
echo("</select>");

//list
if (is_array($array[$category]))
{
        echo("<br>");
        $ifc->set(CMS_L_IFC_TEMPLATE_007, "description b");
        echo("<select name=\"_object[]\" " .
                     "size=\"15\" " .
                     "multiple " .
                     "onchange=\"if (this.selectedIndex != -1) " .
                     "template_select(this[this.selectedIndex].value);\" " .
                     "ondblclick=\"ifc_return();\">");
        $flag = NULL;
        reset($array[$category]);
        while (list($key, $value) = each($array[$category]))
        {
                $name = strabridge($key, 40);
                echo("<option value=\"" . x($value) . "\"" .
                              (streq($value, $_object) ? " selected>" : ">") .
                     x($name) .
                     ($flag ? NULL : str_repeat("&nbsp;", 40 - utf8_strlen($name))) .
                     "</option>");
                $flag = TRUE;
        };
        echo("</select>");
};

//language
if (CMS_IFC_SELECT && CMS_LANGUAGE_ENABLED)
{
        echo("<div class=\"language\">" .
             "<a href=\"javascript:ifc_post('select_language','');\" " .
                "class=\"language-" . (streq($language, "") ? "on" : "off") . "\">" .
             image("language/default_small", 16, 12, CMS_L_LANGUAGE_DEFAULT) .
             "</a>");

        $_language = explode(",", CMS_LANGUAGE_ENABLED);

        reset($_language);
        while (list(, $value) = each($_language))
                echo("<a href=\"javascript:ifc_post('select_language','" . rqx($value) . "');\" " .
                        "class=\"language-" . (streq($language, $value) ? "on" : "off") . "\">" .
                     image(is_file(CMS_DATA_PATH . "language/" . $value . "_small.gif") ?
                           CMS_DATA_URL . "language/" . $value . "_small.gif" :
                           "language/default_small",
                           16, 12, $value) .
                     "</a>");

        echo("</div>");
};
echo("</td>" .

//display template
     "<td class=\"iframe\">" .
     "<iframe id=\"template-display\" " .
             "src=\"" . x(CMS_ACTIVE_URL) .
             "?ifc_page=" . r(CMS_IFC_PAGE) .
             "&amp;ifc_message=display" .
             "&amp;object=" . r($_object) . "\">" .
     CMS_L_IFC_TEMPLATE_009 .
     "</iframe>" .
     "</td>" .
     "</tr>");
ifc_table_close();

$ifc->close();
?>