<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< INTERFACE >=====================================================================================
//-----------------------------------------------------------------------------------------------------
if (! cms_load("token")) ifc_inactive($ifc_page);

$token = new token();
if (! $token->enabled)   ifc_inactive($ifc_page);

if (empty($object)) $object = cms_cache("token." . CMS_USER . ".object");
else                $object = substr($object, 0, strcspn($object, " \r\n"));

//=====================================================================================================
//   MESSAGE HANDLING / SUB DISPLAY
//=====================================================================================================
switch (CMS_IFC_MESSAGE)
{
case "select":
//.....................................................................................................
        $object = token_get_index($token, $ifc_param);
        break;

case "display":
//.....................................................................................................
        cms_cache("token." . CMS_USER . ".object", $object, TRUE);

        echo(CMS_DOCTYPE_HTML .
             "<html>" .
             "<head>" .
             CMS_HTML_HEADER . CMS_JAVASCRIPT . CMS_STYLESHEET .
             "</head>" .
             "<body>" .
             "<div>");

        if (($resultrow = $token->get($object)) !== FALSE)
        {
                $value = stre($resultrow[CMS_DB_TOKEN_VALUE]) ?
                         "%%$object%%" :
                         "%%$object " . $resultrow[CMS_DB_TOKEN_VALUE] . "%%";
                echo($token->apply($value));
        };

        echo("</div>" .
             "</body>" .
             "</html>");

        exit();

case "add":
case "edit":
//.....................................................................................................
        if (streq(CMS_IFC_MESSAGE, "edit"))
        {
                if (($resultrow = $token->get($object)) === FALSE)
                {
                        $ifc_response = CMS_MSG_ERROR;
                        break;
                };

                $ifc_param1 = $resultrow[CMS_DB_TOKEN_TITLE];
                $ifc_param2 = $object;
                $ifc_param3 = $resultrow[CMS_DB_TOKEN_VALUE];
                $ifc_param4 = $resultrow[CMS_DB_TOKEN_TEXT];
        };

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object" => $object),
                       "_" . CMS_IFC_MESSAGE,
                       streq(CMS_IFC_MESSAGE, "add") ?
                       CMS_L_COMMAND_ADD : CMS_L_COMMAND_EDIT);

        //name
        $ifc->set(CMS_L_NAME,          "text 40 40 bl",          isset($ifc_param1) ? $ifc_param1 : "");

        //index
        $ifc->set(CMS_L_IFC_TOKEN_003, "text 40 40 b",           isset($ifc_param2) ? $ifc_param2 : "");

        //value
        $ifc->set(CMS_L_IFC_TOKEN_008, "text 60 255 b",          isset($ifc_param3) ? $ifc_param3 : "");

        echo("<table class=\"layout\">" .
             "<tr>" .
             "<td>");

        //text
        $ifc->set(CMS_L_IFC_TOKEN_006, "textarea 60x20 65536 l", isset($ifc_param4) ? $ifc_param4 : "");
        echo("</td>" .
             "<td>" .
             "&nbsp;" .
             "</td>" .
             "<td>");

        //javascript
?>
<script>
function token_index()
{
        //standardize index
        var value = ifc_value("ifc_param2");
        if (value == "") value = ifc_value("l_ifc_param1");
        value     = value.replace(/[ \r\n]+/g, "_")
                         .replace(/_{2,}/g, "_");
        ifc_change("ifc_param2", value);
};
//................................
function token_value()
{
        //standardize value list
        var value  = ifc_value("ifc_param3")
                     .replace(/[^0-9a-zA-Z_,]+/g, "_")
                     .replace(/_{2,}/g, "_")
                     .replace(/,{2,}/g, ",")
                     .replace(/^,/, "")
                     .replace(/,$/, "");
        ifc_change("ifc_param3", value);

        var array  = value.split(",");
        var object = document.getElementById("placeholder");
        var node   = null;
        var text   = "";

        //clear placeholder list
        while ((node = object.firstChild) != null)
                object.removeChild(node);

        //create placeholder list
        for (var i in array)
        {
                value      = array[i];
                if (value == "") break;
                node       = document.createElement("option");
                node.value = "%" + value + "%";
                node.text  = strabridge(value, 10);
                object.appendChild(node);
        };
};
//................................
function token_insert(value)
{
        textcontrol_set("document.ifc.l_ifc_param4", "#replace", value);
};
//................................
function token_select()
{
        textcontrol_select(document.ifc.l_ifc_param4);
};

document.ifc.ifc_param2.onchange   = token_index;
document.ifc.ifc_param3.onchange   = token_value;
document.ifc.l_ifc_param4.onselect = token_select;
document.ifc.l_ifc_param4.onchange = token_select;
</script>
<?php

        //placeholders
        echo("<label class=\"element\">");
        $ifc->set(CMS_L_IFC_MEDIA_015, "description b");
        echo("<select id=\"placeholder\" " .
                     "size=\"20\" " .
                     "onclick=\"token_insert(this[this.selectedIndex].value);\">");
        if (isset($ifc_param3))
        {
                $array = explode(",", $ifc_param3);
                reset($array);
                while (list(, $value) = each($array))
                {
                        if ($value == "") break;
                        echo("<option value=\"%" . x($value) . "%\">" .
                             x(strabridge($value, 10)) .
                             "</option>");
                };
        };
        echo("</select>" .
             "</label>" .
             "</td>" .
             "</tr>" .
             "</table>");

        //category
        $ifc->set(CMS_L_IFC_TOKEN_007,      "text 40 40 b");
        $ifc->set(CMS_L_IFC_TOKEN_001,      "label");
        $ifc->set(token_get_select($token), "select 40", token_get_category($token, $object));

        $ifc->close();

case "_add":
//.....................................................................................................
        $_object = $token->add($ifc_param2,                             //index
                               $ifc_param3,                             //value
                               $ifc_param5 ? $ifc_param5 : $ifc_param6, //category
                               $ifc_param1,                             //title
                               $ifc_param4);                            //text
        if ($_object !== FALSE)
        {
                $object       = $_object;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "_edit":
//.....................................................................................................
        $_object = $token->update($object,                                 //index
                                  $ifc_param2,                             //_index
                                  $ifc_param3,                             //value
                                  $ifc_param5 ? $ifc_param5 : $ifc_param6, //category
                                  $ifc_param1,                             //title
                                  $ifc_param4);                            //text
        if ($_object !== FALSE)
        {
                $object       = $ifc_param2;
                $ifc_response = CMS_MSG_DONE;
                break;
        };

        $ifc_response = CMS_MSG_ERROR;
        break;

case "delete":
//.....................................................................................................
        if (empty($_object)) break; //no selection

        $category   = token_get_category($token, $object);
        $flag_error = TRUE;

        //delete selected tokens
        reset($_object);
        while (list(, $value) = each($_object))
        {
                $value       = substr($value, 0, strcspn($value, " \r\n"));
                $flag_error &= ! $token->delete($value);
        };

        $object       = token_get_index($token, $category);
        $ifc_response = $flag_error ? CMS_MSG_ERROR : CMS_MSG_DONE;
        break;

case "category_rename":
//.....................................................................................................
        $category = token_get_category($token, $object);

        //display
        $ifc = new ifc($ifc_response,
                       $ifc_page,
                       TRUE,
                       array("object"   => $object),
                       "_category_rename",
                       CMS_L_IFC_TOKEN_009);

        //category
        $ifc->set(CMS_L_NAME, "text 40 40", $category);

        $ifc->close();

case "_category_rename":
//.....................................................................................................
        $category     = token_get_category($token, $object);
        $ifc_response = mysql_query("UPDATE " . CMS_DB_TOKEN . " " .
                                    "SET " .    CMS_DB_TOKEN_CATEGORY . "='" . sqlesc($ifc_param1) . "' " .
                                    "WHERE " .  CMS_DB_TOKEN_CATEGORY . "='" . sqlesc($category) . "'") ?
                        CMS_MSG_DONE : CMS_MSG_DONE;
        break;
};

//=====================================================================================================
//   MAIN DISPLAY
//=====================================================================================================
ifc_permission(array(""                            => CMS_L_ACCESS,
                     CMS_TOKEN_PERMISSION_OPERATOR => CMS_L_OPERATOR));

//get category from object
if (nstre($object))
{
        $category = token_get_category($token, $object);
        if ($category === FALSE) $category = "";
        cms_cache("token." . CMS_USER . ".category", $category, TRUE);
}

//get object from category
else
{
        $category = (string)cms_cache("token." . CMS_USER . ".category");
        $object   = token_get_index($token, $category);

        if ($object === FALSE)
        {
                $category = "";
                $object   = token_get_index($token, $category);
        };
};

//menu
$menu = NULL;
if (CMS_IFC_SELECT && ($object != ""))
        $menu[CMS_L_COMMAND_INSERT . "|token/command_apply"] = "javascript:ifc_return();";
if ($token->operator)
{
        $menu[CMS_L_COMMAND_ADD .    "|token/command_add"]   = "add";
        if ($object != "")
        {
                $menu[CMS_L_COMMAND_EDIT .   "|token/command_edit"]   = "edit";
                $menu[CMS_L_COMMAND_DELETE . "|token/command_delete"] = "#delete";
                $menu[CMS_L_IFC_TOKEN_009 .  "|token/command_rename"] = "category_rename";
        };
};

//display
$ifc = new ifc($ifc_response,
               $ifc_page,
               $menu,
               array("object" => $object));
?>
<script>
function token_select(value)
{
        document.ifc.object.value = value;
        document.ifc.token.value  = "%%" + value + "%%";
        if (document.getElementById)
                document.getElementById("token-display").src =
                        "<?php echo(q(CMS_ACTIVE_URL) . "?ifc_page=" . rq(CMS_IFC_PAGE));?>" +
                        "&ifc_message=display&object=" + encodeURIComponent(value);
};
</script>
<?php

//category
ifc_table_open();
echo("<colgroup>" .
     "<col style=\"WIDTH:1px\">" .
     "<col>" .
     "</colgroup>" .

     "<tr>" .
     "<td class=\"varied2\">");

//category
$ifc->set(CMS_L_IFC_TOKEN_001, "description b");
echo("<select onchange=\"if (this.selectedIndex != -1) " .
             "ifc_post('select',this[this.selectedIndex].value);\">" .
     "<option value=\"\"" .
              option(nstre($category), " selected") . ">" .
     str_repeat("&nbsp;", 40) .
     "</option>");

$result = mysql_query("SELECT DISTINCT " . CMS_DB_TOKEN_CATEGORY . " " .
                      "FROM " .            CMS_DB_TOKEN . " " .
                      "WHERE " .           CMS_DB_TOKEN_CATEGORY . "!='' " .
                      "ORDER BY " .        CMS_DB_TOKEN_CATEGORY);

while ($resultrow = mysql_fetch_assoc($result))
{
        $value = x($resultrow[CMS_DB_TOKEN_CATEGORY]);
        echo("<option value=\"$value\"" .
                      (streq($resultrow[CMS_DB_TOKEN_CATEGORY], $category) ? " selected>" : ">") .
             $value .
             "</option>");
};
echo("</select>");

$_object = "";

//list
if (
     ($result = mysql_query("SELECT " .   CMS_DB_TOKEN_INDEX . ", " .
                                          CMS_DB_TOKEN_VALUE . ", " .
                                          CMS_DB_TOKEN_TITLE . " " .
                            "FROM " .     CMS_DB_TOKEN . " " .
                            "WHERE " .    CMS_DB_TOKEN_CATEGORY . "='" . sqlesc($category) . "' " .
                            "ORDER BY " . CMS_DB_TOKEN_INDEX))
     &&
     mysql_num_rows($result)
   )
{
        echo("<br>");

        $ifc->set(CMS_L_IFC_TOKEN_002, "description b");
        echo("<select name=\"_object[]\" " .
                     "size=\"15\" " .
                     "multiple " .
                     "onchange=\"if (this.selectedIndex != -1) " .
                     "token_select(this[this.selectedIndex].value);\" " .
                     "ondblclick=\"ifc_return();\">");
        $flag = FALSE;
        while ($resultrow = mysql_fetch_assoc($result))
        {
                $value    = $resultrow[CMS_DB_TOKEN_INDEX];
                $_value   = $resultrow[CMS_DB_TOKEN_VALUE];
                $_value   = stre($_value) ? $value : "$value " . str_replace(",", ", ", $_value);
                $name     = l($resultrow[CMS_DB_TOKEN_TITLE]);
                $name     = strabridge($name, 40);
                $selected = "";

                if (stre($object)) $object = $value;
                if (streq($value, $object))
                {
                        $selected = " selected";
                        $_object  = $_value;
                };

                echo("<option value=\"" . x($_value) . "\"$selected>" .
                     x($name) .
                     ($flag ? "" : str_repeat("&nbsp;", 40 - utf8_strlen($name))) .
                     "</option>");
                $flag = TRUE;
        };
        echo("</select><br>");

        //token
        $ifc->set(CMS_L_IFC_TOKEN_003, "description b");
        echo("<input name=\"token\" " .
                    "type=\"text\" " .
                    (stre($_object) ? "" : "value=\"%%" . x($_object) . "%%\" ") .
                    "size=\"40\" " .
                    "onfocus=\"this.select();\" " .
                    "readonly " .
                    "class=\"select\">");
};
echo("</td>" .

//display token
     "<td class=\"iframe\">" .
     "<iframe id=\"token-display\" " .
             "src=\"" . x(CMS_ACTIVE_URL) .
             "?ifc_page=" . r(CMS_IFC_PAGE) .
             "&amp;ifc_message=display" .
             "&amp;object=" . r($object) . "\">" .
     CMS_L_IFC_TOKEN_004 .
     "</iframe>" .
     "</td>" .
     "</tr>");
ifc_table_close();

$ifc->close();
?>