<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< MODULE >========================================================================================
//-----------------------------------------------------------------------------------------------------
global $blog_message,
       $blog_index,
       $blog_date,
       $blog_meta,
       $blog_page,
       $blog_edit_message,
       $blog_edit_title,
       $blog_edit_meta,
       $blog_edit_status,
       $blog_edit_time_day,
       $blog_edit_time_month,
       $blog_edit_time_year,
       $blog_edit_time_hour,
       $blog_edit_time_minute,
       $blog_edit_sticky,
       $blog_edit_text,
       $blog_code_edit_message,
       $blog_code_edit_position,
       $blog_code_edit_text;

//load libraries
if (! (cms_load("blog") && cms_load("comment")))
{
        echo(CMS_MSG_UNAVAILABLE);
        return;
};

//instance
if (isset($GLOBALS["blog"]["instance"]) && nstre($GLOBALS["blog"]["instance"]))
        $instance = $GLOBALS["blog"]["instance"];
else
        $instance = defined("CMS_CONTENT_INDEX") ? CMS_CONTENT_INDEX : "";

$blog = new blog($instance);
if (! $blog->enabled)
{
        echo(CMS_MSG_UNAVAILABLE);
        return;
};

//validate access permissions
if (! ($blog->reader || $blog->writer || $blog->operator)) return;

//current time
$time = time();

//-----------------------------------------------------------------------------------------------------

//message

$error   = array();
$success = "";

switch ($blog_message)
{
case "_edit":
//.....................................................................................................
        switch ($blog_edit_message)
        {
        case CMS_L_COMMAND_DELETE:
//.....................................................................................................
                if (nstre($blog_index))
                {
                        if ($blog->delete($blog_index))
                        {
                                //delete comments
                                mysql_query("DELETE FROM " . CMS_DB_COMMENT . " " .
                                            "WHERE " .       CMS_DB_COMMENT_INSTANCE .
                                            "='" .           sqlesc("$instance.$blog_index") . "'");

                                $blog_index = NULL;
                                $success    = CMS_L_MOD_BLOG_006;
                        }
                        else
                        {
                                $error[]    = CMS_L_MOD_BLOG_012;
                        };
                };

        case CMS_L_COMMAND_CANCEL:
//.....................................................................................................
                $blog_message = NULL;
                break;

        case CMS_L_MOD_BLOG_005:
//.....................................................................................................
                $blog_message = NULL;

        case CMS_L_COMMAND_SAVE:
//.....................................................................................................
                if ((int)$blog_edit_status === 2)
                {
                        $status = CMS_DB_BLOG_STATUS_ACTIVE;
                        $_time  = mktime($blog_edit_time_hour,
                                         $blog_edit_time_minute,
                                         0,
                                         $blog_edit_time_month,
                                         $blog_edit_time_day,
                                         $blog_edit_time_year);
                }
                else
                {
                        $status = $blog_edit_status;
                        $_time  = $time;
                };

                $sticky = $blog_edit_sticky ? CMS_DB_BLOG_STICKY_ON : CMS_DB_BLOG_STICKY_OFF;

                if (stre($blog_index))
                {
                        $index = $blog->add($blog_edit_title,
                                            $blog_edit_meta,
                                            $blog_edit_text,
                                            $status,
                                            $_time,
                                            $sticky);

                        if ($index !== FALSE)
                        {
                                $blog_index = $index;
                                $blog_date  = NULL;
                                $blog_meta  = NULL;
                                $blog_page  = NULL;
                                $success    = CMS_L_MOD_BLOG_008;
                        }
                        else
                        {
                                $error[]    = CMS_L_MOD_BLOG_014;
                        };
                }
                else
                {
                        if ($blog->edit($blog_index,
                                        $blog_edit_title,
                                        $blog_edit_meta,
                                        $blog_edit_text,
                                        $status,
                                        $_time,
                                        $sticky))
                                $success = CMS_L_MOD_BLOG_007;
                        else
                                $error[] = CMS_L_MOD_BLOG_013;
                };

                break;
        };

        break;

case "_code_edit":
//.....................................................................................................
        switch ($blog_code_edit_message)
        {
        case CMS_L_COMMAND_CANCEL:
//.....................................................................................................
                break;

        case CMS_L_COMMAND_SAVE:
//.....................................................................................................
                if ($blog->code_set($blog_code_edit_position,
                                    $blog_code_edit_text))
                        $success = CMS_L_MOD_BLOG_017;
                else
                        $error[] = CMS_L_MOD_BLOG_018;

                break;
        };

        $blog_message = NULL;
        break;
};

//-----------------------------------------------------------------------------------------------------

echo("<div id=\"blog\" " .
          "class=\"blog\">" .
     "<div class=\"blog-content\">");

//display errors
if (count($error))
        echo("<div class=\"blog-error\">" .
             implode("<br>", $error) .
             "</div>");

//display success
if (nstre($success))
        echo("<div class=\"blog-success\">" .
             $success .
             "</div>");

//-----------------------------------------------------------------------------------------------------

switch ($blog_message)
{
case "edit":
case "_edit":
//.....................................................................................................

        //retrieve article
        $result = mysql_query("SELECT * " .
                              "FROM " .  CMS_DB_BLOG . " " .
                              "WHERE " . CMS_DB_BLOG_INSTANCE .
                              "='" .     sqlesc($instance) . "' " .
                              "AND " .   CMS_DB_BLOG_INDEX .
                              "='" .     sqlesc($blog_index) . "' " .
                              "LIMIT 1");
        if ($result === FALSE) break; //error
        $resultrow = mysql_fetch_assoc($result);
        if (! $resultrow)      break; //article not found

        $status           = $resultrow[CMS_DB_BLOG_STATUS];
        $_time            = $resultrow[CMS_DB_BLOG_TIME];
        $blog_edit_sticky = $resultrow[CMS_DB_BLOG_STICKY];
        $blog_edit_title  = $resultrow[CMS_DB_BLOG_TITLE];
        $blog_edit_meta   = $resultrow[CMS_DB_BLOG_META];
        $blog_edit_text   = $resultrow[CMS_DB_BLOG_TEXT];


case "add":
//.....................................................................................................

        //process status and time
        switch ($blog_message)
        {
        case "add":
                $blog_edit_status = CMS_DB_BLOG_STATUS_ACTIVE;
                $date             = getdate($time);
                break;

        case "edit":
        case "_edit":
                if (((int)$status === CMS_DB_BLOG_STATUS_ACTIVE))
                {
                        $blog_edit_status = 2;
                        $date             = getdate($_time);
                        break;
                };

                $blog_edit_status = $status;
                $date             = getdate($time);
                break;
        };

        $blog_edit_time_day    = $date["mday"];
        $blog_edit_time_month  = $date["mon"];
        $blog_edit_time_year   = $date["year"];
        $blog_edit_time_hour   = $date["hours"];
        $blog_edit_time_minute = $date["minutes"];

        //time selection array
        for ($i = 1; $i <= 31; $i++) $array_day[sprintf("%02d", $i)] = $i;
        $array_month = array(CMS_L_JANUARY   =>  1,
                             CMS_L_FEBRUARY  =>  2,
                             CMS_L_MARCH     =>  3,
                             CMS_L_APRIL     =>  4,
                             CMS_L_MAY       =>  5,
                             CMS_L_JUNE      =>  6,
                             CMS_L_JULY      =>  7,
                             CMS_L_AUGUST    =>  8,
                             CMS_L_SEPTEMBER =>  9,
                             CMS_L_OCTOBER   => 10,
                             CMS_L_NOVEMBER  => 11,
                             CMS_L_DECEMBER  => 12);
        $i           = $date["year"] - 10;
        $c           = date("Y", $time) + 10;
        if ($i < 1970) $i = 1970;
        if ($c > 2037) $c = 2037;
        for (; $i <= $c; $i++)       $array_year[sprintf("%04d", $i)]   = $i;
        for ($i = 0; $i < 24; $i++)  $array_hour[sprintf("%02d", $i)]   = $i;
        for ($i = 0; $i < 60; $i++)  $array_minute[sprintf("%02d", $i)] = $i;

        //command
        echo("<menu class=\"blog-command\">" .

        //overview command
             "<a href=\"" . x(CMS_ACTIVE_URL .
                              cms_param(array("blog_date" => $blog_date,
                                              "blog_meta" => $blog_meta,
                                              "blog_page" => $blog_page))) .
                        "#blog\" " .
                "class=\"button\">" .
             CMS_L_MOD_BLOG_011 .
             "</a>");

        //delete command
        if ($blog->test_delete($blog_index) && nstreq($blog_message, "add"))
                echo(" <a href=\"" . x(CMS_ACTIVE_URL .
                                       cms_param(array("blog_message"      => "_edit",
                                                       "blog_index"        => $blog_index,
                                                       "blog_date"         => $blog_date,
                                                       "blog_meta"         => $blog_meta,
                                                       "blog_page"         => $blog_page,
                                                       "blog_edit_message" => CMS_L_COMMAND_DELETE))) .
                                     "#blog\" " .
                         "class=\"button\" " .
                         "onclick=\"return confirm('" . CMS_L_MOD_BLOG_029 . "');\">" .
                     CMS_L_COMMAND_DELETE .
                     "</a>");
        echo("</menu>" .

        //display add form
             "<form name=\"blog_edit\" " .
                   "action=\"" . x(CMS_ACTIVE_URL .
                                   cms_param(array("blog_message" => "_edit",
                                                   "blog_index"   => $blog_index,
                                                   "blog_date"    => $blog_date,
                                                   "blog_meta"    => $blog_meta,
                                                   "blog_page"    => $blog_page))) .
                                 "#blog\" " .
                   "method=\"post\">" .
             "<table class=\"blog-edit\">" .

        //header
             "<tr>" .
             "<th colspan=\"2\">" .
             CMS_L_MOD_BLOG_002 .
             "</th>" .
             "</tr>" .

        //title
             "<tr>" .
             "<td>" .
             CMS_L_MOD_BLOG_003 . ":" .
             "</td>" .
             "<td>" .
             "<input name=\"blog_edit_title\" " .
                    "type=\"text\" " .
                    "size=\"40\" " .
                    "value=\"" . x($blog_edit_title) . "\">" .
             "</td>" .
             "</tr>" .

        //tags
             "<tr>" .
             "<td>" .
             CMS_L_MOD_BLOG_004 . ":" .
             "</td>" .
             "<td>" .
             "<div class=\"blog-edit-meta\">" .
             "<input name=\"blog_edit_meta\" " .
                    "type=\"text\" " .
                    "size=\"40\" " .
                    "value=\"" . x($blog_edit_meta) . "\">");

        //retrieve tag suggestions
        $query = "SELECT " .    "c." . CMS_DB_BLOG_META_TERM_TEXT . " " .
                 "FROM " .      CMS_DB_BLOG .           " AS a " .

                 "LEFT JOIN " . CMS_DB_BLOG_META_LINK . " AS b " .
                 "ON " .        "b." . CMS_DB_BLOG_META_LINK_ARTICLE .
                 "=" .          "a." . CMS_DB_BLOG_INDEX . " " .

                 "LEFT JOIN " . CMS_DB_BLOG_META_TERM . " AS c " .
                 "ON " .        "c." . CMS_DB_BLOG_META_TERM_INDEX .
                 "=" .          "b." . CMS_DB_BLOG_META_LINK_TERM . " " .

                 "WHERE " .     "a." . CMS_DB_BLOG_INSTANCE .
                 "='" .         sqlesc($instance) . "' " .
                 "AND " .       "c." . CMS_DB_BLOG_META_TERM_TEXT . " " .
                 "IS NOT NULL " .

                 "GROUP BY " .  "b." . CMS_DB_BLOG_META_LINK_TERM . " " .
                 "ORDER BY " .  "COUNT(b." . CMS_DB_BLOG_META_LINK_TERM . ") DESC";
        $result = mysql_query($query);

        //display tag suggestions
        if (($result !== FALSE) && (mysql_num_rows($result) > 0))
        {
                echo("<div class=\"blog-edit-meta-suggestion\">");
?>
<script>
function blog_tag(value)
{
        var object = document.getElementsByName("blog_edit_meta")[0];
        if (object.value.match(/\S/)) object.value += ", ";
        object.value += value;
        return false;
};
</script>
<?php
                while ($resultrow = mysql_fetch_row($result))
                        echo("<a href=\"#\" " .
                                "onclick=\"return blog_tag(this.textContent);\">" .
                             x($resultrow[0]) .
                             "</a> ");
                echo("</div>");
        };

        echo("</div>" .
             "</td>" .
             "</tr>" .

        //publication options
             "<tr>" .
             "<td class=\"varied\">" .
             CMS_L_MOD_BLOG_022 . ":" .
             "</td>" .
             "<td class=\"varied\">" .

        //immediate publication
             "<label>" .
             "<input name=\"blog_edit_status\" " .
                    "type=\"radio\" " .
                    "value=\"" . CMS_DB_BLOG_STATUS_ACTIVE . "\"" .
                    (((int)$blog_edit_status === CMS_DB_BLOG_STATUS_ACTIVE) ? " checked" : "") . ">" .
             CMS_L_MOD_BLOG_023 .
             "</label> " .

        //no publication
             "<label>" .
             "<input name=\"blog_edit_status\" " .
                    "type=\"radio\" " .
                    "value=\"" . x(CMS_DB_BLOG_STATUS_INACTIVE) . "\" " .
                    (((int)$blog_edit_status === CMS_DB_BLOG_STATUS_INACTIVE) ? " checked" : "") . ">" .
             CMS_L_MOD_BLOG_024 .
             "</label> " .

        //sticky
             "<label>" .
             "<input name=\"blog_edit_sticky\" " .
                    "type=\"checkbox\" " .
                    "value=\"" . x(CMS_DB_BLOG_STICKY_ON) . "\" " .
                    (((int)$blog_edit_sticky === CMS_DB_BLOG_STICKY_ON) ? " checked" : "") . ">" .
             CMS_L_MOD_BLOG_037 .
             "</label>" .

        //scheduled publication
             "<table class=\"layout\">" .
             "<tr>" .
             "<td style=\"VERTICAL-ALIGN:bottom\">" .
             "<input name=\"blog_edit_status\" " .
                    "type=\"radio\" " .
                    "value=\"2\" " .
                    (((int)$blog_edit_status === 2) ? " checked" : "") . ">" .
             "</td>" .
             "<td>" .
             CMS_L_MOD_BLOG_025 . "<br>");
        select($array_day, $blog_edit_time_day, "blog_edit_time_day", TRUE);
        echo("</td>" .
             "<td>" .
             "&nbsp;" .
             "</td>" .
             "<td>" .
             CMS_L_MOD_BLOG_026 . "<br>");
        select($array_month, $blog_edit_time_month, "blog_edit_time_month", TRUE);
        echo("</td>" .
             "<td>" .
             "&nbsp;" .
             "</td>" .
             "<td>" .
             CMS_L_MOD_BLOG_027 . "<br>");
        select($array_year, $blog_edit_time_year, "blog_edit_time_year", TRUE);
        echo("</td>" .
             "<td>" .
             "&nbsp;" .
             "</td>" .
             "<td>" .
             CMS_L_MOD_BLOG_028 . "<br>");
        select($array_hour, $blog_edit_time_hour, "blog_edit_time_hour", TRUE);
        echo(":");
        select($array_minute, $blog_edit_time_minute, "blog_edit_time_minute", TRUE);
        echo("</td>" .
             "</tr>" .
             "</table>");
?>
<script>
document.blog_edit.blog_edit_time_day.onchange    =
document.blog_edit.blog_edit_time_month.onchange  =
document.blog_edit.blog_edit_time_year.onchange   =
document.blog_edit.blog_edit_time_hour.onchange   =
document.blog_edit.blog_edit_time_minute.onchange =
function() { document.blog_edit.blog_edit_status[2].click(); };
</script>
<?php
        echo("</td>" .
             "</tr>" .

        //text
             "<tr>" .
             "<td colspan=\"2\">");

        //extended editing buttons
        $extension = "";

        if (cms_load("ifc"))
        {
                //images
                if (cms_available("image") && ifc_available("image") && cms_permission("interface.image", NULL, NULL))
                {
                        $buffer     = "javascript:load_page('" .
                                      q(CMS_MODULES_URL) . "interface.php" .
                                      "?ifc_page=image" .
                                      "&ifc_option=external" .
                                      "&ifc_select=_object[]" .
                                      "&ifc_select_action=" .
                                      "javascript:textcontrol_set(" .
                                      "\'this.opener.document.blog_edit.blog_edit_text\'," .
                                      "\'%2523image_left\'," .
                                      "\'%return%\');');";
                        $extension .= "<a href=\"" . x($buffer) . "\">" .
                                      image("textcontrol/button_image_external", NULL, NULL, "image") .
                                      "</a>";
                };

                //links
                if (cms_available("content") && ifc_available("content") && cms_permission("interface.content", NULL, NULL))
                {
                        $buffer     = "javascript:load_page('" .
                                      q(CMS_MODULES_URL) . "interface.php" .
                                      "?ifc_page=content" .
                                      "&ifc_message=edit_href" .
                                      "&ifc_option=external" .
                                      "&ifc_select=_value" .
                                      "&ifc_select_action=" .
                                      "javascript:textcontrol_set(" .
                                      "\'this.opener.document.blog_edit.blog_edit_text\'," .
                                      "\'%2523hyperlink\'," .
                                      "\'%return%\');');";
                        $extension .= "<a href=\"" . x($buffer) . "\">" .
                                      image("textcontrol/button_hyperlink_external", NULL, NULL, "hyperlink") .
                                      "</a>";
                };

                //tokens
                if (cms_available("token") && ifc_available("token") && cms_permission("interface.token", NULL, NULL))
                {
                        $buffer     = "javascript:load_page('" .
                                      q(CMS_MODULES_URL) . "interface.php" .
                                      "?ifc_page=token" .
                                      "&ifc_option=external" .
                                      "&ifc_select=token" .
                                      "&ifc_select_action=" .
                                      "javascript:textcontrol_set(" .
                                      "\'this.opener.document.blog_edit.blog_edit_text\'," .
                                      "\'%2523token\'," .
                                      "\'%return%\');');";
                        $extension .= "<a href=\"" . x($buffer) . "\">" .
                                      image("textcontrol/button_token_external", NULL, NULL, "token") .
                                      "</a>";
                };
        };

        echo(jscript("textcontrol(" .
                     "\"document.blog_edit.blog_edit_text\", " .
                     "\"" . q(CMS_IMAGES_URL) . "\"" .
                     (nstre($extension) ? ", \"" . q($extension) . "\"" : "") . ");") .
             "<textarea name=\"blog_edit_text\" " .
                       "cols=\"60\" " .
                       "rows=\"20\" " .
                       "onselect=\"textcontrol_select(this);\" " .
                       "onchange=\"textcontrol_select(this);\">\n" .
             x($blog_edit_text) .
             "</textarea>" .
             "</td>" .
             "</tr>" .

        //command
             "<tr>" .
             "<td colspan=\"2\" " .
                 "class=\"varied\" " .
                 "style=\"TEXT-ALIGN:right\">");

        //cancel button
        echo("<input name=\"blog_edit_message\" " .
                    "type=\"submit\" " .
                    "value=\"" . CMS_L_COMMAND_CANCEL . "\"> " .

        //save button
             "<input name=\"blog_edit_message\" " .
                    "type=\"submit\" " .
                    "value=\"" . CMS_L_COMMAND_SAVE . "\"> " .

        //save and preview button
             "<input name=\"blog_edit_message\" " .
                    "type=\"submit\" " .
                    "value=\"" . CMS_L_MOD_BLOG_005 . "\">" .
             "</td>" .
             "</tr>" .
             "</table>" .
             "</form>" .
             "</div>" . //blog_content
             "</div>"); //blog

        return;

case "code_edit":
//.....................................................................................................

        //display code form
        echo("<form name=\"blog_code_edit\" " .
                   "action=\"" . x(CMS_ACTIVE_URL .
                                   cms_param(array("blog_message" => "_code_edit",
                                                   "blog_index"   => $blog_index,
                                                   "blog_date"    => $blog_date,
                                                   "blog_meta"    => $blog_meta,
                                                   "blog_page"    => $blog_page))) .
                                 "#blog\" " .
                   "method=\"post\">" .
             "<table class=\"blog-code-edit\">" .

        //header
             "<tr>" .
             "<th>" .
             CMS_L_MOD_BLOG_016 .
             "</th>" .
             "</tr>" .

        //text
             "<tr>" .
             "<td>" .

        //code replacements
             CMS_L_MOD_BLOG_032 . ": ");
        $array = array(CMS_L_URL          => "%url%",
                       CMS_L_MOD_BLOG_003 => "%title%",
                       CMS_L_MOD_BLOG_034 => "%author%",
                       CMS_L_MOD_BLOG_035 => "%user%");
        reset($array);
        while (list($key, $value) = each($array))
                echo("<a href=\"#\" " .
                        "onclick=\"textcontrol_set(" .
                        "'document.blog_code_edit.blog_code_edit_text'," .
                        "'#replace'," .
                        "'" . qx($value) . "');" .
                        "return false;\">" .
                     x($key) .
                     "</a> ");

        echo("<br>" .
             "<input name=\"blog_code_edit_position\" " .
                    "type=\"hidden\" " .
                    "value=\"" . x($blog_code_edit_position) . "\">" .
             "<textarea name=\"blog_code_edit_text\" " .
                       "cols=\"60\" " .
                       "rows=\"20\" " .
                       "onselect=\"textcontrol_select(this);\" " .
                       "onchange=\"textcontrol_select(this);\">\n" .
             x($blog->code_get($blog_code_edit_position)) .
             "</textarea>" .
             "</td>" .
             "</tr>" .

        //command
             "<tr>" .
             "<td class=\"varied\" " .
                 "style=\"TEXT-ALIGN:right\">" .

        //cancel button
             "<input name=\"blog_code_edit_message\" " .
                    "type=\"submit\" " .
                    "value=\"" . CMS_L_COMMAND_CANCEL . "\"> " .

        //save button
             "<input name=\"blog_code_edit_message\" " .
                    "type=\"submit\" " .
                    "value=\"" . CMS_L_COMMAND_SAVE . "\"> " .
             "</td>" .
             "</tr>" .
             "</table>" .
             "</form>" .
             "</div>" . //blog_content
             "</div>"); //blog

        return;

case "rss":
//.....................................................................................................

        //close output buffer
        ob_end_clean();

        //send rss content type header
        header("Content-Type: application/rss+xml; charset=utf-8");

        //caching
        $cache_key  = "blog.rss.$instance." . CMS_LANGUAGE;
        $cache_time = cms_cache_time($cache_key);

        if (($cache_time !== FALSE) && ($cache_time > ($time - 60))) //60 seconds delay
        {
                echo(cms_cache($cache_key));
                exit();
        };

        //start output
        $buffer  = "<?xml version=\"1.0\" " .
                         "encoding=\"utf-8\"?>" .
                   "<rss version=\"2.0\">" .
                   "<channel>";

        //title
        $value   = isset($GLOBALS["blog"]["rss_title"]) ?
                   $GLOBALS["blog"]["rss_title"] : CMS_L_MOD_BLOG_031;
        $buffer .= "<title>" . x($value) . "</title>";

        //link
        $value   = CMS_ACTIVE_URL . cms_param();
        $buffer .= "<link>" . x($value) . "</link>";

        //description
        $value   = isset($GLOBALS["blog"]["rss_description"]) ?
                   $GLOBALS["blog"]["rss_description"] : "";
        $buffer .= "<description>" . x($value) . "</description>";

        //language
        $buffer .= "<language>" . x(CMS_LANGUAGE) . "</language>";

        //retrieve articles
        $query  = "SELECT * " .
                  "FROM " .     CMS_DB_BLOG . " " .
                  "WHERE " .    CMS_DB_BLOG_INSTANCE .
                  "='" .        sqlesc($instance) . "' " .
                  "AND " .      CMS_DB_BLOG_STATUS .
                  "='" .        CMS_DB_BLOG_STATUS_ACTIVE . "' " .
                  "AND " .      CMS_DB_BLOG_TIME .
                  "<='" .       sqlesc($time) . "' " .
                  "ORDER BY " . CMS_DB_BLOG_TIME . " DESC " .
                  "LIMIT 50";
        $result = mysql_query($query);

        //publication date
        if ($resultrow = mysql_fetch_assoc($result))
        {
                $value   = date("r", $resultrow[CMS_DB_BLOG_TIME]);
                $buffer .= "<pubDate>" . x($value) . "</pubDate>";
        };

        //last build date
        $value   = date("r");
        $buffer .= "<lastBuildDate>" . x($value) . "</lastBuildDate>";

        //category
        $value   = isset($GLOBALS["blog"]["rss_category"]) ?
                   $GLOBALS["blog"]["rss_category"] : "";
        $buffer .= "<category>" . x($value) . "</category>";

        //generator
        $buffer .= "<generator>" . x(CMS_SOFTWARE . " " . CMS_VERSION) . "</generator>";

        //list articles
        $_time = $time - 259200; //3 days

        while ($resultrow)
        {
                $buffer .= "<item>";

                //title
                $value   = $resultrow[CMS_DB_BLOG_TITLE];
                if ($resultrow[CMS_DB_BLOG_TIME] > $_time)
                        $value .= " (" . friendly_date($resultrow[CMS_DB_BLOG_TIME]) . ")";
                $buffer .= "<title>" . x($value) . "</title>";

                //description
                $_value  = remove_format($resultrow[CMS_DB_BLOG_TEXT]);
                $value   = limitstr($_value, 200, " ");
                if (strlen($value) !== strlen($_value)) $value .= "\xE2\x80\xA6";
                $buffer .= "<description>" . x($value) . "</description>";

                //guid
                $value   = defined("CMS_CONTENT_INDEX") ?
                           CMS_MODULES_URL . "content.php" .
                           querystring(array("content_index" => CMS_CONTENT_INDEX,
                                             "blog_index"    => $resultrow[CMS_DB_BLOG_INDEX])) :
                           CMS_ACTIVE_URL .
                           cms_param(array("blog_index" => $resultrow[CMS_DB_BLOG_INDEX]));
                $buffer .= "<guid isPermaLink=\"true\">" . x($value) . "</guid>";

                //link
                $value   = CMS_ACTIVE_URL .
                           cms_param(array("blog_index" => $resultrow[CMS_DB_BLOG_INDEX]));
                $buffer .= "<link>" . x($value) . "</link>";

                //publication date
                $value   = date("r", $resultrow[CMS_DB_BLOG_TIME]);
                $buffer .= "<pubDate>" . x($value) . "</pubDate>";

                $buffer .= "</item>";

                //fetch next article
                $resultrow = mysql_fetch_assoc($result);
        };

        $buffer .= "</channel>" .
                   "</rss>";

        //cache permanently
        cms_cache($cache_key, $buffer, TRUE);

        echo($buffer);
        exit();
};

//-----------------------------------------------------------------------------------------------------

//article

while (nstre($blog_index))
{
        $buffer = "";

        //filter active
        if (! ($blog->writer || $blog->operator))
                $buffer = "AND " . CMS_DB_BLOG_STATUS .
                          "='" .   CMS_DB_BLOG_STATUS_ACTIVE . "' " .
                          "AND " . CMS_DB_BLOG_TIME .
                          "<='" .  sqlesc($time) . "' ";

        //retrieve article
        $result = mysql_query("SELECT * " .
                              "FROM " .  CMS_DB_BLOG . " " .
                              "WHERE " . CMS_DB_BLOG_INSTANCE .
                              "='" .     sqlesc($instance) . "' " .
                              "AND " .   CMS_DB_BLOG_INDEX .
                              "='" .     sqlesc($blog_index) . "' " .
                              $buffer .
                              "LIMIT 1");
        if ($result === FALSE) break; //error
        $resultrow = mysql_fetch_assoc($result);

        if (! $resultrow) //article not found
        {
                echo(CMS_L_MOD_BLOG_036);
                break;
        };

        //code replacements
        $replacement = array("url"    => CMS_ACTIVE_URL . cms_param(array("blog_index" => $blog_index)),
                             "title"  => $resultrow[CMS_DB_BLOG_TITLE],
                             "author" => permission_get_name($resultrow[CMS_DB_BLOG_OWNER]),
                             "user"   => $resultrow[CMS_DB_BLOG_OWNER]);

        echo("<menu class=\"blog-command\">" .

        //overview command
             "<a href=\"" . x(CMS_ACTIVE_URL .
                              cms_param(array("blog_date" => $blog_date,
                                              "blog_meta" => $blog_meta,
                                              "blog_page" => $blog_page))) .
                        "#blog\" " .
                "class=\"button\">" .
             CMS_L_MOD_BLOG_011 .
             "</a>");

        //delete command
        if ($blog->test_delete($blog_index))
                echo(" <a href=\"" . x(CMS_ACTIVE_URL .
                                       cms_param(array("blog_message"      => "_edit",
                                                       "blog_index"        => $blog_index,
                                                       "blog_date"         => $blog_date,
                                                       "blog_meta"         => $blog_meta,
                                                       "blog_edit_message" => CMS_L_COMMAND_DELETE))) .
                                     "#blog\" " .
                         "class=\"button\" " .
                         "onclick=\"return confirm('" . CMS_L_MOD_BLOG_029 . "');\">" .
                     CMS_L_COMMAND_DELETE .
                     "</a>");

        //edit command
        if ($blog->test_edit($blog_index))
                echo(" <a href=\"" . x(CMS_ACTIVE_URL .
                                       cms_param(array("blog_message" => "edit",
                                                       "blog_index"   => $blog_index,
                                                       "blog_date"    => $blog_date,
                                                       "blog_meta"    => $blog_meta))) .
                                     "#blog\" " .
                         "class=\"button\">" .
                     CMS_L_MOD_BLOG_009 .
                     "</a>");
        echo("</menu>" .

             "<article class=\"blog-article\">");

        insert("top_article");

        //code
        echo("<aside class=\"blog-code\">");

        //edit code command
        if ($blog->test_code_set())
                echo("<menu class=\"blog-command\">" .
                     "<a href=\"" . x(CMS_ACTIVE_URL .
                                      cms_param(array("blog_message"            => "code_edit",
                                                      "blog_index"              => $blog_index,
                                                      "blog_date"               => $blog_date,
                                                      "blog_meta"               => $blog_meta,
                                                      "blog_page"               => $blog_page,
                                                      "blog_code_edit_position" => CMS_DB_BLOG_CODE_POSITION_BEFORE))) .
                                    "#blog\" " .
                        "class=\"button\">" .
                     CMS_L_MOD_BLOG_016 .
                     "</a>" .
                     "</menu>");

        echo($blog->code_parse(CMS_DB_BLOG_CODE_POSITION_BEFORE, $replacement) .
             "</aside>" .

             "<header>" .

        //info
             "<div class=\"blog-article-info\">" .

        //time
             "<time datetime=\"" . x(date("c", $resultrow[CMS_DB_BLOG_TIME])) . "\" " .
                   "class=\"blog-article-time\">" .
             x(friendly_date($resultrow[CMS_DB_BLOG_TIME])) .
             "</time> " .

        //author
             "<span class=\"blog-article-author\">" .
             sprintf(CMS_L_MOD_BLOG_033, x($replacement["author"])) .
             "</span>" .

             "</div>" .

        //title
             "<h2 class=\"blog-article-title\">" .
             x($resultrow[CMS_DB_BLOG_TITLE]) .
             "</h2>" .

             "</header>" .

        //text
             "<div class=\"blog-article-text\">" .
             parse_text($resultrow[CMS_DB_BLOG_TEXT]) .
             "</div>" .

        //code
             "<aside class=\"blog-code\">");

        //edit code command
        if ($blog->test_code_set())
                echo("<menu class=\"blog-command\">" .
                     "<a href=\"" . x(CMS_ACTIVE_URL .
                                      cms_param(array("blog_message"            => "code_edit",
                                                      "blog_index"              => $blog_index,
                                                      "blog_date"               => $blog_date,
                                                      "blog_meta"               => $blog_meta,
                                                      "blog_page"               => $blog_page,
                                                      "blog_code_edit_position" => CMS_DB_BLOG_CODE_POSITION_AFTER))) .
                                    "#blog\" " .
                        "class=\"button\">" .
                     CMS_L_MOD_BLOG_016 .
                     "</a>" .
                     "</menu>");

        echo($blog->code_parse(CMS_DB_BLOG_CODE_POSITION_AFTER, $replacement) .
             "</aside>");

        insert("bottom_article");

        echo("</article>");

        //comments
        $GLOBALS["comment"]["instance"] = "$instance.$blog_index";

        echo("<div class=\"blog-comment\">");
        cms_param($blog_index, "blog_index");
        cms_param($blog_date,  "blog_date");
        cms_param($blog_meta,  "blog_meta");
        cms_param($blog_page,  "blog_page");
        cms_application("comment");
        cms_param("", "blog_index");
        cms_param("", "blog_date");
        cms_param("", "blog_meta");
        cms_param("", "blog_page");
        echo("</div>" .

             "</div>");
        break;
};

//-----------------------------------------------------------------------------------------------------

//command

if (stre($blog_index))
{
        if ($blog->test_add())
                echo("<menu class=\"blog-command\">" .
                     "<a href=\"" . x(CMS_ACTIVE_URL .
                                      cms_param(array("blog_message" => "add",
                                                      "blog_date"    => $blog_date,
                                                      "blog_meta"    => $blog_meta,
                                                      "blog_page"    => $blog_page))) .
                                    "#blog\" " .
                        "class=\"button\">" .
                     CMS_L_MOD_BLOG_002 .
                     "</a>" .
                     "</menu>");
};

//-----------------------------------------------------------------------------------------------------

//overview

if (stre($blog_index))
{
        $buffer = "";

        //filter active
        if (! ($blog->writer || $blog->operator))
                $buffer = "AND " . "a." . CMS_DB_BLOG_STATUS .
                          "='" .   CMS_DB_BLOG_STATUS_ACTIVE . "' " .
                          "AND " . "a." . CMS_DB_BLOG_TIME .
                          "<='" .  sqlesc($time) . "' ";

        //archive selection
        if (nstre($blog_date))
        {
                $year  = (int)substr($blog_date, 0, 4);
                $month = (int)substr($blog_date, 4, 2);
                $day   = (int)substr($blog_date, 6, 2);

                if ($year !== 0)
                        $buffer .= "AND YEAR(FROM_UNIXTIME(" .  "a." . CMS_DB_BLOG_TIME . "))" .
                                   "='" .                       sqlesc($year) . "' ";
                if ($month !== 0)
                        $buffer .= "AND MONTH(FROM_UNIXTIME(" . "a." . CMS_DB_BLOG_TIME . "))" .
                                   "='" .                       sqlesc($month) . "' ";
                if ($day !== 0)
                        $buffer .= "AND DAY(FROM_UNIXTIME(" .   "a." . CMS_DB_BLOG_TIME . "))" .
                                   "='" .                       sqlesc($day) . "' ";
        };

        //meta selection
        if (nstre($blog_meta))
                $buffer .= "AND " . "b." . CMS_DB_BLOG_META_LINK_TERM .
                           "='" .   sqlesc($blog_meta) . "' ";

        //get number of articles
        $query = "SELECT COUNT(DISTINCT a." . CMS_DB_BLOG_INDEX . ") " .
                 "FROM " .      CMS_DB_BLOG .           " AS a " .
                 "LEFT JOIN " . CMS_DB_BLOG_META_LINK . " AS b " .
                 "ON " .        "b." . CMS_DB_BLOG_META_LINK_ARTICLE .
                 "=" .          "a." . CMS_DB_BLOG_INDEX . " " .
                 "WHERE " .     "a." . CMS_DB_BLOG_INSTANCE .
                 "='" .         sqlesc($instance) . "' " .
                 $buffer;

        $result = mysql_query($query);
        $count  = ($result === FALSE) ? 0 : mysql_result($result, 0);
        $_count = ceil($count / 10) - 1;
        if ($_count < 0)         $_count = 0;
        $page   = (int)$blog_page;
        if ($page < 0)           $page   = 0;
        elseif ($page > $_count) $page   = $_count;

        $comment_reader = cms_permission("comment.reader.$instance");

        while ($count > 0)
        {
                $query = "SELECT " .     "a.* " .
                         ($comment_reader ?
                                      ", COUNT(DISTINCT c." . CMS_DB_COMMENT_INDEX . ") AS `#count` " : "") .
                         "FROM " .       CMS_DB_BLOG .           " AS a " .
                         "LEFT JOIN " .  CMS_DB_BLOG_META_LINK . " AS b " .
                         "ON " .         "b." . CMS_DB_BLOG_META_LINK_ARTICLE .
                         "=" .           "a." . CMS_DB_BLOG_INDEX . " " .
                         ($comment_reader ?
                         "LEFT JOIN " .  CMS_DB_COMMENT .        " AS c " .
                         "ON " .         "c." . CMS_DB_COMMENT_STATUS .
                         "='" .          sqlesc(CMS_DB_COMMENT_STATUS_ACTIVE) . "' " .
                         "AND " .        "c." . CMS_DB_COMMENT_INSTANCE .
                         "=CONCAT_WS(" . "'.', " .
                                         "'" . sqlesc($instance) . "', " .
                                         "a." . CMS_DB_BLOG_INDEX . ") " .
                         "WHERE " .      "a." . CMS_DB_BLOG_INSTANCE .
                         "='" .          sqlesc($instance) . "' " : "WHERE 1 ") .
                         $buffer .
                         "GROUP BY " .   "a." . CMS_DB_BLOG_INDEX . " " .
                         "ORDER BY " .   "a." . CMS_DB_BLOG_STICKY . " DESC, " .
                                         "a." . CMS_DB_BLOG_TIME .   " DESC " .
                         "LIMIT " .      sqlesc($page * 10) . ", 10";

                $result = mysql_query($query);
                if ($result === FALSE) break; //error

                echo("<div class=\"blog-overview\">");

                insert("top_overview");

                while ($resultrow = mysql_fetch_assoc($result))
                {
                        $url = CMS_ACTIVE_URL .
                               cms_param(array("blog_index" => $resultrow[CMS_DB_BLOG_INDEX],
                                               "blog_date"  => $blog_date,
                                               "blog_meta"  => $blog_meta,
                                               "blog_page"  => option($page > 0, $page)));

                        if ((int)$resultrow[CMS_DB_BLOG_STATUS] === CMS_DB_BLOG_STATUS_ACTIVE)
                                $class  = ($resultrow[CMS_DB_BLOG_TIME] > $time) ?
                                          "blog-overview-article-scheduled" :
                                          "blog-overview-article";
                        else
                                $class  = "blog-overview-article-disabled";

                        if ((int)$resultrow[CMS_DB_BLOG_STICKY] === CMS_DB_BLOG_STICKY_ON)
                                $class .= "-sticky";

                        echo("<article class=\"$class\">" .

                        //info
                             "<div class=\"blog-overview-info\">" .

                        //time
                             "<time datetime=\"" . x(date("c", $resultrow[CMS_DB_BLOG_TIME])) . "\" " .
                                   "class=\"blog-overview-time\">" .
                             x(friendly_date($resultrow[CMS_DB_BLOG_TIME])) .
                             "</time> " .

                        //author
                             "<span class=\"blog-overview-author\">" .
                             sprintf(CMS_L_MOD_BLOG_033, x(permission_get_name($resultrow[CMS_DB_BLOG_OWNER]))) .
                             "</span>" .

                             "</div>");

                        //image
                        $image = get_first_image($resultrow[CMS_DB_BLOG_TEXT]);
                        if ($image !== NULL)
                        {
                                $image = translate_url($image);
                                $image = image_process($image, 100);
                                echo("<div class=\"blog-overview-image\">" .
                                     "<a href=\"" . x($url) . "#blog\">" .
                                     "<img src=\"" . x($image) . "\" " .
                                          "alt=\"" . x($resultrow[CMS_DB_BLOG_TITLE]) . "\">" .
                                     "</a>" .
                                     "</div>");
                        };

                        //title
                        echo("<h2 class=\"blog-overview-title\">" .
                             "<a href=\"" . x($url) . "#blog\">" .
                             x($resultrow[CMS_DB_BLOG_TITLE]) .
                             "</a>" .
                             "</h2>" .

                        //teaser
                             "<div class=\"blog-overview-text\">" .
                             x(limitstr(htmltoplain(remove_format($resultrow[CMS_DB_BLOG_TEXT], TRUE, TRUE)), 350, " ")) . " " .
                             "<a href=\"" . x($url) . "#blog\">" .
                             "\xE2\x80\xA6" . CMS_L_MOD_BLOG_010 .
                             "</a>");
                        if ($comment_reader)
                             echo(" | " .
                                  "<a href=\"" . x($url) . "#comment\">" .
                                  sprintf(CMS_L_MOD_BLOG_038, $resultrow["#count"]) .
                                  "</a>" .
                                  "</div>");

                        //command
                        $buffer = "";

                        //delete command
                        if ($blog->test_delete($blog_index))
                                $buffer .= "<a href=\"" . x(CMS_ACTIVE_URL .
                                                            cms_param(array("blog_message"      => "_edit",
                                                                            "blog_index"        => $resultrow[CMS_DB_BLOG_INDEX],
                                                                            "blog_date"         => $blog_date,
                                                                            "blog_meta"         => $blog_meta,
                                                                            "blog_page"         => $blog_page,
                                                                            "blog_edit_message" => CMS_L_COMMAND_DELETE))) .
                                                          "#blog\" " .
                                              "class=\"button\" " .
                                              "onclick=\"return confirm('" . CMS_L_MOD_BLOG_029 . "');\">" .
                                           CMS_L_COMMAND_DELETE .
                                           "</a> ";

                        //edit command
                        if ($blog->test_edit($blog_index))
                                $buffer .= "<a href=\"" . x(CMS_ACTIVE_URL .
                                                            cms_param(array("blog_message"      => "edit",
                                                                            "blog_index"        => $resultrow[CMS_DB_BLOG_INDEX],
                                                                            "blog_date"         => $blog_date,
                                                                            "blog_meta"         => $blog_meta,
                                                                            "blog_page"         => $blog_page))) .
                                                          "#blog\" " .
                                              "class=\"button\">" .
                                           CMS_L_MOD_BLOG_009 .
                                           "</a>";

                        if (nstre($buffer))
                                echo("<menu class=\"blog-command\">" .
                                     ltrim($buffer) .
                                     "</menu>");

                        //code replacements
                        $_replacement = array("url"    => CMS_ACTIVE_URL . cms_param(array("blog_index" => $resultrow[CMS_DB_BLOG_INDEX])),
                                              "title"  => $resultrow[CMS_DB_BLOG_TITLE],
                                              "author" => permission_get_name($resultrow[CMS_DB_BLOG_OWNER]),
                                              "user"   => $resultrow[CMS_DB_BLOG_OWNER]);

                        //code
                        echo("<aside class=\"blog-code\">");

                        //edit code command
                        if ($blog->test_code_set())
                                echo("<menu class=\"blog-command\">" .
                                     "<a href=\"" . x(CMS_ACTIVE_URL .
                                                      cms_param(array("blog_message"            => "code_edit",
                                                                      "blog_date"               => $blog_date,
                                                                      "blog_meta"               => $blog_meta,
                                                                      "blog_page"               => $blog_page,
                                                                      "blog_code_edit_position" => CMS_DB_BLOG_CODE_POSITION_TEASER))) .
                                                    "#blog\" " .
                                        "class=\"button\">" .
                                     CMS_L_MOD_BLOG_016 .
                                     "</a>" .
                                     "</menu>");

                        echo($blog->code_parse(CMS_DB_BLOG_CODE_POSITION_TEASER, $_replacement) .
                             "</aside>" .
                             "</article>");
                };

                //pagination
                echo("<div class=\"blog-overview-pagination\">");

                //previous command
                if ($page > 0)
                        echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                              cms_param(array("blog_date" => $blog_date,
                                                              "blog_meta" => $blog_meta,
                                                              "blog_page" => $page - 1))) .
                                            "#blog\" " .
                                "rel=\"prev\">" .
                             "\xC2\xAB" .
                             "</a> ");

                //page number command
                for ($i = 0; $i <= $_count; $i++)
                        echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                              cms_param(array("blog_date" => $blog_date,
                                                              "blog_meta" => $blog_meta,
                                                              "blog_page" => $i))) .
                                            "#blog\">" .
                             (($i === $page) ? "<strong>" . ($i + 1) . "</strong>" : $i + 1) .
                             "</a>" .
                             (($i < $_count) ? " | " : ""));

                //next command
                if ($page < $_count)
                        echo(" | " .
                             "<a href=\"" . x(CMS_ACTIVE_URL .
                                              cms_param(array("blog_date" => $blog_date,
                                                              "blog_meta" => $blog_meta,
                                                              "blog_page" => $page + 1))) .
                                            "#blog\" " .
                                "rel=\"next\">" .
                             CMS_L_MOD_BLOG_001 . "&nbsp;\xC2\xBB" .
                             "</a>");

                echo("</div>");

                insert("bottom_overview");

                echo("</div>");
                break;
        };

        permission(array(CMS_BLOG_PERMISSION_READER . ".$instance"   => CMS_L_READ,
                         CMS_BLOG_PERMISSION_WRITER . ".$instance"   => CMS_L_WRITE,
                         CMS_BLOG_PERMISSION_OPERATOR . ".$instance" => CMS_L_OPERATOR));

        echo("</div>"); //blog_content

        //code replacements
        $replacement = array("url"    => CMS_ACTIVE_URL . cms_param(),
                             "title"  => isset($GLOBALS["blog"]["rss_title"]) ?
                                         $GLOBALS["blog"]["rss_title"] : CMS_L_MOD_BLOG_031,
                             "author" => "",
                             "user"   => "");
};

//-----------------------------------------------------------------------------------------------------

echo("<aside class=\"blog-control\">");

insert("top_control");

//archive

echo("<nav class=\"blog-archive\">" .
     "<h2>" .
     CMS_L_MOD_BLOG_019 .
     "</h2>");

if (stre($blog_date))
{
        $year  = 0;
        $month = 0;
        $day   = 0;
}
else
{
        echo("<a href=\"" . x(CMS_ACTIVE_URL .
                              cms_param(array("blog_meta" => $blog_meta))) .
                            "#blog\">" .
             CMS_L_MOD_BLOG_021 .
             "</a><br>");

        $year  = (int)substr($blog_date, 0, 4);
        $month = (int)substr($blog_date, 4, 2);
        $day   = (int)substr($blog_date, 6, 2);
};

//filter active
$buffer = "";
if (! ($blog->writer || $blog->operator))
        $buffer = "AND " . CMS_DB_BLOG_STATUS .
                  "='" .   CMS_DB_BLOG_STATUS_ACTIVE . "' " .
                  "AND " . CMS_DB_BLOG_TIME .
                  "<='" .  sqlesc($time) . "' ";

$_time  = mktime(0, 0, 0, $month, 1, $year);

$result = mysql_query("SELECT YEAR(FROM_UNIXTIME(" . CMS_DB_BLOG_TIME . ")) AS `#year`, " .
                             "COUNT(*) AS `#count` " .
                      "FROM " .  CMS_DB_BLOG . " " .
                      "WHERE " . CMS_DB_BLOG_INSTANCE .
                      "='" .     sqlesc($instance) . "' " .
                      $buffer .
                      "GROUP BY `#year` " .
                      "ORDER BY `#year` DESC");

while ($resultrow = mysql_fetch_assoc($result))
{
        $flag = (int)$resultrow["#year"] === $year;
        $date = sprintf("%04d", $resultrow["#year"]);
        echo("<a href=\"" . x(CMS_ACTIVE_URL .
                              cms_param(array("blog_date" => $date,
                                              "blog_meta" => $blog_meta))) .
                            "#blog\" " .
                "title=\"" . sprintf(CMS_L_MOD_BLOG_015, $resultrow["#count"]) . "\" " .
                "class=\"" . ($flag ? "blog-archive-year-active" : "blog-archive-year") . "\">" .
             x($resultrow["#year"]) .
             "</a> ");

        //selected year
        if ($flag)
        {
                $_result = mysql_query("SELECT MONTH(FROM_UNIXTIME(" . CMS_DB_BLOG_TIME . ")) AS `#month`, " .
                                              "COUNT(*) AS `#count` " .
                                       "FROM " .  CMS_DB_BLOG . " " .
                                       "WHERE " . CMS_DB_BLOG_INSTANCE .
                                       "='" .     sqlesc($instance) . "' " .
                                       "AND YEAR(FROM_UNIXTIME(" . CMS_DB_BLOG_TIME . "))" .
                                       "='" .     sqlesc($year) . "' " .
                                       "GROUP BY `#month` " .
                                       "ORDER BY `#month`");

                while ($_resultrow = mysql_fetch_assoc($_result))
                {
                        $_flag = (int)$_resultrow["#month"] === $month;
                        $date  = sprintf("%04d%02d",
                                         $resultrow["#year"],
                                         $_resultrow["#month"]);
                        echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                              cms_param(array("blog_date" => $date,
                                                              "blog_meta" => $blog_meta))) .
                                            "#blog\" " .
                                "title=\"" . sprintf(CMS_L_MOD_BLOG_015, $_resultrow["#count"]) . "\" " .
                                "class=\"" . ($_flag ? "blog-archive-month-active" : "blog-archive-month") . "\">" .
                             month($_resultrow["#month"]) .
                             "</a> ");

                        //selected month
                        if ($_flag)
                        {
                                $__result = mysql_query("SELECT DAY(FROM_UNIXTIME(" . CMS_DB_BLOG_TIME . ")) AS `#day`, " .
                                                               "COUNT(*) AS `#count` " .
                                                        "FROM " .  CMS_DB_BLOG . " " .
                                                        "WHERE " . CMS_DB_BLOG_INSTANCE .
                                                        "='" .     sqlesc($instance) . "' " .
                                                        "AND YEAR(FROM_UNIXTIME(" . CMS_DB_BLOG_TIME . "))" .
                                                        "='" .     sqlesc($year) . "' " .
                                                        "AND MONTH(FROM_UNIXTIME(" . CMS_DB_BLOG_TIME . "))" .
                                                        "='" .     sqlesc($month) . "' " .
                                                        "GROUP BY `#day` " .
                                                        "ORDER BY `#day`");

                                while ($__resultrow = mysql_fetch_assoc($__result))
                                        $array[$__resultrow["#day"]] = $__resultrow["#count"];

                                //weekdays
                                echo("<table>" .
                                     "<tr>");
                                for ($i = 0; $i < 7; $i++)
                                        echo("<th>" .
                                             utf8_substr(weekday($i), 0, 2) .
                                             "</th>");
                                echo("</tr>");

                                //days
                                $wday = (int)date("w", $_time);
                                $mday = (int)date("t", $_time);
                                $i    = 1;

                                while (TRUE)
                                {
                                        if (($i % 7) === 1) echo("<tr>");

                                        echo("<td>");
                                        if (($i > $wday) && (($_i = $i - $wday) <= $mday)) //within month range
                                        {
                                                if (isset($array[$_i]))
                                                {
                                                        $__flag = $_i === $day;
                                                        $date   = sprintf("%04d%02d%02d",
                                                                          $resultrow["#year"],
                                                                          $_resultrow["#month"],
                                                                          $_i);
                                                        echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                                                              cms_param(array("blog_date" => $date,
                                                                                              "blog_meta" => $blog_meta))) .
                                                                            "#blog\" " .
                                                                "title=\"" . sprintf(CMS_L_MOD_BLOG_015, $array[$_i]) . "\" " .
                                                                "class=\"" . ($__flag ? "blog-archive-day-active" : "blog-archive-day") . "\">" .
                                                             $_i .
                                                             "</a>");
                                                }
                                                else
                                                {
                                                        echo($_i);
                                                };
                                        };
                                        echo("</td>");

                                        if (($i % 7) === 0)
                                        {
                                                echo("</tr>");
                                                if ($i > $mday) break;
                                        };

                                        $i++;
                                };

                                echo("</table>");
                        };
                };
        };
};

echo("</nav>");

//-----------------------------------------------------------------------------------------------------

//meta

//filter active
$buffer = "";
if (! ($blog->writer || $blog->operator))
        $buffer = "AND " . "a." . CMS_DB_BLOG_STATUS .
                  "='" .   CMS_DB_BLOG_STATUS_ACTIVE . "' " .
                  "AND " . "a." . CMS_DB_BLOG_TIME .
                  "<='" .  sqlesc($time) . "' ";

$query = "SELECT " .    "b." . CMS_DB_BLOG_META_LINK_TERM . ", " .
                        "c." . CMS_DB_BLOG_META_TERM_TEXT . ", " .
                        "COUNT(*) " .
         "FROM " .      CMS_DB_BLOG .           " AS a " .

         "LEFT JOIN " . CMS_DB_BLOG_META_LINK . " AS b " .
         "ON " .        "b." . CMS_DB_BLOG_META_LINK_ARTICLE .
         "=" .          "a." . CMS_DB_BLOG_INDEX . " " .

         "LEFT JOIN " . CMS_DB_BLOG_META_TERM . " AS c " .
         "ON " .        "c." . CMS_DB_BLOG_META_TERM_INDEX .
         "=" .          "b." . CMS_DB_BLOG_META_LINK_TERM . " " .

         "WHERE " .     "a." . CMS_DB_BLOG_INSTANCE .
         "='" .         sqlesc($instance) . "' " .
         $buffer .
         "AND " .       "c." . CMS_DB_BLOG_META_TERM_TEXT . " " .
         "IS NOT NULL " .

         "GROUP BY " .  "b." . CMS_DB_BLOG_META_LINK_TERM . " " .
         "ORDER BY " .  "c." . CMS_DB_BLOG_META_TERM_TEXT;

$result = mysql_query($query);
if ($result !== FALSE)
{
        echo("<nav class=\"blog-meta\">" .
             "<h2>" .
             CMS_L_MOD_BLOG_020 .
             "</h2>");

        if (nstre($blog_meta))
                echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                      cms_param(array("blog_date" => $blog_date))) .
                                    "#blog\">" .
                     CMS_L_MOD_BLOG_021 .
                     "</a><br>");

        $list = array();
        $min  = PHP_INT_MAX;
        $max  = 0;

        while ($resultrow = mysql_fetch_row($result))
        {
                $list[$resultrow[0]] = array(0 => $resultrow[1], $resultrow[2]);
                if ($resultrow[2] < $min) $min = $resultrow[2];
                if ($resultrow[2] > $max) $max = $resultrow[2];
        };

        $diff   = $max - $min;
        $factor = ($diff === 0) ? 10 : 10 / $diff;

        reset($list);
        while (list($key, $value) = each($list))
        {
                $size = 10 + round($factor * ($value[1] - $min));

                echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                      cms_param(array("blog_date" => $blog_date,
                                                      "blog_meta" => $key))) .
                                    "#blog\" " .
                        "title=\"" . sprintf(CMS_L_MOD_BLOG_015, $value[1]) . "\" " .
                        "style=\"FONT-SIZE:" . x($size) . "px\">" .
                     x(utf8_ucwords($value[0])) .
                     "</a> ");
        };

        echo("</nav>");
};

//-----------------------------------------------------------------------------------------------------

//code

echo("<aside class=\"blog-code\">");

//edit code command
if ($blog->test_code_set())
        echo("<menu class=\"blog-command\">" .
             "<a href=\"" . x(CMS_ACTIVE_URL .
                              cms_param(array("blog_message"            => "code_edit",
                                              "blog_code_edit_position" => CMS_DB_BLOG_CODE_POSITION_CONTROL,
                                              "blog_index"              => $blog_index,
                                              "blog_date"               => $blog_date,
                                              "blog_meta"               => $blog_meta,
                                              "blog_page"               => $blog_page))) .
                            "#blog\" " .
                "class=\"button\">" .
             CMS_L_MOD_BLOG_016 .
             "</a>" .
             "</menu>");

echo($blog->code_parse(CMS_DB_BLOG_CODE_POSITION_CONTROL, $replacement) .
     "</aside>");

//-----------------------------------------------------------------------------------------------------

//feed

echo("<nav class=\"blog-rss\">" .
     "<a href=\"" . x(CMS_ACTIVE_URL . cms_param(array("blog_message" => "rss"))) . "\">" .
     CMS_L_MOD_BLOG_030 .
     "</a>" .
     "</nav>");

insert("bottom_control");

echo("</aside>" . //blog_control
     "</div>");   //blog

?>