<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< MODULE >========================================================================================
//-----------------------------------------------------------------------------------------------------
global $forum_message,
       $forum_index,
       $forum_buffer,
       $forum_search,
       $forum_option,
       $forum_edit_title,
       $forum_edit_text,
       $forum_edit_name,
       $forum_edit_email,
       $forum_edit_message;

if (
     (! cms_load("forum"))
     ||
     (! cms_load("flexview"))
   )
{
        echo(CMS_MSG_UNAVAILABLE);
        return;
};

$forum = new forum();
if (! $forum->enabled)
{
        echo(CMS_MSG_UNAVAILABLE);
        return;
};

$forum_option   = (int)$forum_option;
$insert_enabled = $forum->operator
                  &&
                  $forum_buffer
                  &&
                  ($forum_buffer != $forum_index)
                  &&
                  (
                    (! $forum_index)
                    ||
                    (! $forum->mysql->is_child($forum_index, $forum_buffer, $forum->db_table))
                  );

switch ($forum_message)
{
case "add":
case "edit":
//.....................................................................................................
        if ($forum_edit_message == CMS_L_COMMAND_CANCEL) break;

        if ($forum_edit_message)
        {
                $forum_edit_title = trim($forum_edit_title);
                $forum_edit_text  = trim($forum_edit_text);

                if (
                     (CMS_USER == "anonymous")
                     ||
                     ($forum_message == "edit")
                   )
                {
                        $forum_edit_name  = trim($forum_edit_name);
                        $forum_edit_email = trim($forum_edit_email);
                }
                else
                {
                        $forum_edit_name  = CMS_NAME;
                        $forum_edit_email = $forum_edit_email ? CMS_EMAIL : NULL;
                };

                if (
                     (! $forum_edit_title)
                     ||
                     (! $forum_edit_text)
                     ||
                     (
                       (
                         (CMS_USER == "anonymous")
                         ||
                         ($forum_message == "edit")
                       )
                       &&
                       (! $forum_edit_name)
                     )
                     ||
                     (
                       $forum_edit_email
                       &&
                       (! verify_email($forum_edit_email))
                     )
                   )
                        $forum_edit_message = CMS_L_COMMAND_EDIT;
        }
        else
        {
                if ($forum_message == "add")
                {
                        if (
                             $forum->writer
                             &&
                             (
                               $forum_index
                               ||
                               $forum->operator
                             )
                             &&
                             ($result = mysql_query("SELECT " . CMS_DB_FORUM_CONTAINER . ", " .
                                                                CMS_DB_FORUM_TITLE . ", " .
                                                                CMS_DB_FORUM_TEXT . ", " .
                                                                CMS_DB_FORUM_NAME . ", " .
                                                                CMS_DB_FORUM_TIME . " " .
                                                    "FROM " .   $forum->db_table . " " .
                                                    "WHERE " .  CMS_DB_FORUM_INDEX . "='" . sqlesc($forum_index) . "' " .
                                                    "LIMIT 1"))
                             &&
                             ($resultrow = mysql_fetch_assoc($result))
                           )
                        {
                                if ($resultrow[CMS_DB_FORUM_CONTAINER])
                                {
                                        $forum_edit_title = $resultrow[CMS_DB_FORUM_TITLE];
                                                if (strpos($resultrow[CMS_DB_FORUM_TITLE], CMS_L_MOD_FORUM_002) !== 0)
                                        $forum_edit_title = CMS_L_MOD_FORUM_002 . $forum_edit_title;
                                        $forum_edit_text  = sprintf(CMS_L_MOD_FORUM_001,
                                                                    $resultrow[CMS_DB_FORUM_NAME],
                                                                    weekday(date("w", $resultrow[CMS_DB_FORUM_TIME])),
                                                                    date(CMS_L_DATE_FORMAT, $resultrow[CMS_DB_FORUM_TIME]),
                                                                    date(CMS_L_SHORT_TIME_FORMAT, $resultrow[CMS_DB_FORUM_TIME])) .
                                                            ":\n\n> " .
                                                            substr(linebreak(remove_format($resultrow[CMS_DB_FORUM_TEXT]), 50, "\n> "), 0, -2);
                                        $forum_edit_text  = str_replace("[", "\[", $forum_edit_text);
                                        $forum_edit_text  = str_replace("]", "\]", $forum_edit_text);
                                };

                                if (CMS_USER != "anonymous")
                                {
                                        $forum_edit_name  = CMS_NAME;
                                        $forum_edit_email = NULL;
                                };
                        };
                }
                else
                {
                        if (
                             $forum->operator
                             &&
                             ($result = mysql_query("SELECT " . CMS_DB_FORUM_TITLE . ", " .
                                                                CMS_DB_FORUM_TEXT . ", " .
                                                                CMS_DB_FORUM_NAME . ", " .
                                                                CMS_DB_FORUM_EMAIL . " " .
                                                    "FROM " .   $forum->db_table . " " .
                                                    "WHERE " .  CMS_DB_FORUM_INDEX . "='" . sqlesc($forum_index) . "' " .
                                                    "LIMIT 1"))
                             &&
                             ($resultrow = mysql_fetch_assoc($result))
                           )
                        {
                                $forum_edit_title = $resultrow[CMS_DB_FORUM_TITLE];
                                $forum_edit_text  = $resultrow[CMS_DB_FORUM_TEXT];
                                $forum_edit_name  = $resultrow[CMS_DB_FORUM_NAME];
                                $forum_edit_email = $resultrow[CMS_DB_FORUM_EMAIL];
                        };
                };
        };

        switch ($forum_edit_message)
        {
        default:
        case CMS_L_COMMAND_EDIT:
//.....................................................................................................
                insert("top_edit");

                echo("<form name=\"forum_edit\" " .
                           "action=\"" . x(CMS_ACTIVE_URL .
                                           cms_param(array("forum_index"   => $forum_index,
                                                           "forum_message" => $forum_message,
                                                           "forum_option"  => $forum_option))) . "\" " .
                           "method=\"post\">" .
                     "<table class=\"layout\" " .
                            "style=\"WIDTH:100%\">" .
                     "<colgroup>" .
                     "<col span=\"2\" " .
                          "style=\"WIDTH:1px\">" .
                     "<col>" .
                     "</colgroup>" .
                     "<tr>" .
                     "<th colspan=\"2\">" .
                     CMS_L_MOD_FORUM_010 .
                     "</th>" .
                     "<th>" .
                     "&nbsp;" .
                     "</th>" .
                     "</tr>" .
                     "<tr>" .
                     "<td colspan=\"2\">");
                if ($forum_edit_message && (! $forum_edit_title))
                        echo("<strong>" .
                             CMS_L_MOD_FORUM_017 .
                             "</strong><br>");
                echo("<label>" .
                     "<small>" .
                     CMS_L_MOD_FORUM_014 .
                     "</small><br>" .
                     "<input name=\"forum_edit_title\" " .
                            "type=\"text\" " .
                            "size=\"40\" " .
                            "maxlength=\"40\" " .
                            "value=\"" . x($forum_edit_title) . "\">" .
                     "</label><br>");
                if ($forum_edit_message && (! $forum_edit_text))
                        echo("&nbsp;<br>" .
                             "<strong>" .
                             CMS_L_MOD_FORUM_018 .
                             "</strong><br>");
                echo("<label>" .
                     "<small>" .
                     CMS_L_MOD_FORUM_016 .
                     "</small><br>" .
                     jscript("textcontrol(\"document.forum_edit.forum_edit_text\", \"" . q(CMS_IMAGES_URL) . "\");") .
                     "<textarea name=\"forum_edit_text\" " .
                               "cols=\"60\" " .
                               "rows=\"25\" " .
                               "onselect=\"textcontrol_select(this);\" " .
                               "onchange=\"textcontrol_select(this);\">\n" .
                     x($forum_edit_text) .
                     "</textarea>" .
                     "</label>" .
                     "</td>" .
                     "<td>" .
                     "&nbsp;" .
                     "</td>" .
                     "</tr>");
                if (streq(CMS_USER, "anonymous") || streq($forum_message, "edit"))
                {
                        echo("<tr>" .
                             "<td class=\"varied\">");
                        if ($forum_edit_message && (! $forum_edit_name))
                                echo("<strong>" .
                                     CMS_L_MOD_FORUM_019 .
                                     "</strong><br>");
                        echo("<label>" .
                             "<small>" .
                             CMS_L_NAME .
                             "</small><br>" .
                             "<input name=\"forum_edit_name\" " .
                                    "type=\"text\" " .
                                    "size=\"40\" " .
                                    "maxlength=\"40\" " .
                                    "value=\"" . x($forum_edit_name) . "\">" .
                             "</label>" .
                             "</td>" .
                             "<td rowspan=\"2\" " .
                                 "class=\"varied\" " .
                                 "style=\"TEXT-ALIGN:right;VERTICAL-ALIGN:top;WHITE-SPACE:nowrap\">");
                }
                elseif (CMS_EMAIL)
                {
                        echo("<tr>" .
                             "<td class=\"varied\" " .
                                 "style=\"TEXT-ALIGN:left\">" .
                             "<label>" .
                             "<input name=\"forum_edit_email\" " .
                                    "type=\"checkbox\" " .
                                    "value=\"1\"" .
                                    option($forum_edit_email, " checked") . ">" .
                             CMS_L_MOD_FORUM_009 .
                             "</label>" .
                             "</td>" .
                             "<td class=\"varied\" " .
                                 "style=\"TEXT-ALIGN:right;VERTICAL-ALIGN:top;WHITE-SPACE:nowrap\">");
                }
                else
                {
                        echo("<tr>" .
                             "<td colspan=\"2\" " .
                                 "class=\"varied\" " .
                                 "style=\"TEXT-ALIGN:right;WHITE-SPACE:nowrap\">");
                };
                echo("<input name=\"forum_edit_message\" " .
                            "type=\"submit\" " .
                            "value=\"" . CMS_L_COMMAND_SHOW . "\"> " .
                     "<input name=\"forum_edit_message\" " .
                            "type=\"submit\" " .
                            "value=\"" . CMS_L_COMMAND_CANCEL . "\">" .
                     "</td>");
                if (streq(CMS_USER, "anonymous") || streq($forum_message, "edit"))
                {
                        echo("<td rowspan=\"2\" " .
                                 "class=\"varied\">" .
                             "&nbsp;" .
                             "</td>" .
                             "</tr>" .
                             "<tr>" .
                             "<td colspan=\"2\" " .
                                 "class=\"varied\">");
                        if ($forum_edit_message && $forum_edit_email && (! verify_email($forum_edit_email)))
                                echo("<strong>" .
                                     CMS_L_MOD_FORUM_013 .
                                     "</strong><br>");
                        echo("<label>" .
                             "<small>" .
                             "(" . CMS_L_EMAIL . ")" .
                             "</small><br>" .
                             "<input name=\"forum_edit_email\" " .
                                    "type=\"text\" " .
                                    "size=\"40\" " .
                                    "maxlength=\"40\" " .
                                    "value=\"" . x($forum_edit_email) . "\">" .
                             "</label><br>" .
                             "<small>" .
                             CMS_L_MOD_FORUM_006 .
                             "</small>" .
                             "</td>");
                }
                else
                {
                        echo("<td class=\"varied\">" .
                             "&nbsp;" .
                             "</td>");
                };
                echo("</tr>" .
                     "</table>" .
                     "</form>");

                insert("bottom_edit");
                permission(array(""                            => CMS_L_READ,
                                 CMS_FORUM_PERMISSION_WRITER   => CMS_L_WRITE,
                                 CMS_FORUM_PERMISSION_OPERATOR => CMS_L_OPERATOR));

                return;

        case CMS_L_COMMAND_SHOW:
//.....................................................................................................
                insert("top_preview");

                echo("<form name=\"forum_edit\" " .
                           "action=\"" . x(CMS_ACTIVE_URL .
                                           cms_param(array("forum_index"   => $forum_index,
                                                           "forum_message" => $forum_message,
                                                           "forum_option"  => $forum_option))) . "\" " .
                           "method=\"post\">" .
                     "<input name=\"forum_edit_title\" " .
                            "type=\"hidden\" " .
                            "value=\"" . x($forum_edit_title) . "\">" .
                     "<input name=\"forum_edit_text\" " .
                            "type=\"hidden\" " .
                            "value=\"" . x($forum_edit_text) . "\">");
                if ((CMS_USER == "anonymous") || ($forum_message == "edit"))
                        echo("<input name=\"forum_edit_name\" " .
                                    "type=\"hidden\" " .
                                    "value=\"" . x($forum_edit_name) . "\">" .
                             "<input name=\"forum_edit_email\" " .
                                    "type=\"hidden\" " .
                                    "value=\"" . x($forum_edit_email) . "\">");
                elseif ($forum_edit_email)
                        echo("<input name=\"forum_edit_email\" " .
                                    "type=\"hidden\" " .
                                    "value=\"1\">");
                echo("<table class=\"layout\" " .
                            "style=\"WIDTH:100%\">" .
                     "<tr>" .
                     "<th>" .
                     CMS_L_MOD_FORUM_015 .
                     "</th>" .
                     "</tr>" .
                     "<tr>" .
                     "<td style=\"TEXT-ALIGN:left\">" .
                     "<h2>" .
                     x($forum_edit_title) .
                     "</h2>" .
                     "<p>" .
                     parse_text($forum_edit_text) .
                     "</p>" .
                     "</td>" .
                     "</tr>" .
                     "<td class=\"varied\" " .
                         "style=\"TEXT-ALIGN:right;WHITE-SPACE:nowrap\">" .
                     "<input name=\"forum_edit_message\" " .
                            "type=\"submit\" " .
                            "value=\"" . CMS_L_COMMAND_EDIT . "\"> " .
                     "<input name=\"forum_edit_message\" " .
                            "type=\"submit\" " .
                            "value=\"" . CMS_L_COMMAND_SAVE . "\"> " .
                     "<input name=\"forum_edit_message\" " .
                            "type=\"submit\" " .
                            "value=\"" . CMS_L_COMMAND_CANCEL . "\">" .
                     "</td>" .
                     "</tr>" .
                     "</table>" .
                     "</form>");

                insert("bottom_preview");
                permission(array(""                            => CMS_L_READ,
                                 CMS_FORUM_PERMISSION_WRITER   => CMS_L_WRITE,
                                 CMS_FORUM_PERMISSION_OPERATOR => CMS_L_OPERATOR));

                return;

        case CMS_L_COMMAND_SAVE:
//.....................................................................................................
                if ($forum_message == "add")
                {
                        $forum_index = $forum->add($forum_index,
                                                   $forum_edit_title,
                                                   $forum_edit_text,
                                                   $forum_edit_name,
                                                   $forum_edit_email);
                }
                else
                {
                        $forum->edit($forum_index,
                                     $forum_edit_title,
                                     $forum_edit_text,
                                     $forum_edit_name,
                                     $forum_edit_email);
                };
        };
        break;

case "cut":
//.....................................................................................................
        if ($forum->operator) $forum_buffer = $forum_index;
        break;

case "insert":
//.....................................................................................................
        if ($insert_enabled)
        {
                $forum->move($forum_buffer, $forum_index);
                $forum_index    = $forum_buffer;
                $forum_buffer   = NULL;
                $insert_enabled = NULL;
        };
        break;

case "delete":
//.....................................................................................................
        if ($forum->operator)
        {
                $forum->delete($forum_index);
                $forum_index    = 0;
                $forum_buffer   = NULL;
                $insert_enabled = NULL;
        };
        break;
};

insert("top");

if (! $forum_search)
{
        //get selected entry data
        if (
             $forum_index
             &&
             (
               (! ($result = mysql_query("SELECT * " .
                                         "FROM " .  $forum->db_table . " " .
                                         "WHERE " . CMS_DB_FORUM_INDEX . "='" . sqlesc($forum_index) . "' " .
                                         "LIMIT 1")))
               ||
               (! ($resultrow = mysql_fetch_assoc($result)))
             )
           )
                $forum_index = NULL;

        //get directory data
        if ($result = mysql_query("SELECT " .   CMS_DB_FORUM_INDEX . ", " .
                                                CMS_DB_FORUM_CONTAINER . ", " .
                                  "CONCAT(" .   "'\"', " .
                                                CMS_DB_FORUM_TITLE . ", " .
                                                "'\", ', " .
                                                CMS_DB_FORUM_NAME . ") " .
                                  "AS " .       CMS_DB_FORUM_TITLE . " " .
                                  "FROM " .     $forum->db_table . " " .
                                  "ORDER BY " . CMS_DB_FORUM_TIME . " DESC"))
        {
                $flexview = new flexview();
                $flexview->import_database($result);
                $flexview->set_encoding_function(__NAMESPACE__ . "\\r");
        };
};

//buffer active url
$buffer["active_url"]    =
        x(CMS_ACTIVE_URL .
          cms_param(array("forum_index"  => $forum_index,
                          "forum_buffer" => $forum_buffer,
                          "forum_option" => $forum_option)));

//buffer marker prefix
$buffer["marker_prefix"] =
        r(str_replace(".", "-", cms_application()));

echo("<form action=\"" . $buffer["active_url"] . "\" " .
           "method=\"post\">" .
     "<table class=\"layout\" " .
            "style=\"WIDTH:100%\">" .
     "<colgroup>" .
     "<col style=\"WIDTH:150px\">" .
     "<col>" .
     "<col style=\"WIDTH:150px\">" .
     "</colgroup>" .
     "<tr>" .

//title
     "<th colspan=\"2\">" .
     "<a name=\"" . $buffer["marker_prefix"] . "-top\">");
if ($forum_search)      echo(CMS_L_MOD_FORUM_005);
elseif (! $forum_index) echo(CMS_L_MOD_FORUM_012);
else                    echo(x($resultrow[CMS_DB_FORUM_TITLE]));
echo("</a>" .
     "</th>" .

//search
     "<th style=\"TEXT-ALIGN:left;VERTICAL-ALIGN:bottom\">" .
     "<label for=\"forum-search\">" .
     "<small>" .
     CMS_L_MOD_FORUM_004 .
     "</small>" .
     "</label>" .
     "</th>" .
     "</tr>" .

//top command bar
     "<tr>" .
     "<td class=\"varied\" " .
         "style=\"TEXT-ALIGN:left;VERTICAL-ALIGN:bottom\">");
if ($forum_search)
{
        echo("<a href=\"" . $buffer["active_url"] . "\" " .
                "style=\"WHITE-SPACE:nowrap\">" .
             "[" . CMS_L_COMMAND_PREVIOUS . "]" .
             "</a>" .
             "</td>" .
             "<td class=\"varied\">" .
             "&nbsp;");
}
else
{
        //buffer button top
        $buffer["button_top"]  =
                "<a href=\"" . $buffer["active_url"] . "#" . $buffer["marker_prefix"] . "-top\" " .
                   "style=\"WHITE-SPACE:nowrap\">" .
                "<small>" .
                "[" . CMS_L_MOD_FORUM_008 . "]" .
                "</small>" .
                "</a>";

        //buffer button down
        $buffer["button_down"] =
                "<a href=\"" . $buffer["active_url"] . "#" . $buffer["marker_prefix"] . "-bottom\" " .
                   "style=\"WHITE-SPACE:nowrap\">" .
                ($forum_index ?
                "<small>" .
                "[" . CMS_L_MOD_FORUM_022 . "]" .
                "</small>" :
                "[" . CMS_L_MOD_FORUM_007 . "]") .
                "</a>";

        echo($buffer["button_down"] .
             "</td>");
        if ($forum_index)
        {
                echo("<td class=\"varied\" " .
                         "style=\"TEXT-ALIGN:left;VERTICAL-ALIGN:bottom\">");
                $flexview->show_path($forum_index,
                                     CMS_ACTIVE_URL .
                                     cms_param(array("forum_index"  => chr(27) . "%index%",
                                                     "forum_buffer" => $forum_buffer,
                                                     "forum_option" => $forum_option)),
                                     CMS_DB_FORUM_TITLE);
        }
        else
        {
                echo("<td class=\"varied\">" .
                     "&nbsp;");
        };
};
echo("</td>" .

//search input
     "<td class=\"varied\" " .
         "style=\"TEXT-ALIGN:left;VERTICAL-ALIGN:top\">" .
     "<input id=\"forum-search\" " .
            "name=\"forum_search\" " .
            "type=\"text\" " .
            "size=\"15\" " .
            "maxlength=\"40\" " .
            "value=\"" . x($forum_search) . "\">" .
     "</td>" .
     "</tr>");

//search results
if ($forum_search)
{
        echo("<tr>" .
             "<td colspan=\"3\">");
        $forum->search($forum_search,
                       CMS_ACTIVE_URL .
                       cms_param(array("forum_index"  => chr(27) . "%index%",
                                       "forum_buffer" => $forum_buffer,
                                       "forum_option" => $forum_option)));
        echo("</td>" .
             "</tr>");
}
else
{
        //buffer operator commands
        $buffer["operator_command"] = "";

        if ($forum->operator && (! $forum_search))
        {
                $buffer["operator_command"] .=
                        "<tr>" .
                        "<td>" .
                        "&nbsp;" .
                        "</td>" .
                        "<td colspan=\"2\" " .
                            "style=\"TEXT-ALIGN:left\">";
                if ($forum_index)
                {
                        $buffer["operator_command"] .=
                                "<a href=\"" . x(CMS_ACTIVE_URL .
                                                 cms_param(array("forum_index"   => $forum_index,
                                                                 "forum_message" => "edit",
                                                                 "forum_option"  => $forum_option))) . "\" " .
                                   "style=\"WHITE-SPACE:nowrap\">" .
                                "<small>" .
                                "[" . CMS_L_COMMAND_EDIT . "]" .
                                "</small>" .
                                "</a> ";

                        if ($forum_index != $forum_buffer)
                                $buffer["operator_command"] .=
                                        "<a href=\"" . x(CMS_ACTIVE_URL .
                                                         cms_param(array("forum_index"   => $forum_index,
                                                                         "forum_message" => "cut",
                                                                         "forum_option"  => $forum_option))) . "\" " .
                                           "style=\"WHITE-SPACE:nowrap\">" .
                                        "<small>" .
                                        "[" . CMS_L_COMMAND_CUT . "]" .
                                        "</small>" .
                                        "</a> ";
                }
                else
                {
                        $buffer["operator_command"] .=
                                "<a href=\"" . x(CMS_ACTIVE_URL .
                                                 cms_param(array("forum_message" => "add",
                                                                 "forum_option"  => $forum_option))) . "\" " .
                                   "style=\"WHITE-SPACE:nowrap\">" .
                                "<small>" .
                                "[" . CMS_L_MOD_FORUM_003 . "]" .
                                "</small>" .
                                "</a> ";
                };

                if ($insert_enabled)
                        $buffer["operator_command"] .=
                                "<a href=\"" . x(CMS_ACTIVE_URL .
                                                 cms_param(array("forum_index"   => $forum_index,
                                                                 "forum_buffer"  => $forum_buffer,
                                                                 "forum_message" => "insert",
                                                                 "forum_option"  => $forum_option))) . "\" " .
                                   "style=\"WHITE-SPACE:nowrap\">" .
                                "<small>" .
                                "[" . CMS_L_COMMAND_PASTE . "]" .
                                "</small>" .
                                "</a> ";
                if ($forum_index)
                {
                        $buffer["operator_command"] .=
                                jscript("
function forum_delete()
{
        if (confirm(\"" . q(sprintf(CMS_L_MOD_FORUM_011,
                                    $resultrow[CMS_DB_FORUM_TITLE])) . "\"))
                window.location.href = \"" . q(CMS_ACTIVE_URL .
                                               cms_param(array("forum_index"   => $forum_index,
                                                               "forum_message" => "delete",
                                                               "forum_option"  => $forum_option))) . "\";
};") .
                             "<a href=\"javascript:forum_delete();\" " .
                                "style=\"WHITE-SPACE:nowrap\">" .
                             "<small>" .
                             "[" . CMS_L_COMMAND_DELETE . "]" .
                             "</small>" .
                             "</a> ";
                };
                $buffer["operator_command"] .=
                        "</td>" .
                        "</tr>";
        };

        if ($forum_index)
        {
                //buffer navigation
                if (isset($flexview->object[$forum_index]["#parent"]))
                {
                        //navigate previous entry
                        $key                  = $flexview->object[$forum_index]["#parent"];
                        $_key                 = NULL;
                        $buffer["navigation"] =
                                "<a href=\"" . x(CMS_ACTIVE_URL .
                                                 cms_param(array("forum_index"  => $key,
                                                                 "forum_buffer" => $forum_buffer,
                                                                 "forum_option" => $forum_option))) . "\" " .
                                   "title=\"" . CMS_L_COMMAND_PREVIOUS .
                                   ($key ? ": " . x($flexview->object[$key]["#data"]["title"]) : NULL) . "\">" .
                                image("forum/icon_previous") .
                                "</a> ";

                        reset($flexview->object[$key]);
                        while (list($__key) = each($flexview->object[$key]))
                        {
                                if (($__key == "#data") || ($__key == "#parent")) continue;

                                //navigate next thread
                                if ($__key == $forum_index)
                                {
                                        if ($_key)
                                                $buffer["navigation"] .=
                                                        "<a href=\"" . x(CMS_ACTIVE_URL .
                                                                         cms_param(array("forum_index"  => $_key,
                                                                                         "forum_buffer" => $forum_buffer,
                                                                                         "forum_option" => $forum_option))) . "\" " .
                                                           "title=\"" . CMS_L_MOD_FORUM_025 . ": " .
                                                           x($flexview->object[$_key]["#data"]["title"]) . "\">" .
                                                        image("forum/icon_top") .
                                                        "</a> ";
                                }

                                //navigate previous thread
                                elseif ($_key == $forum_index)
                                {
                                        $buffer["navigation"] .=
                                                "<a href=\"" . x(CMS_ACTIVE_URL .
                                                                 cms_param(array("forum_index"  => $__key,
                                                                                 "forum_buffer" => $forum_buffer,
                                                                                 "forum_option" => $forum_option))) . "\" " .
                                                   "title=\"" . CMS_L_MOD_FORUM_026 . ": " .
                                                   x($flexview->object[$__key]["#data"]["title"]) . "\">" .
                                                image("forum/icon_bottom") .
                                                "</a> ";
                                        break;
                                };

                                $_key = $__key;

                        };
                };

                //navigate next entry
                reset($flexview->object[$forum_index]);
                while (list($key) = each($flexview->object[$forum_index]))
                {
                        if (($key == "#data") || ($key == "#parent")) continue;

                        $buffer["navigation"] .=
                                "<a href=\"" . x(CMS_ACTIVE_URL .
                                                 cms_param(array("forum_index"  => $key,
                                                                 "forum_buffer" => $forum_buffer,
                                                                 "forum_option" => $forum_option))) . "\" " .
                                   "title=\"" . CMS_L_COMMAND_NEXT . ": " .
                                   x($flexview->object[$key]["#data"]["title"]) . "\">" .
                                image("forum/icon_next") .
                                "</a> ";
                        break;
                };

                //display entry
                $forum->log_access($forum_index);

                $count = count($flexview->object[$forum_index]) - 2;

                //operator command bar
                echo($buffer["operator_command"] .

                //info
                     "<tr>" .
                     "<td style=\"WHITE-SPACE:nowrap\">" .
                     "<strong>" .
                     x($resultrow[CMS_DB_FORUM_NAME]) .
                     "</strong><br>");
                if ($forum->operator)
                        echo("<small>" .
                             x($resultrow[CMS_DB_FORUM_USER]) .
                             "</small><br>");
                echo(x(friendly_date($resultrow[CMS_DB_FORUM_TIME])) . "<br>" .
                     "</small>" .
                     sprintf(CMS_L_MOD_FORUM_020, $resultrow[CMS_DB_FORUM_ACCESS]) .
                     "</small>" .
                     "</td>" .

                //text
                     "<td colspan=\"2\" " .
                         "style=\"TEXT-ALIGN:left\">" .
                     parse_text($resultrow[CMS_DB_FORUM_TEXT]) .
                     "</td>" .
                     "</tr>");

                //navigation
                if ($count && (! ($forum_option & CMS_FORUM_OPTION_SHOW_SUBENTRY)))
                {
                        echo("<tr>" .
                             "<td style=\"WHITE-SPACE:nowrap\">" .
                             "<strong>" .
                             sprintf(CMS_L_MOD_FORUM_021, $count) .
                             "</strong>" .
                             "</td>" .
                             "<td colspan=\"2\" " .
                                 "style=\"TEXT-ALIGN:left\">");
                        $flexview->show_folder($forum_index,
                                               CMS_ACTIVE_URL .
                                               cms_param(array("forum_index"  => chr(27) . "%index%",
                                                               "forum_buffer" => $forum_buffer,
                                                               "forum_option" => $forum_option)),
                                               CMS_DB_FORUM_TITLE,
                                               ($forum_buffer ? array($forum_buffer => "forum/icon_cut") : NULL),
                                               NULL,
                                               $resultrow[CMS_DB_FORUM_CONTAINER]);
                        echo("</td>" .
                             "</tr>");
                };

                //spacer
                echo("<tr>" .
                     "<td class=\"varied\">" .
                     "&nbsp;" .
                     "</td>" .

                //command bar
                     "<td class=\"varied\" " .
                         "style=\"TEXT-ALIGN:left\">");

                //write entry
                if ($forum->writer)
                        echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                              cms_param(array("forum_index"   => $forum_index,
                                                              "forum_message" => "add",
                                                              "forum_option"  => $forum_option))) . "\" " .
                                "style=\"WHITE-SPACE:nowrap\">" .
                             image("forum/icon_write") . " [" . CMS_L_MOD_FORUM_010 . "]" .
                             "</a> ");

                //show or hide subentry
                echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                      cms_param(array("forum_index"  => $forum_index,
                                                      "forum_buffer" => $forum_buffer,
                                                      "forum_search" => $forum_search,
                                                      "forum_option" => $forum_option ^ CMS_FORUM_OPTION_SHOW_SUBENTRY))) . "\" " .
                        "style=\"WHITE-SPACE:nowrap\">" .
                     (($forum_option & CMS_FORUM_OPTION_SHOW_SUBENTRY) ?
                     "[" . CMS_L_MOD_FORUM_023 . "]" :
                     "[" . CMS_L_MOD_FORUM_024 . "]") .
                     "</a> " .

                //navigation
                     $buffer["navigation"] .
                     "</td>" .

                //top/down
                     "<td class=\"varied\" " .
                         "style=\"TEXT-ALIGN:left\">" .
                     $buffer["button_top"] . " " .
                     $buffer["button_down"] .
                     "</td>" .
                     "</tr>");
        }

        //operator command bar
        else
        {
                echo($buffer["operator_command"]);
        };

        //display subentries
        if (
             (
               (! $forum_index)
               ||
               ($forum_option & CMS_FORUM_OPTION_SHOW_SUBENTRY)
             )
             &&
             ($_result = mysql_query("SELECT * " .
                                     "FROM " .     $forum->db_table . " " .
                                     "WHERE " .    CMS_DB_FORUM_CONTAINER . "='" . sqlesc($forum_index) . "' " .
                                     "ORDER BY " . CMS_DB_FORUM_TIME . " DESC"))
           )
        {
                while ($_resultrow = mysql_fetch_assoc($_result))
                {
                        $count = count($flexview->object[$_resultrow[CMS_DB_FORUM_INDEX]]) - 2;

                        //author
                        echo("<tr>" .
                             "<td>" .
                             "<strong>" .
                             x($_resultrow[CMS_DB_FORUM_NAME]) .
                             "</strong>");
                        if ($forum->operator)
                                echo("<br><small>" .
                                     $_resultrow[CMS_DB_FORUM_USER] .
                                     "</small>");
                        echo("</td>" .

                        //title
                             "<th colspan=\"2\">" .
                             "<a href=\"" . x(CMS_ACTIVE_URL .
                                              cms_param(array("forum_index"  => $_resultrow[CMS_DB_FORUM_INDEX],
                                                              "forum_buffer" => $forum_buffer,
                                                              "forum_option" => $forum_option))) . "\">" .
                             image($count ? "forum/icon_thread" : "forum/icon_entry") . " " . x($_resultrow[CMS_DB_FORUM_TITLE]) .
                             "</a>" .
                             "</th>" .
                             "</tr>" .

                        //info
                             "<tr>" .
                             "<td>" .
                             x(friendly_date($_resultrow[CMS_DB_FORUM_TIME])) . "<br>" .
                             "<small>" .
                             sprintf(CMS_L_MOD_FORUM_020, $_resultrow[CMS_DB_FORUM_ACCESS]) .
                             "</small>" .
                             "</td>" .

                        //text
                             "<td colspan=\"2\" " .
                                 "style=\"TEXT-ALIGN:left\">" .
                             parse_text($_resultrow[CMS_DB_FORUM_TEXT]) .
                             "</td>" .
                             "</tr>");

                        //navigation
                        if ($forum_index && $count)
                        {
                                echo("<tr>" .
                                     "<td>" .
                                     "<strong>" .
                                     sprintf(CMS_L_MOD_FORUM_021, $count) .
                                     "</strong>" .
                                     "</td>" .
                                     "<td colspan=\"2\" " .
                                         "style=\"TEXT-ALIGN:left\">");
                                $flexview->show_folder($_resultrow[CMS_DB_FORUM_INDEX],
                                                       CMS_ACTIVE_URL .
                                                       cms_param(array("forum_index"  => chr(27) . "%index%",
                                                                       "forum_buffer" => $forum_buffer,
                                                                       "forum_option" => $forum_option)),
                                                       CMS_DB_FORUM_TITLE,
                                                       ($forum_buffer ? array($forum_buffer => "forum/icon_cut") : NULL),
                                                       NULL,
                                                       $_resultrow[CMS_DB_FORUM_CONTAINER]);
                                echo("</td>" .
                                     "</tr>");
                        };

                        //spacer
                        echo("<tr>" .
                             "<td class=\"varied\">" .
                             "&nbsp;" .
                             "</td>" .

                        //command bar
                             "<td class=\"varied\" " .
                                 "style=\"TEXT-ALIGN:left\">");

                        //write entry
                        if ($forum->writer)
                                echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                                      cms_param(array("forum_index"   => $_resultrow[CMS_DB_FORUM_INDEX],
                                                                      "forum_message" => "add",
                                                                      "forum_option"  => $forum_option))) . "\" " .
                                        "style=\"WHITE-SPACE:nowrap\">" .
                                     image("forum/icon_write") . " [" . CMS_L_MOD_FORUM_010 . "]" .
                                     "</a> ");
                        echo("</td>" .

                        //top/down
                             "<td class=\"varied\" " .
                                 "style=\"TEXT-ALIGN:left\">" .
                             $buffer["button_top"]);
                        if ($forum_index)
                                echo(" " . $buffer["button_down"]);
                        echo("</td>" .
                             "</tr>");
                };
        };

        //directory
        if ($forum_index)
        {
                echo("<tr>" .
                     "<th colspan=\"3\">" .
                     "<a name=\"" . $buffer["marker_prefix"] . "-bottom\">" .
                     CMS_L_MOD_FORUM_012 .
                     "</a>" .
                     "</th>" .
                     "</tr>" .
                     $buffer["operator_command"] .
                     "<tr>" .
                     "<td colspan=\"3\" " .
                         "style=\"TEXT-ALIGN:left\">");
                $flexview->show_tree($forum_index,
                                     CMS_ACTIVE_URL .
                                     cms_param(array("forum_index"  => chr(27) . "%index%",
                                                     "forum_buffer" => $forum_buffer,
                                                     "forum_option" => $forum_option)) .
                                     "#" . $buffer["marker_prefix"] . "-bottom",
                                     CMS_DB_FORUM_TITLE,
                                     ($forum_buffer ? array($forum_buffer => "forum/icon_cut") : NULL));
                echo("</td>" .
                     "</tr>");
        }

        //actual entry list
        else
        {
                echo("<tr>" .
                     "<th colspan=\"3\">" .
                     "<a name=\"" . $buffer["marker_prefix"] . "-bottom\">" .
                     CMS_L_MOD_FORUM_007 .
                     "</a>" .
                     "</th>" .
                     "</tr>" .
                     "<tr>" .
                     "<td colspan=\"3\">");
                $forum->show_new(CMS_ACTIVE_URL .
                                 cms_param(array("forum_index"  => chr(27) . "%index%",
                                                 "forum_buffer" => $forum_buffer,
                                                 "forum_option" => $forum_option)));
                echo("</td>" .
                     "</tr>");
        };

        echo("<tr>" .
             "<td colspan=\"2\" " .
                 "class=\"varied\">" .
             "&nbsp;" .
             "</td>" .
             "<td class=\"varied\" " .
                 "style=\"TEXT-ALIGN:left\">" .
             $buffer["button_top"] .
             "</td>" .
             "</tr>");
};

echo("</table>" .
     "</form>");

insert("bottom");
permission(array(""                            => CMS_L_READ,
                 CMS_FORUM_PERMISSION_WRITER   => CMS_L_WRITE,
                 CMS_FORUM_PERMISSION_OPERATOR => CMS_L_OPERATOR));
?>
