<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< MODULE >========================================================================================
//-----------------------------------------------------------------------------------------------------
global $search_message,
       $search_term,
       $search_language,
       $search_page,
       $search_submit_url,
       $search_submit_message;

if (! cms_load("search"))
{
        echo(CMS_MSG_UNAVAILABLE);
        return;
};

$search = new search();
if (! $search->enabled)
{
        echo(CMS_MSG_UNAVAILABLE);
        return;
};

echo("<div class=\"search\">");

switch ($search_message)
{
case "submit":
//.....................................................................................................
        if (! cms_permission(CMS_SEARCH_PERMISSION_SUBMIT))      break;
        if (streq($search_submit_message, CMS_L_COMMAND_CANCEL)) break;

        insert("submit_top");

        echo("<form action=\"" . x(CMS_ACTIVE_URL .
                                   cms_param(array("search_message" => "submit"))) . "\" " .
                   "method=\"post\">" .
             "<table class=\"search-submit\">" .
             "<tr>" .
             "<th>" .
             CMS_L_MOD_SEARCH_002 .
             "</th>" .
             "</tr>" .
             "<tr>" .
             "<td>");
        if ($search_submit_message !== "")
                $search->queue_add($search_submit_url, CMS_SEARCH_QUEUE_TYPE_SUBMISSION);
        echo("<label>" .
             CMS_L_URL . "<br>" .
             "<input name=\"search_submit_url\" " .
                    "type=\"text\" " .
                    "size=\"40\" " .
                    "maxlength=\"255\" " .
                    "value=\"http://\">" .
             "</label><br>" .
             "<small>" .
             CMS_L_MOD_SEARCH_003 .
             "</small>" .
             "</td>" .
             "</tr>" .
             "<tr>" .
             "<td class=\"varied\" " .
                 "style=\"TEXT-ALIGN:right\">" .
             "<input name=\"search_submit_message\" " .
                    "type=\"submit\" " .
                    "value=\"" . CMS_L_MOD_SEARCH_004 . "\"> " .
             "<input name=\"search_submit_message\" " .
                    "type=\"submit\" " .
                    "value=\"" . CMS_L_COMMAND_CANCEL . "\">" .
             "</td>" .
             "</tr>" .
             "</table>" .
             "</form>");

        insert("submit_bottom");
        permission(array(""                           => CMS_L_READ,
                         CMS_SEARCH_PERMISSION_SUBMIT => CMS_L_WRITE));

        return;
};

#insert top
insert("top");

echo("<form name=\"search_input\" " .
           "action=\"" . x(CMS_ACTIVE_URL . cms_param()) . "\" " .
           "method=\"get\">");

//reset command
if (
     ($result = mysql_query("SELECT COUNT(*) FROM " . CMS_DB_SEARCH_ENTRY . " " .
                            "WHERE " . CMS_DB_SEARCH_ENTRY_ERROR . "='0'"))
     &&
     ($resultrow = mysql_fetch_row($result))
   )
        echo("<h3>" .
             sprintf(CMS_L_MOD_SEARCH_010, $resultrow[0]) .
             "</h3>");

//search term input
echo("<div class=\"search-input\">" .
     "<input name=\"search_term\" " .
            "type=\"text\" " .
            "value=\"" . x($search_term) . "\" " .
            "placeholder=\"" . CMS_L_MOD_SEARCH_013 . "\"> ");

//language
if (stre($search_language)) $search_language = (CMS_LANGUAGE !== "") ? CMS_LANGUAGE : "#any";

$data  = new data("#system/language");
$array = array(CMS_L_MOD_SEARCH_012 => "#any");

$data->move("first");
while ($key = $data->move("next"))
        $array[$data->get($key, "name")] = $key;

asort($array);

select($array, $search_language, "search_language", TRUE);

//submit command
echo(" " .
     "<input type=\"submit\" " .
            "value=\"" . CMS_L_MOD_SEARCH_001 . "\">" .
     "</div>");

if (nstre($search_term))
{
        //execute search query
        $result = $search->find($search_term,
                                $search_page,
                                streq($search_language, "#any") ? NULL : $search_language);

        echo("<div id=\"search-result\">");

        //no results
        if ($result === FALSE)
        {
                echo(info(($search_page > 0) ? CMS_L_MOD_SEARCH_006 : CMS_L_MOD_SEARCH_005));
        }
        else
        {
                //display results
                echo("<ol start=\"" . ($search_page * $search->find_results_per_page + 1) . "\">");

                reset($result);
                while (list(, $value) = each($result))
                {
                        extract($value);

                        echo("<li>" .

                        //title
                             "<a href=\"" . x($address) . "\">" .
                             "<strong>" .
                             x($title) .
                             "</strong>" .
                             "</a><br>" .

                        //text
                             $text . "<br>" .

                        //address, date
                             "<small>" .
                             sprintf(CMS_L_MOD_SEARCH_008,
                                     x($address),
                                     x(friendly_date($time)),
                                     number_format($score, 2,
                                                   CMS_L_DECIMAL_SEPARATOR,
                                                   CMS_L_THOUSAND_SEPARATOR)));

                        //number of similar pages
                        if ($supplemental > 0)
                                echo(sprintf(CMS_L_MOD_SEARCH_011, $supplemental));
                        echo("</small>" .
                             "</li>");
                };

                echo("</ol>");
        };

        echo("</div>");

        //result page navigation
        if (($search_page > 0) || ($result !== FALSE))
                echo("<div class=\"search-pagination\">");

        //previous pages
        if ($search_page > 0)
                echo(CMS_L_MOD_SEARCH_009 . ":");

        for ($i = 0; $i < $search_page; $i++)
        {
                $offset = $i * $search->find_results_per_page;
                $end    = $offset + $search->find_results_per_page;
                $offset++;

                echo(" <a href=\"" . x(CMS_ACTIVE_URL .
                                       cms_param(array("search_term"     => $search_term,
                                                       "search_language" => $search_language,
                                                       "search_page"     => $i))) . "\">" .
                     "[$offset-$end]" .
                     "</a>");
        };

        //further results
        if ($result !== FALSE)
                echo(" <a href=\"" . x(CMS_ACTIVE_URL .
                                       cms_param(array("search_term"     => $search_term,
                                                       "search_language" => $search_language,
                                                       "search_page"     => $search_page + 1))) . "\">" .
                     "<strong>" .
                     CMS_L_MOD_SEARCH_007 .
                     "</strong>" .
                     "</a>");

        if (($search_page > 0) || ($result !== FALSE))
                echo("</div>");
};

//display tag cloud of weightiest words
if (stre($search_term))
{
        $tag = $search->tag(NULL, 100);

        if (is_array($tag) && (count($tag) > 0))
        {
                echo("<div class=\"search-cloud\">");

                $size_max   = 40;
                $size_min   = 10;
                $score_max  = max($tag);
                $score_min  = min($tag);
                $score_diff = $score_max - $score_min;
                $factor     = ($size_max - $size_min) / $score_diff;
                $array      = array_keys($tag);

                //order by tag
                sort($array);

                reset($array);
                while (list(, $value) = each($array))
                {
                        $score   = $tag[$value] - $score_min;
                        $size    = $size_min + round($factor * $score);
                        $opacity = round(0.35 + 0.65 * $score / $score_max, 2);

                        echo("<a href=\"" . x(CMS_ACTIVE_URL .
                                              cms_param(array("search_term"     => $value,
                                                              "search_language" => $search_language))) . "\" " .
                                "style=\"FONT-SIZE:" . x($size) . "px;LINE-HEIGHT:100%;OPACITY:$opacity\">" .
                             x($value) .
                             "</a> ");
                };

                echo("</div>");
        };
};

//submit page command
if (cms_permission(CMS_SEARCH_PERMISSION_SUBMIT))
        echo("<menu class=\"search-command\">" .
             "<a href=\"" . x(CMS_ACTIVE_URL .
                              cms_param(array("search_message" => "submit"))) . "\">" .
             CMS_L_MOD_SEARCH_002 .
             "</a>" .
             "</menu>");

echo("</form>" .
     jscript("document.search_input.search_term.focus();"));

#insert bottom
insert("bottom");
permission(array(""                           => CMS_L_READ,
                 CMS_SEARCH_PERMISSION_SUBMIT => CMS_L_WRITE));

echo("</div>");
?>
