<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< MODULE >========================================================================================
//-----------------------------------------------------------------------------------------------------
require("../nuos.inc");

function mod_download() {

global $download_index,
       $download_start;

$flag = FALSE;

//verify index
if ($download_index)
{
        $path = CMS_DATA_PATH . "#download/$download_index";

        if (
             is_file($path)
             &&
             cms_load("download")
           )
        {
                $download = new download;

                //collect data
                if ($download->data->get($download_index));
                {
                        $name        = l($download->data->get($download_index, "name"));
                        $type        = substr(strrchr($download_index, "."), 1);
                        $size        = sprintf("%u", filesize($path));
                        $description = l($download->data->get($download_index, "description"));
                        $location    = $path;
                        $target      = CMS_ACTIVE_URL .
                                       "?download_index=" . r($download_index) .
                                       "&download_start=1";
                        $flag        = TRUE;
                };
        };
};

if (empty($download_start))
{
        echo(CMS_DOCTYPE_HTML .
             "<html>" .
             "<head>" .
             CMS_HTML_HEADER . CMS_JAVASCRIPT . CMS_STYLESHEET .
             "</head>" .
             "<body class=\"" . x(CMS_CLASS) . "\"" .
                   ($flag ? " onload=\"setTimeout('location.replace(\'" . qx(q($target)) . "\');',2500);\">" : ">") .
             "<div>");

        insert("top");

        //display data
        if ($flag)
        {
                echo("<table class=\"layout\" " .
                            "style=\"WIDTH:100%\">" .

                     "<colgroup>" .
                     "<col style=\"WIDTH:1px\">" .
                     "<col>" .
                     "</colgroup>" .

                //title
                     "<tr>" .
                     "<th colspan=\"2\">" .
                     CMS_L_MOD_DOWNLOAD_001 .
                     "</th>" .
                     "</tr>" .

                //filename
                     "<tr>" .
                     "<td class=\"varied\">" .
                     CMS_L_MOD_DOWNLOAD_004 . ":" .
                     "</td>" .
                     "<td class=\"varied\">" .
                     "<span style=\"FONT-WEIGHT:bold\">" .
                     x($name) .
                     "</span>" .
                     "</td>" .
                     "</tr>");

                //filetype
                if ($type)
                        echo("<tr>" .
                             "<td class=\"varied\">" .
                             CMS_L_MOD_DOWNLOAD_006 . ":" .
                             "</td>" .
                             "<td class=\"varied\">" .
                             x(strtoupper($type)) .
                             "</td>" .
                             "</tr>");

                //filesize
                if ($size)
                        echo("<tr>" .
                             "<td class=\"varied\">" .
                             CMS_L_MOD_DOWNLOAD_005 . ":" .
                             "</td>" .
                             "<td class=\"varied\">" .
                             format_bytesize($size) .
                             "</td>" .
                             "</tr>");

                //description
                if ($description)
                        echo("<tr>" .
                             "<td class=\"varied\">" .
                             CMS_L_DESCRIPTION . ":" .
                             "</td>" .
                             "<td class=\"varied\">" .
                             parse_text($description) .
                             "</td>" .
                             "</tr>");
                echo("<tr>" .
                     "<td colspan=\"2\" " .
                         "class=\"varied\">" .
                     "<strong>" .
                     sprintf(CMS_L_MOD_DOWNLOAD_002, x($target)) .
                     "</strong><br>" .
                     "<small>" .
                     CMS_L_MOD_DOWNLOAD_003 .
                     "</small>" .
                     "</td>" .
                     "</tr>" .
                     "</table>");
        }

        //download not available
        else
        {
                echo(alert(CMS_L_MOD_DOWNLOAD_007));
        };

        insert("bottom");

        permission(array("" => CMS_L_ACCESS));

        echo("</div>" .
             "</body>" .
             "</html>");
}
elseif ($flag)
{
        if (is_file($location))
        {
                $name = stringtofilename($name, "_") . "." . strtolower($type);
                $time = time();

                //log download action
                $log = new log();
                $log->access(sprintf(CMS_L_MOD_DOWNLOAD_008, $name));

                //limit download time to one hour
                set_time_limit(3600);

                //end output buffering
                ob_implicit_flush(TRUE);
                while (ob_get_level()) ob_end_clean();

                //send download
                header("Cache-Control: private, max-age=3600, must-revalidate");
                header("Cache-Control: post-check=3600, pre-check=3600", FALSE); //proprietary internet explorer setting
                header("Content-Disposition: attachment; filename=\"$name\"");
                header("Content-Length: " . filesize($location));
                header("Content-Type: " . get_mime_type($name));
                header("Date: " . gmdate("D, d M Y H:i:s", $time) . " GMT");
                header("Expires: " . gmdate("D, d M Y H:i:s", $time + 3600) . " GMT");
                header("Last-Modified: " . gmdate("D, d M Y H:i:s", filemtime($location)) . " GMT");

                download($location);
                exit();
        };
};

}; mod_download();
?>