<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< MODULE >========================================================================================
//-----------------------------------------------------------------------------------------------------
require("../nuos.inc");

function mod_identification () {

if (empty($_COOKIE["cms_check_cookie"]))
{
        //check for cookie availability
        if (
             (! isset($_GET["cms_check_cookie"]))
             &&
             setcookie("cms_check_cookie",       //name
                       "1",                      //value
                       NULL,                     //expire
                       CMS_RELATIVE_URL,         //path
                       NULL,                     //domain
                       CMS_PROTOCOL === "https", //secure
                       TRUE)                     //httponly
           )
        {
                global $location;

                $location = CMS_ACTIVE_URL . cms_param(array("location" => $location));

                //refresh has to be used instead of location
                //in order to redirect or cookie might not be set
                header("Refresh: 0; URL=$location");

                echo(CMS_DOCTYPE_HTML .
                     "<html>" .
                     "<head>" .
                     CMS_HTML_HEADER . CMS_STYLESHEET .
                     "</head>" .

                     "<body class=\"" . x(CMS_CLASS) . "\">" .
                     "<div>" .
                     sprintf(CMS_L_MOD_IDENTIFICATION_007, x($location)) .
                     "</div>" .
                     "</body>" .
                     "</html>");
        }

        //cookies not available
        else
        {
                echo(CMS_DOCTYPE_HTML .
                     "<html>" .
                     "<head>" .
                     CMS_HTML_HEADER . CMS_STYLESHEET .
                     "</head>" .

                     "<body class=\"" . x(CMS_CLASS) . "\">" .
                     "<div>" .
                     CMS_L_NOCOOKIE .
                     "</div>" .
                     "</body>" .
                     "</html>");
        };
}

//cookies available, show identification prompt
else
{
        echo(CMS_DOCTYPE_HTML .
             "<html>" .
             "<head>" .
             CMS_HTML_HEADER . CMS_JAVASCRIPT . CMS_STYLESHEET .
             "</head>" .

             "<body class=\"" . x(CMS_CLASS) . "\">" .
             "<div>");

        require(CMS_MODULES_PATH . "#module/mod.identification.inc");

        echo("</div>" .
             "</body>" .
             "</html>");
};

}; mod_identification();
?>