<?php /*

   nuos Content Management System
   Copyright (C) 2012 Patrick Heyer, www.nuos-cms.org

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

namespace cms;

//-----------------------------------------------------------------------------------------------------
//===< MODULE >========================================================================================
//-----------------------------------------------------------------------------------------------------
require("../nuos.inc");

//load libraries
cms_load("ifc",      TRUE);
cms_load("flexview", TRUE);

function ifc_module_list()
{
        $array = array();

        $hdir  = opendir(CMS_INTERFACE_PATH);
        while ($file_object = readdir($hdir))
        {
                if (
                     is_file(CMS_INTERFACE_PATH . $file_object)
                     &&
                     preg_match("/^ifc\.(.*)\.inc$/", $file_object, $file_object)
                     &&
                     cms_permission($file_object[1], TRUE, NULL)
                   )
                {
                        $constant               = "CMS_L_IFC_" . strtoupper($file_object[1]);
                        $array[$file_object[1]] = (defined($constant) && ($constant = constant($constant))) ?
                                                  $constant : $file_object[1];
                };
        };
        closedir($hdir);

        if (! $order = file(CMS_INTERFACE_PATH . "order", FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES)) return $array;

        $return = array();

        reset($order);
        while (list(, $value) = each($order))
        {
                $value = rtrim($value);
                if ($value === "-")
                {
                        $return[unique_id()] = "-";
                }
                elseif (isset($array[$value]))
                {
                        $return[$value] = $array[$value];
                        unset($array[$value]);
                };
        };

        return $return + $array;
};

//get modules
$ifc_page = ifc_module_list();

//execute selected module
if (CMS_IFC_PAGE && isset($ifc_page[CMS_IFC_PAGE]))
{
        if (substr_count(CMS_IFC_OPTION, "external")) $ifc_page = NULL;
        require(CMS_INTERFACE_PATH . "ifc." . CMS_IFC_PAGE . ".inc");
}

//no module selected
else
{
        ifc_default($ifc_page);
};
?>